var require = meteorInstall({"imports":{"server":{"accounts":{"ldap.js":["babel-runtime/helpers/typeof","ldapjs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/ldap.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({LDAP:function(){return LDAP}});var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var ldapjs;module.import("ldapjs",{"default":function(v){ldapjs=v}});
var Future = Npm.require("fibers/future");                                                                             // 1
                                                                                                                       // 2
                                                                                                                       //
// At a minimum, set up LDAP_DEFAULTS.url and .dn according to                                                         //
// your needs. url should appear as 'ldap://your.url.here'                                                             //
// dn should appear in normal ldap format of comma separated attribute=value                                           //
// e.g. 'uid=someuser,cn=users,dc=somevalue'                                                                           //
LDAP_DEFAULTS = {                                                                                                      // 8
  url: false,                                                                                                          // 9
  port: "389",                                                                                                         // 10
  dn: false,                                                                                                           // 11
  searchDN: false,                                                                                                     // 12
  searchCredentials: false,                                                                                            // 13
  createNewUser: true,                                                                                                 // 14
  defaultDomain: false,                                                                                                // 15
  searchResultsProfileMap: false,                                                                                      // 16
  base: null,                                                                                                          // 17
  search: "(objectclass=*)",                                                                                           // 18
  ldapsCertificate: false                                                                                              // 19
};                                                                                                                     // 8
                                                                                                                       //
/**                                                                                                                    //
 @class LDAP                                                                                                           //
 @constructor                                                                                                          //
 */                                                                                                                    //
function LDAP() {                                                                                                      // 26
  // Set options                                                                                                       //
  this.options = _.clone(LDAP_DEFAULTS);                                                                               // 28
};                                                                                                                     // 29
                                                                                                                       //
/**                                                                                                                    //
 * Attempt to bind (authenticate) ldap                                                                                 //
 * and perform a dn search if specified                                                                                //
 *                                                                                                                     //
 * @method ldapCheck                                                                                                   //
 *                                                                                                                     //
 * @param {Object} options  Object with username, ldapPass and overrides for LDAP_DEFAULTS object.                     //
 * Additionally the searchBeforeBind parameter can be specified, which is used to search for the DN                    //
 * if not provided.                                                                                                    //
 */                                                                                                                    //
LDAP.prototype.ldapCheck = function (db, options) {                                                                    // 41
                                                                                                                       //
  var _this = this;                                                                                                    // 43
                                                                                                                       //
  options = options || {};                                                                                             // 45
                                                                                                                       //
  if (options.hasOwnProperty("username") && options.hasOwnProperty("ldapPass") || options.hasOwnProperty("searchUsername")) {
    var _ret = function () {                                                                                           // 48
      _this.options.base = db.getLdapBase();                                                                           // 49
      _this.options.url = db.getLdapUrl();                                                                             // 50
      _this.options.searchBeforeBind = {};                                                                             // 51
      _this.options.searchBeforeBind[db.getLdapSearchUsername()] = options.searchUsername || options.username;         // 52
      _this.options.filter = db.getLdapFilter() || "(objectclass=*)";                                                  // 54
      _this.options.searchBindDn = db.getLdapSearchBindDn();                                                           // 55
      _this.options.searchBindPassword = db.getLdapSearchBindPassword();                                               // 56
                                                                                                                       //
      var resolved = false;                                                                                            // 58
      var ldapAsyncFut = new Future();                                                                                 // 59
                                                                                                                       //
      // Create ldap client                                                                                            //
      var fullUrl = db.getLdapUrl();                                                                                   // 62
      var client = null;                                                                                               // 63
                                                                                                                       //
      var errorFunc = function errorFunc(err) {                                                                        // 65
        if (err) {                                                                                                     // 66
          if (resolved) return;                                                                                        // 67
          resolved = true;                                                                                             // 68
          ldapAsyncFut["return"]({                                                                                     // 69
            error: err                                                                                                 // 70
          });                                                                                                          // 69
        }                                                                                                              // 72
      };                                                                                                               // 73
                                                                                                                       //
      if (fullUrl.indexOf("ldaps://") === 0) {                                                                         // 75
        client = ldapjs.createClient({                                                                                 // 76
          url: fullUrl,                                                                                                // 77
          tlsOptions: {                                                                                                // 78
            ca: [_this.options.ldapsCertificate]                                                                       // 79
          }                                                                                                            // 78
        }, errorFunc);                                                                                                 // 76
      } else {                                                                                                         // 82
        client = ldapjs.createClient({                                                                                 // 83
          url: fullUrl                                                                                                 // 84
        }, errorFunc);                                                                                                 // 83
      }                                                                                                                // 86
                                                                                                                       //
      client.on("error", errorFunc);                                                                                   // 88
                                                                                                                       //
      var username = options.username;                                                                                 // 90
      var domain = _this.options.defaultDomain;                                                                        // 91
                                                                                                                       //
      if (!options.hasOwnProperty("searchUsername")) {                                                                 // 93
        // Slide @xyz.whatever from username if it was passed in                                                       //
        // and replace it with the domain specified in defaults                                                        //
        var emailSliceIndex = options.username.indexOf("@");                                                           // 96
                                                                                                                       //
        // If user appended email domain, strip it out                                                                 //
        // And use the defaults.defaultDomain if set                                                                   //
        if (emailSliceIndex !== -1) {                                                                                  // 100
          username = options.username.substring(0, emailSliceIndex);                                                   // 101
          domain = domain || options.username.substring(emailSliceIndex + 1, options.username.length);                 // 102
        } else {                                                                                                       // 103
          username = options.username;                                                                                 // 104
        }                                                                                                              // 105
      }                                                                                                                // 106
                                                                                                                       //
      if (_this.options.searchBindDn) {                                                                                // 108
        var _ret2 = function () {                                                                                      // 108
          var ldapBindFut = new Future();                                                                              // 109
          client.bind(_this.options.searchBindDn, _this.options.searchBindPassword, function (err) {                   // 110
            if (err) {                                                                                                 // 112
              ldapBindFut["throw"](err);                                                                               // 113
            } else {                                                                                                   // 114
              ldapBindFut["return"]();                                                                                 // 115
            }                                                                                                          // 116
          });                                                                                                          // 117
                                                                                                                       //
          try {                                                                                                        // 120
            ldapBindFut.wait();                                                                                        // 121
          } catch (err) {                                                                                              // 122
            return {                                                                                                   // 123
              v: {                                                                                                     // 123
                v: { error: err }                                                                                      // 123
              }                                                                                                        // 123
            };                                                                                                         // 123
          }                                                                                                            // 124
        }();                                                                                                           // 108
                                                                                                                       //
        if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                // 108
      }                                                                                                                // 125
      // initialize result                                                                                             //
      var retObject = {                                                                                                // 127
        username: username,                                                                                            // 128
        email: domain ? username + "@" + domain : false,                                                               // 129
        emptySearch: true,                                                                                             // 130
        searchResults: {}                                                                                              // 131
      };                                                                                                               // 127
                                                                                                                       //
      var filter = _this.options.filter;                                                                               // 134
      Object.keys(_this.options.searchBeforeBind).forEach(function (searchKey) {                                       // 135
        filter = "&" + filter + "(" + searchKey + "=" + _this.options.searchBeforeBind[searchKey] + ")";               // 136
      });                                                                                                              // 137
                                                                                                                       //
      var searchOptions = {                                                                                            // 139
        scope: "sub",                                                                                                  // 140
        sizeLimit: 1,                                                                                                  // 141
        filter: filter                                                                                                 // 142
      };                                                                                                               // 139
                                                                                                                       //
      // perform LDAP search to determine DN                                                                           //
      client.search(_this.options.base, searchOptions, function (err, res) {                                           // 146
        if (err) {                                                                                                     // 147
          if (resolved) return;                                                                                        // 148
          resolved = true;                                                                                             // 149
          ldapAsyncFut["return"]({                                                                                     // 150
            error: err                                                                                                 // 151
          });                                                                                                          // 150
          return;                                                                                                      // 153
        }                                                                                                              // 154
                                                                                                                       //
        retObject.emptySearch = true;                                                                                  // 156
        res.on("searchEntry", function (entry) {                                                                       // 157
          retObject.dn = entry.objectName;                                                                             // 158
          retObject.username = retObject.dn;                                                                           // 159
          retObject.emptySearch = false;                                                                               // 160
                                                                                                                       //
          retObject.searchResults = _.omit(entry.object, "userPassword");                                              // 162
                                                                                                                       //
          if (options.hasOwnProperty("searchUsername")) {                                                              // 164
            // This was only a search, return immediately                                                              //
            resolved = true;                                                                                           // 166
            ldapAsyncFut["return"](retObject);                                                                         // 167
            return;                                                                                                    // 168
          }                                                                                                            // 169
                                                                                                                       //
          // use the determined DN to bind                                                                             //
          client.bind(entry.objectName, options.ldapPass, function (err) {                                             // 172
            try {                                                                                                      // 173
              if (err) {                                                                                               // 174
                throw new Meteor.Error(err.code, err.message);                                                         // 175
              } else {                                                                                                 // 176
                resolved = true;                                                                                       // 177
                ldapAsyncFut["return"](retObject);                                                                     // 178
              }                                                                                                        // 179
            } catch (e) {                                                                                              // 180
              if (resolved) return;                                                                                    // 182
              resolved = true;                                                                                         // 183
              ldapAsyncFut["return"]({                                                                                 // 184
                error: e                                                                                               // 185
              });                                                                                                      // 184
            }                                                                                                          // 187
          });                                                                                                          // 188
        });                                                                                                            // 189
                                                                                                                       //
        res.on("error", errorFunc);                                                                                    // 191
                                                                                                                       //
        // If no dn is found, return as is.                                                                            //
        res.on("end", function (result) {                                                                              // 194
          if (retObject.dn === undefined) {                                                                            // 195
            resolved = true;                                                                                           // 196
            ldapAsyncFut["return"](retObject);                                                                         // 197
          }                                                                                                            // 198
        });                                                                                                            // 199
      });                                                                                                              // 200
                                                                                                                       //
      return {                                                                                                         // 202
        v: ldapAsyncFut.wait()                                                                                         // 202
      };                                                                                                               // 202
    }();                                                                                                               // 48
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 48
  } else {                                                                                                             // 204
    throw new Meteor.Error(403, "Missing LDAP Auth Parameter");                                                        // 205
  }                                                                                                                    // 206
};                                                                                                                     // 208
                                                                                                                       //
LDAP.prototype.updateUserQuota = function (db, user) {                                                                 // 210
  var fallback = {                                                                                                     // 211
    storage: user.cachedStorageQuota || 0,                                                                             // 212
    grains: Infinity,                                                                                                  // 213
    compute: Infinity                                                                                                  // 214
  };                                                                                                                   // 211
                                                                                                                       //
  var setting = db.collections.settings.findOne({ _id: "quotaLdapAttribute" });                                        // 217
  if (!setting) return fallback;                                                                                       // 218
                                                                                                                       //
  // TODO(someday): don't just assume the first login identity is the primary identity?                                //
  var email = db.getPrimaryEmail(user._id, user.loginIdentities[0].id);                                                // 221
  if (!email) return fallback;                                                                                         // 222
                                                                                                                       //
  var ldapUser = void 0;                                                                                               // 224
  try {                                                                                                                // 225
    ldapUser = this.ldapCheck(db, { searchUsername: email });                                                          // 226
  } catch (err) {                                                                                                      // 227
    console.error("Error looking up quota from LDAP");                                                                 // 228
    return fallback;                                                                                                   // 229
  }                                                                                                                    // 230
                                                                                                                       //
  if (!ldapUser || !ldapUser.searchResults) return fallback;                                                           // 232
                                                                                                                       //
  var newStorageQuota = +ldapUser.searchResults[setting.value];                                                        // 234
  if (newStorageQuota !== user.cachedStorageQuota) {                                                                   // 235
    Meteor.users.update({ _id: user._id }, { $set: { cachedStorageQuota: newStorageQuota } });                         // 236
  }                                                                                                                    // 237
                                                                                                                       //
  // TODO(someday): cache timestamp as well and only check/update if greater than 60s ago                              //
  return {                                                                                                             // 240
    storage: newStorageQuota,                                                                                          // 241
    grains: Infinity,                                                                                                  // 242
    compute: Infinity                                                                                                  // 243
  };                                                                                                                   // 240
};                                                                                                                     // 245
                                                                                                                       //
                                                                                                                       // 247
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"picture.js":["meteor/http",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/picture.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({userPictureUrl:function(){return userPictureUrl},fetchPicture:function(){return fetchPicture}});var HTTP;module.import("meteor/http",{"HTTP":function(v){HTTP=v}});
                                                                                                                       //
var userPictureUrl = function userPictureUrl(user) {                                                                   // 3
  if (user.services && !(user.profile && user.profile.picture)) {                                                      // 4
    // Try to determine user's avatar URL from login service.                                                          //
                                                                                                                       //
    var google = user.services.google;                                                                                 // 7
    if (google && google.picture) {                                                                                    // 8
      return google.picture;                                                                                           // 9
    }                                                                                                                  // 10
                                                                                                                       //
    var github = user.services.github;                                                                                 // 12
    if (github && github.id) {                                                                                         // 13
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                   // 14
    }                                                                                                                  // 15
                                                                                                                       //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                      //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                          //
    // Github are different because they are actually the identity providers, so they already know                     //
    // the user logged in.                                                                                             //
  }                                                                                                                    // 21
};                                                                                                                     // 22
                                                                                                                       //
var fetchPicture = function fetchPicture(db, url) {                                                                    // 24
  try {                                                                                                                // 25
    var result = HTTP.get(url, {                                                                                       // 26
      npmRequestOptions: { encoding: null },                                                                           // 27
      timeout: 5000                                                                                                    // 28
    });                                                                                                                // 26
                                                                                                                       //
    var metadata = {};                                                                                                 // 31
                                                                                                                       //
    metadata.mimeType = result.headers["content-type"];                                                                // 33
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                  // 36
    }                                                                                                                  // 37
                                                                                                                       //
    var enc = result.headers["content-encoding"];                                                                      // 39
    if (enc && enc !== "identity") {                                                                                   // 40
      metadata.encoding = enc;                                                                                         // 41
    }                                                                                                                  // 42
                                                                                                                       //
    return db.addStaticAsset(metadata, result.content);                                                                // 44
  } catch (err) {                                                                                                      // 45
    console.error("failed to fetch user profile picture:", url, err.stack);                                            // 46
  }                                                                                                                    // 47
};                                                                                                                     // 48
                                                                                                                       //
                                                                                                                       // 50
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"saml-utils.js":["crypto","querystring","url","xml2js","xmlbuilder","xml-crypto","xmldom","zlib",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/saml-utils.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SAML:function(){return SAML}});var crypto;module.import("crypto",{"default":function(v){crypto=v}});var querystring;module.import("querystring",{"default":function(v){querystring=v}});var Url;module.import("url",{"default":function(v){Url=v}});var xml2js;module.import("xml2js",{"default":function(v){xml2js=v}});var xmlbuilder;module.import("xmlbuilder",{"default":function(v){xmlbuilder=v}});var xmlCrypto;module.import("xml-crypto",{"default":function(v){xmlCrypto=v}});var xmldom;module.import("xmldom",{"default":function(v){xmldom=v}});var zlib;module.import("zlib",{"default":function(v){zlib=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 10
                                                                                                                       //
var SAML = function SAML(options) {                                                                                    // 12
  this.options = this.initialize(options);                                                                             // 13
};                                                                                                                     // 14
                                                                                                                       //
SAML.prototype.initialize = function (options) {                                                                       // 16
  if (!options) {                                                                                                      // 17
    options = {};                                                                                                      // 18
  }                                                                                                                    // 19
                                                                                                                       //
  if (!options.protocol) {                                                                                             // 21
    options.protocol = "https://";                                                                                     // 22
  }                                                                                                                    // 23
                                                                                                                       //
  if (!options.path) {                                                                                                 // 25
    options.path = "/saml/consume";                                                                                    // 26
  }                                                                                                                    // 27
                                                                                                                       //
  if (!options.issuer) {                                                                                               // 29
    options.issuer = "onelogin_saml";                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (options.identifierFormat === undefined) {                                                                        // 33
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  return options;                                                                                                      // 37
};                                                                                                                     // 38
                                                                                                                       //
SAML.prototype.generateUniqueID = function () {                                                                        // 40
  var chars = "abcdef0123456789";                                                                                      // 41
  var uniqueID = "";                                                                                                   // 42
  for (var i = 0; i < 20; i++) {                                                                                       // 43
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                       // 44
  }                                                                                                                    // 45
                                                                                                                       //
  return uniqueID;                                                                                                     // 47
};                                                                                                                     // 48
                                                                                                                       //
SAML.prototype.generateInstant = function () {                                                                         // 50
  var date = new Date();                                                                                               // 51
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                     // 53
                                                                                                                       //
SAML.prototype.signRequest = function (xml) {                                                                          // 55
  var signer = crypto.createSign("RSA-SHA1");                                                                          // 56
  signer.update(xml);                                                                                                  // 57
  return signer.sign(this.options.privateCert, "base64");                                                              // 58
};                                                                                                                     // 59
                                                                                                                       //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                             // 61
  var id = "_" + this.generateUniqueID();                                                                              // 62
  var instant = this.generateInstant();                                                                                // 63
                                                                                                                       //
  var callbackUrl = void 0;                                                                                            // 65
  // Post-auth destination                                                                                             //
  if (this.options.callbackUrl) {                                                                                      // 67
    callbackUrl = this.options.callbackUrl;                                                                            // 68
  } else {                                                                                                             // 69
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                        // 70
  }                                                                                                                    // 71
                                                                                                                       //
  if (this.options.id) id = this.options.id;                                                                           // 73
                                                                                                                       //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                       //
  if (this.options.identifierFormat) {                                                                                 // 82
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                    // 85
                                                                                                                       //
  request += "<samlp:RequestedAuthnContext xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Comparison=\"exact\">" + "<saml:AuthnContextClassRef xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" + "</saml:AuthnContextClassRef>" + "</samlp:RequestedAuthnContext>\n" + "</samlp:AuthnRequest>";
                                                                                                                       //
  return request;                                                                                                      // 95
};                                                                                                                     // 96
                                                                                                                       //
SAML.prototype.generateLogoutRequest = function (req) {                                                                // 98
  var id = "_" + this.generateUniqueID();                                                                              // 99
  var instant = this.generateInstant();                                                                                // 100
                                                                                                                       //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                   //
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                        //
                                                                                                                       //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                      // 114
};                                                                                                                     // 115
                                                                                                                       //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                                // 117
  var _this = this;                                                                                                    // 118
  zlib.deflateRaw(request, function (err, buffer) {                                                                    // 119
    if (err) {                                                                                                         // 120
      return callback(err);                                                                                            // 121
    }                                                                                                                  // 122
                                                                                                                       //
    var base64 = buffer.toString("base64");                                                                            // 124
    var target = _this.options.entryPoint;                                                                             // 125
                                                                                                                       //
    if (operation === "logout") {                                                                                      // 127
      if (_this.options.logoutUrl) {                                                                                   // 128
        target = _this.options.logoutUrl;                                                                              // 129
      }                                                                                                                // 130
    }                                                                                                                  // 131
                                                                                                                       //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                     // 133
                                                                                                                       //
    var samlRequest = {                                                                                                // 138
      SAMLRequest: base64                                                                                              // 139
    };                                                                                                                 // 138
                                                                                                                       //
    if (_this.options.privateCert) {                                                                                   // 142
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                               // 143
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                   // 144
    }                                                                                                                  // 145
                                                                                                                       //
    target += querystring.stringify(samlRequest);                                                                      // 147
                                                                                                                       //
    callback(null, target);                                                                                            // 149
  });                                                                                                                  // 150
};                                                                                                                     // 151
                                                                                                                       //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                            // 153
  var request = this.generateAuthorizeRequest(req);                                                                    // 154
                                                                                                                       //
  this.requestToUrl(request, "authorize", callback);                                                                   // 156
};                                                                                                                     // 157
                                                                                                                       //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                               // 159
  var request = this.generateLogoutRequest(req);                                                                       // 160
                                                                                                                       //
  this.requestToUrl(request, "logout", callback);                                                                      // 162
};                                                                                                                     // 163
                                                                                                                       //
SAML.prototype.certToPEM = function (cert) {                                                                           // 165
  cert = cert.match(/.{1,64}/g).join("\n");                                                                            // 166
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                       // 167
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                       // 168
  return cert;                                                                                                         // 169
};                                                                                                                     // 170
                                                                                                                       //
SAML.prototype.validateSignature = function (xml, cert) {                                                              // 172
  var _this = this;                                                                                                    // 173
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                               // 174
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                                 // 176
  sig.keyInfoProvider = {                                                                                              // 177
    getKeyInfo: function getKeyInfo(key) {                                                                             // 178
      return "<X509Data></X509Data>";                                                                                  // 179
    },                                                                                                                 // 180
                                                                                                                       //
    getKey: function getKey(keyInfo) {                                                                                 // 182
      return _this.certToPEM(cert);                                                                                    // 183
    }                                                                                                                  // 184
  };                                                                                                                   // 177
  sig.loadSignature(signature.toString());                                                                             // 186
  return sig.checkSignature(xml);                                                                                      // 187
};                                                                                                                     // 188
                                                                                                                       //
SAML.prototype.getElement = function (parentElement, elementName) {                                                    // 190
  if (parentElement["saml:" + elementName]) {                                                                          // 191
    return parentElement["saml:" + elementName];                                                                       // 192
  } else if (parentElement["samlp:" + elementName]) {                                                                  // 193
    return parentElement["samlp:" + elementName];                                                                      // 194
  } else if (parentElement["saml2p:" + elementName]) {                                                                 // 195
    return parentElement["saml2p:" + elementName];                                                                     // 196
  } else if (parentElement["saml2:" + elementName]) {                                                                  // 197
    return parentElement["saml2:" + elementName];                                                                      // 198
  }                                                                                                                    // 199
                                                                                                                       //
  return parentElement[elementName];                                                                                   // 201
};                                                                                                                     // 202
                                                                                                                       //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                                  // 204
  var _this = this;                                                                                                    // 205
  var xml = new Buffer(samlResponse, "base64").toString("utf8");                                                       // 206
  var parser = new xml2js.Parser({ explicitRoot: true });                                                              // 207
  parser.parseString(xml, function (err, doc) {                                                                        // 208
    // Verify signature                                                                                                //
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                     // 210
      return callback(new Error("Invalid signature"), null, false);                                                    // 211
    }                                                                                                                  // 212
                                                                                                                       //
    var response = _this.getElement(doc, "Response");                                                                  // 214
    if (response) {                                                                                                    // 215
      var assertion = _this.getElement(response, "Assertion");                                                         // 216
      if (!assertion) {                                                                                                // 217
        return callback(new Error("Missing SAML assertion"), null, false);                                             // 218
      }                                                                                                                // 219
                                                                                                                       //
      profile = {};                                                                                                    // 221
                                                                                                                       //
      if (response.$ && response.$.InResponseTo) {                                                                     // 223
        profile.inResponseToId = response.$.InResponseTo;                                                              // 224
      }                                                                                                                // 225
                                                                                                                       //
      if (response.$ && response.$.Destination) {                                                                      // 227
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                                // 228
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination));    // 229
        }                                                                                                              // 231
      }                                                                                                                // 232
                                                                                                                       //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                           // 234
      if (issuer) {                                                                                                    // 235
        profile.issuer = issuer[0];                                                                                    // 236
      }                                                                                                                // 237
                                                                                                                       //
      var subject = _this.getElement(assertion[0], "Subject");                                                         // 239
      if (subject) {                                                                                                   // 240
        var nameID = _this.getElement(subject[0], "NameID");                                                           // 241
        if (nameID) {                                                                                                  // 242
          profile.nameID = nameID[0]._;                                                                                // 243
                                                                                                                       //
          if (nameID[0].$.Format) {                                                                                    // 245
            profile.nameIDFormat = nameID[0].$.Format;                                                                 // 246
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                      // 247
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."));
            }                                                                                                          // 251
          }                                                                                                            // 252
        }                                                                                                              // 253
                                                                                                                       //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                                 // 255
        if (subjectConfirmation) {                                                                                     // 256
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];        // 257
          if (subjectConfirmationData) {                                                                               // 259
            var recipient = subjectConfirmationData.$.Recipient;                                                       // 260
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                            // 261
              return callback(new Error("SAML sent to wrong recipient"));                                              // 262
            }                                                                                                          // 263
                                                                                                                       //
            var nowMs = Date.now();                                                                                    // 265
            var notBefore = subjectConfirmationData.$.NotBefore;                                                       // 266
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                          // 267
              return callback(new Error("SAML assertion was signed for the future."));                                 // 268
            }                                                                                                          // 269
                                                                                                                       //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                                 // 271
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                   // 272
              return callback(new Error("SAML assertion was signed for the past."));                                   // 273
            }                                                                                                          // 274
          }                                                                                                            // 275
        }                                                                                                              // 276
      }                                                                                                                // 277
                                                                                                                       //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                                // 279
      if (conditions) {                                                                                                // 280
        for (var key in conditions) {                                                                                  // 281
          if (conditions.hasOwnProperty(key)) {                                                                        // 282
            var value = conditions[key];                                                                               // 283
            if (key === "$") {                                                                                         // 284
              var _nowMs = Date.now();                                                                                 // 285
              var _notBefore = value.NotBefore;                                                                        // 286
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                     // 287
                return callback(new Error("SAML condition NotBefore is in the future."));                              // 288
              }                                                                                                        // 289
                                                                                                                       //
              var _notOnOrAfter = value.NotOnOrAfter;                                                                  // 291
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                              // 292
                return callback(new Error("SAML condition notOnOrAfter is in the past."));                             // 293
              }                                                                                                        // 294
            } else if (key.endsWith("AudienceRestriction") || key.endsWith("OneTimeUse") || key.endsWith("ProxyRestriction")) {
              continue;                                                                                                // 298
              // Do nothing.                                                                                           //
              // We already check both Destination and SubjectConfirmation.Recipient, so                               //
              // the Audience constraint isn't as important, and is tricky to handle                                   //
              // correctly.                                                                                            //
              // OneTimeUse is actually very tricky to get right, and requires a cache of                              //
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                           //
              // we would probably need to stuff it in Mongo to make it robust across multiple                         //
              // front-ends. It is a very rarely used constraint anyways.                                              //
              // ProxyRestriction constraints only govern the future use of the assertion by the                       //
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                         //
              // spec, it is always considered valid.                                                                  //
            } else {                                                                                                   // 310
                return callback(new Error("Unrecognized SAML constraint: " + key));                                    // 311
              }                                                                                                        // 312
          }                                                                                                            // 313
        }                                                                                                              // 314
      }                                                                                                                // 315
                                                                                                                       //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                   // 317
      if (attributeStatement) {                                                                                        // 318
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                         // 319
                                                                                                                       //
        if (attributes) {                                                                                              // 321
          attributes.forEach(function (attribute) {                                                                    // 322
            var value = _this.getElement(attribute, "AttributeValue");                                                 // 323
            if (typeof value[0] === "string") {                                                                        // 324
              profile[attribute.$.Name] = value[0];                                                                    // 325
            } else {                                                                                                   // 326
              profile[attribute.$.Name] = value[0]._;                                                                  // 327
            }                                                                                                          // 328
          });                                                                                                          // 329
        }                                                                                                              // 330
                                                                                                                       //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                           // 332
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs              //
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                                 // 334
        }                                                                                                              // 335
                                                                                                                       //
        if (!profile.email && profile.mail) {                                                                          // 337
          profile.email = profile.mail;                                                                                // 338
        }                                                                                                              // 339
                                                                                                                       //
        var microsoftEmail = profile["http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress"];            // 341
        if (!profile.email && microsoftEmail) {                                                                        // 342
          profile.email = microsoftEmail;                                                                              // 343
        }                                                                                                              // 344
                                                                                                                       //
        var microsoftDisplayName = profile["http://schemas.microsoft.com/identity/claims/displayname"];                // 346
        if (!profile.displayName && microsoftDisplayName) {                                                            // 347
          profile.displayName = microsoftDisplayName;                                                                  // 348
        }                                                                                                              // 349
      }                                                                                                                // 350
                                                                                                                       //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                                // 353
      }                                                                                                                // 354
                                                                                                                       //
      callback(null, profile, false);                                                                                  // 356
    } else {                                                                                                           // 357
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                    // 358
                                                                                                                       //
      if (logoutResponse) {                                                                                            // 360
        callback(null, null, true);                                                                                    // 361
      } else {                                                                                                         // 362
        return callback(new Error("Unknown SAML response message"), null, false);                                      // 363
      }                                                                                                                // 364
    }                                                                                                                  // 366
  });                                                                                                                  // 368
};                                                                                                                     // 369
                                                                                                                       //
SAML.prototype.generateServiceProviderMetadata = function () {                                                         // 371
  var entityId = this.options.issuer;                                                                                  // 372
  var metadata = {                                                                                                     // 373
    "EntityDescriptor": {                                                                                              // 374
      "@xmlns": "urn:oasis:names:tc:SAML:2.0:metadata",                                                                // 375
      "@xmlns:ds": "http://www.w3.org/2000/09/xmldsig#",                                                               // 376
      "@entityID": entityId,                                                                                           // 377
      "@ID": entityId.replace(/\W/g, "_"),                                                                             // 378
      "SPSSODescriptor": {                                                                                             // 379
        "@protocolSupportEnumeration": "urn:oasis:names:tc:SAML:2.0:protocol"                                          // 380
      }                                                                                                                // 379
    }                                                                                                                  // 374
  };                                                                                                                   // 373
                                                                                                                       //
  var decryptionCert = this.options.localCertPublic; // TODO(someday); support local certs                             // 385
  if (decryptionCert) {                                                                                                // 386
    decryptionCert = decryptionCert.replace(/-+BEGIN CERTIFICATE-+\r?\n?/, "");                                        // 387
    decryptionCert = decryptionCert.replace(/-+END CERTIFICATE-+\r?\n?/, "");                                          // 388
    decryptionCert = decryptionCert.replace(/\r\n/g, "\n");                                                            // 389
                                                                                                                       //
    metadata.EntityDescriptor.SPSSODescriptor.KeyDescriptor = {                                                        // 391
      "ds:KeyInfo": {                                                                                                  // 392
        "ds:X509Data": {                                                                                               // 393
          "ds:X509Certificate": {                                                                                      // 394
            "#text": decryptionCert                                                                                    // 395
          }                                                                                                            // 394
        }                                                                                                              // 393
      },                                                                                                               // 392
      "EncryptionMethod": [                                                                                            // 399
      // this should be the set that the xmlenc library supports                                                       //
      { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes256-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes128-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#tripledes-cbc" }]
    };                                                                                                                 // 391
  }                                                                                                                    // 406
                                                                                                                       //
  if (this.options.logoutCallbackUrl) {                                                                                // 408
    metadata.EntityDescriptor.SPSSODescriptor.SingleLogoutService = {                                                  // 409
      "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                    // 410
      "@Location": this.options.logoutCallbackUrl                                                                      // 411
    };                                                                                                                 // 409
  }                                                                                                                    // 413
                                                                                                                       //
  metadata.EntityDescriptor.SPSSODescriptor.NameIDFormat = this.options.identifierFormat;                              // 415
  metadata.EntityDescriptor.SPSSODescriptor.AssertionConsumerService = {                                               // 416
    "@index": "1",                                                                                                     // 417
    "@isDefault": "true",                                                                                              // 418
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                      // 419
    "@Location": Meteor.absoluteUrl("_saml/validate/default")                                                          // 420
  };                                                                                                                   // 416
                                                                                                                       //
  return xmlbuilder.create(metadata).end({ pretty: true, indent: "  ", newline: "\n" });                               // 423
};                                                                                                                     // 424
                                                                                                                       //
                                                                                                                       // 426
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"async-helpers.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/async-helpers.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({inMeteor:function(){return inMeteor},promiseToFuture:function(){return promiseToFuture},waitPromise:function(){return waitPromise},onInMeteor:function(){return onInMeteor}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 3
                                                                                                                       //
var inMeteorListener = undefined;                                                                                      // 5
var onInMeteor = function onInMeteor(callback) {                                                                       // 6
  inMeteorListener = callback;                                                                                         // 7
};                                                                                                                     // 8
                                                                                                                       //
// Meteor context <-> Async Node.js context adapters                                                                   //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 11
  callback();                                                                                                          // 12
});                                                                                                                    // 13
                                                                                                                       //
var inMeteor = function inMeteor(callback) {                                                                           // 15
  if (inMeteorListener) {                                                                                              // 16
    inMeteorListener();                                                                                                // 17
  }                                                                                                                    // 18
                                                                                                                       //
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 21
    inMeteorInternal(function () {                                                                                     // 22
      try {                                                                                                            // 23
        resolve(callback());                                                                                           // 24
      } catch (err) {                                                                                                  // 25
        reject(err);                                                                                                   // 26
      }                                                                                                                // 27
    });                                                                                                                // 28
  });                                                                                                                  // 29
};                                                                                                                     // 30
                                                                                                                       //
var promiseToFuture = function promiseToFuture(promise) {                                                              // 32
  var result = new Future();                                                                                           // 33
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 34
  return result;                                                                                                       // 35
};                                                                                                                     // 36
                                                                                                                       //
var waitPromise = function waitPromise(promise) {                                                                      // 38
  return promiseToFuture(promise).wait();                                                                              // 39
};                                                                                                                     // 40
                                                                                                                       //
                                                                                                                       // 42
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"auth.js":["meteor/meteor","meteor/check","crypto","fs","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var SANDSTORM_VARDIR;module.import("/imports/server/constants.js",{"SANDSTORM_VARDIR":function(v){SANDSTORM_VARDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 8
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 9
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 11
  if (tokenIsSetupSession(token)) {                                                                                    // 12
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 13
    globalDb.collections.setupSession.remove({                                                                         // 14
      _id: "current-session",                                                                                          // 15
      hashedSessionId: hash                                                                                            // 16
    });                                                                                                                // 14
  }                                                                                                                    // 18
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 20
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 21
    console.log("Admin token deleted.");                                                                               // 22
  }                                                                                                                    // 23
}                                                                                                                      // 24
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 26
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 27
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 28
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 29
    if (stats.mtime < expireTime) {                                                                                    // 30
      return false;                                                                                                    // 31
    } else {                                                                                                           // 32
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 33
    }                                                                                                                  // 34
  } else {                                                                                                             // 35
    return false;                                                                                                      // 36
  }                                                                                                                    // 37
}                                                                                                                      // 38
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 40
  if (token) {                                                                                                         // 41
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 42
    if (setupSession) {                                                                                                // 43
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 44
      var now = new Date();                                                                                            // 45
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 46
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 47
        return true;                                                                                                   // 48
      }                                                                                                                // 49
    }                                                                                                                  // 50
  }                                                                                                                    // 51
                                                                                                                       //
  return false;                                                                                                        // 53
}                                                                                                                      // 54
                                                                                                                       //
function checkAuth(token) {                                                                                            // 56
  check(token, Match.OneOf(undefined, null, String));                                                                  // 57
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 58
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 59
  }                                                                                                                    // 60
}                                                                                                                      // 61
                                                                                                                       //
                                                                                                                       // 63
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backend.js":["babel-runtime/helpers/classCallCheck","/imports/server/constants.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/backend.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SandstormBackend:function(){return SandstormBackend},shouldRestartGrain:function(){return shouldRestartGrain}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});var inMeteor,promiseToFuture,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"promiseToFuture":function(v){promiseToFuture=v},"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 20
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 21
var Crypto = Npm.require("crypto");                                                                                    // 22
                                                                                                                       //
var storageUsageUnimplemented = false;                                                                                 // 24
                                                                                                                       //
function generateSessionId(grainId, userId, packageSalt, clientSalt) {                                                 // 26
  var sessionParts = [grainId, clientSalt];                                                                            // 27
  if (userId) {                                                                                                        // 28
    sessionParts.push(userId);                                                                                         // 29
  }                                                                                                                    // 30
                                                                                                                       //
  if (packageSalt) {                                                                                                   // 32
    sessionParts.push(packageSalt);                                                                                    // 33
  }                                                                                                                    // 34
                                                                                                                       //
  var sessionInput = sessionParts.join(":");                                                                           // 36
  return Crypto.createHash("sha256").update(sessionInput).digest("hex");                                               // 37
}                                                                                                                      // 38
                                                                                                                       //
var shouldRestartGrain = function shouldRestartGrain(error, retryCount) {                                              // 40
  // Given an error thrown by an RPC call to a grain, return whether or not it makes sense to try                      //
  // to restart the grain and retry. `retryCount` is the number of times that the request has                          //
  // already gone through this cycle (should be zero for the first call).                                              //
  return error.kjType === "disconnected" && retryCount < 1;                                                            // 44
};                                                                                                                     // 45
                                                                                                                       //
var SandstormBackend = function () {                                                                                   //
  function SandstormBackend(db, backendCap) {                                                                          // 48
    _classCallCheck(this, SandstormBackend);                                                                           // 48
                                                                                                                       //
    this._db = db;                                                                                                     // 49
    this._backendCap = backendCap;                                                                                     // 50
  }                                                                                                                    // 51
                                                                                                                       //
  SandstormBackend.prototype.cap = function cap() {                                                                    //
    return this._backendCap;                                                                                           // 54
  };                                                                                                                   // 55
                                                                                                                       //
  SandstormBackend.prototype.deleteUser = function deleteUser(userId) {                                                //
    return waitPromise(this._backendCap.deleteUser());                                                                 // 58
  };                                                                                                                   // 59
                                                                                                                       //
  SandstormBackend.prototype.shutdownGrain = function shutdownGrain(grainId, ownerId, keepSessions) {                  //
    if (!keepSessions) {                                                                                               // 62
      Sessions.remove({ grainId: grainId });                                                                           // 63
    }                                                                                                                  // 64
                                                                                                                       //
    var grain = this._backendCap.getGrain(ownerId, grainId).supervisor;                                                // 66
    return grain.shutdown().then(function () {                                                                         // 67
      grain.close();                                                                                                   // 68
      throw new Error("expected shutdown() to throw disconnected");                                                    // 69
    }, function (err) {                                                                                                // 70
                                                                                                                       //
      grain.close();                                                                                                   // 72
      if (err.kjType !== "disconnected") {                                                                             // 73
        throw err;                                                                                                     // 74
      }                                                                                                                // 75
    });                                                                                                                // 76
  };                                                                                                                   // 77
                                                                                                                       //
  SandstormBackend.prototype.deleteGrain = function deleteGrain(grainId, ownerId) {                                    //
    // We leave it up to the caller if they want to actually wait, but some don't so we report                         //
    // exceptions.                                                                                                     //
    return this._backendCap.deleteGrain(ownerId, grainId)["catch"](function (err) {                                    // 82
      console.error("problem deleting grain " + grainId + ":", err.message);                                           // 83
      throw err;                                                                                                       // 84
    });                                                                                                                // 85
  };                                                                                                                   // 86
                                                                                                                       //
  SandstormBackend.prototype.maybeRetryUseGrain = function maybeRetryUseGrain(grainId, cb, retryCount, err) {          //
    var _this = this;                                                                                                  // 88
                                                                                                                       //
    if (shouldRestartGrain(err, retryCount)) {                                                                         // 89
      return inMeteor(function () {                                                                                    // 90
        return cb(_this.continueGrain(grainId).supervisor)["catch"](_this.maybeRetryUseGrain.bind(_this, grainId, cb, retryCount + 1));
      });                                                                                                              // 93
    } else {                                                                                                           // 94
      throw err;                                                                                                       // 95
    }                                                                                                                  // 96
  };                                                                                                                   // 97
                                                                                                                       //
  SandstormBackend.prototype.useGrain = function useGrain(grainId, cb) {                                               //
    var _this2 = this;                                                                                                 // 99
                                                                                                                       //
    // This will open a grain for you, handling restarts if needed, and call the passed function with                  //
    // the supervisor capability as the only parameter. The callback must return a promise that used                   //
    // the supervisor, so that we can check if a disconnect error occurred, and retry if possible.                     //
    // This function returns the same promise that your callback returns.                                              //
    //                                                                                                                 //
    // This function is NOT expected to be run in a meteor context.                                                    //
    return inMeteor(function () {                                                                                      // 106
      return cb(_this2.continueGrain(grainId).supervisor)["catch"](_this2.maybeRetryUseGrain.bind(_this2, grainId, cb, 0));
    });                                                                                                                // 109
  };                                                                                                                   // 110
                                                                                                                       //
  SandstormBackend.prototype.continueGrain = function continueGrain(grainId) {                                         //
    var grain = Grains.findOne(grainId);                                                                               // 113
    if (!grain) {                                                                                                      // 114
      throw new Meteor.Error(404, "Grain Not Found", "Grain ID: " + grainId);                                          // 115
    }                                                                                                                  // 116
                                                                                                                       //
    // If a DevPackage with the same app ID is currently active, we let it override the installed                      //
    // package, so that the grain runs using the dev app.                                                              //
    var devPackage = DevPackages.findOne({ appId: grain.appId });                                                      // 120
    var isDev = void 0;                                                                                                // 121
    var mountProc = void 0;                                                                                            // 122
    var pkg = void 0;                                                                                                  // 123
    if (devPackage) {                                                                                                  // 124
      isDev = true;                                                                                                    // 125
      pkg = devPackage;                                                                                                // 126
      mountProc = pkg.mountProc;                                                                                       // 127
    } else {                                                                                                           // 128
      pkg = Packages.findOne(grain.packageId);                                                                         // 129
      if (!pkg) {                                                                                                      // 130
        throw new Meteor.Error(500, "Grain's package not installed", "Package ID: " + grain.packageId);                // 131
      }                                                                                                                // 133
    }                                                                                                                  // 134
                                                                                                                       //
    var manifest = pkg.manifest;                                                                                       // 136
    var packageId = pkg._id;                                                                                           // 137
                                                                                                                       //
    if (!("continueCommand" in manifest)) {                                                                            // 139
      throw new Meteor.Error(500, "Package manifest defines no continueCommand.", "Package ID: " + packageId);         // 140
    }                                                                                                                  // 142
                                                                                                                       //
    var result = this.startGrainInternal(packageId, grainId, grain.userId, manifest.continueCommand, false, isDev, mountProc);
    result.packageSalt = isDev ? pkg._id : grain.packageSalt;                                                          // 146
    return result;                                                                                                     // 147
  };                                                                                                                   // 148
                                                                                                                       //
  SandstormBackend.prototype.startGrainInternal = function startGrainInternal(packageId, grainId, ownerId, command, isNew, isDev, mountProc) {
    // Starts the grain supervisor.  Must be executed in a Meteor context.  Blocks until grain is                      //
    // started. Returns a promise for an object containing two fields: `owner` (the ID of the owning                   //
    // user) and `supervisor` (the supervisor capability).                                                             //
                                                                                                                       //
    if (isUserExcessivelyOverQuota(Meteor.users.findOne(ownerId))) {                                                   // 155
      throw new Meteor.Error(402, "Cannot start grain because owner's storage is exhausted.\n" + "Please ask them to upgrade.");
    }                                                                                                                  // 159
                                                                                                                       //
    // Ugly: Stay backwards-compatible with old manifests that had "executablePath" and "args" rather                  //
    //   than just "argv".                                                                                             //
    if ("args" in command) {                                                                                           // 163
      if (!("argv" in command)) {                                                                                      // 164
        command.argv = command.args;                                                                                   // 165
      }                                                                                                                // 166
                                                                                                                       //
      delete command.args;                                                                                             // 168
    }                                                                                                                  // 169
                                                                                                                       //
    if ("executablePath" in command) {                                                                                 // 171
      if (!("deprecatedExecutablePath" in command)) {                                                                  // 172
        command.deprecatedExecutablePath = command.executablePath;                                                     // 173
      }                                                                                                                // 174
                                                                                                                       //
      delete command.executablePath;                                                                                   // 176
    }                                                                                                                  // 177
                                                                                                                       //
    return this._backendCap.startGrain(ownerId, grainId, packageId, command, isNew, isDev, mountProc);                 // 179
  };                                                                                                                   // 180
                                                                                                                       //
  SandstormBackend.prototype.updateLastActive = function updateLastActive(grainId, userId, identityId) {               //
    // Update the lastActive date on the grain, any relevant API tokens, and the user,                                 //
    // and also update the user's storage usage.                                                                       //
                                                                                                                       //
    var storagePromise = undefined;                                                                                    // 186
    if (this._db.isQuotaEnabled() && !storageUsageUnimplemented) {                                                     // 187
      storagePromise = this._backendCap.getUserStorageUsage(userId);                                                   // 188
    }                                                                                                                  // 189
                                                                                                                       //
    var now = new Date();                                                                                              // 191
    if (Grains.update(grainId, { $set: { lastUsed: now } }) === 0) {                                                   // 192
      // Grain must have been deleted. Ignore.                                                                         //
      return;                                                                                                          // 194
    }                                                                                                                  // 195
                                                                                                                       //
    if (userId) {                                                                                                      // 197
      Meteor.users.update(userId, { $set: { lastActive: now } });                                                      // 198
    }                                                                                                                  // 199
                                                                                                                       //
    if (identityId) {                                                                                                  // 201
      Meteor.users.update({ _id: identityId }, { $set: { lastActive: now } });                                         // 202
      // Update any API tokens that match this user/grain pairing as well                                              //
      ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: { lastUsed: now } }, { multi: true });
    }                                                                                                                  // 207
                                                                                                                       //
    if (storagePromise) {                                                                                              // 209
      try {                                                                                                            // 210
        var ownerId = Grains.findOne(grainId).userId;                                                                  // 211
        var size = parseInt(waitPromise(storagePromise).size);                                                         // 212
        Meteor.users.update(ownerId, { $set: { storageUsage: size } });                                                // 213
        // TODO(security): Consider actively killing grains if the user is excessively over quota?                     //
        //   Otherwise a constantly-active grain could consume arbitrary space without being stopped.                  //
      } catch (err) {                                                                                                  // 216
        if (err.kjType === "unimplemented") {                                                                          // 217
          storageUsageUnimplemented = true;                                                                            // 218
        } else {                                                                                                       // 219
          console.error("error getting user storage usage:", err.stack);                                               // 220
        }                                                                                                              // 221
      }                                                                                                                // 222
    }                                                                                                                  // 223
  };                                                                                                                   // 224
                                                                                                                       //
  SandstormBackend.prototype.openSessionInternal = function openSessionInternal(grainId, userId, identityId, title, apiToken, cachedSalt) {
    // Start the grain if it is not running. This is an optimization: if we didn't start it here,                      //
    // it would start on the first request to the session host, but we'd like to get started before                    //
    // the round trip.                                                                                                 //
                                                                                                                       //
    var _continueGrain = this.continueGrain(grainId);                                                                  // 226
                                                                                                                       //
    var supervisor = _continueGrain.supervisor;                                                                        // 226
    var packageSalt = _continueGrain.packageSalt;                                                                      // 226
                                                                                                                       //
                                                                                                                       //
    this.updateLastActive(grainId, userId, identityId);                                                                // 232
                                                                                                                       //
    cachedSalt = cachedSalt || Random.id(22);                                                                          // 234
    var sessionId = generateSessionId(grainId, userId, packageSalt, cachedSalt);                                       // 235
    var session = Sessions.findOne({ _id: sessionId });                                                                // 236
    if (session) {                                                                                                     // 237
      // TODO(someday): also do some more checks for anonymous sessions (sessions without a userId).                   //
      if (session.identityId && session.identityId !== identityId || session.grainId !== grainId) {                    // 239
        var e = new Meteor.Error(500, "Duplicate SessionId");                                                          // 241
        console.error(e);                                                                                              // 242
        throw e;                                                                                                       // 243
      } else {                                                                                                         // 244
        return {                                                                                                       // 245
          supervisor: supervisor,                                                                                      // 246
          methodResult: {                                                                                              // 247
            sessionId: session._id,                                                                                    // 248
            title: title,                                                                                              // 249
            grainId: grainId,                                                                                          // 250
            hostId: session.hostId,                                                                                    // 251
            tabId: session.tabId,                                                                                      // 252
            salt: cachedSalt                                                                                           // 253
          }                                                                                                            // 247
        };                                                                                                             // 245
      }                                                                                                                // 256
    }                                                                                                                  // 257
                                                                                                                       //
    // TODO(someday): Allow caller to specify the parent session from which to inherit the tab ID, or                  //
    //   something.                                                                                                    //
                                                                                                                       //
    session = {                                                                                                        // 262
      _id: sessionId,                                                                                                  // 263
      grainId: grainId,                                                                                                // 264
      hostId: Crypto.createHash("sha256").update(sessionId).digest("hex").slice(0, 32),                                // 265
      tabId: Crypto.createHash("sha256").update("tab:").update(sessionId).digest("hex").slice(0, 32),                  // 266
      timestamp: new Date().getTime(),                                                                                 // 267
      hasLoaded: false                                                                                                 // 268
    };                                                                                                                 // 262
                                                                                                                       //
    if (userId) {                                                                                                      // 271
      session.identityId = identityId;                                                                                 // 272
      session.userId = userId;                                                                                         // 273
    } else if (apiToken) {                                                                                             // 274
      session.hashedToken = apiToken._id;                                                                              // 275
    } else {}                                                                                                          // 276
    // Must be old-style sharing, i.e. !grain.private.                                                                 //
    // jscs:ignore disallowEmptyBlocks                                                                                 //
                                                                                                                       //
    Sessions.insert(session);                                                                                          // 280
                                                                                                                       //
    return {                                                                                                           // 282
      supervisor: supervisor,                                                                                          // 283
      methodResult: {                                                                                                  // 284
        sessionId: session._id,                                                                                        // 285
        title: title,                                                                                                  // 286
        grainId: grainId,                                                                                              // 287
        hostId: session.hostId,                                                                                        // 288
        tabId: session.tabId,                                                                                          // 289
        salt: cachedSalt                                                                                               // 290
      }                                                                                                                // 284
    };                                                                                                                 // 282
  };                                                                                                                   // 293
                                                                                                                       //
  return SandstormBackend;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 294
                                                                                                                       //
                                                                                                                       // 296
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"constants.js":["meteor/meteor","url",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/constants.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SANDSTORM_ALTHOME:function(){return SANDSTORM_ALTHOME},SANDSTORM_LOGDIR:function(){return SANDSTORM_LOGDIR},SANDSTORM_VARDIR:function(){return SANDSTORM_VARDIR},staticAssetHost:function(){return staticAssetHost}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Url;module.import("url",{"default":function(v){Url=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
                                                                                                                       //
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       //
var SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                       // 22
var SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                         // 23
var SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                   // 24
                                                                                                                       //
// TODO: dedupe this and the equivalent copy in sandstorm-db                                                           //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 27
                                                                                                                       //
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + wildcardHost[0] + "static" + wildcardHost[1];  // 29
                                                                                                                       //
                                                                                                                       // 31
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications.js":["meteor/check",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/desktop-notifications.js                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({createAppActivityDesktopNotification:function(){return createAppActivityDesktopNotification}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var createAppActivityDesktopNotification = function createAppActivityDesktopNotification(options) {                    // 19
  check(options, {                                                                                                     // 20
    userId: String,                                                                                                    // 21
    notificationId: String,                                                                                            // 22
    appActivity: {                                                                                                     // 23
      user: {                                                                                                          // 24
        identityId: String,                                                                                            // 25
        name: String,                                                                                                  // 26
        avatarUrl: String                                                                                              // 27
      },                                                                                                               // 24
      grainId: String,                                                                                                 // 29
      path: String,                                                                                                    // 30
      body: Match.ObjectIncluding({                                                                                    // 31
        defaultText: String                                                                                            // 32
      }),                                                                                                              // 31
      actionText: Match.ObjectIncluding({                                                                              // 34
        defaultText: String                                                                                            // 35
      })                                                                                                               // 34
    }                                                                                                                  // 23
  });                                                                                                                  // 20
                                                                                                                       //
  globalDb.collections.desktopNotifications.insert({                                                                   // 40
    userId: options.userId,                                                                                            // 41
    notificationId: options.notificationId,                                                                            // 42
    creationDate: new Date(),                                                                                          // 43
    appActivity: options.appActivity                                                                                   // 44
  });                                                                                                                  // 40
};                                                                                                                     // 46
                                                                                                                       //
                                                                                                                       // 48
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"email.js":["meteor/meteor","nodemailer","nodemailer-smtp-pool",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/email.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({send:function(){return send},rawSend:function(){return rawSend}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var nodemailer;module.import("nodemailer",{"default":function(v){nodemailer=v}});var smtpPool;module.import("nodemailer-smtp-pool",{"default":function(v){smtpPool=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 5
                                                                                                                       //
var getSmtpConfig = function getSmtpConfig() {                                                                         // 7
  var config = Settings.findOne({ _id: "smtpConfig" });                                                                // 8
  return config && config.value;                                                                                       // 9
};                                                                                                                     // 10
                                                                                                                       //
var makePool = function makePool(mailConfig) {                                                                         // 12
  var auth = false;                                                                                                    // 13
  if (mailConfig.auth && (mailConfig.auth.user || mailConfig.auth.pass)) {                                             // 14
    auth = mailConfig.auth;                                                                                            // 15
  }                                                                                                                    // 16
                                                                                                                       //
  var secure = mailConfig.port === 465;                                                                                // 18
  var tlsOptions = {                                                                                                   // 19
    // Previously, node 0.10 did not attempt to validate certificates received when connecting                         //
    // with STARTTLS, so to avoid regressing we need to preserve that behavior here for now.                           //
    rejectUnauthorized: false                                                                                          // 22
  };                                                                                                                   // 19
                                                                                                                       //
  var pool = nodemailer.createTransport(smtpPool({                                                                     // 25
    host: mailConfig.hostname,                                                                                         // 26
    port: mailConfig.port,                                                                                             // 27
    secure: secure,                                                                                                    // 28
    tls: tlsOptions,                                                                                                   // 29
    auth: auth                                                                                                         // 30
  }));                                                                                                                 // 25
                                                                                                                       //
  // TODO(someday): allow maxConnections to be configured?                                                             //
  pool._futureWrappedSendMail = _.bind(Future.wrap(pool.sendMail), pool);                                              // 34
  return pool;                                                                                                         // 35
};                                                                                                                     // 36
                                                                                                                       //
// We construct the SMTP pool at the first call to Email.send, so that                                                 //
// other code like migrations can modify the SMTP configuration.                                                       //
var pool = void 0;                                                                                                     // 40
var configured = false;                                                                                                // 41
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 43
  Settings.find({ _id: "smtpConfig" }).observeChanges({                                                                // 44
    removed: function removed() {                                                                                      // 45
      configured = false;                                                                                              // 46
    },                                                                                                                 // 47
                                                                                                                       //
    changed: function changed() {                                                                                      // 49
      configured = false;                                                                                              // 50
    },                                                                                                                 // 51
                                                                                                                       //
    added: function added() {                                                                                          // 53
      configured = false;                                                                                              // 54
    }                                                                                                                  // 55
  });                                                                                                                  // 44
});                                                                                                                    // 57
                                                                                                                       //
var getPool = function getPool(smtpConfig) {                                                                           // 59
  if (smtpConfig) {                                                                                                    // 60
    return makePool(smtpConfig);                                                                                       // 61
  } else if (!configured) {                                                                                            // 62
    configured = true;                                                                                                 // 63
    var config = getSmtpConfig();                                                                                      // 64
    if (config) {                                                                                                      // 65
      pool = makePool(config);                                                                                         // 66
    }                                                                                                                  // 67
  }                                                                                                                    // 68
                                                                                                                       //
  return pool;                                                                                                         // 70
};                                                                                                                     // 71
                                                                                                                       //
var smtpSend = function smtpSend(pool, mailOptions) {                                                                  // 73
  pool._futureWrappedSendMail(mailOptions).wait();                                                                     // 74
};                                                                                                                     // 75
                                                                                                                       //
var rawSend = function rawSend(mailOptions, smtpConfig) {                                                              // 77
  // Sends an email mailOptions object structured as described in                                                      //
  // https://github.com/nodemailer/mailcomposer#e-mail-message-fields                                                  //
  // across the transport described by smtpConfig.                                                                     //
  var pool = getPool(smtpConfig);                                                                                      // 81
  if (pool) {                                                                                                          // 82
    smtpSend(pool, mailOptions);                                                                                       // 83
  } else {                                                                                                             // 84
    throw new Error("SMTP pool is misconfigured.");                                                                    // 85
  }                                                                                                                    // 86
};                                                                                                                     // 87
                                                                                                                       //
// Old comment below                                                                                                   //
/**                                                                                                                    //
 * Send an email.                                                                                                      //
 *                                                                                                                     //
 * Connects to the mail server configured via the MAIL_URL environment                                                 //
 * variable. If unset, prints formatted message to stdout. The "from" option                                           //
 * is required, and at least one of "to", "cc", and "bcc" must be provided;                                            //
 * all other options are optional.                                                                                     //
 *                                                                                                                     //
 * @param options                                                                                                      //
 * @param options.from {String} RFC5322 "From:" address                                                                //
 * @param options.to {String|String[]} RFC5322 "To:" address[es]                                                       //
 * @param options.cc {String|String[]} RFC5322 "Cc:" address[es]                                                       //
 * @param options.bcc {String|String[]} RFC5322 "Bcc:" address[es]                                                     //
 * @param options.replyTo {String|String[]} RFC5322 "Reply-To:" address[es]                                            //
 * @param options.subject {String} RFC5322 "Subject:" line                                                             //
 * @param options.text {String} RFC5322 mail body (plain text)                                                         //
 * @param options.html {String} RFC5322 mail body (HTML)                                                               //
 * @param options.headers {Object} custom RFC5322 headers (dictionary)                                                 //
 */                                                                                                                    //
                                                                                                                       //
// New API doc comment below                                                                                           //
/**                                                                                                                    //
 * @summary Send an email. Throws an `Error` on failure to contact mail server                                         //
 * or if mail server returns an error. All fields should match                                                         //
 * [RFC5322](http://tools.ietf.org/html/rfc5322) specification.                                                        //
 * @locus Server                                                                                                       //
 * @param {Object} options                                                                                             //
 * @param {String} options.from "From:" address (required)                                                             //
 * @param {String|String[]} options.to,cc,bcc,replyTo                                                                  //
 *   "To:", "Cc:", "Bcc:", and "Reply-To:" addresses                                                                   //
 * @param {String} [options.subject]  "Subject:" line                                                                  //
 * @param {String} [options.text|html] Mail body (in plain text or HTML)                                               //
 * @param {Object} [options.headers] Dictionary of custom headers                                                      //
 * @param {Object} [options.smtpConfig] SMTP server to use. Otherwise defaults to configured one.                      //
 * @param {String} [options.smtpConfig.hostname] SMTP server hostname.                                                 //
 * @param {Number} [options.smtpConfig.port] SMTP server port.                                                         //
 * @param {Object} [options.smtpConfig.auth] SMTP server authentication tokens.  Optional.                             //
 * @param {String} [options.smtpConfig.auth.user] Username of user to log in to SMTP server as.  Optional.             //
 * @param {String} [options.smtpConfig.auth.pass] Password of user to log in to SMTP server as.  Optional.             //
 * @param {Object} [options.attachments] Attachments. See:                                                             //
 *   https://github.com/nodemailer/mailcomposer/tree/v0.1.15#add-attachments                                           //
 * @param {String} [options.envelopeFrom] Envelope sender.                                                             //
 */                                                                                                                    //
var send = function send(options) {                                                                                    // 133
  // Unpack options                                                                                                    //
  var from = options.from;                                                                                             // 133
  var to = options.to;                                                                                                 // 133
  var cc = options.cc;                                                                                                 // 133
  var bcc = options.bcc;                                                                                               // 133
  var replyTo = options.replyTo;                                                                                       // 133
  var subject = options.subject;                                                                                       // 133
  var text = options.text;                                                                                             // 133
  var html = options.html;                                                                                             // 133
  var envelopeFrom = options.envelopeFrom;                                                                             // 133
  var headers = options.headers;                                                                                       // 133
  var attachments = options.attachments;                                                                               // 133
  var smtpConfig = options.smtpConfig;                                                                                 // 133
                                                                                                                       //
                                                                                                                       //
  var opts = {                                                                                                         // 150
    from: from,                                                                                                        // 151
    to: to,                                                                                                            // 152
    cc: cc,                                                                                                            // 153
    bcc: bcc,                                                                                                          // 154
    replyTo: replyTo,                                                                                                  // 155
    subject: subject,                                                                                                  // 156
    text: text,                                                                                                        // 157
    html: html,                                                                                                        // 158
    headers: headers,                                                                                                  // 159
    attachments: attachments                                                                                           // 160
  };                                                                                                                   // 150
                                                                                                                       //
  if (envelopeFrom) {                                                                                                  // 163
    opts.envelope = {                                                                                                  // 164
      from: envelopeFrom,                                                                                              // 165
      to: to,                                                                                                          // 166
      cc: cc,                                                                                                          // 167
      bcc: bcc                                                                                                         // 168
    };                                                                                                                 // 164
  }                                                                                                                    // 170
                                                                                                                       //
  rawSend(opts, smtpConfig);                                                                                           // 172
};                                                                                                                     // 173
                                                                                                                       //
                                                                                                                       // 175
                                                                                                                       //
// TODO(cleanup): Remove this once BlackrockPayments code finds a better way to import it.                             //
global.SandstormEmail = { send: send };                                                                                // 178
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"frontend-ref.js":["babel-runtime/helpers/classCallCheck","./persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/frontend-ref.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({FrontendRefRegistry:function(){return FrontendRefRegistry}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var checkRequirements;module.import("./persistent.js",{"checkRequirements":function(v){checkRequirements=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var FrontendRefRegistry = function () {                                                                                //
  function FrontendRefRegistry() {                                                                                     // 20
    _classCallCheck(this, FrontendRefRegistry);                                                                        // 20
                                                                                                                       //
    this._frontendRefHandlers = {};                                                                                    // 21
    this._typeIdHandlers = {};                                                                                         // 22
  }                                                                                                                    // 23
                                                                                                                       //
  FrontendRefRegistry.prototype.create = function create(db, frontendRef, requirements) {                              //
    // Construct a fresh capability based on a `frontendRef` value.                                                    //
                                                                                                                       //
    checkRequirements(requirements);                                                                                   // 28
                                                                                                                       //
    var saveTemplate = { frontendRef: frontendRef };                                                                   // 30
    if (requirements) {                                                                                                // 31
      saveTemplate.requirements = requirements;                                                                        // 32
    }                                                                                                                  // 33
                                                                                                                       //
    return this.restore(db, saveTemplate, frontendRef);                                                                // 35
  };                                                                                                                   // 36
                                                                                                                       //
  FrontendRefRegistry.prototype.restore = function restore(db, saveTemplate, frontendRef) {                            //
    // Restores a frontendRef capability using the appropriate registered handler.                                     //
                                                                                                                       //
    var keys = Object.keys(frontendRef);                                                                               // 41
    if (keys.length != 1) {                                                                                            // 42
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var key = keys[0];                                                                                                 // 46
    var handler = this._frontendRefHandlers[key];                                                                      // 47
    if (!handler) {                                                                                                    // 48
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return handler.restore(db, saveTemplate, frontendRef[key]);                                                        // 52
  };                                                                                                                   // 53
                                                                                                                       //
  FrontendRefRegistry.prototype.query = function query(db, userAccountId, tag) {                                       //
    // Performs a powerbox query using the appropriate registered handler.                                             //
                                                                                                                       //
    var handler = this._typeIdHandlers[tag.id];                                                                        // 58
    if (handler) {                                                                                                     // 59
      return handler.query(db, userAccountId, tag.value);                                                              // 60
    } else {                                                                                                           // 61
      return []; // no matches                                                                                         // 62
    }                                                                                                                  // 63
  };                                                                                                                   // 64
                                                                                                                       //
  FrontendRefRegistry.prototype.validate = function validate(db, session, mutableFrontendRef) {                        //
    // Validates a powerbox request on the given `session` (a record from the Sessions table)                          //
    // requesting the creation of the given frontendRef type. `mutableFrontendRef` is expected to                      //
    // come directly from the client; calling validate() verifies that it has a valid type, and                        //
    // may modify the value to add bits that need to be generated server-side. `validate()` also                       //
    // returns an array of MembraneRequirements that shall apply to the capability. These                              //
    // requirements will not yet have been checked, so the caller should check them before                             //
    // proceeding.                                                                                                     //
                                                                                                                       //
    var keys = Object.keys(mutableFrontendRef);                                                                        // 75
    if (keys.length != 1) {                                                                                            // 76
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 77
    }                                                                                                                  // 78
                                                                                                                       //
    var key = keys[0];                                                                                                 // 80
    var handler = this._frontendRefHandlers[key];                                                                      // 81
    if (!handler) {                                                                                                    // 82
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 83
    }                                                                                                                  // 84
                                                                                                                       //
    if (!handler.validate) {                                                                                           // 86
      throw new Error("frontendRef type cannot be created via powerbox: " + JSON.stringify(mutableFrontendRef));       // 87
    }                                                                                                                  // 89
                                                                                                                       //
    return handler.validate(db, session, mutableFrontendRef[key]);                                                     // 91
  };                                                                                                                   // 92
                                                                                                                       //
  FrontendRefRegistry.prototype.register = function register(object) {                                                 //
    // Register callbacks related to a particular frontendRef type. The object has the fields:                         //
    //   `frontendRefField`: Name of the field of `ApiTokens.frontendRef` that is filled in for                        //
    //       this type. Only needed if `create` and/or `validate` handlers are defined.                                //
    //   `typeId`: Type ID of powerbox tags handled by the `query` callback. Stringified decimal                       //
    //       64-bit integer. Only needed if `query` is defined.                                                        //
    //   `restore`: Callback to construct a capability of this type when restoring a saved                             //
    //       capability. Has signature `(db, saveTemplate, value) -> capability`, where:                               //
    //     `value`: The value of the single field of `ApiTokens.frontendRef` for this capability.                      //
    //     `saveTemplate`: The token template to pass to the PersistentImpl constructor.                               //
    //     `capability` (returned): A Cap'n Proto capability implementing SystemPersistent along                       //
    //         with whatever other interfaces are appropriate for the ref type.                                        //
    //   `validate`: Callback to validate a powerbox request for a new capability of this type.                        //
    //       Has signature `(db, session, mutableValue) -> {descriptor, requirements}`, where:                         //
    //     `mutableValue` is the value of the single field of `frontendRef` for this capability.                       //
    //         If this is an object value, the callback may optionally modify it, e.g. adding                          //
    //         additional fields that need to be generated server-side. The callback *must*, at                        //
    //         the very least, type-check this value. It should throw an exception if the vaule is                     //
    //         not valid.                                                                                              //
    //     `session` is the record from the Sessions table of the UI session where the powerbox                        //
    //         request occurred.                                                                                       //
    //     `descriptor` (returned) is the JSON-encoded PowerboxDescriptor for the capability. Note                     //
    //         that if the descriptor contains any `tag.value`s, they of course need to be                             //
    //         presented as capnp-encoded Buffers.                                                                     //
    //     `requirements` (returned) is an array of MembraneRequirements which should apply to the                     //
    //         new capability. Note that these requirements will be checked immediately and the                        //
    //         powerbox request will fail if they aren't met.                                                          //
    //    `query`: Callback to populate options for a powerbox request for this type ID. Has                           //
    //        signature `(db, userAccountId, tagValue) -> options`, where:                                             //
    //      `tagValue`: A Buffer of the Cap'n-Proto-encoded `PowerboxDescriptor.Tag.value`.                            //
    //      `options` (returned): An array of objects representing the options that should be                          //
    //          offered to the user for this query. See the `powerboxOptions` Meteor publish in                        //
    //          powerbox-server.js for a full description of the fields of each option.                                //
                                                                                                                       //
    if (object.frontendRefField) {                                                                                     // 128
      if (object.frontendRefField in this._frontendRefHandlers) {                                                      // 129
        throw new Error("frontendRef handler already registered: " + object.frontendRefField);                         // 130
      }                                                                                                                // 131
                                                                                                                       //
      this._frontendRefHandlers[object.frontendRefField] = object;                                                     // 133
    }                                                                                                                  // 134
                                                                                                                       //
    if (object.typeId) {                                                                                               // 136
      if (object.typeId in this._typeIdHandlers) {                                                                     // 137
        throw new Error("typeId handler already registered: " + object.typeId);                                        // 138
      }                                                                                                                // 139
                                                                                                                       //
      this._typeIdHandlers[object.typeId] = object;                                                                    // 141
    }                                                                                                                  // 142
  };                                                                                                                   // 143
                                                                                                                       //
  return FrontendRefRegistry;                                                                                          //
}();                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 146
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"migrations.js":["meteor/meteor","meteor/underscore","meteor/check","/imports/server/accounts/picture.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/migrations.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({migrateToLatest:function(){return migrateToLatest}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var _;module.import("meteor/underscore",{"_":function(v){_=v}});var Match;module.import("meteor/check",{"Match":function(v){Match=v}});var userPictureUrl,fetchPicture;module.import("/imports/server/accounts/picture.js",{"userPictureUrl":function(v){userPictureUrl=v},"fetchPicture":function(v){fetchPicture=v}});var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});// Minimal tooling for doing run-at-least-once, ordered migrations.
//                                                                                                                     //
// Because migrations can experience partial failure and likely have                                                   //
// side-effects, we should be careful to make sure all migrations are                                                  //
// idempotent and safe to accidentally run multiple times.                                                             //
                                                                                                                       //
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       // 9
                                                                                                                       // 10
                                                                                                                       // 11
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 13
var Url = Npm.require("url");                                                                                          // 14
var Crypto = Npm.require("crypto");                                                                                    // 15
                                                                                                                       //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect(db, backend) {                                    // 17
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 18
  ["google", "github"].forEach(function (serviceName) {                                                                // 19
    var config = configurations.findOne({ service: serviceName });                                                     // 20
    if (config && config.loginStyle !== "redirect") {                                                                  // 21
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                           // 22
    }                                                                                                                  // 23
  });                                                                                                                  // 24
};                                                                                                                     // 25
                                                                                                                       //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings(db, backend) {      // 27
  // In the before time, Google and Github login were enabled by default.                                              //
  //                                                                                                                   //
  // This actually didn't make much sense, required the first user to configure                                        //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                          //
  // secure.                                                                                                           //
  //                                                                                                                   //
  // Now, we have admin-token, so we wish to disable all logins by default                                             //
  // (since they need to be configured anyway) but since users may have never                                          //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                          //
  // we can't just use the value in the Settings collection, since it might                                            //
  // never have been set.                                                                                              //
  //                                                                                                                   //
  // Thus, if the service is configured but absent from Settings, we should                                            //
  // explicitly enable it in Settings, and then the rest of the logic can just                                         //
  // depend on what value is in Settings and default to false without breaking                                         //
  // user installations.                                                                                               //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 44
  ["google", "github"].forEach(function (serviceName) {                                                                // 45
    var config = configurations.findOne({ service: serviceName });                                                     // 46
    var serviceConfig = db.collections.settings.findOne({ _id: serviceName });                                         // 47
    if (config && !serviceConfig) {                                                                                    // 48
      // Only explicitly enable the login service if:                                                                  //
      // 1) the service is already configured                                                                          //
      // 2) there is no sandstorm configuration already present (the user was                                          //
      //    using the previous default behavior).                                                                      //
      db.collections.settings.insert({ _id: serviceName, value: true });                                               // 53
    }                                                                                                                  // 54
  });                                                                                                                  // 55
};                                                                                                                     // 56
                                                                                                                       //
var denormalizeInviteInfo = function denormalizeInviteInfo(db, backend) {                                              // 58
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                        //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                    //
  // which has more information about the key, namely a freeform note entered by the admin when                        //
  // they created the key. In the case that the email invite form was used, the note has the form                      //
  // "E-mail invite to <address>".                                                                                     //
  //                                                                                                                   //
  // Later, we decided it was useful to indicate in the users table visible to the admin                               //
  // information about the invite terms. Namely, for email invites we want to show the address                         //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                          //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                        //
  // from the SignupKeys table.                                                                                        //
                                                                                                                       //
  db.collections.users.find().forEach(function (user) {                                                                // 71
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                          // 72
      var signupInfo = db.collections.signupKeys.findOne(user.signupKey);                                              // 73
      if (signupInfo && signupInfo.note) {                                                                             // 74
        var newFields = { signupNote: signupInfo.note };                                                               // 75
                                                                                                                       //
        var prefix = "E-mail invite to ";                                                                              // 77
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                               // 78
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                                // 79
        }                                                                                                              // 80
                                                                                                                       //
        db.collections.users.update(user._id, { $set: newFields });                                                    // 82
      }                                                                                                                // 83
    }                                                                                                                  // 84
  });                                                                                                                  // 85
};                                                                                                                     // 86
                                                                                                                       //
var mergeRoleAssignmentsIntoApiTokens = function mergeRoleAssignmentsIntoApiTokens(db, backend) {                      // 88
  db.collections.roleAssignments.find().forEach(function (roleAssignment) {                                            // 89
    db.collections.apiTokens.insert({                                                                                  // 90
      grainId: roleAssignment.grainId,                                                                                 // 91
      userId: roleAssignment.sharer,                                                                                   // 92
      roleAssignment: roleAssignment.roleAssignment,                                                                   // 93
      petname: roleAssignment.petname,                                                                                 // 94
      created: roleAssignment.created,                                                                                 // 95
      owner: {                                                                                                         // 96
        user: {                                                                                                        // 97
          userId: roleAssignment.recipient,                                                                            // 98
          title: roleAssignment.title                                                                                  // 99
        }                                                                                                              // 97
      }                                                                                                                // 96
    });                                                                                                                // 90
  });                                                                                                                  // 103
};                                                                                                                     // 104
                                                                                                                       //
var fixOasisStorageUsageStats = function fixOasisStorageUsageStats(db, backend) {};                                    // 106
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                     //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                      //
// with a no-op.                                                                                                       //
                                                                                                                       //
var fetchProfilePictures = function fetchProfilePictures(db, backend) {                                                // 111
  db.collections.users.find({}).forEach(function (user) {                                                              // 112
    var url = userPictureUrl(user);                                                                                    // 113
    if (url) {                                                                                                         // 114
      console.log("Fetching user picture:", url);                                                                      // 115
      var assetId = fetchPicture(db, url);                                                                             // 116
      if (assetId) {                                                                                                   // 117
        db.collections.users.update(user._id, { $set: { "profile.picture": assetId } });                               // 118
      }                                                                                                                // 119
    }                                                                                                                  // 120
  });                                                                                                                  // 121
};                                                                                                                     // 122
                                                                                                                       //
var assignPlans = function assignPlans(db, backend) {                                                                  // 124
  // This was a one-time migration intended to be applied on Oasis to existing users.                                  //
  // It has run, so we only need this stub function here.                                                              //
};                                                                                                                     // 127
                                                                                                                       //
var removeKeyrings = function removeKeyrings(db, backend) {                                                            // 129
  // These blobs full of public keys were not intended to find their way into mongo and while                          //
  // harmless they slow things down because they're huge. Remove them.                                                 //
  db.collections.packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
};                                                                                                                     // 135
                                                                                                                       //
var useLocalizedTextInUserActions = function useLocalizedTextInUserActions(db, backend) {                              // 137
  function toLocalizedText(newObj, oldObj, field) {                                                                    // 138
    if (field in oldObj) {                                                                                             // 139
      if (typeof oldObj[field] === "string") {                                                                         // 140
        newObj[field] = { defaultText: oldObj[field] };                                                                // 141
      } else {                                                                                                         // 142
        newObj[field] = oldObj[field];                                                                                 // 143
      }                                                                                                                // 144
    }                                                                                                                  // 145
  }                                                                                                                    // 146
                                                                                                                       //
  db.collections.userActions.find({}).forEach(function (userAction) {                                                  // 148
    var fields = {};                                                                                                   // 149
    toLocalizedText(fields, userAction, "appTitle");                                                                   // 150
    toLocalizedText(fields, userAction, "title");                                                                      // 151
    toLocalizedText(fields, userAction, "nounPhrase");                                                                 // 152
    db.collections.userActions.update(userAction._id, { $set: fields });                                               // 153
  });                                                                                                                  // 154
};                                                                                                                     // 155
                                                                                                                       //
var verifyAllPgpSignatures = function verifyAllPgpSignatures(db, backend) {                                            // 157
  db.collections.packages.find({}).forEach(function (pkg) {                                                            // 158
    try {                                                                                                              // 159
      console.log("checking PGP signature for package:", pkg._id);                                                     // 160
      var info = waitPromise(backend.cap().tryGetPackage(pkg._id));                                                    // 161
      if (info.authorPgpKeyFingerprint) {                                                                              // 162
        console.log("  " + info.authorPgpKeyFingerprint);                                                              // 163
        db.collections.packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });  // 164
      } else {                                                                                                         // 166
        console.log("  no signature");                                                                                 // 167
      }                                                                                                                // 168
    } catch (err) {                                                                                                    // 169
      console.error(err.stack);                                                                                        // 170
    }                                                                                                                  // 171
  });                                                                                                                  // 172
};                                                                                                                     // 173
                                                                                                                       //
var splitUserIdsIntoAccountIdsAndIdentityIds = function splitUserIdsIntoAccountIdsAndIdentityIds(db, backend) {        // 175
  db.collections.users.find().forEach(function (user) {                                                                // 176
    var identity = {};                                                                                                 // 177
    var serviceUserId = void 0;                                                                                        // 178
    if ("devName" in user) {                                                                                           // 179
      identity.service = "dev";                                                                                        // 180
      serviceUserId = user.devName;                                                                                    // 181
    } else if ("expires" in user) {                                                                                    // 182
      identity.service = "demo";                                                                                       // 183
      serviceUserId = user._id;                                                                                        // 184
    } else if (user.services && "google" in user.services) {                                                           // 185
      identity.service = "google";                                                                                     // 186
      if (user.services.google.email && user.services.google.verified_email) {                                         // 187
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                          //
        identity.verifiedEmail = user.services.google.email;                                                           // 188
      }                                                                                                                // 189
                                                                                                                       //
      serviceUserId = user.services.google.id;                                                                         // 191
    } else if (user.services && "github" in user.services) {                                                           // 192
      identity.service = "github";                                                                                     // 193
      identity.unverifiedEmail = user.services.github.email;                                                           // 194
      serviceUserId = user.services.github.id;                                                                         // 195
    } else if (user.services && "emailToken" in user.services) {                                                       // 196
      identity.service = "emailToken";                                                                                 // 197
      identity.verifiedEmail = user.services.emailToken.email;                                                         // 198
      serviceUserId = user.services.emailToken.email;                                                                  // 199
    }                                                                                                                  // 200
                                                                                                                       //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");            // 202
                                                                                                                       //
    if (user.profile) {                                                                                                // 205
      if (user.profile.name) {                                                                                         // 206
        identity.name = user.profile.name;                                                                             // 207
      }                                                                                                                // 208
                                                                                                                       //
      if (user.profile.handle) {                                                                                       // 210
        identity.handle = user.profile.handle;                                                                         // 211
      }                                                                                                                // 212
                                                                                                                       //
      if (user.profile.picture) {                                                                                      // 214
        identity.picture = user.profile.picture;                                                                       // 215
      }                                                                                                                // 216
                                                                                                                       //
      if (user.profile.pronoun) {                                                                                      // 218
        identity.pronoun = user.profile.pronoun;                                                                       // 219
      }                                                                                                                // 220
                                                                                                                       //
      if (user.profile.email) {                                                                                        // 222
        identity.unverifiedEmail = user.profile.email;                                                                 // 223
      }                                                                                                                // 224
    }                                                                                                                  // 225
                                                                                                                       //
    identity.main = true;                                                                                              // 227
                                                                                                                       //
    db.collections.users.update(user._id, { $set: { identities: [identity] } });                                       // 229
                                                                                                                       //
    db.collections.grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });        // 231
    db.collections.sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });      // 232
    db.collections.apiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });     // 233
    db.collections.apiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({                                                                           // 243
      "requirements.permissionsHeld.userId": user._id                                                                  // 244
    }, {                                                                                                               // 243
      $set: { "requirements.$.permissionsHeld.identityId": identity.id },                                              // 246
      $unset: { "requirements.$.permissionsHeld.userId": 1 }                                                           // 247
    }, {                                                                                                               // 245
      multi: true                                                                                                      // 249
    }) > 0) {}                                                                                                         // 248
    // The `$` operator modifies the first element in the array that matches the query. Since                          //
    // there may be many matches, we need to repeat until no documents are modified.                                   //
  });                                                                                                                  // 254
                                                                                                                       //
  db.collections.apiTokens.remove({ userInfo: { $exists: true } });                                                    // 256
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                              //
  // that this field could show up in the database was in this deprecated, no-longer-functional                        //
  // form of API token.                                                                                                //
};                                                                                                                     // 260
                                                                                                                       //
var appUpdateSettings = function appUpdateSettings(db, backend) {                                                      // 262
  db.collections.settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                         // 263
  db.collections.settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                     // 264
  db.collections.settings.insert({ _id: "appUpdatesEnabled", value: true });                                           // 265
};                                                                                                                     // 266
                                                                                                                       //
var moveDevAndEmailLoginDataIntoIdentities = function moveDevAndEmailLoginDataIntoIdentities(db, backend) {            // 268
  db.collections.users.find().forEach(function (user) {                                                                // 269
    if (user.identities.length !== 1) {                                                                                // 270
      throw new Error("User does not have exactly one identity: ", user);                                              // 271
    }                                                                                                                  // 272
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 274
    if (Match.test(identity.service, Object)) {                                                                        // 275
      return;                                                                                                          // 275
    } // Already migrated.                                                                                             // 275
                                                                                                                       //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                   // 277
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                    // 278
                                                                                                                       //
    var serviceObject = {};                                                                                            // 280
    var fieldsToUnset = {};                                                                                            // 281
                                                                                                                       //
    if (identity.service === "dev") {                                                                                  // 283
      serviceObject.name = user.devName;                                                                               // 284
      fieldsToUnset.devName = 1;                                                                                       // 285
    } else if (identity.service === "emailToken") {                                                                    // 286
      serviceObject.tokens = user.services.emailToken.tokens;                                                          // 287
      serviceObject.email = user.services.emailToken.email;                                                            // 288
      fieldsToUnset["services.emailToken"] = 1;                                                                        // 289
    }                                                                                                                  // 290
                                                                                                                       //
    newIdentity.service = {};                                                                                          // 292
    newIdentity.service[identity.service] = serviceObject;                                                             // 293
                                                                                                                       //
    var modifier = { $set: { identities: [newIdentity] } };                                                            // 295
    if (Object.keys(fieldsToUnset).length > 0) {                                                                       // 296
      modifier.$unset = fieldsToUnset;                                                                                 // 297
    }                                                                                                                  // 298
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, modifier);                                                          // 300
  });                                                                                                                  // 301
};                                                                                                                     // 302
                                                                                                                       //
var repairEmailIdentityIds = function repairEmailIdentityIds(db, backend) {                                            // 304
  db.collections.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {             // 305
    if (user.identities.length !== 1) {                                                                                // 306
      throw new Error("User does not have exactly one identity: ", user);                                              // 307
    }                                                                                                                  // 308
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 310
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");               // 311
    newIdentity.service = { email: identity.service.emailToken };                                                      // 313
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");   // 314
                                                                                                                       //
    db.collections.grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                           // 333
  });                                                                                                                  // 334
};                                                                                                                     // 335
                                                                                                                       //
var splitAccountUsersAndIdentityUsers = function splitAccountUsersAndIdentityUsers(db, backend) {                      // 337
  db.collections.users.find({ identities: { $exists: true } }).forEach(function (user) {                               // 338
    if (user.identities.length !== 1) {                                                                                // 339
      throw new Error("User does not have exactly one identity: ", user);                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 343
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                             // 344
    identityUser._id = identity.id;                                                                                    // 345
    identityUser.profile = identity.profile;                                                                           // 346
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                       // 347
    identityUser.profile.service = Object.keys(identity.service)[0];                                                   // 348
                                                                                                                       //
    // Updating this user needs to be a two step process because the `services` field typically                        //
    // contains subfields that are constrained to be unique by Mongo indices.                                          //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                     // 352
    if (identity.service.dev) {                                                                                        // 353
      identityUser.stagedServices.dev = identity.service.dev;                                                          // 354
    } else if (identity.service.email) {                                                                               // 355
      identityUser.stagedServices.email = identity.service.email;                                                      // 356
    }                                                                                                                  // 357
                                                                                                                       //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                            // 363
    accountUser.nonloginIdentities = [];                                                                               // 364
    if (user.services && user.services.resume) {                                                                       // 365
      accountUser.services = { resume: user.services.resume };                                                         // 366
    }                                                                                                                  // 367
                                                                                                                       //
    accountUser.stashedOldUser = user;                                                                                 // 369
                                                                                                                       //
    db.collections.apiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });
                                                                                                                       //
    db.collections.users.upsert({ _id: identityUser._id }, identityUser);                                              // 376
    db.collections.users.update({ _id: user._id }, accountUser);                                                       // 377
  });                                                                                                                  // 378
                                                                                                                       //
  db.collections.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                       // 380
    db.collections.users.update({ _id: identity._id }, {                                                               // 381
      $unset: { stagedServices: 1 },                                                                                   // 382
      $set: { services: identity.stagedServices }                                                                      // 383
    });                                                                                                                // 381
  });                                                                                                                  // 385
};                                                                                                                     // 386
                                                                                                                       //
var populateContactsFromApiTokens = function populateContactsFromApiTokens(db, backend) {                              // 388
  db.collections.apiTokens.find({                                                                                      // 389
    "owner.user.identityId": { $exists: 1 },                                                                           // 390
    accountId: { $exists: 1 }                                                                                          // 391
  }).forEach(function (token) {                                                                                        // 389
    var identityId = token.owner.user.identityId;                                                                      // 393
    var identity = db.getIdentity(identityId);                                                                         // 394
    if (identity) {                                                                                                    // 395
      var profile = identity.profile;                                                                                  // 396
      db.collections.contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                           // 397
        ownerId: token.accountId,                                                                                      // 398
        petname: profile && profile.name,                                                                              // 399
        created: new Date(),                                                                                           // 400
        identityId: identityId,                                                                                        // 401
        profile: profile                                                                                               // 402
      });                                                                                                              // 397
    }                                                                                                                  // 404
  });                                                                                                                  // 405
};                                                                                                                     // 406
                                                                                                                       //
var cleanUpApiTokens = function cleanUpApiTokens(db, backend) {                                                        // 408
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                       //
  // where the user still existed in the database.                                                                     //
  db.collections.apiTokens.remove({                                                                                    // 411
    userId: { $exists: true },                                                                                         // 412
    identityId: { $exists: false }                                                                                     // 413
  });                                                                                                                  // 411
  db.collections.apiTokens.remove({                                                                                    // 415
    "owner.user.userId": { $exists: true },                                                                            // 416
    "owner.user.identityId": { $exists: false }                                                                        // 417
  });                                                                                                                  // 415
                                                                                                                       //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                             //
  db.collections.apiTokens.find({                                                                                      // 421
    "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true }                                                  // 422
  }).forEach(function (apiToken) {                                                                                     // 421
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                  // 424
    db.collections.apiTokens.update({ _id: apiToken._id }, {                                                           // 425
      $set: { "owner.user.denormalizedGrainMetadata.icon": icon },                                                     // 426
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true }                                                 // 427
    });                                                                                                                // 425
  });                                                                                                                  // 429
                                                                                                                       //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                    //
  function repairChain(parentToken) {                                                                                  // 432
    db.collections.apiTokens.find({                                                                                    // 433
      parentToken: parentToken._id,                                                                                    // 434
      grainId: { $exists: true },                                                                                      // 435
      identityId: { $exists: false }                                                                                   // 436
    }).forEach(function (childToken) {                                                                                 // 433
      db.collections.apiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });      // 438
      repairChain(childToken);                                                                                         // 439
    });                                                                                                                // 440
  }                                                                                                                    // 441
                                                                                                                       //
  db.collections.apiTokens.find({                                                                                      // 443
    grainId: { $exists: true },                                                                                        // 444
    identityId: { $exists: true },                                                                                     // 445
    parentToken: { $exists: false }                                                                                    // 446
  }).forEach(repairChain);                                                                                             // 443
};                                                                                                                     // 448
                                                                                                                       //
var initServerTitleAndReturnAddress = function initServerTitleAndReturnAddress(db, backend) {                          // 450
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                             // 451
  db.collections.settings.insert({ _id: "serverTitle", value: hostname });                                             // 452
  db.collections.settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                             // 453
};                                                                                                                     // 454
                                                                                                                       //
var sendReferralNotifications = function sendReferralNotifications(db, backend) {                                      // 456
  if (db.isReferralEnabled()) {                                                                                        // 457
    db.collections.users.find({                                                                                        // 458
      loginIdentities: { $exists: true },                                                                              // 459
      expires: { $exists: false }                                                                                      // 460
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                               // 458
      db.sendReferralProgramNotification(user._id);                                                                    // 462
    });                                                                                                                // 463
  }                                                                                                                    // 464
};                                                                                                                     // 465
                                                                                                                       //
var assignBonuses = function assignBonuses(db, backend) {                                                              // 467
  // This was a one-time migration intended to be applied on Oasis to existing users.                                  //
  // It has run, so we only need this stub function here.                                                              //
};                                                                                                                     // 470
                                                                                                                       //
var splitSmtpUrl = function splitSmtpUrl(db, backend) {                                                                // 472
  var smtpUrlSetting = db.collections.settings.findOne({ _id: "smtpUrl" });                                            // 473
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                          // 474
  var returnAddress = db.collections.settings.findOne({ _id: "returnAddress" });                                       // 475
                                                                                                                       //
  // Default values.                                                                                                   //
  var smtpConfig = {                                                                                                   // 478
    hostname: "localhost",                                                                                             // 479
    port: "25",                                                                                                        // 480
    auth: undefined,                                                                                                   // 481
    returnAddress: returnAddress.value                                                                                 // 482
  };                                                                                                                   // 478
                                                                                                                       //
  var parsed = void 0;                                                                                                 // 485
  try {                                                                                                                // 486
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                            // 487
  } catch (e) {}                                                                                                       // 488
                                                                                                                       //
  if (parsed) {                                                                                                        // 490
    // If there was a SMTP URL previously defined, import its data.                                                    //
    var auth = undefined;                                                                                              // 492
    if (parsed.auth) {                                                                                                 // 493
      var colonIndex = parsed.auth.indexOf(":");                                                                       // 494
      var user = undefined;                                                                                            // 495
      var pass = undefined;                                                                                            // 496
      if (colonIndex !== -1) {                                                                                         // 497
        user = parsed.auth.slice(0, colonIndex);                                                                       // 498
        pass = parsed.auth.slice(colonIndex + 1);                                                                      // 499
      }                                                                                                                // 500
                                                                                                                       //
      auth = {                                                                                                         // 502
        user: user,                                                                                                    // 503
        pass: pass                                                                                                     // 504
      };                                                                                                               // 502
    }                                                                                                                  // 506
                                                                                                                       //
    // Override defaults with previous config's values.                                                                //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                              // 509
    smtpConfig.port = parsed.port || "25";                                                                             // 510
    smtpConfig.auth = auth;                                                                                            // 511
  }                                                                                                                    // 512
                                                                                                                       //
  db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                        // 514
  db.collections.settings.remove({ _id: "returnAddress" });                                                            // 515
  db.collections.settings.remove({ _id: "smtpUrl" });                                                                  // 516
};                                                                                                                     // 517
                                                                                                                       //
var smtpPortShouldBeNumber = function smtpPortShouldBeNumber(db, backend) {                                            // 519
  var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                  // 520
  if (entry) {                                                                                                         // 521
    var setting = entry.value;                                                                                         // 522
    if (setting.port) {                                                                                                // 523
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                 // 524
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: setting });                                       // 525
    }                                                                                                                  // 526
  }                                                                                                                    // 527
};                                                                                                                     // 528
                                                                                                                       //
var consolidateOrgSettings = function consolidateOrgSettings(db, backend) {                                            // 530
  var settings = db.collections.settings;                                                                              // 531
  var orgGoogleDomain = settings.findOne({ _id: "organizationGoogle" });                                               // 532
  var orgEmailDomain = settings.findOne({ _id: "organizationEmail" });                                                 // 533
  var orgLdap = settings.findOne({ _id: "organizationLdap" });                                                         // 534
  var orgSaml = settings.findOne({ _id: "organizationSaml" });                                                         // 535
                                                                                                                       //
  var orgMembership = {                                                                                                // 537
    google: {                                                                                                          // 538
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                      // 539
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                             // 540
    },                                                                                                                 // 538
    email: {                                                                                                           // 542
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                        // 543
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                               // 544
    },                                                                                                                 // 542
    ldap: {                                                                                                            // 546
      enabled: orgLdap ? orgLdap.value : false                                                                         // 547
    },                                                                                                                 // 546
    saml: {                                                                                                            // 549
      enabled: orgSaml ? orgSaml.value : false                                                                         // 550
    }                                                                                                                  // 549
  };                                                                                                                   // 537
                                                                                                                       //
  settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                        // 554
  settings.remove({ _id: "organizationGoogle" });                                                                      // 555
  settings.remove({ _id: "organizationEmail" });                                                                       // 556
  settings.remove({ _id: "organizationLdap" });                                                                        // 557
  settings.remove({ _id: "organizationSaml" });                                                                        // 558
};                                                                                                                     // 559
                                                                                                                       //
var unsetSmtpDefaultHostnameIfNoUsersExist = function unsetSmtpDefaultHostnameIfNoUsersExist(db, backend) {            // 561
  // We don't actually want to have the default hostname "localhost" set.                                              //
  // If the user has already finished configuring their server, then this migration should do                          //
  // nothing (since we might break their deployment), but for new installs (which will have no users                   //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                     //
  // default value.                                                                                                    //
  var hasUsers = db.collections.users.findOne();                                                                       // 567
  if (!hasUsers) {                                                                                                     // 568
    var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                // 569
    var smtpConfig = entry.value;                                                                                      // 570
    if (smtpConfig.hostname === "localhost") {                                                                         // 571
      smtpConfig.hostname = "";                                                                                        // 572
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                    // 573
    }                                                                                                                  // 574
  }                                                                                                                    // 575
};                                                                                                                     // 576
                                                                                                                       //
var extractLastUsedFromApiTokenOwner = function extractLastUsedFromApiTokenOwner(db, backend) {                        // 578
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                     //
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                     //
  // itself.                                                                                                           //
  db.collections.apiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                        // 582
    var lastUsed = token.owner.user.lastUsed;                                                                          // 583
    db.collections.apiTokens.update({ _id: token._id }, {                                                              // 584
      $set: { lastUsed: lastUsed },                                                                                    // 585
      $unset: { "owner.user.lastUsed": true }                                                                          // 586
    });                                                                                                                // 584
  });                                                                                                                  // 588
};                                                                                                                     // 589
                                                                                                                       //
var setUpstreamTitles = function setUpstreamTitles(db, backend) {                                                      // 591
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                    //
                                                                                                                       //
  var apiTokensRaw = db.collections.apiTokens.rawCollection();                                                         // 594
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                     // 595
                                                                                                                       //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                            //
  // for each of these, so we'd like to skip those which have nothing to update.                                       //
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                  // 602
  });                                                                                                                  // 602
                                                                                                                       //
  var count = 0;                                                                                                       // 604
  db.collections.grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {          // 605
    if (count % 100 == 0) {                                                                                            // 606
      console.log(count + " / " + grainIds.length);                                                                    // 607
    }                                                                                                                  // 608
                                                                                                                       //
    ++count;                                                                                                           // 610
                                                                                                                       //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                              //
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                         //
    // original name, so we don't know whether it was the owner or the receiver who renamed their                      //
    // copy post-sharaing. We assume it was the owner, because:                                                        //
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                    //
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                        //
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                         //
    //    was the user who had renamed their copy. They can rename it again if they like. On the                       //
    //    other hand, if we guessed wrongly in the other direction, the user would see                                 //
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                      //
    //    owner who renamed post-sharing.                                                                              //
    db.collections.apiTokens.update({                                                                                  // 623
      grainId: grain._id,                                                                                              // 624
      "owner.user.title": { $exists: true, $ne: grain.title }                                                          // 625
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                        // 623
  });                                                                                                                  // 627
};                                                                                                                     // 628
                                                                                                                       //
var markAllRead = function markAllRead(db, backend) {                                                                  // 630
  // Mark as "read" all grains and tokens that predate the creation of read/unread status.                             //
  // Otherwise it's pretty annoying to see all your old grains look like they have activity.                           //
                                                                                                                       //
  db.collections.grains.update({}, { $set: { ownerSeenAllActivity: true } }, { multi: true });                         // 634
  db.collections.apiTokens.update({ "owner.user": { $exists: true } }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
};                                                                                                                     // 638
                                                                                                                       //
var clearAppIndex = function clearAppIndex(db, backend) {                                                              // 640
  // Due to a bug in the app update code, some app update notifications that the user accepted                         //
  // around July 9-16, 2016 may not have applied. We have no way of knowing exactly which updates                      //
  // the user accepted but didn't receive. Instead, to recover, we are clearing the local cache of                     //
  // the app index one time. This way, the next time the app index is re-fetched, the server will                      //
  // interpret all of the apps in the index as updated and will re-deliver notifications to                            //
  // everyone. This may mean users get notifications that they previously dismissed, but they can                      //
  // click "dismiss" again easily enough.                                                                              //
                                                                                                                       //
  db.collections.appIndex.remove({});                                                                                  // 649
};                                                                                                                     // 650
                                                                                                                       //
var assignEmailVerifierIds = function assignEmailVerifierIds(db, backend) {                                            // 652
  // Originally, the ID of an EmailVerifier was actually the _id of the root token from which it                       //
  // was restored. This was broken, though: Conceptually, it meant that you couldn't have a working                    //
  // EmailVerifier that had not been restore()d from disk. In practice, that wasn't a problem due                      //
  // to the fact that powerbox selections always involve a restore(), but a different problem                          //
  // existed: the capability returned by claimRequest() would return one ID, but after save()ing                       //
  // and restore()ing that capability, the ID would be different, because the new capability would                     //
  // be a copy -- not a child -- of the original. Additionally, the whole thing made various code                      //
  // ugly because it was puncturing layers of abstraction. So, we switched to doing the right                          //
  // thing: assigning an ID to the EmailVerifier on first creation and storing it separately.                          //
                                                                                                                       //
  db.collections.apiTokens.find({ "frontendRef.emailVerifier": { $exists: true } }).forEach(function (token) {         // 663
    db.collections.apiTokens.update(token._id, { $set: { "frontendRef.emailVerifier.id": token._id } });               // 664
  });                                                                                                                  // 665
};                                                                                                                     // 666
                                                                                                                       //
var startPreinstallingApps = function startPreinstallingApps(db, backend) {                                            // 668
  // This isn't really a normal migration. It will run only on brand new servers, and it has to                        //
  // run after the `clearAppIndex` migration because it relies on populating AppIndex.                                 //
                                                                                                                       //
  var startPreinstallingAppsHelper = function startPreinstallingAppsHelper() {                                         // 672
    db.updateAppIndex();                                                                                               // 673
                                                                                                                       //
    var preinstalledApps = db.collections.appIndex.find({ _id: {                                                       // 675
        $in: db.getProductivitySuiteAppIds() }                                                                         // 676
    }).fetch();                                                                                                        // 675
    var appAndPackageIds = _.map(preinstalledApps, function (app) {                                                    // 678
      return {                                                                                                         // 679
        appId: app.appId,                                                                                              // 680
        packageId: app.packageId                                                                                       // 681
      };                                                                                                               // 679
    });                                                                                                                // 683
                                                                                                                       //
    db.setPreinstalledApps(appAndPackageIds);                                                                          // 685
  };                                                                                                                   // 686
                                                                                                                       //
  if (!Meteor.settings["public"].isTesting && !db.allowDevAccounts()) {                                                // 688
    // We want preinstalling apps to run async and not block startup.                                                  //
    Meteor.setTimeout(startPreinstallingAppsHelper, 0);                                                                // 690
  }                                                                                                                    // 691
};                                                                                                                     // 692
                                                                                                                       //
var setNewServer = function setNewServer(db, backend) {                                                                // 694
  // This migration only applies to "old" servers. New servers will set                                                //
  // new_server_migrations_applied to false before any migrations run.                                                 //
  if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" })) {                                  // 697
    db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: true });                           // 698
  }                                                                                                                    // 699
};                                                                                                                     // 700
                                                                                                                       //
function backgroundFillInGrainSizes(db, backend) {                                                                     // 702
  // Fill in sizes for all grains that don't have them. Since computing a grain size requires a                        //
  // directory walk, we don't want to do them all at once. Instead, we compute one a second until                      //
  // all grains have sizes.                                                                                            //
                                                                                                                       //
  try {                                                                                                                // 707
    var grain = db.collections.grains.findOne({ size: { $exists: false } }, { fields: { _id: 1, userId: 1 } });        // 708
                                                                                                                       //
    if (grain) {                                                                                                       // 710
      // Compute size!                                                                                                 //
      try {                                                                                                            // 712
        var result = waitPromise(backend.cap().getGrainStorageUsage(grain.userId, grain._id));                         // 713
        db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: parseInt(result.size) } });
      } catch (err) {                                                                                                  // 717
        if (err.kjType === "failed") {                                                                                 // 718
          // Backend had a problem. Maybe the grain doesn't actually exist on disk and the database                    //
          // is messed up. We'll set the size to zero and move on.                                                     //
          console.error("Error while backfilling grain size for", grain._id, ":", err.stack);                          // 721
          db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: 0 } });           // 722
        } else {                                                                                                       // 723
          // Rethrow on disconnected / overloaded / unimplemented.                                                     //
          throw err;                                                                                                   // 725
        }                                                                                                              // 726
      }                                                                                                                // 727
                                                                                                                       //
      // Do another one in a second.                                                                                   //
      Meteor.setTimeout(backgroundFillInGrainSizes.bind(this, db, backend), 1000);                                     // 730
    }                                                                                                                  // 731
  } catch (err) {                                                                                                      // 732
    // We'll just stop for now, to avoid spamming logs if this error persists. Next time the server                    //
    // restarts, the migration will continue.                                                                          //
    console.error("Error while backfilling grain sizes:", err.stack);                                                  // 735
  }                                                                                                                    // 736
}                                                                                                                      // 737
                                                                                                                       //
// This must come after all the functions named within are defined.                                                    //
// Only append to this list!  Do not modify or remove list entries;                                                    //
// doing so is likely change the meaning and semantics of user databases.                                              //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles, markAllRead, clearAppIndex, assignEmailVerifierIds, setNewServer];
                                                                                                                       //
var NEW_SERVER_STARTUP = [startPreinstallingApps];                                                                     // 775
                                                                                                                       //
var migrateToLatest = function migrateToLatest(db, backend) {                                                          // 779
  if (Meteor.settings.replicaNumber) {                                                                                 // 780
    (function () {                                                                                                     // 780
      // This is a replica. Wait for the first replica to perform migrations.                                          //
                                                                                                                       //
      console.log("Waiting for migrations on replica zero...");                                                        // 783
                                                                                                                       //
      var done = new Future();                                                                                         // 785
      var change = function change(doc) {                                                                              // 786
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                           // 787
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                          // 788
      };                                                                                                               // 789
                                                                                                                       //
      var observer = db.collections.migrations.find({ _id: "migrations_applied" }).observe({                           // 791
        added: change,                                                                                                 // 792
        changed: change                                                                                                // 793
      });                                                                                                              // 791
                                                                                                                       //
      var newServerDone = new Future();                                                                                // 796
      var newServerChange = function newServerChange(doc) {                                                            // 797
        if (doc.value) {                                                                                               // 798
          console.log("New server migrations applied elsewhere");                                                      // 799
          newServerDone["return"]();                                                                                   // 800
        }                                                                                                              // 801
      };                                                                                                               // 802
                                                                                                                       //
      var newServerObserver = db.collections.migrations.find({ _id: "new_server_migrations_applied" }).observe({       // 804
        added: newServerChange,                                                                                        // 805
        changed: newServerChange                                                                                       // 806
      });                                                                                                              // 804
                                                                                                                       //
      done.wait();                                                                                                     // 809
      observer.stop();                                                                                                 // 810
      newServerDone.wait();                                                                                            // 811
      newServerObserver.stop();                                                                                        // 812
      console.log("Migrations have completed on replica zero.");                                                       // 813
    })();                                                                                                              // 780
  } else {                                                                                                             // 814
    var applied = db.collections.migrations.findOne({ _id: "migrations_applied" });                                    // 815
    var start = void 0;                                                                                                // 816
    if (!applied) {                                                                                                    // 817
      // Migrations table is not yet seeded with a value.  This means it has                                           //
      // applied 0 migrations.  Persist this.                                                                          //
      db.collections.migrations.insert({ _id: "migrations_applied", value: 0 });                                       // 820
      start = 0;                                                                                                       // 821
                                                                                                                       //
      // This also means this is a brand new server                                                                    //
      db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: false });                        // 824
    } else {                                                                                                           // 825
      start = applied.value;                                                                                           // 826
    }                                                                                                                  // 827
                                                                                                                       //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                     // 829
                                                                                                                       //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                  // 831
      // Apply migration i, then record that migration i was successfully run.                                         //
      console.log("Applying migration " + (i + 1));                                                                    // 833
      MIGRATIONS[i](db, backend);                                                                                      // 834
      db.collections.migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                     // 835
      console.log("Applied migration " + (i + 1));                                                                     // 836
    }                                                                                                                  // 837
                                                                                                                       //
    if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" }).value) {                          // 839
      // new_server_migrations_applied is guaranteed to exist since we have a migration that                           //
      // ensures it.                                                                                                   //
      for (var _i = 0; _i < NEW_SERVER_STARTUP.length; _i++) {                                                         // 842
        console.log("Running new server startup function " + (_i + 1));                                                // 843
        NEW_SERVER_STARTUP[_i](db, backend);                                                                           // 844
        console.log("Running new server startup function " + (_i + 1));                                                // 845
      }                                                                                                                // 846
                                                                                                                       //
      db.collections.migrations.update({ _id: "new_server_migrations_applied" }, { $set: { value: true } });           // 848
    }                                                                                                                  // 849
                                                                                                                       //
    // Start background migrations.                                                                                    //
    backgroundFillInGrainSizes(db, backend);                                                                           // 852
  }                                                                                                                    // 853
};                                                                                                                     // 854
                                                                                                                       //
                                                                                                                       // 856
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"observe-helpers.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/observe-helpers.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({fillUndefinedForChangedDoc:function(){return fillUndefinedForChangedDoc}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
function fillUndefinedForChangedDoc(newDoc, oldDoc) {                                                                  // 17
  // In publishes, setting a field to `undefined` specifies that it is no longer present.                              //
  // Annoyingly, in the changed callback of observing a collection, it does not do this for you.                       //
  Object.keys(oldDoc).forEach(function (key) {                                                                         // 20
    if (!(key in newDoc)) {                                                                                            // 21
      newDoc[key] = undefined;                                                                                         // 22
    }                                                                                                                  // 23
  });                                                                                                                  // 24
}                                                                                                                      // 25
                                                                                                                       //
                                                                                                                       // 27
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"persistent.js":["babel-runtime/helpers/classCallCheck","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/persistent.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({PersistentImpl:function(){return PersistentImpl},hashSturdyRef:function(){return hashSturdyRef},generateSturdyRef:function(){return generateSturdyRef},checkRequirements:function(){return checkRequirements}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 19
                                                                                                                       //
var privateDb = Symbol("PersistentImpl.db");                                                                           // 21
var privateTemplate = Symbol("PersistentImpl.template");                                                               // 22
var privateIsSaved = Symbol("PersistentImpl.isSaved");                                                                 // 23
                                                                                                                       //
var PersistentImpl = function () {                                                                                     //
  function PersistentImpl(db, saveTemplate) {                                                                          // 26
    _classCallCheck(this, PersistentImpl);                                                                             // 26
                                                                                                                       //
    this[privateDb] = db;                                                                                              // 27
    this[privateTemplate] = saveTemplate;                                                                              // 28
                                                                                                                       //
    // TODO(someday): This may or may not be quite right in cases where we're saving a root token                      //
    //   by copy. Is the copy the "same" capability or not? Today, isSaved() is only used by                           //
    //   wakelock notification handles which are not issued through the powerbox, therefore do not                     //
    //   go through claimRequest(), therefore are not saved by copy, so the point is moot.                             //
    this[privateIsSaved] = !!saveTemplate.parentToken;                                                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  PersistentImpl.prototype.isSaved = function isSaved() {                                                              //
    // Can be called by subclasses to ask whether or not a record currently exists in the ApiTokens                    //
    // table representing this capability.                                                                             //
                                                                                                                       //
    return this[privateIsSaved];                                                                                       // 41
  };                                                                                                                   // 42
                                                                                                                       //
  PersistentImpl.prototype.save = function save(params) {                                                              //
    var _this = this;                                                                                                  // 44
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 45
      if (!params.sealFor) {                                                                                           // 46
        throw new Error("must specify 'sealFor'");                                                                     // 47
      }                                                                                                                // 48
                                                                                                                       //
      var db = _this[privateDb];                                                                                       // 50
                                                                                                                       //
      var newToken = _.clone(_this[privateTemplate]);                                                                  // 52
      newToken.owner = params.sealFor;                                                                                 // 53
      if (newToken.owner.user) {                                                                                       // 54
        if (!newToken.identityId) {                                                                                    // 55
          throw new Error("can't save non-UiView with user as owner");                                                 // 56
        }                                                                                                              // 57
                                                                                                                       //
        // Only "identityId" and "title" are allowed to be passed to save().                                           //
        var userOwner = _.pick(newToken.owner.user, "identityId", "title");                                            // 60
                                                                                                                       //
        // Fill in denormalizedGrainMetadata and upstreamTitle ourselves.                                              //
        userOwner.denormalizedGrainMetadata = db.getDenormalizedGrainInfo(newToken.grainId);                           // 63
                                                                                                                       //
        var grain = db.getGrain(newToken.grainId);                                                                     // 65
        if (grain && grain.title !== userOwner.title) {                                                                // 66
          userOwner.upstreamTitle = grain.title;                                                                       // 67
        }                                                                                                              // 68
                                                                                                                       //
        newToken.owner.user = userOwner;                                                                               // 70
      }                                                                                                                // 71
                                                                                                                       //
      var sturdyRef = generateSturdyRef();                                                                             // 73
      newToken._id = hashSturdyRef(sturdyRef);                                                                         // 74
                                                                                                                       //
      newToken.created = new Date();                                                                                   // 76
                                                                                                                       //
      db.collections.apiTokens.insert(newToken);                                                                       // 78
      _this[privateIsSaved] = true;                                                                                    // 79
      return { sturdyRef: new Buffer(sturdyRef) };                                                                     // 80
    });                                                                                                                // 81
  };                                                                                                                   // 82
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
                                                                                                                       //
                                                                                                                       //
  return PersistentImpl;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
function hashSturdyRef(sturdyRef) {                                                                                    // 87
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 88
};                                                                                                                     // 89
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 91
  return Random.secret();                                                                                              // 92
}                                                                                                                      // 93
                                                                                                                       //
function checkRequirements(db, requirements) {                                                                         // 95
  // Checks if the given list of MembraneRequirements are all satisfied, returning true if so and                      //
  // false otherwise.                                                                                                  //
                                                                                                                       //
  // TODO(cleanup): SandstormPermissions has a different way of checking the same requirements.                        //
  //   Reuse?                                                                                                          //
                                                                                                                       //
  // TODO(security): Eventually we want checkRequirements(), when it passes, to produce an observer                    //
  //   that can be used to receive a notification when the requirements may no longer be satisfied,                    //
  //   in order to revoke the live object. See RequirementObserver in supervisor.capnp.                                //
                                                                                                                       //
  if (!requirements) {                                                                                                 // 106
    return true;                                                                                                       // 107
  }                                                                                                                    // 108
                                                                                                                       //
  requirements.forEach(function (requirement) {                                                                        // 110
    if (requirement.tokenValid) {                                                                                      // 111
      var token = db.collections.apiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token) {                                                                                                    // 115
        throw new Meteor.Error(403, "Capability revoked because the link through which it was introduced has been " + "revoked or deleted.");
      }                                                                                                                // 119
                                                                                                                       //
      checkRequirements(db, token.requirements);                                                                       // 121
                                                                                                                       //
      if (token.parentToken) {                                                                                         // 123
        checkRequirements(db, [{ tokenValid: token.parentToken }]);                                                    // 124
      }                                                                                                                // 125
    } else if (requirement.permissionsHeld) {                                                                          // 126
      var p = requirement.permissionsHeld;                                                                             // 127
      var viewInfo = db.collections.grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;       // 128
      var vertex = void 0;                                                                                             // 130
      if (p.identityId) {                                                                                              // 131
        vertex = { grain: { _id: p.grainId, identityId: p.identityId } };                                              // 132
      } else {                                                                                                         // 133
        vertex = { token: { _id: p.tokenId, grainId: p.grainId } };                                                    // 134
      }                                                                                                                // 135
                                                                                                                       //
      var currentPermissions = SandstormPermissions.grainPermissions(db, vertex, viewInfo || {}).permissions;          // 137
      if (!currentPermissions) {                                                                                       // 139
        throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
      }                                                                                                                // 143
                                                                                                                       //
      var requiredPermissions = p.permissions || [];                                                                   // 145
      for (var ii = 0; ii < requiredPermissions.length; ++ii) {                                                        // 146
        if (requiredPermissions[ii] && !currentPermissions[ii]) {                                                      // 147
          throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
        }                                                                                                              // 151
      }                                                                                                                // 152
    } else if (requirement.userIsAdmin) {                                                                              // 153
      if (!db.isAdminById(requirement.userIsAdmin)) {                                                                  // 154
        throw new Meteor.Error(403, "Capability revoked because the user who created it has lost their admin " + "rights.");
      }                                                                                                                // 158
    } else {                                                                                                           // 159
      throw new Meteor.Error(403, "Unknown requirement type.");                                                        // 160
    }                                                                                                                  // 161
  });                                                                                                                  // 162
};                                                                                                                     // 163
                                                                                                                       //
                                                                                                                       // 165
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"static-asset.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/static-asset.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({StaticAssetImpl:function(){return StaticAssetImpl},IdenticonStaticAssetImpl:function(){return IdenticonStaticAssetImpl}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014-2016 Sandstorm Development Group, Inc. and contributors                                          //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var Url = Npm.require("url");                                                                                          // 18
var StaticAsset = Capnp.importSystem("sandstorm/grain.capnp").StaticAsset;                                             // 19
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 21
                                                                                                                       //
var StaticAssetImpl = function () {                                                                                    //
  function StaticAssetImpl(assetId) {                                                                                  // 24
    _classCallCheck(this, StaticAssetImpl);                                                                            // 24
                                                                                                                       //
    check(assetId, String);                                                                                            // 25
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 26
    this._hostPath = makeWildcardHost("static") + "/" + assetId;                                                       // 27
  }                                                                                                                    // 28
                                                                                                                       //
  StaticAssetImpl.prototype.getUrl = function getUrl() {                                                               //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 31
  };                                                                                                                   // 32
                                                                                                                       //
  return StaticAssetImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 33
                                                                                                                       //
var IdenticonStaticAssetImpl = function () {                                                                           //
  function IdenticonStaticAssetImpl(hash, size) {                                                                      // 36
    _classCallCheck(this, IdenticonStaticAssetImpl);                                                                   // 36
                                                                                                                       //
    check(hash, String);                                                                                               // 37
    check(size, Match.Integer);                                                                                        // 38
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 39
    this._hostPath = makeWildcardHost("static") + "/identicon/" + hash + "?s=" + size;                                 // 40
  }                                                                                                                    // 41
                                                                                                                       //
  IdenticonStaticAssetImpl.prototype.getUrl = function getUrl() {                                                      //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 44
  };                                                                                                                   // 45
                                                                                                                       //
  return IdenticonStaticAssetImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 46
                                                                                                                       //
                                                                                                                       // 48
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"constants.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/constants.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({ACCOUNT_DELETION_SUSPENSION_TIME:function(){return ACCOUNT_DELETION_SUSPENSION_TIME}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
module.runModuleSetters(ACCOUNT_DELETION_SUSPENSION_TIME = 7 * 60 * 60 * 24 * 1000); // 7 days in ms                   // 17
                                                                                                                       //
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"db-deprecated.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/db-deprecated.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
var quotaManager = void 0;                                                                                             // 26
if (Meteor.isServer) {var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});         // 27
                                                                                                                       // 28
  // Imports are usually not allowed to occur in a block. However, it is the only way to do                            //
  // this under Meteor. Using // jscs:disable doesn't work for what it considers syntax violations,                    //
  // and so we've added this file to .jscsrc's excludedFiles explicitly.                                               //
                                                                                                                       //
  quotaManager = new LDAP();                                                                                           // 33
} else {                                                                                                               // 34
  quotaManager = {                                                                                                     // 35
    updateUserQuota: function updateUserQuota(db, user) {                                                              // 36
      return {                                                                                                         // 37
        storage: user.cachedStorageQuota || 0,                                                                         // 38
        grains: Infinity,                                                                                              // 39
        compute: Infinity                                                                                              // 40
      };                                                                                                               // 37
    }                                                                                                                  // 42
  };                                                                                                                   // 35
}                                                                                                                      // 44
                                                                                                                       //
globalDb = new SandstormDb(quotaManager);                                                                              // 46
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 48
DevPackages = globalDb.collections.devPackages;                                                                        // 49
UserActions = globalDb.collections.userActions;                                                                        // 50
Grains = globalDb.collections.grains;                                                                                  // 51
Contacts = globalDb.collections.contacts;                                                                              // 52
Sessions = globalDb.collections.sessions;                                                                              // 53
SignupKeys = globalDb.collections.signupKeys;                                                                          // 54
ActivityStats = globalDb.collections.activityStats;                                                                    // 55
DeleteStats = globalDb.collections.deleteStats;                                                                        // 56
FileTokens = globalDb.collections.fileTokens;                                                                          // 57
ApiTokens = globalDb.collections.apiTokens;                                                                            // 58
Notifications = globalDb.collections.notifications;                                                                    // 59
StatsTokens = globalDb.collections.statsTokens;                                                                        // 60
Misc = globalDb.collections.misc;                                                                                      // 61
Settings = globalDb.collections.settings;                                                                              // 62
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 64
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 65
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 66
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 67
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 68
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 69
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 70
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 71
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 72
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 73
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 74
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 75
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 76
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/demo.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({allowDemo:function(){return allowDemo}});// Sandstorm - Personal Cloud Sandbox                          //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;           // 17
                                                                                                                       //
                                                                                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"server":{"accounts":{"email-token":{"token-server.js":["crypto","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/email-token/token-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var crypto;module.import("crypto",{"default":function(v){crypto=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
                                                                                                                       //
                                                                                                                       // 3
                                                                                                                       //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                      // 5
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                              // 6
var V1_HASHFUNC = "sha512";                                                                                            // 7
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token                    //
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                                 //
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                      //
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly                     //
// sufficient to reconstruct the output of pbkdf2().                                                                   //
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                          // 13
                                                                                                                       //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                              // 15
                                                                                                                       //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                           // 17
  Meteor.users.update({                                                                                                // 18
    "services.email.tokens.createdAt": {                                                                               // 19
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                                  // 20
    }                                                                                                                  // 19
  }, {                                                                                                                 // 18
    $pull: {                                                                                                           // 23
      "services.email.tokens": {                                                                                       // 24
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                                 // 25
      }                                                                                                                // 24
    }                                                                                                                  // 23
  }, {                                                                                                                 // 22
    multi: true                                                                                                        // 29
  });                                                                                                                  // 28
};                                                                                                                     // 31
                                                                                                                       //
Meteor.startup(cleanupExpiredTokens);                                                                                  // 33
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                              //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                                // 35
                                                                                                                       //
var hashToken = function hashToken(token) {                                                                            // 37
  return {                                                                                                             // 38
    digest: SHA256(token),                                                                                             // 39
    algorithm: "sha-256"                                                                                               // 40
  };                                                                                                                   // 38
};                                                                                                                     // 42
                                                                                                                       //
var checkToken = function checkToken(tokens, token) {                                                                  // 44
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.                   //
  // Returns the matching object, if one is found, or undefined if none match.                                         //
  var foundToken = undefined;                                                                                          // 47
  tokens.forEach(function (userToken) {                                                                                // 48
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                                // 49
      foundToken = userToken;                                                                                          // 51
    }                                                                                                                  // 52
  });                                                                                                                  // 53
                                                                                                                       //
  return foundToken;                                                                                                   // 55
};                                                                                                                     // 56
                                                                                                                       //
var consumeToken = function consumeToken(user, token) {                                                                // 58
  var hashedToken = hashToken(token);                                                                                  // 59
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                                // 60
                                                                                                                       //
  if (foundToken !== undefined) {                                                                                      // 62
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                       // 63
  }                                                                                                                    // 64
                                                                                                                       //
  return foundToken;                                                                                                   // 66
};                                                                                                                     // 67
                                                                                                                       //
var makeBox = function makeBox(token, plaintext) {                                                                     // 69
  // Encrypt plaintext symmetrically with a key derived from token.  Returns an object with                            //
  // ciphertext and associated data needed to decrypt later.                                                           //
                                                                                                                       //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                          //
  // be used as a key directly, so we need to use a KDF with a strong random salt.                                     //
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole                   //
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                      //
  // This would require lengthening the token, which would make the manual-code-entry workflow                         //
  // worse, so I'm punting on that for now.                                                                            //
  var salt = Random.secret(16);                                                                                        // 79
  var key = crypto.pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                                        // 80
  var iv = crypto.randomBytes(16);                                                                                     // 81
  var cipher = crypto.createCipheriv(V1_CIPHER, key, iv);                                                              // 82
  var ciphertext = cipher.update(new Buffer(plaintext, "binary"));                                                     // 83
  return {                                                                                                             // 84
    version: 1,                                                                                                        // 85
    salt: salt,                                                                                                        // 86
    iv: iv.toString("base64"),                                                                                         // 87
    boxedValue: ciphertext.toString("base64")                                                                          // 88
  };                                                                                                                   // 84
};                                                                                                                     // 90
                                                                                                                       //
var tryUnbox = function tryUnbox(box, secret) {                                                                        // 92
  if (box) {                                                                                                           // 93
    if (box.version === 1) {                                                                                           // 94
      var key = crypto.pbkdf2Sync(secret, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                               // 95
      var iv = new Buffer(box.iv, "base64");                                                                           // 96
      var cipher = crypto.createDecipheriv(V1_CIPHER, key, iv);                                                        // 97
      var cipherText = new Buffer(box.boxedValue, "base64");                                                           // 98
      var plaintext = cipher.update(cipherText);                                                                       // 99
      return plaintext.toString("binary");                                                                             // 100
    }                                                                                                                  // 101
  }                                                                                                                    // 102
                                                                                                                       //
  // If no box was provided, or it was of an unknown version, return no data.                                          //
  return;                                                                                                              // 105
};                                                                                                                     // 106
                                                                                                                       //
// Handler to login with a token.                                                                                      //
Accounts.registerLoginHandler("email", function (options) {                                                            // 109
  if (!options.email) {                                                                                                // 110
    return undefined; // don't handle                                                                                  // 111
  }                                                                                                                    // 112
                                                                                                                       //
  if (!Accounts.identityServices.email.isEnabled()) {                                                                  // 114
    throw new Meteor.Error(403, "Email identity service is disabled.");                                                // 115
  }                                                                                                                    // 116
                                                                                                                       //
  options = options.email;                                                                                             // 118
  check(options, {                                                                                                     // 119
    email: String,                                                                                                     // 120
    token: String                                                                                                      // 121
  });                                                                                                                  // 119
                                                                                                                       //
  var user = Meteor.users.findOne({                                                                                    // 124
    "services.email.email": options.email                                                                              // 125
  }, {                                                                                                                 // 124
    fields: {                                                                                                          // 127
      "services.email": 1                                                                                              // 128
    }                                                                                                                  // 127
  });                                                                                                                  // 126
                                                                                                                       //
  if (!user) {                                                                                                         // 132
    console.error("User not found:", options.email);                                                                   // 133
    return {                                                                                                           // 134
      error: new Meteor.Error(403, "User not found")                                                                   // 135
    };                                                                                                                 // 134
  }                                                                                                                    // 137
                                                                                                                       //
  if (!user.services.email.tokens) {                                                                                   // 139
    console.error("User has no token set:", options.email);                                                            // 140
    return {                                                                                                           // 141
      error: new Meteor.Error(403, "User has no token set")                                                            // 142
    };                                                                                                                 // 141
  }                                                                                                                    // 144
                                                                                                                       //
  var tokenString = options.token.trim();                                                                              // 146
  var maybeToken = consumeToken(user, tokenString);                                                                    // 147
  if (!maybeToken) {                                                                                                   // 148
    console.error("Token not found:", options.email);                                                                  // 149
    return {                                                                                                           // 150
      error: new Meteor.Error(403, "Invalid authentication code")                                                      // 151
    };                                                                                                                 // 150
  }                                                                                                                    // 153
                                                                                                                       //
  // Attempt to decrypt the resumePath, if provided.                                                                   //
  var resumePath = tryUnbox(maybeToken.secureBox, tokenString);                                                        // 156
                                                                                                                       //
  return {                                                                                                             // 158
    userId: user._id,                                                                                                  // 159
    options: {                                                                                                         // 160
      resumePath: resumePath                                                                                           // 161
    }                                                                                                                  // 160
  };                                                                                                                   // 158
});                                                                                                                    // 164
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 166
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 168
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 169
                                                                                                                       //
var makeTokenUrl = function makeTokenUrl(email, token, linkingIdentity) {                                              // 171
  if (linkingIdentity) {                                                                                               // 172
    return process.env.ROOT_URL + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId();
  } else {                                                                                                             // 175
    return process.env.ROOT_URL + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);       // 176
  }                                                                                                                    // 178
};                                                                                                                     // 179
                                                                                                                       //
///                                                                                                                    //
/// EMAIL VERIFICATION                                                                                                 //
///                                                                                                                    //
var sendTokenEmail = function sendTokenEmail(db, email, token, linkingIdentity) {                                      // 184
  var subject = void 0;                                                                                                // 185
  var text = void 0;                                                                                                   // 186
  if (!linkingIdentity) {                                                                                              // 187
    subject = "Log in to " + HOSTNAME;                                                                                 // 188
    text = "To confirm this email address on ";                                                                        // 189
  } else {                                                                                                             // 190
    subject = "Confirm this email address on " + HOSTNAME;                                                             // 191
    text = "To confirm this email address on ";                                                                        // 192
  }                                                                                                                    // 193
                                                                                                                       //
  text = text + HOSTNAME + ", click on the following link:\n\n" + makeTokenUrl(email, token, linkingIdentity) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                       //
  var options = {                                                                                                      // 200
    to: email,                                                                                                         // 201
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                                    // 202
    subject: subject,                                                                                                  // 203
    text: text                                                                                                         // 204
  };                                                                                                                   // 200
                                                                                                                       //
  sendEmail(options);                                                                                                  // 207
};                                                                                                                     // 208
                                                                                                                       //
///                                                                                                                    //
/// CREATING USERS                                                                                                     //
///                                                                                                                    //
// returns the user id                                                                                                 //
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, linkingIdentity, resumePath) {       // 214
  check(email, String);                                                                                                // 215
  check(linkingIdentity, Boolean);                                                                                     // 216
  check(resumePath, String);                                                                                           // 217
                                                                                                                       //
  var atIndex = email.indexOf("@");                                                                                    // 219
  if (atIndex === -1) {                                                                                                // 220
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                                // 221
  }                                                                                                                    // 222
                                                                                                                       //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });             // 224
  var userId = void 0;                                                                                                 // 226
                                                                                                                       //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                                 //
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                         //
  var token = Random.id(12);                                                                                           // 230
  var tokenObj = hashToken(token);                                                                                     // 231
  tokenObj.createdAt = new Date();                                                                                     // 232
  tokenObj.secureBox = makeBox(token, resumePath);                                                                     // 233
                                                                                                                       //
  if (user) {                                                                                                          // 235
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                         // 236
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again");
    }                                                                                                                  // 240
                                                                                                                       //
    userId = user._id;                                                                                                 // 242
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                          // 244
  } else {                                                                                                             // 245
    var options = {};                                                                                                  // 246
    user = {                                                                                                           // 247
      services: {                                                                                                      // 248
        email: {                                                                                                       // 249
          tokens: [tokenObj],                                                                                          // 250
          email: email                                                                                                 // 251
        }                                                                                                              // 249
      }                                                                                                                // 248
    };                                                                                                                 // 247
                                                                                                                       //
    userId = Accounts.insertUserDoc(options, user);                                                                    // 256
  }                                                                                                                    // 257
                                                                                                                       //
  sendTokenEmail(db, email, token, linkingIdentity);                                                                   // 259
                                                                                                                       //
  return userId;                                                                                                       // 261
};                                                                                                                     // 262
                                                                                                                       //
Meteor.methods({                                                                                                       // 264
  createAndEmailTokenForUser: function createAndEmailTokenForUser(email, linkingIdentity, resumePath) {                // 265
    // method for create user. Requests come from the client.                                                          //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                         //
    // It will always send an email to the user                                                                        //
                                                                                                                       //
    check(email, String);                                                                                              // 270
    check(linkingIdentity, Boolean);                                                                                   // 271
    check(resumePath, String);                                                                                         // 272
                                                                                                                       //
    if (!Accounts.identityServices.email.isEnabled()) {                                                                // 274
      throw new Meteor.Error(403, "Email identity service is disabled.");                                              // 275
    }                                                                                                                  // 276
    // Create user. result contains id and token.                                                                      //
    var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, linkingIdentity, resumePath);           // 278
  },                                                                                                                   // 279
                                                                                                                       //
  linkEmailIdentityToAccount: function linkEmailIdentityToAccount(email, token) {                                      // 281
    // Links the email identity with address `email` and login token `token` to the current account.                   //
    check(email, String);                                                                                              // 283
    check(token, String);                                                                                              // 284
    var account = Meteor.user();                                                                                       // 285
    if (!account || !account.loginIdentities) {                                                                        // 286
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                       // 287
    }                                                                                                                  // 288
                                                                                                                       //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 290
    if (!identity) {                                                                                                   // 292
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 293
    }                                                                                                                  // 294
                                                                                                                       //
    var maybeToken = consumeToken(identity, token.trim());                                                             // 296
    if (!maybeToken) {                                                                                                 // 297
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 298
    }                                                                                                                  // 299
                                                                                                                       //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id);
                                                                                                                       //
    // Return the resume path, if we have one.                                                                         //
    var resumePath = tryUnbox(maybeToken.secureBox, token);                                                            // 305
    return resumePath;                                                                                                 // 306
  }                                                                                                                    // 307
});                                                                                                                    // 264
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"identity":{"identity-server.js":["/imports/server/backend.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/identity/identity-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var SandstormBackend;module.import("/imports/server/backend.js",{"SandstormBackend":function(v){SandstormBackend=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var linkIdentityToAccountInternal = function linkIdentityToAccountInternal(db, backend, identityId, accountId) {       // 19
  // Links the identity to the account and grants it login access if possible. Makes the account                       //
  // durable if it is a demo account.                                                                                  //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 23
  check(backend, SandstormBackend);                                                                                    // 24
  check(identityId, String);                                                                                           // 25
  check(accountId, String);                                                                                            // 26
                                                                                                                       //
  var accountUser = Meteor.users.findOne({ _id: accountId });                                                          // 28
  if (!accountUser) {                                                                                                  // 29
    throw new Meteor.Error(404, "No account found with ID " + accountId);                                              // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (accountUser.profile) {                                                                                           // 33
    throw new Meteor.Error(400, "Cannot link an identity to another identity.");                                       // 34
  }                                                                                                                    // 35
                                                                                                                       //
  if (!!_.findWhere(accountUser.loginIdentities, { id: identityId }) || !!_.findWhere(accountUser.nonloginIdentities, { id: identityId })) {
    throw new Meteor.Error("alreadyLinked", "Cannot link an identity that's alread linked to this account.");          // 39
  }                                                                                                                    // 41
                                                                                                                       //
  var identityUser = Meteor.users.findOne({ _id: identityId });                                                        // 43
                                                                                                                       //
  if (!identityUser) {                                                                                                 // 45
    throw new Meteor.Error(404, "No identity found with ID " + identityId);                                            // 46
  }                                                                                                                    // 47
                                                                                                                       //
  if (!identityUser.profile) {                                                                                         // 49
    throw new Meteor.Error(400, "Cannot link an account to another account");                                          // 50
  }                                                                                                                    // 51
                                                                                                                       //
  db.deleteUnusedAccount(backend, identityUser._id);                                                                   // 53
  if (Meteor.users.findOne({ "loginIdentities.id": identityUser._id })) {                                              // 54
    throw new Meteor.Error(403, "Cannot link an identity that can already log into another account");                  // 55
  }                                                                                                                    // 57
                                                                                                                       //
  var alreadyLinked = !!Meteor.users.findOne({ "nonloginIdentities.id": identityUser._id });                           // 59
                                                                                                                       //
  var pushModifier = alreadyLinked ? { nonloginIdentities: { id: identityUser._id } } : { loginIdentities: { id: identityUser._id } };
                                                                                                                       //
  var modifier = void 0;                                                                                               // 65
  if (accountUser.expires) {                                                                                           // 66
    if (alreadyLinked) {                                                                                               // 67
      throw new Meteor.Error(403, "Cannot create an account for an identity that's " + "already linked to another account.");
    }                                                                                                                  // 70
                                                                                                                       //
    modifier = {                                                                                                       // 72
      $push: pushModifier,                                                                                             // 73
      $unset: { expires: 1 },                                                                                          // 74
      $set: { upgradedFromDemo: Date.now() }                                                                           // 75
    };                                                                                                                 // 72
    if (db.isReferralEnabled()) {                                                                                      // 77
      // Demo users never got the referral notification. Send it now:                                                  //
      db.sendReferralProgramNotification(accountUser._id);                                                             // 79
    }                                                                                                                  // 80
  } else {                                                                                                             // 82
    modifier = { $push: pushModifier };                                                                                // 83
  }                                                                                                                    // 84
                                                                                                                       //
  // Make sure not to add the same identity twice.                                                                     //
  Meteor.users.update({ _id: accountUser._id,                                                                          // 87
    "nonloginIdentities.id": { $ne: identityUser._id },                                                                // 88
    "loginIdentities.id": { $ne: identityUser._id } }, modifier);                                                      // 89
                                                                                                                       //
  if (accountUser.expires) {                                                                                           // 92
    var demoIdentityId = SandstormDb.getUserIdentityIds(accountUser)[0];                                               // 93
    Meteor.users.update({ _id: demoIdentityId }, { $unset: { expires: 1 },                                             // 94
      $set: { upgradedFromDemo: Date.now() } });                                                                       // 96
                                                                                                                       //
    // Mark the demo identity as nonlogin. It'd be nicer if the identity started out as nonlogin,                      //
    // but to get that to work we would need to adjust the account creation and first login logic.                     //
    Meteor.users.update({ _id: accountUser._id,                                                                        // 100
      "loginIdentities.id": demoIdentityId,                                                                            // 101
      "nonloginIdentities.id": { $not: { $eq: demoIdentityId } } }, { $pull: { loginIdentities: { id: demoIdentityId } },
      $push: { nonloginIdentities: { id: demoIdentityId } } });                                                        // 104
  }                                                                                                                    // 106
};                                                                                                                     // 107
                                                                                                                       //
Meteor.methods({                                                                                                       // 109
  loginWithIdentity: function loginWithIdentity(accountUserId) {                                                       // 110
    // Logs into the account with ID `accountUserId`. Throws an exception if the current user is                       //
    // not an identity user listed in the account's `loginIdentities` field. This method is not                        //
    // intended to be called directly; client-side code should only invoke it through                                  //
    // `Meteor.loginWithIdentity()`, which additionally maintains the standard Meteor client-side                      //
    // login state.                                                                                                    //
                                                                                                                       //
    check(accountUserId, String);                                                                                      // 117
                                                                                                                       //
    var identityUser = Meteor.user();                                                                                  // 119
    if (!identityUser || !identityUser.profile) {                                                                      // 120
      throw new Meteor.Error(403, "Must be already logged in as an identity.");                                        // 121
    }                                                                                                                  // 122
                                                                                                                       //
    var accountUser = Meteor.users.findOne(accountUserId);                                                             // 124
    if (!accountUser) {                                                                                                // 125
      throw new Meteor.Error(404, "No such user found: " + accountUserId);                                             // 126
    }                                                                                                                  // 127
                                                                                                                       //
    var linkedIdentity = _.findWhere(accountUser.loginIdentities, { id: identityUser._id });                           // 129
                                                                                                                       //
    if (!linkedIdentity) {                                                                                             // 131
      throw new Meteor.Error(403, "Current identity is not a login identity for account " + accountUserId);            // 132
    }                                                                                                                  // 134
                                                                                                                       //
    return Accounts._loginMethod(this, "loginWithIdentity", [accountUserId], "identity", function () {                 // 136
      return { userId: accountUserId };                                                                                // 137
    });                                                                                                                // 137
  },                                                                                                                   // 138
                                                                                                                       //
  createAccountForIdentity: function createAccountForIdentity() {                                                      // 140
    // Creates a new account for the currently-logged-in identity.                                                     //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 143
    if (!(user && user.profile)) {                                                                                     // 144
      throw new Meteor.Error(403, "Must be logged in as an identity in order to create an account.");                  // 145
    }                                                                                                                  // 146
                                                                                                                       //
    if (Meteor.users.findOne({                                                                                         // 148
      $or: [{ "loginIdentities.id": user._id }, { "nonloginIdentities.id": user._id }]                                 // 149
    })) {                                                                                                              // 148
      throw new Meteor.Error(403, "Cannot create an account for an identity that's already " + "linked to another account.");
    }                                                                                                                  // 156
                                                                                                                       //
    var newUser = {                                                                                                    // 158
      loginIdentities: [{ id: user._id }],                                                                             // 159
      nonloginIdentities: []                                                                                           // 160
    };                                                                                                                 // 158
    if (user.services.dev) {                                                                                           // 162
      newUser.signupKey = "devAccounts";                                                                               // 163
      if (user.services.dev.isAdmin) {                                                                                 // 164
        newUser.isAdmin = true;                                                                                        // 165
      }                                                                                                                // 166
                                                                                                                       //
      if (user.services.dev.hasCompletedSignup) {                                                                      // 168
        newUser.hasCompletedSignup = true;                                                                             // 169
      }                                                                                                                // 170
    } else if (user.expires) {                                                                                         // 171
      // Demo user.                                                                                                    //
      newUser.expires = user.expires;                                                                                  // 173
      if (!!user.appDemoId) {                                                                                          // 174
        newUser.appDemoId = user.appDemoId;                                                                            // 175
      }                                                                                                                // 176
    }                                                                                                                  // 177
                                                                                                                       //
    var options = {};                                                                                                  // 179
                                                                                                                       //
    // This will throw an error if the identity has been added as a login identity to some                             //
    // other account while we were executing the body of this method.                                                  //
    return Accounts.insertUserDoc(options, newUser);                                                                   // 183
  },                                                                                                                   // 184
                                                                                                                       //
  linkIdentityToAccount: function linkIdentityToAccount(token) {                                                       // 186
    // Links the identity of the current user to the account that has `token` as a resume token.                       //
    // If the account is a demo account, makes the account durable and gives the identity login                        //
    // access to it.                                                                                                   //
                                                                                                                       //
    check(token, String);                                                                                              // 191
                                                                                                                       //
    if (!this.userId) {                                                                                                // 193
      throw new Meteor.Error(403, "Cannot link to account if not logged in.");                                         // 194
    }                                                                                                                  // 195
                                                                                                                       //
    var hashed = Accounts._hashLoginToken(token);                                                                      // 197
    var accountUser = Meteor.users.findOne({ "services.resume.loginTokens.hashedToken": hashed });                     // 198
                                                                                                                       //
    linkIdentityToAccountInternal(this.connection.sandstormDb, this.connection.sandstormBackend, this.userId, accountUser._id);
  },                                                                                                                   // 202
                                                                                                                       //
  unlinkIdentity: function unlinkIdentity(accountUserId, identityId) {                                                 // 204
    // Unlinks the identity with ID `identityId` from the account with ID `accountUserId`.                             //
                                                                                                                       //
    check(identityId, String);                                                                                         // 207
    check(accountUserId, String);                                                                                      // 208
                                                                                                                       //
    if (!this.userId) {                                                                                                // 210
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 211
    }                                                                                                                  // 212
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 214
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 215
    }                                                                                                                  // 216
                                                                                                                       //
    var identityUser = Meteor.users.findOne({ _id: identityId });                                                      // 218
    Meteor.users.update({                                                                                              // 219
      _id: accountUserId                                                                                               // 220
    }, {                                                                                                               // 219
      $pull: {                                                                                                         // 222
        nonloginIdentities: { id: identityId },                                                                        // 223
        loginIdentities: { id: identityId }                                                                            // 224
      }                                                                                                                // 222
    });                                                                                                                // 221
  },                                                                                                                   // 227
                                                                                                                       //
  setIdentityAllowsLogin: function setIdentityAllowsLogin(identityId, allowLogin) {                                    // 229
    // Sets whether the current account allows the identity with ID `identityId` to log in.                            //
                                                                                                                       //
    check(identityId, String);                                                                                         // 232
    check(allowLogin, Boolean);                                                                                        // 233
    if (!this.userId) {                                                                                                // 234
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 235
    }                                                                                                                  // 236
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 238
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 239
    }                                                                                                                  // 240
                                                                                                                       //
    if (allowLogin) {                                                                                                  // 242
      Meteor.users.update({ _id: this.userId,                                                                          // 243
        "nonloginIdentities.id": identityId,                                                                           // 244
        "loginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { nonloginIdentities: { id: identityId } },    // 245
        $push: { loginIdentities: { id: identityId } } });                                                             // 247
    } else {                                                                                                           // 248
      Meteor.users.update({ _id: this.userId,                                                                          // 249
        "loginIdentities.id": identityId,                                                                              // 250
        "nonloginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { loginIdentities: { id: identityId } },    // 251
        $push: { nonloginIdentities: { id: identityId } } });                                                          // 253
    }                                                                                                                  // 254
  },                                                                                                                   // 255
                                                                                                                       //
  logoutIdentitiesOfCurrentAccount: function logoutIdentitiesOfCurrentAccount() {                                      // 257
    // Logs out all identities that are allowed to log in to the current account.                                      //
    var user = Meteor.user();                                                                                          // 259
    if (user && user.loginIdentities) {                                                                                // 260
      user.loginIdentities.forEach(function (identity) {                                                               // 261
        Meteor.users.update({ _id: identity.id }, { $set: { "services.resume.loginTokens": [] } });                    // 262
      });                                                                                                              // 263
    }                                                                                                                  // 264
  }                                                                                                                    // 265
});                                                                                                                    // 109
                                                                                                                       //
Accounts.linkIdentityToAccount = function (db, backend, identityId, accountId) {                                       // 268
  // Links the identity to the account. If the account is a demo account, makes it durable and                         //
  // gives the identity login access to it.                                                                            //
  check(db, SandstormDb);                                                                                              // 271
  check(backend, SandstormBackend);                                                                                    // 272
  check(identityId, String);                                                                                           // 273
  check(accountId, String);                                                                                            // 274
  linkIdentityToAccountInternal(db, backend, identityId, accountId);                                                   // 275
};                                                                                                                     // 276
                                                                                                                       //
Meteor.publish("accountsOfIdentity", function (identityId) {                                                           // 278
  check(identityId, String);                                                                                           // 279
  if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                              // 280
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var loginIdentities = {};                                                                                            // 283
                                                                                                                       //
  var _this = this;                                                                                                    // 285
  function addIdentitiesOfAccount(account) {                                                                           // 286
    account.loginIdentities.forEach(function (identity) {                                                              // 287
      if (!(identity.id in loginIdentities)) {                                                                         // 288
        var user = Meteor.users.findOne({ _id: identity.id });                                                         // 289
        if (user) {                                                                                                    // 290
          SandstormDb.fillInProfileDefaults(user);                                                                     // 291
          SandstormDb.fillInIntrinsicName(user);                                                                       // 292
          SandstormDb.fillInLoginId(user);                                                                             // 293
          var filteredUser = _.pick(user, "_id", "profile", "loginId");                                                // 294
          filteredUser.loginAccountId = account._id;                                                                   // 295
          filteredUser.sourceIdentityId = identityId;                                                                  // 296
          _this.added("loginIdentitiesOfLinkedAccounts", user._id, filteredUser);                                      // 297
        }                                                                                                              // 298
                                                                                                                       //
        loginIdentities[identity.id] = Meteor.users.find({ _id: identity.id }, { fields: { profile: 1 } }).observeChanges({
          changed: function changed(id, fields) {                                                                      // 302
            _this.changed("loginIdentitiesOfLinkedAccounts", id, fields);                                              // 303
          }                                                                                                            // 304
        });                                                                                                            // 301
      }                                                                                                                // 306
    });                                                                                                                // 307
  }                                                                                                                    // 308
                                                                                                                       //
  var cursor = Meteor.users.find({                                                                                     // 310
    $or: [{ "loginIdentities.id": identityId }, { "nonloginIdentities.id": identityId }]                               // 311
  });                                                                                                                  // 310
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 317
    added: function added(account) {                                                                                   // 318
      addIdentitiesOfAccount(account);                                                                                 // 319
    },                                                                                                                 // 320
                                                                                                                       //
    changed: function changed(newAccount, oldAccount) {                                                                // 322
      addIdentitiesOfAccount(newAccount);                                                                              // 323
    },                                                                                                                 // 324
                                                                                                                       //
    removed: function removed(account) {                                                                               // 326
      account.loginIdentities.forEach(function (identity) {                                                            // 327
        if (identity.id in loginIdentities) {                                                                          // 328
          _this.removed("loginIdentitiesOfLinkedAccounts", identity.id);                                               // 329
          loginIdentities[identity.id].stop();                                                                         // 330
          delete loginIdentities[identity.id];                                                                         // 331
        }                                                                                                              // 332
      });                                                                                                              // 333
    }                                                                                                                  // 334
  });                                                                                                                  // 317
  this.ready();                                                                                                        // 336
                                                                                                                       //
  this.onStop(function () {                                                                                            // 338
    handle.stop();                                                                                                     // 339
    Object.keys(loginIdentities).forEach(function (identityId) {                                                       // 340
      loginIdentities[identityId].stop();                                                                              // 341
      delete loginIdentities[identityId];                                                                              // 342
    });                                                                                                                // 343
  });                                                                                                                  // 344
});                                                                                                                    // 345
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"ldap":{"ldap-server.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/ldap/ldap-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});                               // 1
                                                                                                                       //
// Register login handler with Meteor                                                                                  //
Accounts.registerLoginHandler("ldap", function (loginRequest) {                                                        // 4
  // If 'ldap' isn't set in loginRequest object,                                                                       //
  // then this isn't the proper handler (return undefined)                                                             //
  if (!loginRequest.ldap) {                                                                                            // 7
    return undefined;                                                                                                  // 8
  }                                                                                                                    // 9
                                                                                                                       //
  if (!Accounts.identityServices.ldap.isEnabled()) {                                                                   // 11
    throw new Meteor.Error(403, "LDAP service is disabled.");                                                          // 12
  }                                                                                                                    // 13
                                                                                                                       //
  check(loginRequest, {                                                                                                // 15
    ldap: true,                                                                                                        // 16
    username: String,                                                                                                  // 17
    ldapPass: String                                                                                                   // 18
  });                                                                                                                  // 15
                                                                                                                       //
  // Instantiate LDAP                                                                                                  //
  var ldapObj = new LDAP();                                                                                            // 22
                                                                                                                       //
  // Call ldapCheck and get response                                                                                   //
  var ldapResponse = ldapObj.ldapCheck(this.connection.sandstormDb, loginRequest);                                     // 25
                                                                                                                       //
  if (ldapResponse.error) {                                                                                            // 27
    return {                                                                                                           // 28
      userId: null,                                                                                                    // 29
      error: ldapResponse.error                                                                                        // 30
    };                                                                                                                 // 28
  } else if (ldapResponse.emptySearch) {                                                                               // 32
    return {                                                                                                           // 33
      userId: null,                                                                                                    // 34
      error: new Meteor.Error(403, "User not found in LDAP")                                                           // 35
    };                                                                                                                 // 33
  } else {                                                                                                             // 37
    // Set initial userId and token vals                                                                               //
    return Accounts.updateOrCreateUserFromExternalService("ldap", { id: ldapResponse.dn, username: loginRequest.username,
      rawAttrs: ldapResponse.searchResults }, {});                                                                     // 41
  }                                                                                                                    // 42
});                                                                                                                    // 44
                                                                                                                       //
Meteor.methods({                                                                                                       // 46
  updateQuota: function updateQuota() {                                                                                // 47
    return this.connection.sandstormDb.updateUserQuota(Meteor.user());                                                 // 48
    // This is a no-op if settings aren't enabled                                                                      //
  }                                                                                                                    // 50
});                                                                                                                    // 46
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"saml":{"saml-server.js":["url","/imports/server/accounts/saml-utils.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/saml/saml-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Url;module.import("url",{"default":function(v){Url=v}});var SAML;module.import("/imports/server/accounts/saml-utils.js",{"SAML":function(v){SAML=v}});
                                                                                                                       // 2
                                                                                                                       //
var Fiber = Npm.require("fibers");                                                                                     // 4
                                                                                                                       //
if (!Accounts.saml) {                                                                                                  // 6
  Accounts.saml = {};                                                                                                  // 7
}                                                                                                                      // 8
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 12
                                                                                                                       //
RoutePolicy.declare("/_saml/", "network");                                                                             // 14
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 16
                                                                                                                       //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                            //
//   replicated (but currently Sandstorm for Work is not replicated).                                                  //
var _loginResultForCredentialToken = {};                                                                               // 20
                                                                                                                       //
var retrieveCredential = function retrieveCredential(credentialToken) {                                                // 22
  var result = _loginResultForCredentialToken[credentialToken];                                                        // 23
  delete _loginResultForCredentialToken[credentialToken];                                                              // 24
  return result;                                                                                                       // 25
};                                                                                                                     // 26
                                                                                                                       //
Accounts.registerLoginHandler(function (loginRequest) {                                                                // 28
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                           // 29
    return undefined;                                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                   // 33
    throw new Meteor.Error(403, "SAML service is disabled.");                                                          // 34
  }                                                                                                                    // 35
                                                                                                                       //
  var loginResult = retrieveCredential(loginRequest.credentialToken);                                                  // 37
  if (!loginResult) {                                                                                                  // 38
    throw new Meteor.Error(500, "SAML login did not complete.");                                                       // 39
  } else if (loginResult.profile && loginResult.profile.email) {                                                       // 40
    var user = _.pick(loginResult.profile, "displayName", "email");                                                    // 41
    user.id = loginResult.profile.nameID;                                                                              // 42
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                           // 43
  } else {                                                                                                             // 44
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                      // 45
  }                                                                                                                    // 46
});                                                                                                                    // 47
                                                                                                                       //
var samlUrlToObject = function samlUrlToObject(url) {                                                                  // 49
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                                //
  if (!url) return null;                                                                                               // 51
                                                                                                                       //
  var splitPath = url.split("/");                                                                                      // 54
                                                                                                                       //
  // Any non-saml request will continue down the default                                                               //
  // middlewares.                                                                                                      //
  if (splitPath[1] !== "_saml") return null;                                                                           // 58
                                                                                                                       //
  return {                                                                                                             // 61
    actionName: splitPath[2],                                                                                          // 62
    serviceName: splitPath[3],                                                                                         // 63
    credentialToken: splitPath[4]                                                                                      // 64
  };                                                                                                                   // 61
};                                                                                                                     // 66
                                                                                                                       //
var closePopup = function closePopup(res, err) {                                                                       // 68
  res.writeHead(200, { "Content-Type": "text/html" });                                                                 // 69
  var content = "<html><head><script>window.close()</script></head></html>";                                           // 70
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a></body></html>';
  res.end(content, "utf-8");                                                                                           // 74
};                                                                                                                     // 75
                                                                                                                       //
var generateService = function generateService() {                                                                     // 77
  var entityId = SandstormDb.prototype.getSamlEntityId();                                                              // 78
  var service = {                                                                                                      // 79
    "provider": "default",                                                                                             // 80
    "entryPoint": SandstormDb.prototype.getSamlEntryPoint(),                                                           // 81
    // TODO(someday): find a better way to inject the DB                                                               //
    "issuer": entityId || HOSTNAME,                                                                                    // 83
    "cert": SandstormDb.prototype.getSamlPublicCert()                                                                  // 84
  };                                                                                                                   // 79
  return service;                                                                                                      // 86
};                                                                                                                     // 87
                                                                                                                       //
var middleware = function middleware(req, res, next) {                                                                 // 89
  // Make sure to catch any exceptions because otherwise we'd crash                                                    //
  // the runner                                                                                                        //
  try {                                                                                                                // 92
    var samlObject = samlUrlToObject(req.url);                                                                         // 93
    if (!samlObject || !samlObject.serviceName) {                                                                      // 94
      next();                                                                                                          // 95
      return;                                                                                                          // 96
    }                                                                                                                  // 97
                                                                                                                       //
    if (samlObject.actionName === "config") {                                                                          // 99
      var _saml = new SAML(generateService());                                                                         // 100
      res.writeHead(200, { "Content-Type": "text/xml" });                                                              // 101
      res.end(_saml.generateServiceProviderMetadata());                                                                // 102
      return;                                                                                                          // 103
    }                                                                                                                  // 104
                                                                                                                       //
    if (!Accounts.identityServices.saml.isEnabled()) {                                                                 // 106
      next();                                                                                                          // 107
      return;                                                                                                          // 108
    }                                                                                                                  // 109
                                                                                                                       //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                                // 111
                                                                                                                       //
    var service = generateService();                                                                                   // 114
                                                                                                                       //
    // Skip everything if there's no service set by the saml middleware                                                //
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                       //
    if (samlObject.actionName === "authorize") {                                                                       // 120
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                                  // 121
      service.id = samlObject.credentialToken;                                                                         // 122
      var _saml2 = new SAML(service);                                                                                  // 123
      _saml2.getAuthorizeUrl(req, function (err, url) {                                                                // 124
        if (err) throw new Error("Unable to generate authorize url");                                                  // 125
        res.writeHead(302, { "Location": url });                                                                       // 127
        res.end();                                                                                                     // 128
      });                                                                                                              // 129
    } else if (samlObject.actionName === "validate") {                                                                 // 130
      var _saml3 = new SAML(service);                                                                                  // 131
      _saml3.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut) {                              // 132
        if (err) {                                                                                                     // 133
          console.error("Error validating SAML response", err.toString());                                             // 134
          throw new Error("Unable to validate response url");                                                          // 135
        }                                                                                                              // 136
                                                                                                                       //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                     //
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                          // 139
        if (!credentialToken) {                                                                                        // 140
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                              // 145
                                                                                                                       //
        _loginResultForCredentialToken[credentialToken] = {                                                            // 147
          profile: profile                                                                                             // 148
        };                                                                                                             // 147
                                                                                                                       //
        closePopup(res);                                                                                               // 151
      });                                                                                                              // 152
    } else {                                                                                                           // 153
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                              // 154
    }                                                                                                                  // 155
  } catch (err) {                                                                                                      // 156
    closePopup(res, err);                                                                                              // 157
  }                                                                                                                    // 158
};                                                                                                                     // 159
                                                                                                                       //
// Listen to incoming OAuth http requests                                                                              //
WebApp.connectHandlers.use(connect.urlencoded()).use(function (req, res, next) {                                       // 162
  // Need to create a Fiber since we're using synchronous http calls and nothing                                       //
  // else is wrapping this in a fiber automatically                                                                    //
  Fiber(function () {                                                                                                  // 165
    middleware(req, res, next);                                                                                        // 166
  }).run();                                                                                                            // 167
});                                                                                                                    // 168
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"accounts-server.js":["meteor/accounts-base","/imports/server/accounts/picture.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Accounts;module.import("meteor/accounts-base",{"Accounts":function(v){Accounts=v}});var fetchPicture,userPictureUrl;module.import("/imports/server/accounts/picture.js",{"fetchPicture":function(v){fetchPicture=v},"userPictureUrl":function(v){userPictureUrl=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 20
var Future = Npm.require("fibers/future");                                                                             // 21
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 23
  check(handle, String);                                                                                               // 24
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 25
});                                                                                                                    // 26
                                                                                                                       //
Accounts.onCreateUser(function (options, user) {                                                                       // 28
  if (user.loginIdentities) {                                                                                          // 29
    // it's an account                                                                                                 //
    check(user, { _id: String,                                                                                         // 31
      createdAt: Date,                                                                                                 // 32
      isAdmin: Match.Optional(Boolean),                                                                                // 33
      hasCompletedSignup: Match.Optional(Boolean),                                                                     // 34
      signupKey: Match.Optional(String),                                                                               // 35
      signupNote: Match.Optional(String),                                                                              // 36
      signupEmail: Match.Optional(String),                                                                             // 37
      expires: Match.Optional(Date),                                                                                   // 38
      appDemoId: Match.Optional(String),                                                                               // 39
      loginIdentities: [{ id: String }],                                                                               // 40
      nonloginIdentities: [{ id: String }] });                                                                         // 41
                                                                                                                       //
    if (globalDb.isReferralEnabled()) {                                                                                // 43
      user.experiments = user.experiments || {};                                                                       // 44
      user.experiments = {                                                                                             // 45
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                               // 46
      };                                                                                                               // 45
      if (!("expires" in user)) {                                                                                      // 48
        globalDb.sendReferralProgramNotification(user._id);                                                            // 49
      }                                                                                                                // 50
    }                                                                                                                  // 51
                                                                                                                       //
    globalDb.preinstallAppsForUser(user._id);                                                                          // 53
                                                                                                                       //
    return user;                                                                                                       // 55
  }                                                                                                                    // 56
                                                                                                                       //
  if (globalDb.getOrganizationDisallowGuests() && !globalDb.isIdentityInOrganization(user)) {                          // 58
    throw new Meteor.Error(400, "User not in organization.");                                                          // 60
  }                                                                                                                    // 61
                                                                                                                       //
  // Check profile.                                                                                                    //
  if (options.profile) {                                                                                               // 64
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                               //
    check(options.profile, Match.ObjectIncluding({                                                                     // 66
      name: Match.OneOf(null, Match.Optional(String)),                                                                 // 67
      handle: Match.Optional(ValidHandle),                                                                             // 68
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                       // 69
    }));                                                                                                               // 66
  }                                                                                                                    // 71
                                                                                                                       //
  check(options.unverifiedEmail, Match.Optional(String));                                                              // 73
                                                                                                                       //
  if (options.unverifiedEmail) {                                                                                       // 75
    user.unverifiedEmail = options.unverifiedEmail;                                                                    // 76
  }                                                                                                                    // 77
                                                                                                                       //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronouns");                                          // 79
                                                                                                                       //
  // Try downloading avatar.                                                                                           //
  var url = userPictureUrl(user);                                                                                      // 82
  if (url) {                                                                                                           // 83
    var assetId = fetchPicture(globalDb, url);                                                                         // 84
    if (assetId) {                                                                                                     // 85
      user.profile.picture = assetId;                                                                                  // 86
    }                                                                                                                  // 87
  }                                                                                                                    // 88
                                                                                                                       //
  var serviceUserId = void 0;                                                                                          // 90
  if (user.services && user.services.dev) {                                                                            // 91
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                         // 92
    serviceUserId = user.services.dev.name;                                                                            // 93
    user.profile.service = "dev";                                                                                      // 94
  } else if ("expires" in user) {                                                                                      // 95
    serviceUserId = user._id;                                                                                          // 96
    user.profile.service = "demo";                                                                                     // 97
  } else if (user.services && user.services.email) {                                                                   // 98
    check(user.services.email, {                                                                                       // 99
      email: String,                                                                                                   // 100
      tokens: [{                                                                                                       // 101
        digest: String,                                                                                                // 103
        algorithm: String,                                                                                             // 104
        createdAt: Date,                                                                                               // 105
        secureBox: Match.Optional({                                                                                    // 106
          version: Number,                                                                                             // 107
          salt: String,                                                                                                // 108
          iv: String,                                                                                                  // 109
          boxedValue: String                                                                                           // 110
        })                                                                                                             // 106
      }]                                                                                                               // 102
    });                                                                                                                // 99
    serviceUserId = user.services.email.email;                                                                         // 115
    user.profile.service = "email";                                                                                    // 116
  } else if (user.services && "google" in user.services) {                                                             // 117
    serviceUserId = user.services.google.id;                                                                           // 118
    user.profile.service = "google";                                                                                   // 119
  } else if (user.services && "github" in user.services) {                                                             // 120
    serviceUserId = user.services.github.id;                                                                           // 121
    user.profile.service = "github";                                                                                   // 122
  } else if (user.services && "ldap" in user.services) {                                                               // 123
    serviceUserId = user.services.ldap.id;                                                                             // 124
    user.profile.service = "ldap";                                                                                     // 125
  } else if (user.services && "saml" in user.services) {                                                               // 126
    serviceUserId = user.services.saml.id;                                                                             // 127
    user.profile.service = "saml";                                                                                     // 128
  } else {                                                                                                             // 129
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));         // 130
  }                                                                                                                    // 132
                                                                                                                       //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");             // 134
                                                                                                                       //
  return user;                                                                                                         // 137
});                                                                                                                    // 138
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 140
  if (!attempt.allowed) {                                                                                              // 141
    return false;                                                                                                      // 142
  }                                                                                                                    // 143
                                                                                                                       //
  var db = attempt.connection.sandstormDb;                                                                             // 145
  var user = attempt.user;                                                                                             // 146
                                                                                                                       //
  if (user.suspended && user.suspended.admin) {                                                                        // 148
    throw new Meteor.Error(403, "User has been suspended. Please contact the administrator " + "of this server if you believe this to be in error.");
  }                                                                                                                    // 151
                                                                                                                       //
  if (user.loginIdentities) {                                                                                          // 153
    // it's an account                                                                                                 //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                        // 155
      throw new Meteor.Error(403, "User not in organization.");                                                        // 157
    }                                                                                                                  // 158
                                                                                                                       //
    db.updateUserQuota(user); // This is a no-op if settings aren't enabled                                            // 160
  } else {                                                                                                             // 161
      if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                  // 162
        throw new Meteor.Error(403, "User not in organization.");                                                      // 164
      }                                                                                                                // 165
    }                                                                                                                  // 166
                                                                                                                       //
  return true;                                                                                                         // 168
});                                                                                                                    // 169
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"accounts-ui-methods.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-methods.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file contains method definitions which are available on both client and server (on the                         //
// client for prediction purposes, on the server for actual execution).                                                //
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 20
  check(handle, String);                                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  updateProfile: function updateProfile(identityId, profile) {                                                         // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                                //
    check(identityId, String);                                                                                         // 28
                                                                                                                       //
    check(profile, {                                                                                                   // 30
      name: String,                                                                                                    // 31
      handle: ValidHandle,                                                                                             // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                                      // 33
      unverifiedEmail: Match.Optional(String)                                                                          // 34
    });                                                                                                                // 30
                                                                                                                       //
    if (!this.userId) {                                                                                                // 37
      throw new Meteor.Error(403, "not logged in");                                                                    // 38
    }                                                                                                                  // 39
                                                                                                                       //
    var userToUpdate = Meteor.users.findOne({ _id: identityId });                                                      // 41
                                                                                                                       //
    if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                 // 43
      throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);                            // 45
    }                                                                                                                  // 46
                                                                                                                       //
    var newValues = {                                                                                                  // 48
      "profile.name": profile.name,                                                                                    // 49
      "profile.handle": profile.handle,                                                                                // 50
      "profile.pronoun": profile.pronoun                                                                               // 51
    };                                                                                                                 // 48
                                                                                                                       //
    Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                                               // 54
                                                                                                                       //
    if (!Meteor.user().hasCompletedSignup) {                                                                           // 56
      Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });                               // 57
    }                                                                                                                  // 58
  },                                                                                                                   // 59
                                                                                                                       //
  testFirstSignup: function testFirstSignup(profile) {                                                                 // 61
    if (!this.userId) {                                                                                                // 62
      throw new Meteor.Error(403, "not logged in");                                                                    // 63
    }                                                                                                                  // 64
                                                                                                                       //
    Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                                          // 66
  },                                                                                                                   // 67
                                                                                                                       //
  uploadProfilePicture: function uploadProfilePicture(identityId) {                                                    // 69
    check(identityId, String);                                                                                         // 70
    if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                       // 71
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 72
    }                                                                                                                  // 73
                                                                                                                       //
    return this.connection.sandstormDb.newAssetUpload({                                                                // 75
      profilePicture: { userId: this.userId, identityId: identityId }                                                  // 76
    });                                                                                                                // 75
  },                                                                                                                   // 78
                                                                                                                       //
  cancelUploadProfilePicture: function cancelUploadProfilePicture(id) {                                                // 80
    check(id, String);                                                                                                 // 81
    this.connection.sandstormDb.fulfillAssetUpload(id);                                                                // 82
  },                                                                                                                   // 83
                                                                                                                       //
  setPrimaryEmail: function setPrimaryEmail(email) {                                                                   // 85
    check(email, String);                                                                                              // 86
    if (!this.userId) {                                                                                                // 87
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 88
    }                                                                                                                  // 89
                                                                                                                       //
    var emails = SandstormDb.getUserEmails(Meteor.user());                                                             // 91
    if (!_.findWhere(emails, { email: email, verified: true })) {                                                      // 92
      throw new Meteor.Error(403, "Not a verified email of the current user: " + email);                               // 93
    }                                                                                                                  // 94
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                                      // 96
  }                                                                                                                    // 97
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"accounts-ui-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-server.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                                       //
Meteor.users.deny({                                                                                                    // 18
  insert: function insert() {                                                                                          // 19
    return true;                                                                                                       // 19
  },                                                                                                                   // 19
                                                                                                                       //
  update: function update() {                                                                                          // 21
    return true;                                                                                                       // 21
  },                                                                                                                   // 21
                                                                                                                       //
  remove: function remove() {                                                                                          // 23
    return true;                                                                                                       // 23
  },                                                                                                                   // 23
                                                                                                                       //
  fetch: []                                                                                                            // 25
});                                                                                                                    // 18
                                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                                             // 28
  var db = this.connection.sandstormDb;                                                                                // 29
  if (this.userId) {                                                                                                   // 30
    // TODO(someday): Make this reactive.                                                                              //
    var user = Meteor.users.findOne(this.userId);                                                                      // 32
    var usage = db.getMyUsage(user);                                                                                   // 33
    this.added("users", this.userId, {                                                                                 // 34
      pseudoUsage: usage                                                                                               // 35
    });                                                                                                                // 34
  }                                                                                                                    // 37
                                                                                                                       //
  this.ready();                                                                                                        // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function setMaintenanceMessage(params) {                                                      // 12
    checkAuth(undefined);                                                                                              // 13
    check(params, maintenanceMessageShape);                                                                            // 14
    var db = this.connection.sandstormDb;                                                                              // 15
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                                 // 17
    db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                   // 18
    db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                     // 19
  }                                                                                                                    // 20
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String,                                                                                            // 10
                                                                                                                       //
  whitelabelCustomLoginProviderName: String,                                                                           // 12
  whitelabelHideSendFeedback: Boolean,                                                                                 // 13
  whitelabelHideTroubleshooting: Boolean,                                                                              // 14
  whitelabelUseServerTitleForHomeText: Boolean                                                                         // 15
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 18
  setPersonalizationSettings: function setPersonalizationSettings(params) {                                            // 19
    checkAuth(undefined);                                                                                              // 20
    check(params, personalizationMessageShape);                                                                        // 21
    var db = this.connection.sandstormDb;                                                                              // 22
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                             // 24
    db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                                 // 25
    db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                           // 26
    db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                          // 27
    db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                         // 28
                                                                                                                       //
    db.collections.settings.upsert({ _id: "whitelabelCustomLoginProviderName" }, { value: params.whitelabelCustomLoginProviderName });
    db.collections.settings.upsert({ _id: "whitelabelHideSendFeedback" }, { value: params.whitelabelHideSendFeedback });
    db.collections.settings.upsert({ _id: "whitelabelHideTroubleshooting" }, { value: params.whitelabelHideTroubleshooting });
    db.collections.settings.upsert({ _id: "whitelabelUseServerTitleForHomeText" }, { value: params.whitelabelUseServerTitleForHomeText });
  },                                                                                                                   // 38
  getWhitelabelLogoUploadToken: function getWhitelabelLogoUploadToken() {                                              // 40
    checkAuth(undefined);                                                                                              // 41
    var db = this.connection.sandstormDb;                                                                              // 42
    return db.newAssetUpload({ loginLogo: {} });                                                                       // 43
  },                                                                                                                   // 44
  resetWhitelabelLogo: function resetWhitelabelLogo() {                                                                // 46
    checkAuth(undefined);                                                                                              // 47
    var db = this.connection.sandstormDb;                                                                              // 48
    var result = globalDb.collections.settings.findAndModify({                                                         // 49
      query: { _id: "whitelabelCustomLogoAssetId" },                                                                   // 50
      remove: true,                                                                                                    // 51
      fields: { value: 1 }                                                                                             // 52
    });                                                                                                                // 49
                                                                                                                       //
    if (result.ok) {                                                                                                   // 55
      var old = result.value;                                                                                          // 56
      if (old) {                                                                                                       // 57
        db.unrefStaticAsset(old.value);                                                                                // 58
      }                                                                                                                // 59
    } else {                                                                                                           // 60
      throw new Meteor.Error(500, "Couldn't remove whitelabelCustomLogoAssetId");                                      // 61
    }                                                                                                                  // 62
  }                                                                                                                    // 63
});                                                                                                                    // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       //
                                                                                                                       // 7
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 9
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 10
};                                                                                                                     // 11
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 15
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 16
                                                                                                                       //
Meteor.methods({                                                                                                       // 18
  adminGetServerLogDownloadToken: function adminGetServerLogDownloadToken() {                                          // 19
    var db = this.connection.sandstormDb;                                                                              // 20
    if (!db.isAdminById(this.userId)) {                                                                                // 21
      throw new Meteor.Error(403, "User must be admin to download system log.");                                       // 22
    }                                                                                                                  // 23
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 25
    SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                    // 26
    setTimeout(function () {                                                                                           // 27
      if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                         // 28
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                      // 29
      }                                                                                                                // 30
    }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                               // 31
    return token;                                                                                                      // 32
  }                                                                                                                    // 33
});                                                                                                                    // 18
                                                                                                                       //
Router.map(function () {                                                                                               // 36
  this.route("adminDownloadServerLog", {                                                                               // 37
    where: "server",                                                                                                   // 38
    path: "/admin/status/server-log/:tokenId",                                                                         // 39
    action: function action() {                                                                                        // 40
      var token = this.params.tokenId;                                                                                 // 41
      var response = this.response;                                                                                    // 42
      var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                               // 43
      delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                             // 44
      if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {           // 45
        // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                           //
        // method being called.                                                                                        //
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 49
        return response.end("Invalid server log download token.");                                                     // 50
      }                                                                                                                // 51
                                                                                                                       //
      var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                           // 53
      var fd = Fs.openSync(logFilePath, "r");                                                                          // 54
      var stats = Fs.fstatSync(fd);                                                                                    // 55
      var initialSize = stats.size;                                                                                    // 56
      var readStream = Fs.createReadStream(undefined, {                                                                // 57
        fd: fd,                                                                                                        // 58
        start: 0,                                                                                                      // 59
        end: initialSize                                                                                               // 60
      });                                                                                                              // 57
                                                                                                                       //
      response.writeHead(200, {                                                                                        // 63
        "Content-Length": initialSize,                                                                                 // 64
        "Content-Type": "text/plain",                                                                                  // 65
        "content-Disposition": "attachment;filename=\"sandstorm.log\""                                                 // 66
      });                                                                                                              // 63
      readStream.pipe(response);                                                                                       // 68
    }                                                                                                                  // 69
  });                                                                                                                  // 37
});                                                                                                                    // 71
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 73
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 76
  if (!db.isAdminById(this.userId)) {                                                                                  // 77
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 78
  }                                                                                                                    // 79
                                                                                                                       //
  var _this = this;                                                                                                    // 81
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 82
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 83
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 85
  var grainIdCount = 0;                                                                                                // 86
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 88
    activeUsers: userIdCount,                                                                                          // 89
    activeGrains: grainIdCount                                                                                         // 90
  });                                                                                                                  // 88
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 93
  var handle = query.observe({                                                                                         // 94
    added: function added(session) {                                                                                   // 95
      var hashedSessionId = hashSessionId(session._id);                                                                // 96
      var changed = {};                                                                                                // 97
                                                                                                                       //
      // Update userId cache.                                                                                          //
      if (session.userId) {                                                                                            // 100
        if (userIdToSessionHashes[session.userId] === undefined) {                                                     // 101
          userIdToSessionHashes[session.userId] = [];                                                                  // 102
          userIdCount = userIdCount + 1;                                                                               // 103
          changed.activeUsers = userIdCount;                                                                           // 104
        }                                                                                                              // 105
                                                                                                                       //
        userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);     // 107
      }                                                                                                                // 109
                                                                                                                       //
      // Update grainId cache.                                                                                         //
      if (grainIdToSessionHashes[session.grainId] === undefined) {                                                     // 112
        grainIdToSessionHashes[session.grainId] = [];                                                                  // 113
        grainIdCount = grainIdCount + 1;                                                                               // 114
        changed.activeGrains = grainIdCount;                                                                           // 115
      }                                                                                                                // 116
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);   // 118
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 121
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 122
      }                                                                                                                // 123
    },                                                                                                                 // 124
    removed: function removed(session) {                                                                               // 126
      var hashedSessionId = hashSessionId(session._id);                                                                // 127
      var changed = {};                                                                                                // 128
                                                                                                                       //
      if (session.userId) {                                                                                            // 130
        userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);     // 131
                                                                                                                       //
        if (userIdToSessionHashes[session.userId].length === 0) {                                                      // 134
          delete userIdToSessionHashes[session.userId];                                                                // 135
          userIdCount = userIdCount - 1;                                                                               // 136
          changed.activeUsers = userIdCount;                                                                           // 137
        }                                                                                                              // 138
      }                                                                                                                // 139
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);   // 141
                                                                                                                       //
      if (grainIdToSessionHashes[session.grainId].length === 0) {                                                      // 144
        delete grainIdToSessionHashes[session.grainId];                                                                // 145
        grainIdCount = grainIdCount - 1;                                                                               // 146
        changed.activeGrains = grainIdCount;                                                                           // 147
      }                                                                                                                // 148
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 150
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 151
      }                                                                                                                // 152
    }                                                                                                                  // 153
  });                                                                                                                  // 94
                                                                                                                       //
  this.onStop(function () {                                                                                            // 156
    handle.stop();                                                                                                     // 157
  });                                                                                                                  // 158
  this.ready();                                                                                                        // 159
});                                                                                                                    // 160
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 162
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 165
  if (!db.isAdminById(this.userId)) {                                                                                  // 166
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 167
  }                                                                                                                    // 168
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 170
    expires: {                                                                                                         // 171
      $gt: new Date()                                                                                                  // 172
    },                                                                                                                 // 171
    loginIdentities: {                                                                                                 // 174
      $exists: true                                                                                                    // 175
    }                                                                                                                  // 174
  }, {                                                                                                                 // 170
    expires: 1,                                                                                                        // 178
    loginIdentities: 1                                                                                                 // 179
  });                                                                                                                  // 177
});                                                                                                                    // 181
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
var Url = Npm.require("url");                                                                                          // 19
var Http = Npm.require("http");                                                                                        // 20
var Https = Npm.require("https");                                                                                      // 21
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 22
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 24
  function ExternalUiView(url, grainId, token) {                                                                       // 25
    _classCallCheck(this, ExternalUiView);                                                                             // 25
                                                                                                                       //
    this.url = url;                                                                                                    // 26
    this.grainId = grainId;                                                                                            // 27
    this.token = token;                                                                                                // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ExternalUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams) {           // 24
    if (sessionType !== ApiSession.typeId) {                                                                           // 32
      throw new Error("SessionType must be ApiSession.");                                                              // 33
    }                                                                                                                  // 34
                                                                                                                       //
    var options = {};                                                                                                  // 36
                                                                                                                       //
    if (this.token) {                                                                                                  // 38
      options.headers = {                                                                                              // 39
        authorization: "Bearer " + this.token                                                                          // 40
      };                                                                                                               // 39
    }                                                                                                                  // 42
                                                                                                                       //
    return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };     // 44
  };                                                                                                                   // 45
                                                                                                                       //
  return ExternalUiView;                                                                                               // 24
}();                                                                                                                   // 24
                                                                                                                       //
var responseCodes = {                                                                                                  // 48
  200: { type: "content", code: "ok" },                                                                                // 49
  201: { type: "content", code: "created" },                                                                           // 50
  202: { type: "content", code: "accepted" },                                                                          // 51
  204: { type: "noContent", shouldResetForm: false },                                                                  // 52
  205: { type: "noContent", shouldResetForm: true },                                                                   // 53
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 58
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 59
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 60
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 65
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 66
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 67
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 68
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 69
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 70
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 71
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 72
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 73
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 75
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 76
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 77
  500: { type: "serverError" },                                                                                        // 78
  501: { type: "serverError" },                                                                                        // 79
  502: { type: "serverError" },                                                                                        // 80
  503: { type: "serverError" },                                                                                        // 81
  504: { type: "serverError" },                                                                                        // 82
  505: { type: "serverError" }                                                                                         // 83
};                                                                                                                     // 48
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 86
  function ExternalWebSession(url, grainId, options) {                                                                 // 87
    _classCallCheck(this, ExternalWebSession);                                                                         // 87
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 88
    this.host = parsedUrl.hostname;                                                                                    // 89
    this.port = parsedUrl.port;                                                                                        // 90
    this.protocol = parsedUrl.protocol;                                                                                // 91
    this.grainId = grainId;                                                                                            // 92
    this.options = options || {};                                                                                      // 93
  }                                                                                                                    // 94
                                                                                                                       //
  ExternalWebSession.prototype.get = function get(path, context) {                                                     // 86
    return this._requestHelper("GET", path, context);                                                                  // 97
  };                                                                                                                   // 98
                                                                                                                       //
  ExternalWebSession.prototype.post = function post(path, content, context) {                                          // 86
    return this._requestHelper("POST", path, context, content.content, content.mimeType);                              // 101
  };                                                                                                                   // 102
                                                                                                                       //
  ExternalWebSession.prototype.put = function put(path, content, context) {                                            // 86
    return this._requestHelper("PUT", path, context, content.content, content.mimeType);                               // 105
  };                                                                                                                   // 106
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function _delete(path, context) {                                           // 86
    return this._requestHelper("DELETE", path, context);                                                               // 109
  };                                                                                                                   // 110
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function _requestHelper(method, path, context, content, contentType) {
    var _this = this;                                                                                                  // 123
    var session = _this;                                                                                               // 124
    return new Promise(function (resolve, reject) {                                                                    // 125
      var options = _.clone(session.options);                                                                          // 126
      options.headers = options.headers || {};                                                                         // 127
      options.path = path;                                                                                             // 128
      options.method = method;                                                                                         // 129
      if (contentType) {                                                                                               // 130
        options.headers["content-type"] = contentType;                                                                 // 131
      }                                                                                                                // 132
                                                                                                                       //
      // set accept header                                                                                             //
      if ("accept" in context) {                                                                                       // 135
        options.headers.accept = context.accept.map(function (acceptedType) {                                          // 136
          return acceptedType.mimeType + "; " + acceptedType.qValue;                                                   // 137
        }).join(", ");                                                                                                 // 138
      } else if (!("accept" in options.headers)) {                                                                     // 139
        options.headers.accept = "*/*";                                                                                // 140
      }                                                                                                                // 141
                                                                                                                       //
      // set cookies                                                                                                   //
      if (context.cookies && context.cookies.length > 0) {                                                             // 144
        options.headers.cookies = options.headers.cookies || "";                                                       // 145
        context.cookies.forEach(function (keyVal) {                                                                    // 146
          options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                              // 147
        });                                                                                                            // 148
        options.headers.cookies = options.headers.cookies.slice(0, -1);                                                // 149
      }                                                                                                                // 150
                                                                                                                       //
      options.host = session.host;                                                                                     // 152
      options.port = session.port;                                                                                     // 153
                                                                                                                       //
      var requestMethod = Http.request;                                                                                // 155
      if (session.protocol === "https:") {                                                                             // 156
        requestMethod = Https.request;                                                                                 // 157
      }                                                                                                                // 158
                                                                                                                       //
      req = requestMethod(options, function (resp) {                                                                   // 160
        var buffers = [];                                                                                              // 161
        var statusInfo = responseCodes[resp.statusCode];                                                               // 162
                                                                                                                       //
        var rpcResponse = {};                                                                                          // 164
                                                                                                                       //
        switch (statusInfo.type) {                                                                                     // 166
          case "content":                                                                                              // 167
            resp.on("data", function (buf) {                                                                           // 168
              buffers.push(buf);                                                                                       // 169
            });                                                                                                        // 170
                                                                                                                       //
            resp.on("end", function () {                                                                               // 172
              var content = {};                                                                                        // 173
              rpcResponse.content = content;                                                                           // 174
                                                                                                                       //
              content.statusCode = statusInfo.code;                                                                    // 176
              if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];             // 177
              if ("content-language" in resp.headers) content.language = resp.headers["content-language"];             // 178
              if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                     // 179
              if ("content-disposition" in resp.headers) {                                                             // 180
                var disposition = resp.headers["content-disposition"];                                                 // 181
                var parts = disposition.split(";");                                                                    // 182
                if (parts[0].toLowerCase().trim() === "attachment") {                                                  // 183
                  parts.forEach(function (part) {                                                                      // 184
                    var splitPart = part.split("=");                                                                   // 185
                    if (splitPart[0].toLowerCase().trim() === "filename") {                                            // 186
                      content.disposition = { download: splitPart[1].trim() };                                         // 187
                    }                                                                                                  // 188
                  });                                                                                                  // 189
                }                                                                                                      // 190
              }                                                                                                        // 191
                                                                                                                       //
              content.body = {};                                                                                       // 193
              content.body.bytes = Buffer.concat(buffers);                                                             // 194
                                                                                                                       //
              resolve(rpcResponse);                                                                                    // 196
            });                                                                                                        // 197
            break;                                                                                                     // 198
          case "noContent":                                                                                            // 199
            var noContent = {};                                                                                        // 200
            rpcResponse.noContent = noContent;                                                                         // 201
            noContent.setShouldResetForm = statusInfo.shouldResetForm;                                                 // 202
            resolve(rpcResponse);                                                                                      // 203
            break;                                                                                                     // 204
          case "redirect":                                                                                             // 205
            var redirect = {};                                                                                         // 206
            rpcResponse.redirect = redirect;                                                                           // 207
            redirect.isPermanent = statusInfo.isPermanent;                                                             // 208
            redirect.switchToGet = statusInfo.switchToGet;                                                             // 209
            if ("location" in resp.headers) redirect.location = resp.headers.location;                                 // 210
            resolve(rpcResponse);                                                                                      // 211
            break;                                                                                                     // 212
          case "clientError":                                                                                          // 213
            var clientError = {};                                                                                      // 214
            rpcResponse.clientError = clientError;                                                                     // 215
            clientError.statusCode = statusInfo.clientErrorCode;                                                       // 216
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 217
            resolve(rpcResponse);                                                                                      // 218
            break;                                                                                                     // 219
          case "serverError":                                                                                          // 220
            var serverError = {};                                                                                      // 221
            rpcResponse.serverError = serverError;                                                                     // 222
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 223
            resolve(rpcResponse);                                                                                      // 224
            break;                                                                                                     // 225
          default:                                                                                                     // 226
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 227
            reject(err);                                                                                               // 228
            break;                                                                                                     // 229
        }                                                                                                              // 166
      });                                                                                                              // 231
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 233
        reject(e);                                                                                                     // 234
      });                                                                                                              // 235
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 237
        req.abort();                                                                                                   // 238
        err = new Error("Request timed out.");                                                                         // 239
        err.kjType = "overloaded";                                                                                     // 240
        reject(err);                                                                                                   // 241
      });                                                                                                              // 242
                                                                                                                       //
      if (content) {                                                                                                   // 244
        req.end(content);                                                                                              // 245
      } else {                                                                                                         // 246
        req.end();                                                                                                     // 247
      }                                                                                                                // 248
    });                                                                                                                // 249
  };                                                                                                                   // 250
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 86
}();                                                                                                                   // 86
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","bignum","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Future = Npm.require("fibers/future");                                                                             // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 24
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 26
  function ByteStreamConnection(connection) {                                                                          // 27
    _classCallCheck(this, ByteStreamConnection);                                                                       // 27
                                                                                                                       //
    this.connection = connection;                                                                                      // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ByteStreamConnection.prototype.done = function done() {                                                              // 26
    this.connection.end();                                                                                             // 32
  };                                                                                                                   // 33
                                                                                                                       //
  ByteStreamConnection.prototype.write = function write(data) {                                                        // 26
    this.connection.write(data);                                                                                       // 36
  };                                                                                                                   // 37
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 26
}();                                                                                                                   // 26
                                                                                                                       //
var IpInterfaceImpl = function (_PersistentImpl) {                                                                     //
  _inherits(IpInterfaceImpl, _PersistentImpl);                                                                         //
                                                                                                                       //
  function IpInterfaceImpl(db, saveTemplate) {                                                                         // 44
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 44
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                             // 44
  }                                                                                                                    // 46
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function listenTcp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 49
      var resolved = false;                                                                                            // 50
      var server = Net.createServer(function (connection) {                                                            // 51
        var wrappedConnection = new ByteStreamConnection(connection);                                                  // 52
        var upstream = port.connect(wrappedConnection).upstream;                                                       // 53
                                                                                                                       //
        connection.on("data", function (data) {                                                                        // 55
          upstream.write(data);                                                                                        // 56
        });                                                                                                            // 57
                                                                                                                       //
        connection.on("close", function (hadError) {                                                                   // 59
          upstream.done();                                                                                             // 60
        });                                                                                                            // 61
                                                                                                                       //
        connection.on("error", function (err) {                                                                        // 63
          if (resolved) {                                                                                              // 64
            connection.write = errorWrite;                                                                             // 65
          } else {                                                                                                     // 66
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 68
          }                                                                                                            // 69
        });                                                                                                            // 70
      });                                                                                                              // 71
                                                                                                                       //
      server.listen(portNum, function () {                                                                             // 73
        resolved = true;                                                                                               // 74
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 75
      });                                                                                                              // 76
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 78
        if (!resolved) {                                                                                               // 79
          reject(err);                                                                                                 // 80
        }                                                                                                              // 81
      });                                                                                                              // 82
    });                                                                                                                // 83
  };                                                                                                                   // 84
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function listenUdp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 87
      var portMap = {};                                                                                                // 88
      var resolved = false;                                                                                            // 89
      var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                               // 90
      server.bind(portNum);                                                                                            // 91
                                                                                                                       //
      server.on("listening", function () {                                                                             // 93
        // Although UDP is connectionless, we don't resolve until here so that we can handle bind                      //
        // errors such as invalid host                                                                                 //
        resolved = true;                                                                                               // 96
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 97
      });                                                                                                              // 98
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 100
        // TODO(someday): do something about errors after the promise is resolved                                      //
        if (!resolved) {                                                                                               // 102
          reject(err);                                                                                                 // 103
        } else {                                                                                                       // 104
          console.error("error in listenUdp: " + err);                                                                 // 105
        }                                                                                                              // 106
      });                                                                                                              // 107
                                                                                                                       //
      var returnMap = {};                                                                                              // 109
      server.on("message", function (msg, rinfo) {                                                                     // 110
        var address = rinfo.address + "]:" + rinfo.port;                                                               // 111
        var returnPort = returnMap[address];                                                                           // 112
                                                                                                                       //
        if (!returnPort) {                                                                                             // 114
          returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                   // 115
        }                                                                                                              // 116
                                                                                                                       //
        port.send(msg, returnPort);                                                                                    // 118
      });                                                                                                              // 119
    });                                                                                                                // 120
  };                                                                                                                   // 121
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 122
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 126
  globalFrontendRefRegistry.register({                                                                                 // 127
    frontendRefField: "ipInterface",                                                                                   // 128
    typeId: IpRpc.IpInterface.typeId,                                                                                  // 129
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 131
      return new Capnp.Capability(new IpInterfaceImpl(db, saveTemplate), IpRpc.PersistentIpInterface);                 // 132
    },                                                                                                                 // 134
    validate: function validate(db, session, value) {                                                                  // 136
      check(value, true);                                                                                              // 137
                                                                                                                       //
      if (!session.userId) {                                                                                           // 139
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 140
      }                                                                                                                // 141
                                                                                                                       //
      return {                                                                                                         // 143
        descriptor: { tags: [{ id: IpRpc.IpInterface.typeId }] },                                                      // 144
        requirements: [{ userIsAdmin: session.userId }]                                                                // 145
      };                                                                                                               // 143
    },                                                                                                                 // 147
    query: function query(db, userId, value) {                                                                         // 149
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 150
        return [{                                                                                                      // 151
          _id: "frontendref-ipinterface",                                                                              // 153
          frontendRef: { ipInterface: true },                                                                          // 154
          cardTemplate: "ipInterfacePowerboxCard"                                                                      // 155
        }];                                                                                                            // 152
      } else {                                                                                                         // 158
        return [];                                                                                                     // 159
      }                                                                                                                // 160
    }                                                                                                                  // 161
  });                                                                                                                  // 127
});                                                                                                                    // 163
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 165
  function BoundUdpPortImpl(server, address, port) {                                                                   // 166
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 166
                                                                                                                       //
    this.server = server;                                                                                              // 167
    this.address = address;                                                                                            // 168
    this.port = port;                                                                                                  // 169
  }                                                                                                                    // 170
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function send(message, returnPort) {                                               // 165
    // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                           //
    // capabilities or build a map with them. What we should be doing is mapping all ports to                          //
    // their raw physical address/port, and using that here                                                            //
    this.server.send(message, 0, message.length, this.port, this.address);                                             // 176
  };                                                                                                                   // 177
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 165
}();                                                                                                                   // 165
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 180
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 181
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 183
  var part1 = num & 255;                                                                                               // 184
  var part2 = num >> 8 & 255;                                                                                          // 185
  var part3 = num >> 16 & 255;                                                                                         // 186
  var part4 = num >> 24 & 255;                                                                                         // 187
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 189
};                                                                                                                     // 190
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 192
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 193
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 195
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 197
    return intToIpv4(ipv4num);                                                                                         // 198
  }                                                                                                                    // 199
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 201
  var numColons = 0;                                                                                                   // 202
  var out = "";                                                                                                        // 203
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 205
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 208
    if ((i + 1) % 4 === 0) {                                                                                           // 209
      out += ":";                                                                                                      // 210
      ++numColons;                                                                                                     // 211
    }                                                                                                                  // 212
  }                                                                                                                    // 213
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 216
    out += "::";                                                                                                       // 217
  }                                                                                                                    // 218
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 220
};                                                                                                                     // 221
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 223
  var type = "udp4";                                                                                                   // 224
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 228
    type = "udp6";                                                                                                     // 229
  }                                                                                                                    // 230
                                                                                                                       //
  return type;                                                                                                         // 232
};                                                                                                                     // 233
                                                                                                                       //
var IpNetworkImpl = function (_PersistentImpl2) {                                                                      //
  _inherits(IpNetworkImpl, _PersistentImpl2);                                                                          //
                                                                                                                       //
  function IpNetworkImpl(db, saveTemplate) {                                                                           // 236
    _classCallCheck(this, IpNetworkImpl);                                                                              // 236
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 236
  }                                                                                                                    // 238
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function getRemoteHost(address) {                                            //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 241
  };                                                                                                                   // 242
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function getRemoteHostByName(address) {                                //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 245
  };                                                                                                                   // 246
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 247
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 251
  globalFrontendRefRegistry.register({                                                                                 // 252
    frontendRefField: "ipNetwork",                                                                                     // 253
    typeId: IpRpc.IpNetwork.typeId,                                                                                    // 254
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 256
      return new Capnp.Capability(new IpNetworkImpl(db, saveTemplate), IpRpc.PersistentIpNetwork);                     // 257
    },                                                                                                                 // 259
    validate: function validate(db, session, value) {                                                                  // 261
      check(value, true);                                                                                              // 262
                                                                                                                       //
      if (!session.userId) {                                                                                           // 264
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 265
      }                                                                                                                // 266
                                                                                                                       //
      return {                                                                                                         // 268
        descriptor: { tags: [{ id: IpRpc.IpNetwork.typeId }] },                                                        // 269
        requirements: [{ userIsAdmin: session.userId }]                                                                // 270
      };                                                                                                               // 268
    },                                                                                                                 // 272
    query: function query(db, userId, value) {                                                                         // 274
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 275
        return [{                                                                                                      // 276
          _id: "frontendref-ipnetwork",                                                                                // 278
          frontendRef: { ipNetwork: true },                                                                            // 279
          cardTemplate: "ipNetworkPowerboxCard"                                                                        // 280
        }];                                                                                                            // 277
      } else {                                                                                                         // 283
        return [];                                                                                                     // 284
      }                                                                                                                // 285
    }                                                                                                                  // 286
  });                                                                                                                  // 252
});                                                                                                                    // 288
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 290
  function IpRemoteHostImpl(address) {                                                                                 // 291
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 291
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 292
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 294
    } else {                                                                                                           // 295
      this.address = address;                                                                                          // 296
    }                                                                                                                  // 297
  }                                                                                                                    // 298
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function getTcpPort(portNum) {                                               // 290
    return { port: new TcpPortImpl(this.address, portNum) };                                                           // 301
  };                                                                                                                   // 302
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function getUdpPort(portNum) {                                               // 290
    return { port: new UdpPortImpl(this.address, portNum) };                                                           // 305
  };                                                                                                                   // 306
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             // 290
}();                                                                                                                   // 290
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 309
  function TcpPortImpl(address, portNum) {                                                                             // 310
    _classCallCheck(this, TcpPortImpl);                                                                                // 310
                                                                                                                       //
    this.address = address;                                                                                            // 311
    this.port = portNum;                                                                                               // 312
  }                                                                                                                    // 313
                                                                                                                       //
  TcpPortImpl.prototype.connect = function connect(downstream) {                                                       // 309
    var _this = this;                                                                                                  // 316
    var resolved = false;                                                                                              // 317
    return new Promise(function (resolve, reject) {                                                                    // 318
      var client = Net.connect({ host: _this.address, port: _this.port }, function () {                                // 319
        resolved = true;                                                                                               // 320
        resolve({ upstream: new ByteStreamConnection(client) });                                                       // 321
      });                                                                                                              // 322
                                                                                                                       //
      client.on("data", function (data) {                                                                              // 324
        downstream.write(data);                                                                                        // 325
      });                                                                                                              // 326
                                                                                                                       //
      client.on("close", function (hadError) {                                                                         // 328
        downstream.done();                                                                                             // 329
      });                                                                                                              // 330
                                                                                                                       //
      client.on("error", function (err) {                                                                              // 332
        if (resolved) {                                                                                                // 333
          client.write = errorWrite;                                                                                   // 334
        } else {                                                                                                       // 335
          // upstream hasn't been resolved yet, so it's safe to reject                                                 //
          reject(err);                                                                                                 // 337
        }                                                                                                              // 338
      });                                                                                                              // 339
    });                                                                                                                // 340
  };                                                                                                                   // 341
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 309
}();                                                                                                                   // 309
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 344
  throw new Error("error occurred in connection");                                                                     // 345
};                                                                                                                     // 346
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 348
  function UdpPortImpl(address, portNum) {                                                                             // 349
    _classCallCheck(this, UdpPortImpl);                                                                                // 349
                                                                                                                       //
    this.address = address;                                                                                            // 350
    this.port = portNum;                                                                                               // 351
                                                                                                                       //
    var type = addressType(address);                                                                                   // 353
    this.socket = Dgram.createSocket(type);                                                                            // 354
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 362
                                                                                                                       //
    var _this = this;                                                                                                  // 364
    this.socket.on("message", function (msg, rinfo) {                                                                  // 365
      if (_this.returnPort) {                                                                                          // 366
        _this.returnPort.send(msg, _this);                                                                             // 367
      }                                                                                                                // 368
    });                                                                                                                // 369
  }                                                                                                                    // 370
                                                                                                                       //
  UdpPortImpl.prototype.send = function send(message, returnPort) {                                                    // 348
    this.returnPort = returnPort;                                                                                      // 373
    this.socket.send(message, 0, message.length, this.port, this.address);                                             // 374
                                                                                                                       //
    // TODO(someday): use callback to catch errors and do something with them                                          //
  };                                                                                                                   // 377
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 348
}();                                                                                                                   // 348
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","smtp-server","mailparser","/imports/server/persistent.js","/imports/server/email.js","/imports/server/backend.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var SMTPServer;module.import("smtp-server",{"SMTPServer":function(v){SMTPServer=v}});var MailParser;module.import("mailparser",{"MailParser":function(v){MailParser=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var rawSend;module.import("/imports/server/email.js",{"rawSend":function(v){rawSend=v}});var shouldRestartGrain;module.import("/imports/server/backend.js",{"shouldRestartGrain":function(v){shouldRestartGrain=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
                                                                                                                       //
                                                                                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 25
var Future = Npm.require("fibers/future");                                                                             // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 29
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 30
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 31
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 32
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 37
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 38
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 40
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 42
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 48
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 49
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 53
}                                                                                                                      // 54
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 56
  var server = new SMTPServer({                                                                                        // 57
    banner: "Sandstorm Mail Server",                                                                                   // 58
    authOptional: true,                                                                                                // 59
    disabledCommands: ["STARTTLS", "AUTH"],                                                                            // 60
    onData: function onData(req, session, callback) {                                                                  // 61
      var mailparser = new MailParser();                                                                               // 62
      req.pipe(mailparser);                                                                                            // 63
                                                                                                                       //
      mailparser.on("end", function (mail) {                                                                           // 65
        // Wrap in outer promise for easier error handling.                                                            //
        Promise.resolve().then(function () {                                                                           // 67
          // Extract the 'from' address.                                                                               //
          var from = void 0;                                                                                           // 69
          if (mail.from && mail.from.length > 0) {                                                                     // 70
            // It's theoretically possible for the message to have multiple 'from' headers, but this                   //
            // never really happens in legitimate practice so we'll just take the first one.                           //
            from = mail.from[0];                                                                                       // 73
          } else {                                                                                                     // 74
            // The mail body is missing a 'From:' header. We'll use the bounce address instead,                        //
            // with the caveat that this is sometimes *not* the original sender                                        //
            // but rather some intermediate agent (e.g. a mailing list daemon). See:                                   //
            //   http://en.wikipedia.org/wiki/Bounce_address                                                           //
            // TODO(someday): Is this really right, or should we report a blank address instead?                       //
            from = { address: session.envelope.mailFrom, name: false };                                                // 80
          }                                                                                                            // 81
                                                                                                                       //
          var attachments = [];                                                                                        // 83
          if (mail.attachments) {                                                                                      // 84
            attachments = mail.attachments.map(function (attachment) {                                                 // 85
              var disposition = attachment.contentDisposition || "attachment";                                         // 86
              disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';          // 87
              return {                                                                                                 // 88
                contentType: attachment.contentType,                                                                   // 89
                contentDisposition: disposition,                                                                       // 90
                contentId: attachment.contentId,                                                                       // 91
                content: attachment.content                                                                            // 92
              };                                                                                                       // 88
            });                                                                                                        // 94
          }                                                                                                            // 95
                                                                                                                       //
          if (mail.replyTo && mail.replyTo.length > 1) {                                                               // 97
            console.error("More than one reply-to address address was received in an email.");                         // 98
          }                                                                                                            // 99
                                                                                                                       //
          var mailMessage = {                                                                                          // 101
            // Note that converting the date to nanoseconds actually goes outside the range of                         //
            // integers that Javascript can represent precisely. But this is OK because dates aren't                   //
            // precise anyway.                                                                                         //
            date: (mail.date || new Date()).getTime() * 1000000,                                                       // 105
            from: from,                                                                                                // 106
            to: mail.to,                                                                                               // 107
            cc: mail.cc || [],                                                                                         // 108
            bcc: mail.bcc || [],                                                                                       // 109
            replyTo: mail.replyTo && mail.replyTo[0] || {},                                                            // 110
            messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                   // 111
            references: mail.references || [],                                                                         // 112
            inReplyTo: mail.inReplyTo || [],                                                                           // 113
            subject: mail.subject || "",                                                                               // 114
            text: mail.text || null,                                                                                   // 115
            html: mail.html || null,                                                                                   // 116
            attachments: attachments                                                                                   // 117
          };                                                                                                           // 101
                                                                                                                       //
          // Get list of grain IDs.                                                                                    //
          var grainPublicIds = _.uniq(session.envelope.rcptTo.map(function (deliverTo) {                               // 121
            // smtp-server already validates that the address contains an @.                                           //
            // To simplify things, we ignore the hostname part of the address and assume that the                      //
            // message would not have been sent here if it weren't intended for our host. Usually                      //
            // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                        //
            // globally unique anyway, so an e-mail meant for another server presumably won't match                    //
            // any ID at this one anyway.                                                                              //
            var address = deliverTo.address;                                                                           // 121
                                                                                                                       //
            return address.slice(0, address.indexOf("@"));                                                             // 129
          }));                                                                                                         // 130
                                                                                                                       //
          // Deliver to each grain in parallel.                                                                        //
          return Promise.all(grainPublicIds.map(function (publicId) {                                                  // 133
            // Wrap in a function so that we can call it recursively to retry.                                         //
            var tryDeliver = function tryDeliver(retryCount) {                                                         // 135
              var grainId = void 0;                                                                                    // 136
              return inMeteor(function () {                                                                            // 137
                var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                    // 138
                if (grain) {                                                                                           // 139
                  grainId = grain._id;                                                                                 // 140
                  return globalBackend.continueGrain(grainId, retryCount > 0);                                         // 141
                } else {                                                                                               // 142
                  // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                //
                  // fails in this case, by adding an onRcptTo() callback.                                             //
                  throw new Error("No such grain: " + publicId);                                                       // 145
                }                                                                                                      // 146
              }).then(function (grainInfo) {                                                                           // 147
                var supervisor = grainInfo.supervisor;                                                                 // 148
                var uiView = supervisor.getMainView().view;                                                            // 149
                                                                                                                       //
                // Create an arbitrary struct to use as the session params. E-mail sessions actually                   //
                // require no params, but node-capnp won't let us pass null and we don't have an                       //
                // EmptyStruct type available, so we just use EmailAddress, but any struct type would                  //
                // work.                                                                                               //
                // TODO(cleanup): Fix node-capnp to accept null.                                                       //
                var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                          // 156
                                                                                                                       //
                // Create a new session of type HackEmailSession. This is a short-term hack until                      //
                // persistent capabilities and the Powerbox are implemented. We need to pass along a                   //
                // HackSessionContext because old versions of sandstorm-http-bridge always use                         //
                // the context of the most recent session; if an old RoundCube grain has a                             //
                // WebSession open, receives an email, and then tries to send an email, the request                    //
                // will go out on the SessionContext associated with the HackEmailSession that                         //
                // delivered the email.                                                                                //
                var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
                return session.send(mailMessage);                                                                      // 169
              })["catch"](function (err) {                                                                             // 170
                if (shouldRestartGrain(err, retryCount)) {                                                             // 171
                  return tryDeliver(retryCount + 1);                                                                   // 172
                } else {                                                                                               // 173
                  throw err;                                                                                           // 174
                }                                                                                                      // 175
              });                                                                                                      // 176
            };                                                                                                         // 177
                                                                                                                       //
            return tryDeliver(0);                                                                                      // 179
          }));                                                                                                         // 180
        }).then(function () {                                                                                          // 181
          callback(null, "Message delivered");                                                                         // 182
        }, function (err) {                                                                                            // 183
          console.error("E-mail delivery failure:", err.stack);                                                        // 184
          var mailErr = new Error(err.message);                                                                        // 185
          err.responseCode = 451;                                                                                      // 186
          callback(err.message);                                                                                       // 187
        });                                                                                                            // 188
      });                                                                                                              // 189
    }                                                                                                                  // 190
  });                                                                                                                  // 57
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 193
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 194
  } else {                                                                                                             // 195
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 197
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 198
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 199
  }                                                                                                                    // 200
});                                                                                                                    // 201
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 203
  return inMeteor(function () {                                                                                        // 204
    var recipientCount = 0;                                                                                            // 205
    recipientCount += email.to ? email.to.length : 0;                                                                  // 206
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 207
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 208
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 209
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 214
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 216
    var userAddress = session._getUserAddress();                                                                       // 217
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 220
      email.from = {                                                                                                   // 221
        address: grainAddress                                                                                          // 222
      };                                                                                                               // 221
    }                                                                                                                  // 224
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 226
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 230
                                                                                                                       //
    // Unpack fields                                                                                                   //
    var from = email.from;                                                                                             // 204
    var to = email.to;                                                                                                 // 204
    var cc = email.cc;                                                                                                 // 204
    var bcc = email.bcc;                                                                                               // 204
    var replyTo = email.replyTo;                                                                                       // 204
    var subject = email.subject;                                                                                       // 204
    var text = email.text;                                                                                             // 204
    var html = email.html;                                                                                             // 204
                                                                                                                       //
                                                                                                                       //
    var options = {                                                                                                    // 235
      from: from,                                                                                                      // 236
      to: to,                                                                                                          // 237
      cc: cc,                                                                                                          // 238
      bcc: bcc,                                                                                                        // 239
      replyTo: replyTo,                                                                                                // 240
      subject: subject,                                                                                                // 241
      text: text,                                                                                                      // 242
      html: html,                                                                                                      // 243
      envelope: {                                                                                                      // 244
        from: grainAddress,                                                                                            // 245
        to: to,                                                                                                        // 246
        cc: cc,                                                                                                        // 247
        bcc: bcc                                                                                                       // 248
      }                                                                                                                // 244
    };                                                                                                                 // 235
                                                                                                                       //
    var headers = {};                                                                                                  // 252
    if (email.messageId) {                                                                                             // 253
      headers["message-id"] = email.messageId;                                                                         // 254
    }                                                                                                                  // 255
                                                                                                                       //
    if (email.references) {                                                                                            // 257
      headers["references"] = email.references; // jscs:ignore requireDotNotation                                      // 258
    }                                                                                                                  // 259
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 261
      headers["in-reply-to"] = email.inReplyTo;                                                                        // 262
    }                                                                                                                  // 263
                                                                                                                       //
    if (email.date) {                                                                                                  // 265
      var date = new Date(email.date / 1000000);                                                                       // 266
      if (!isNaN(date.getTime())) {                                                                                    // 267
        // Check to make sure date is valid                                                                            //
        headers["date"] = date.toUTCString(); // jscs:ignore requireDotNotation                                        // 268
      }                                                                                                                // 269
    }                                                                                                                  // 270
                                                                                                                       //
    options.headers = headers;                                                                                         // 272
                                                                                                                       //
    if (email.attachments) {                                                                                           // 274
      (function () {                                                                                                   // 274
        var attachments = [];                                                                                          // 275
        email.attachments.forEach(function (attachment) {                                                              // 276
          attachments.push({                                                                                           // 277
            filename: false, // Tell nodemailer not to generate a new filename.                                        // 278
            cid: attachment.contentId,                                                                                 // 279
            contentType: attachment.contentType,                                                                       // 280
            contentDisposition: attachment.contentDisposition,                                                         // 281
            content: attachment.content                                                                                // 282
          });                                                                                                          // 277
        });                                                                                                            // 284
        options.attachments = attachments;                                                                             // 285
      })();                                                                                                            // 274
    }                                                                                                                  // 286
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 288
    if (!grain) throw new Error("Grain does not exist.");                                                              // 289
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 290
                                                                                                                       //
    rawSend(options);                                                                                                  // 292
  }.bind(_this))["catch"](function (err) {                                                                             // 293
    console.error("Error sending e-mail:", err.stack);                                                                 // 294
    throw err;                                                                                                         // 295
  });                                                                                                                  // 296
};                                                                                                                     // 297
                                                                                                                       //
var EmailVerifierImpl = function (_PersistentImpl) {                                                                   //
  _inherits(EmailVerifierImpl, _PersistentImpl);                                                                       //
                                                                                                                       //
  function EmailVerifierImpl(db, saveTemplate, params) {                                                               // 300
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 300
                                                                                                                       //
    var _this2 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 300
                                                                                                                       //
    _this2._id = params.id;                                                                                            // 302
    _this2._services = params.services;                                                                                // 303
    return _this2;                                                                                                     // 300
  }                                                                                                                    // 304
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function getId() {                                                               //
    return { id: new Buffer(this._id, "base64") };                                                                     // 307
  };                                                                                                                   // 308
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function verifyEmail(tabId, verification) {                                //
    var _this3 = this;                                                                                                 // 310
                                                                                                                       //
    return unwrapFrontendCap(verification, "verifiedEmail", function (verification) {                                  // 311
      if (verification.tabId !== tabId.toString("hex")) {                                                              // 312
        throw new Error("VerifiedEmail is from a different tab");                                                      // 313
      }                                                                                                                // 314
                                                                                                                       //
      if (_this3._services) {                                                                                          // 316
        // Since this verifier is restricted to specific services, only indicate a match if the                        //
        // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                           //
        // match all services, and therefore all VerifiedEmails.)                                                      //
        if (verification.verifierId !== _this3._id) {                                                                  // 320
          throw new Error("VerifierEmail is for a different EmailVerifier.");                                          // 321
        }                                                                                                              // 322
      }                                                                                                                // 323
                                                                                                                       //
      return verification.address;                                                                                     // 325
    });                                                                                                                // 326
  };                                                                                                                   // 327
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 328
                                                                                                                       //
var VerifiedEmailImpl = function (_PersistentImpl2) {                                                                  //
  _inherits(VerifiedEmailImpl, _PersistentImpl2);                                                                      //
                                                                                                                       //
  function VerifiedEmailImpl(db, saveTemplate) {                                                                       // 331
    _classCallCheck(this, VerifiedEmailImpl);                                                                          // 331
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 331
  }                                                                                                                    // 333
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
function getVerifiedEmails(db, userId, verifierId) {                                                                   // 336
  // Get all of the email addresses verified as belonging to the given user using the given                            //
  // verifier.                                                                                                         //
                                                                                                                       //
  var services = null;                                                                                                 // 340
                                                                                                                       //
  if (verifierId) {                                                                                                    // 342
    var verifier = db.collections.apiTokens.findOne({ "frontendRef.emailVerifier.id": verifierId });                   // 343
    if (!verifier) return []; // invalid verifier                                                                      // 345
    var verifierInfo = verifier.frontendRef.emailVerifier;                                                             // 346
                                                                                                                       //
    if (verifierInfo.services) {                                                                                       // 348
      // Limit to the listed services.                                                                                 //
      services = {};                                                                                                   // 350
      verifierInfo.services.forEach(function (service) {                                                               // 351
        return services[service] = true;                                                                               // 351
      });                                                                                                              // 351
    }                                                                                                                  // 352
  }                                                                                                                    // 353
                                                                                                                       //
  var user = Meteor.users.findOne(userId);                                                                             // 355
  var emails = {}; // map address -> true, for uniquification                                                          // 356
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {              // 357
    if (!services || services[identity.profile.service]) {                                                             // 358
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                               // 359
        emails[email.email] = true;                                                                                    // 359
      });                                                                                                              // 359
    }                                                                                                                  // 360
  });                                                                                                                  // 361
                                                                                                                       //
  return Object.keys(emails);                                                                                          // 363
}                                                                                                                      // 364
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 368
  globalFrontendRefRegistry.register({                                                                                 // 369
    frontendRefField: "emailVerifier",                                                                                 // 370
    typeId: EmailRpc.EmailVerifier.typeId,                                                                             // 371
                                                                                                                       //
    restore: function restore(db, saveTemplate, params) {                                                              // 373
      return new Capnp.Capability(new EmailVerifierImpl(db, saveTemplate, params), EmailImpl.PersistentEmailVerifier);
    },                                                                                                                 // 376
    validate: function validate(db, session, value) {                                                                  // 378
      check(value, { services: Match.Optional([String]) });                                                            // 379
                                                                                                                       //
      var services = value.services;                                                                                   // 381
      if (services) {                                                                                                  // 382
        services.forEach(function (service) {                                                                          // 383
          if (!Accounts.identityServices[service]) {                                                                   // 384
            throw new Error("No such identity service: " + service);                                                   // 385
          }                                                                                                            // 386
        });                                                                                                            // 387
      }                                                                                                                // 388
                                                                                                                       //
      value.id = Crypto.randomBytes(16).toString("base64");                                                            // 390
                                                                                                                       //
      return {                                                                                                         // 392
        descriptor: { tags: [{ id: EmailRpc.EmailVerifier.typeId }] },                                                 // 393
        requirements: []                                                                                               // 394
      };                                                                                                               // 392
    },                                                                                                                 // 396
    query: function query(db, userId, value) {                                                                         // 398
      var results = [];                                                                                                // 399
                                                                                                                       //
      results.push({                                                                                                   // 401
        _id: "emailverifier-all",                                                                                      // 402
        frontendRef: { emailVerifier: {} },                                                                            // 403
        cardTemplate: "emailVerifierPowerboxCard"                                                                      // 404
      });                                                                                                              // 401
                                                                                                                       //
      for (var name in Accounts.identityServices) {                                                                    // 407
        if (Accounts.identityServices[name].isEnabled()) {                                                             // 408
          results.push({                                                                                               // 409
            _id: "emailverifier-" + name,                                                                              // 410
            frontendRef: { emailVerifier: { services: [name] } },                                                      // 411
            cardTemplate: "emailVerifierPowerboxCard"                                                                  // 412
          });                                                                                                          // 409
        }                                                                                                              // 414
      };                                                                                                               // 415
                                                                                                                       //
      return results;                                                                                                  // 417
    }                                                                                                                  // 418
  });                                                                                                                  // 369
                                                                                                                       //
  globalFrontendRefRegistry.register({                                                                                 // 421
    frontendRefField: "verifiedEmail",                                                                                 // 422
    typeId: EmailRpc.VerifiedEmail.typeId,                                                                             // 423
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 425
      return new Capnp.Capability(new VerifiedEmailImpl(db, saveTemplate), EmailImpl.PersistentVerifiedEmail);         // 426
    },                                                                                                                 // 428
    validate: function validate(db, session, value) {                                                                  // 430
      check(value, { verifierId: Match.Optional(String), address: String });                                           // 431
                                                                                                                       //
      if (!session.userId) {                                                                                           // 433
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 434
      }                                                                                                                // 435
                                                                                                                       //
      // Verify that the address actually belongs to the user.                                                         //
                                                                                                                       //
      if (!_.contains(getVerifiedEmails(db, session.userId, value.verifierId), value.address)) {                       // 439
        throw new Meteor.Error(403, "User has no such verified address");                                              // 440
      }                                                                                                                // 441
                                                                                                                       //
      // Add the session's tabId.                                                                                      //
      value.tabId = session.tabId;                                                                                     // 444
                                                                                                                       //
      // Build the descriptor, which contains the verifier ID.                                                         //
      var tagValue = value.verifierId && Capnp.serialize(EmailRpc.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(value.verifierId, "hex") });
                                                                                                                       //
      return {                                                                                                         // 451
        descriptor: { tags: [{ id: EmailRpc.VerifiedEmail.typeId, value: tagValue }] },                                // 452
        requirements: []                                                                                               // 453
      };                                                                                                               // 451
    },                                                                                                                 // 455
    query: function query(db, userId, value) {                                                                         // 457
      var verifierId = value && Capnp.parse(EmailRpc.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");  // 458
      return getVerifiedEmails(db, userId, verifierId).map(function (address) {                                        // 460
        return {                                                                                                       // 460
          _id: "email-" + address,                                                                                     // 461
          frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } },                                // 462
          cardTemplate: "verifiedEmailPowerboxCard"                                                                    // 463
        };                                                                                                             // 460
      });                                                                                                              // 460
    }                                                                                                                  // 465
  });                                                                                                                  // 421
});                                                                                                                    // 467
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"00-startup.js":["/imports/db-deprecated.js","/imports/server/frontend-ref.js","/imports/server/persistent.js","/imports/server/migrations.js","/imports/constants.js","/imports/server/async-helpers.js","fibers",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/00-startup.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.import("/imports/db-deprecated.js");var FrontendRefRegistry;module.import("/imports/server/frontend-ref.js",{"FrontendRefRegistry":function(v){FrontendRefRegistry=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var migrateToLatest;module.import("/imports/server/migrations.js",{"migrateToLatest":function(v){migrateToLatest=v}});var ACCOUNT_DELETION_SUSPENSION_TIME;module.import("/imports/constants.js",{"ACCOUNT_DELETION_SUSPENSION_TIME":function(v){ACCOUNT_DELETION_SUSPENSION_TIME=v}});var onInMeteor;module.import("/imports/server/async-helpers.js",{"onInMeteor":function(v){onInMeteor=v}});var Fiber;module.import("fibers",{"default":function(v){Fiber=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       //
globalFrontendRefRegistry = new FrontendRefRegistry();                                                                 // 24
                                                                                                                       //
SandstormPowerbox.registerUiViewQueryHandler(globalFrontendRefRegistry);                                               // 26
                                                                                                                       //
if (global.BlackrockPayments && BlackrockPayments.registerPaymentsApi) {                                               // 28
  // TODO(cleanup): Meteor.startup() needed because unwrapFrontendCap is not defined yet when this                     //
  //   first runs. Move it into an import.                                                                             //
  Meteor.startup(function () {                                                                                         // 31
    BlackrockPayments.registerPaymentsApi(globalFrontendRefRegistry, PersistentImpl, unwrapFrontendCap);               // 32
  });                                                                                                                  // 34
}                                                                                                                      // 35
                                                                                                                       //
getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                         // 37
                                                                                                                       //
Meteor.onConnection(function (connection) {                                                                            // 39
  // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                           //
  //   packages to actually use the DB, but it's pretty sad.                                                           //
  connection.sandstormDb = globalDb;                                                                                   // 42
  connection.frontendRefRegistry = globalFrontendRefRegistry;                                                          // 43
});                                                                                                                    // 44
SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                     // 45
SandstormDb.periodicCleanup(10 * 60 * 1000, SandstormPermissions.cleanupClientPowerboxTokens(globalDb));               // 46
SandstormDb.periodicCleanup(60 * 60 * 1000, function () {                                                              // 48
  globalDb.cleanupExpiredAssetUploads();                                                                               // 49
});                                                                                                                    // 50
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 51
  SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                    // 52
});                                                                                                                    // 53
var deleteAccount = global.BlackrockPayments && global.BlackrockPayments.deleteAccount;                                // 54
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 55
  globalDb.deletePendingAccounts(ACCOUNT_DELETION_SUSPENSION_TIME, globalBackend, deleteAccount);                      // 56
});                                                                                                                    // 58
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 60
  migrateToLatest(globalDb, globalBackend);                                                                            // 60
});                                                                                                                    // 60
                                                                                                                       //
// If there are multiple replicas, prefix every log message with our replica number.                                   //
if ("replicaNumber" in Meteor.settings) {                                                                              // 63
  (function () {                                                                                                       // 63
    var patchConsole = function patchConsole(name) {                                                                   // 63
      var old = console[name];                                                                                         // 67
      console[name] = function () {                                                                                    // 68
        // Meteor in dev mode writes "LISTENING" to tell the dev runner that it's ready to accept                      //
        // connections.                                                                                                //
        if (arguments.length == 1 && arguments[0] == "LISTENING") {                                                    // 71
          old.apply(this, arguments);                                                                                  // 72
        } else {                                                                                                       // 73
          old.apply(this, [prefix].concat(Array.prototype.slice.call(arguments)));                                     // 74
        }                                                                                                              // 75
      };                                                                                                               // 76
    };                                                                                                                 // 77
                                                                                                                       //
    var prefix = "replica" + Meteor.settings.replicaNumber.toString() + ":";                                           // 64
                                                                                                                       //
    patchConsole("log");                                                                                               // 79
    patchConsole("info");                                                                                              // 80
    patchConsole("warn");                                                                                              // 81
    patchConsole("error");                                                                                             // 82
  })();                                                                                                                // 63
}                                                                                                                      // 83
                                                                                                                       //
// Make the fiber pool size infinite(ish)!                                                                             //
//                                                                                                                     //
// Each fiber created adds an entry to `v8::Isolate::ThreadDataTable`. Unfortunatley, items are                        //
// never deleted from this table. So if we create and delete a lot of fibers, then we leak memory.                     //
// Worse yet, the table is represented as a linked list, and v8 performs a linear scan of this                         //
// linked list every time we switch fibers. We've seen cases where Sandstorm was spending 65% of                       //
// its CPU time just scanning this list! The v8 people say this is "working as intended".                              //
//                                                                                                                     //
// The fibers package has implemented a work-around by maintaining a fiber pool. Fibers are not                        //
// deleted; they are returned to the pool. Unfortunately the pool has a default size of 120. So                        //
// if we pass 120 simultaneous fibers, we start leaking and slowing down. It's very easy to hit                        //
// this number with a few dozen users present.                                                                         //
//                                                                                                                     //
// Up until it hits the limit, the fibers module will grow the pool dynamically, starting with an                      //
// empty pool and adding each new fiber to it. Therefore, if we set the pool size to an impossibly                     //
// large number, we effectively get a pool size equal to the maximum number of simultaneous fibers                     //
// seen. This is exactly what we want! Now no fibers are ever deleted, so we never leak. A                             //
// Sandstorm server that sees a brief surge of traffic may end up holding on to unused RAM                             //
// long-term, but this is a relatively obscure problem.                                                                //
//                                                                                                                     //
// I initially tried to use the value `Infinity` here, but somehow when this made its way down into                    //
// the C++ code and was converted to an integer, that integer ended up being zero. So instead we                       //
// use 1e9 (1 billion), which ought to be enough for anyone.                                                           //
//                                                                                                                     //
// Third-party issues, for reference:                                                                                  //
//                                                                                                                     //
//    https://bugs.chromium.org/p/v8/issues/detail?id=5338                                                             //
//    https://bugs.chromium.org/p/v8/issues/detail?id=3777                                                             //
//    https://github.com/laverdet/node-fibers/issues/305                                                               //
                                                                                                                       // 114
Fiber.poolSize = 1e9;                                                                                                  // 115
                                                                                                                       //
// Special debugging enabled on Blackrock only.                                                                        //
if ("replicaNumber" in Meteor.settings) {                                                                              // 118
  (function () {                                                                                                       // 118
    var sampleStackIfTooManyFibers = function sampleStackIfTooManyFibers() {                                           // 118
      if (Fiber.fibersCreated > TOO_MANY_FIBERS && sampleCounter++ % FIBER_SAMPLING_PERIOD == 0) {                     // 143
        var stack = new Error().stack;                                                                                 // 144
        console.warn("There are too many fibers!", stack);                                                             // 145
      }                                                                                                                // 146
    };                                                                                                                 // 147
                                                                                                                       //
    // Sample calls to inMeteor().                                                                                     //
                                                                                                                       //
                                                                                                                       //
    // Also take samples from various Meteor infrastructure that schedules fibers.                                     //
                                                                                                                       //
    var addFiberSampling = function addFiberSampling(prototype, functionName) {                                        // 118
      var old = prototype[functionName];                                                                               // 154
      prototype[functionName] = function () {                                                                          // 155
        sampleStackIfTooManyFibers();                                                                                  // 156
        return old.apply(this, arguments);                                                                             // 157
      };                                                                                                               // 158
    };                                                                                                                 // 159
                                                                                                                       //
    console.warn("Fiber bomb defense enabled.");                                                                       // 119
                                                                                                                       //
    // TEMPORARY: Monitor the number of fibers created and kill the process any time it goes over                      //
    //   2000. Unfortunately, due to the aforementioned linked list in ThreadDataTable, the process                    //
    //   will become unreasonably slow once the list gets this big. It's better to kill the process                    //
    //   so that it restarts fresh rather than to let the Sandstorm server become unresponsive.                        //
    // TODO(soon): Remove this when the bug is fixed.                                                                  //
    setInterval(function () {                                                                                          // 126
      if (Fiber.fibersCreated > 2000) {                                                                                // 127
        console.error("Process has allocated more than 2000 concurrent fibers. Due to " + "https://bugs.chromium.org/p/v8/issues/detail?id=5338 it will become extremely slow " + "unless we restart it. ABORTING");
        process.abort();                                                                                               // 132
      }                                                                                                                // 133
    }, 5000);                                                                                                          // 134
                                                                                                                       //
    // Let's also log some stack traces when fiber count gets high so we can find out what's                           //
    // happening.                                                                                                      //
    var TOO_MANY_FIBERS = 1000; // Start sampling when we have more than this many fibers.                             // 138
    var FIBER_SAMPLING_PERIOD = 100; // Sample one stack per this many fibers created.                                 // 139
                                                                                                                       //
    var sampleCounter = 0;                                                                                             // 141
    onInMeteor(sampleStackIfTooManyFibers);                                                                            // 150
                                                                                                                       //
    addFiberSampling(Meteor._SynchronousQueue.prototype, "runTask");                                                   // 161
    addFiberSampling(Meteor._SynchronousQueue.prototype, "queueTask");                                                 // 162
    addFiberSampling(Meteor, "bindEnvironment");                                                                       // 163
  })();                                                                                                                // 118
}                                                                                                                      // 164
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 166
  Meteor.startup(function () {                                                                                         // 167
    // Defined in feature-key.js.                                                                                      //
    keepFeatureKeyRenewed(globalDb);                                                                                   // 169
  });                                                                                                                  // 170
}                                                                                                                      // 171
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"account-suspension.js":["/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/account-suspension.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var send;module.import("/imports/server/email.js",{"send":function(v){send=v}});// Sandstorm - Personal Cloud Sandbox  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
function sendDeletionEmails(db, deletedUserId, byAdminUserId) {                                                        // 19
  var deletedUser = db.getUser(deletedUserId);                                                                         // 20
                                                                                                                       //
  var userEmail = _.findWhere(SandstormDb.getUserEmails(deletedUser), { primary: true });                              // 22
  if (!byAdminUserId) {                                                                                                // 23
    // This was initiated by the user, send them an email                                                              //
    if (!userEmail) {                                                                                                  // 24
      console.error("Couldn't send deletion email. No address found for user with userId:", deletedUser._id);          // 25
    } else {                                                                                                           // 27
      var _emailOptions = {                                                                                            // 28
        from: db.getReturnAddress(),                                                                                   // 29
        subject: "Your account on " + db.getServerTitle() + " will be deleted in 7 days.",                             // 30
        text: "You have requested that your Sandstorm account on " + db.getServerTitle() + " be deleted. Your account has been suspended and will be fully deleted in seven days. If you change your mind, log into " + process.env.ROOT_URL + " to cancel the process.\n\nIf you did not request this deletion, please contact the server administrator immediately."
      };                                                                                                               // 28
      try {                                                                                                            // 35
        _emailOptions.to = userEmail.email;                                                                            // 36
        send(_emailOptions);                                                                                           // 37
      } catch (err) {                                                                                                  // 38
        console.error("Failed to send deletion email to user (id=" + deletedUser._id + ") with error: " + err);        // 39
      }                                                                                                                // 41
    }                                                                                                                  // 42
  }                                                                                                                    // 43
                                                                                                                       //
  var deleteUserString = userEmail && userEmail.email || "userId=" + deletedUser._id;                                  // 45
  var emailOptions = {                                                                                                 // 46
    from: db.getReturnAddress(),                                                                                       // 47
    subject: "Account for " + deleteUserString + " on " + db.getServerTitle() + " will be deleted in 7 days"           // 48
  };                                                                                                                   // 46
                                                                                                                       //
  if (byAdminUserId) {                                                                                                 // 51
    var initiatingAdmin = db.getUser(byAdminUserId);                                                                   // 52
    var adminName = db.getIdentity(initiatingAdmin.loginIdentities[0].id).profile.name;                                // 53
    emailOptions.text = adminName + " has requested that the Sandstorm account held by " + deleteUserString + " on " + db.getServerTitle() + " be deleted. The account has been suspended and will be fully deleted in seven days. To cancel the deletion, go to: " + process.env.ROOT_URL + "/admin/users/" + deletedUser._id;
  } else {                                                                                                             // 55
    emailOptions.text = deleteUserString + " has requested that their account be deleted on " + db.getServerTitle() + ". The account has been suspended and will be fully deleted in seven days. To cancel the deletion, go to: " + process.env.ROOT_URL + "/admin/users/" + deletedUser._id;
  }                                                                                                                    // 57
                                                                                                                       //
  Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                                       // 59
    var email = _.findWhere(SandstormDb.getUserEmails(user), { primary: true });                                       // 60
    if (!email) {                                                                                                      // 61
      console.error("No email found for admin with userId:", user._id);                                                // 62
      return;                                                                                                          // 63
    }                                                                                                                  // 64
                                                                                                                       //
    try {                                                                                                              // 66
      emailOptions.to = email.email;                                                                                   // 67
      send(emailOptions);                                                                                              // 68
    } catch (err) {                                                                                                    // 69
      console.error("Failed to send deletion email to admin (id=" + user._id + ") with error: " + err);                // 70
    }                                                                                                                  // 72
  });                                                                                                                  // 73
}                                                                                                                      // 74
                                                                                                                       //
Meteor.methods({                                                                                                       // 76
  suspendAccount: function suspendAccount(userId, willDelete) {                                                        // 77
    check(userId, String);                                                                                             // 78
    check(willDelete, Boolean);                                                                                        // 79
                                                                                                                       //
    if (!isAdmin()) {                                                                                                  // 81
      throw new Meteor.Error(403, "Only admins can suspend other users.");                                             // 82
    }                                                                                                                  // 83
                                                                                                                       //
    if (userId === Meteor.userId()) {                                                                                  // 85
      throw new Meteor.Error(400, "Admins cannot suspend their own accounts from the admin page. Please go to your account setttings.");
    }                                                                                                                  // 87
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 89
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 91
      BlackrockPayments.suspendAccount(db, userId);                                                                    // 92
    }                                                                                                                  // 93
                                                                                                                       //
    db.suspendAccount(userId, Meteor.userId(), willDelete);                                                            // 95
                                                                                                                       //
    if (willDelete) {                                                                                                  // 97
      sendDeletionEmails(db, userId, Meteor.userId());                                                                 // 98
    }                                                                                                                  // 99
  },                                                                                                                   // 100
  deleteOwnAccount: function deleteOwnAccount() {                                                                      // 102
    var db = this.connection.sandstormDb;                                                                              // 103
    if (!Meteor.userId()) {                                                                                            // 104
      throw new Meteor.Error(403, "Must be logged in to delete an account");                                           // 105
    }                                                                                                                  // 106
                                                                                                                       //
    if (db.isUserInOrganization(Meteor.user())) {                                                                      // 108
      throw new Meteor.Error(403, "Users in an organization cannot delete their own account. " + "Please ask your admin to do it for you.");
    }                                                                                                                  // 111
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 113
      BlackrockPayments.suspendAccount(db, Meteor.userId());                                                           // 114
    }                                                                                                                  // 115
                                                                                                                       //
    db.suspendAccount(Meteor.userId(), null, true);                                                                    // 117
                                                                                                                       //
    sendDeletionEmails(db, Meteor.userId());                                                                           // 119
  },                                                                                                                   // 120
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 122
    check(userId, String);                                                                                             // 123
                                                                                                                       //
    if (!isAdmin()) {                                                                                                  // 125
      throw new Meteor.Error(403, "Only admins can unsuspend other users.");                                           // 126
    }                                                                                                                  // 127
                                                                                                                       //
    this.connection.sandstormDb.unsuspendAccount(userId, Meteor.userId());                                             // 129
  },                                                                                                                   // 130
  unsuspendOwnAccount: function unsuspendOwnAccount() {                                                                // 132
    if (!Meteor.userId()) {                                                                                            // 133
      throw new Meteor.Error(403, "Must be logged in to unsuspend an account");                                        // 134
    }                                                                                                                  // 135
                                                                                                                       //
    this.connection.sandstormDb.unsuspendAccount(Meteor.userId());                                                     // 137
  }                                                                                                                    // 138
});                                                                                                                    // 76
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","heapdump","/imports/server/constants.js","/imports/server/auth.js","/imports/server/email.js","/imports/server/observe-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});var fillUndefinedForChangedDoc;module.import("/imports/server/observe-helpers.js",{"fillUndefinedForChangedDoc":function(v){fillUndefinedForChangedDoc=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings", "whitelabelCustomLoginProviderName", "whitelabelCustomLogoAssetId", "whitelabelHideSendFeedback", "whitelabelHideTroubleshooting", "whitelabelUseServerTitleForHomeText", "quotaEnabled", "quotaLdapEnabled", "billingPromptUrl"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit", "secret", "renewalProblem"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 47
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 51
  hostname: String,                                                                                                    // 52
  port: Number,                                                                                                        // 53
  auth: {                                                                                                              // 54
    user: String,                                                                                                      // 55
    pass: String                                                                                                       // 56
  },                                                                                                                   // 54
  returnAddress: String                                                                                                // 58
};                                                                                                                     // 51
                                                                                                                       //
Meteor.methods({                                                                                                       // 61
  setAccountSetting: function setAccountSetting(token, serviceName, value) {                                           // 62
    checkAuth(token);                                                                                                  // 63
    check(serviceName, String);                                                                                        // 64
    check(value, Boolean);                                                                                             // 65
                                                                                                                       //
    // TODO(someday): currently this relies on the fact that an account is tied to a single                            //
    // identity, and thus has only that entry in "services". This will need to be looked at when                       //
    // multiple login methods/identities are allowed for a single account.                                             //
    if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {      // 70
      throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                    // 71
    }                                                                                                                  // 73
                                                                                                                       //
    // Only check configurations for OAuth services.                                                                   //
    var oauthServices = ["google", "github"];                                                                          // 76
    if (value && oauthServices.indexOf(serviceName) != -1) {                                                           // 77
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 78
      var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                              // 79
      if (!config) {                                                                                                   // 80
        throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 83
                                                                                                                       //
      if (!config.clientId || !config.secret) {                                                                        // 85
        throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 88
    }                                                                                                                  // 89
                                                                                                                       //
    Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                                 // 91
    if (value) {                                                                                                       // 92
      Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                    // 93
    }                                                                                                                  // 94
  },                                                                                                                   // 95
                                                                                                                       //
  setSmtpConfig: function setSmtpConfig(token, config) {                                                               // 97
    checkAuth(token);                                                                                                  // 98
    check(config, smtpConfigShape);                                                                                    // 99
                                                                                                                       //
    Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                               // 101
  },                                                                                                                   // 102
                                                                                                                       //
  disableEmail: function disableEmail(token) {                                                                         // 104
    checkAuth(token);                                                                                                  // 105
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 107
    db.collections.settings.update({ _id: "smtpConfig" }, { $set: { "value.hostname": "" } });                         // 108
  },                                                                                                                   // 109
                                                                                                                       //
  setSetting: function setSetting(token, name, value) {                                                                // 111
    checkAuth(token);                                                                                                  // 112
    check(name, String);                                                                                               // 113
    check(value, Match.OneOf(null, String, Date, Boolean));                                                            // 114
                                                                                                                       //
    Settings.upsert({ _id: name }, { $set: { value: value } });                                                        // 116
  },                                                                                                                   // 117
                                                                                                                       //
  submitFeatureKey: function submitFeatureKey(token, textBlock) {                                                      // 119
    checkAuth(token);                                                                                                  // 120
    check(textBlock, Match.OneOf(null, String));                                                                       // 121
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 123
                                                                                                                       //
    // setNewFeatureKey is provided in feature-key.js                                                                  //
    setNewFeatureKey(db, textBlock);                                                                                   // 126
  },                                                                                                                   // 127
                                                                                                                       //
  renewFeatureKey: function (_renewFeatureKey) {                                                                       // 129
    function renewFeatureKey(_x) {                                                                                     // 129
      return _renewFeatureKey.apply(this, arguments);                                                                  // 129
    }                                                                                                                  // 129
                                                                                                                       //
    renewFeatureKey.toString = function () {                                                                           // 129
      return _renewFeatureKey.toString();                                                                              // 129
    };                                                                                                                 // 129
                                                                                                                       //
    return renewFeatureKey;                                                                                            // 129
  }(function (token) {                                                                                                 // 129
    checkAuth(token);                                                                                                  // 130
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 132
                                                                                                                       //
    // renewFeatureKey is provided in feature-key.js.                                                                  //
    renewFeatureKey(db, { interactive: true });                                                                        // 135
  }),                                                                                                                  // 136
                                                                                                                       //
  saveOrganizationSettings: function saveOrganizationSettings(token, params) {                                         // 138
    checkAuth(token);                                                                                                  // 139
    check(params, {                                                                                                    // 140
      membership: {                                                                                                    // 141
        emailToken: {                                                                                                  // 142
          enabled: Boolean,                                                                                            // 143
          domain: String                                                                                               // 144
        },                                                                                                             // 142
        google: {                                                                                                      // 146
          enabled: Boolean,                                                                                            // 147
          domain: String                                                                                               // 148
        },                                                                                                             // 146
        ldap: {                                                                                                        // 150
          enabled: Boolean                                                                                             // 151
        },                                                                                                             // 150
        saml: {                                                                                                        // 153
          enabled: Boolean                                                                                             // 154
        }                                                                                                              // 153
      },                                                                                                               // 141
      settings: {                                                                                                      // 157
        disallowGuests: Boolean,                                                                                       // 158
        shareContacts: Boolean                                                                                         // 159
      }                                                                                                                // 157
    });                                                                                                                // 140
                                                                                                                       //
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
  },                                                                                                                   // 165
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function adminConfigureLoginService(token, options) {                                    // 167
    checkAuth(token);                                                                                                  // 168
    check(options, Match.ObjectIncluding({ service: String }));                                                        // 169
                                                                                                                       //
    var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                  // 171
                                                                                                                       //
    ServiceConfiguration.configurations.upsert({ service: options.service }, options);                                 // 173
  },                                                                                                                   // 174
                                                                                                                       //
  clearResumeTokensForService: function clearResumeTokensForService(token, serviceName) {                              // 176
    checkAuth(token);                                                                                                  // 177
    check(serviceName, String);                                                                                        // 178
                                                                                                                       //
    var query = {};                                                                                                    // 180
    query["services." + serviceName] = { $exists: true };                                                              // 181
    Meteor.users.find(query).forEach(function (identity) {                                                             // 182
      if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
        Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                   // 185
      }                                                                                                                // 186
                                                                                                                       //
      Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });    // 188
    });                                                                                                                // 190
  },                                                                                                                   // 191
                                                                                                                       //
  adminUpdateUser: function adminUpdateUser(token, userInfo) {                                                         // 193
    checkAuth(token);                                                                                                  // 194
    check(userInfo, {                                                                                                  // 195
      userId: String,                                                                                                  // 196
      signupKey: Boolean,                                                                                              // 197
      isAdmin: Boolean                                                                                                 // 198
    });                                                                                                                // 195
                                                                                                                       //
    var userId = userInfo.userId;                                                                                      // 201
    if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                             // 202
      throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                                // 203
    }                                                                                                                  // 204
                                                                                                                       //
    Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                               // 206
  },                                                                                                                   // 207
                                                                                                                       //
  testSend: function testSend(token, smtpConfig, to) {                                                                 // 209
    checkAuth(token);                                                                                                  // 210
    check(smtpConfig, smtpConfigShape);                                                                                // 211
    check(to, String);                                                                                                 // 212
    var returnAddress = smtpConfig.returnAddress;                                                                      // 209
                                                                                                                       //
    var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                          // 209
                                                                                                                       //
    try {                                                                                                              // 215
      sendEmail({                                                                                                      // 216
        to: to,                                                                                                        // 217
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 218
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 219
        text: "Success! Your outgoing SMTP is working.",                                                               // 220
        smtpConfig: restConfig                                                                                         // 221
      });                                                                                                              // 216
    } catch (e) {                                                                                                      // 223
      // Attempt to give more accurate error messages for a variety of known failure modes,                            //
      // and the actual exception data in the event a user hits a new failure mode.                                    //
      if (e.syscall === "getaddrinfo") {                                                                               // 226
        if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                              // 227
          throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
        }                                                                                                              // 229
      } else if (e.syscall === "connect") {                                                                            // 230
        if (e.code === "ECONNREFUSED") {                                                                               // 231
          throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
        }                                                                                                              // 233
      } else if (e.name === "AuthError") {                                                                             // 234
        throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
      }                                                                                                                // 237
                                                                                                                       //
      throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
    }                                                                                                                  // 240
  },                                                                                                                   // 241
                                                                                                                       //
  createSignupKey: function createSignupKey(token, note, quota) {                                                      // 243
    checkAuth(token);                                                                                                  // 244
    check(note, String);                                                                                               // 245
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 246
                                                                                                                       //
    var key = Random.id();                                                                                             // 248
    var content = { _id: key, used: false, note: note };                                                               // 249
    if (typeof quota === "number") content.quota = quota;                                                              // 250
    SignupKeys.insert(content);                                                                                        // 251
    return key;                                                                                                        // 252
  },                                                                                                                   // 253
                                                                                                                       //
  sendInvites: function sendInvites(token, origin, from, list, subject, message, quota) {                              // 255
    checkAuth(token);                                                                                                  // 256
    check([origin, from, list, subject, message], [String]);                                                           // 257
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 258
                                                                                                                       //
    if (!from.trim()) {                                                                                                // 260
      throw new Meteor.Error(403, "Must enter 'from' address.");                                                       // 261
    }                                                                                                                  // 262
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 264
      throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                       // 265
    }                                                                                                                  // 266
                                                                                                                       //
    this.unblock();                                                                                                    // 268
                                                                                                                       //
    list = list.split("\n");                                                                                           // 270
    for (var i in list) {                                                                                              // 271
      var email = list[i].trim();                                                                                      // 272
                                                                                                                       //
      if (email) {                                                                                                     // 274
        var key = Random.id();                                                                                         // 275
                                                                                                                       //
        var content = {                                                                                                // 277
          _id: key,                                                                                                    // 278
          used: false,                                                                                                 // 279
          note: "E-mail invite to " + email,                                                                           // 280
          email: email,                                                                                                // 281
          definitelySent: false                                                                                        // 282
        };                                                                                                             // 277
        if (typeof quota === "number") content.quota = quota;                                                          // 284
        SignupKeys.insert(content);                                                                                    // 285
        sendEmail({                                                                                                    // 286
          to: email,                                                                                                   // 287
          from: from,                                                                                                  // 288
          envelopeFrom: globalDb.getReturnAddress(),                                                                   // 289
          subject: subject,                                                                                            // 290
          text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                   // 291
        });                                                                                                            // 286
        SignupKeys.update(key, { $set: { definitelySent: true } });                                                    // 293
      }                                                                                                                // 294
    }                                                                                                                  // 295
                                                                                                                       //
    return { sent: true };                                                                                             // 297
  },                                                                                                                   // 298
                                                                                                                       //
  adminToggleDisableCap: function adminToggleDisableCap(token, capId, value) {                                         // 300
    checkAuth(token);                                                                                                  // 301
    check(capId, String);                                                                                              // 302
    check(value, Boolean);                                                                                             // 303
                                                                                                                       //
    if (value) {                                                                                                       // 305
      ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                   // 306
    } else {                                                                                                           // 307
      ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                  // 308
    }                                                                                                                  // 309
  },                                                                                                                   // 310
                                                                                                                       //
  updateQuotas: function updateQuotas(token, list, quota) {                                                            // 312
    checkAuth(token);                                                                                                  // 313
    check(list, String);                                                                                               // 314
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 315
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 317
      throw new Meteor.Error(400, "Must enter addresses.");                                                            // 318
    }                                                                                                                  // 319
                                                                                                                       //
    var items = list.split("\n");                                                                                      // 321
    var invalid = [];                                                                                                  // 322
    for (var i in items) {                                                                                             // 323
      var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };               // 324
      var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                       // 326
      n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                  // 327
                                                                                                                       //
      if (n < 1) invalid.push(items[i]);                                                                               // 329
    }                                                                                                                  // 330
                                                                                                                       //
    if (invalid.length > 0) {                                                                                          // 332
      throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));        // 333
    }                                                                                                                  // 335
  },                                                                                                                   // 336
                                                                                                                       //
  dismissAdminStatsNotifications: function dismissAdminStatsNotifications(token) {                                     // 338
    checkAuth(token);                                                                                                  // 339
    globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                        // 340
  },                                                                                                                   // 341
                                                                                                                       //
  signUpAsAdmin: function signUpAsAdmin(token) {                                                                       // 343
    check(token, String);                                                                                              // 344
    checkAuth(token);                                                                                                  // 345
    if (!this.userId) {                                                                                                // 346
      throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                           // 347
    }                                                                                                                  // 348
                                                                                                                       //
    if (!Meteor.user().loginIdentities) {                                                                              // 350
      throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                              // 351
    }                                                                                                                  // 352
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                        // 354
    clearAdminToken(token);                                                                                            // 355
  },                                                                                                                   // 356
                                                                                                                       //
  redeemSetupToken: function redeemSetupToken(token) {                                                                 // 358
    // Redeem an admin token into a setup session.                                                                     //
    check(token, String);                                                                                              // 360
    if (tokenIsValid(token)) {                                                                                         // 361
      var sessId = Random.secret();                                                                                    // 362
      var creationDate = new Date();                                                                                   // 363
      var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                               // 364
      this.connection.sandstormDb.collections.setupSession.upsert({                                                    // 365
        _id: "current-session"                                                                                         // 366
      }, {                                                                                                             // 365
        creationDate: creationDate,                                                                                    // 368
        hashedSessionId: hashedSessionId                                                                               // 369
      });                                                                                                              // 367
      // Then, invalidate the token, so one one else can use it.                                                       //
      clearAdminToken(token);                                                                                          // 372
      return sessId;                                                                                                   // 373
    } else {                                                                                                           // 374
      throw new Meteor.Error(401, "Invalid setup token");                                                              // 375
    }                                                                                                                  // 376
  },                                                                                                                   // 377
  heapdump: function heapdump() {                                                                                      // 379
    // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                                 //
    //                                                                                                                 //
    // Call this from the JS console like:                                                                             //
    //   Meteor.call("heapdump");                                                                                      //
                                                                                                                       //
    checkAuth();                                                                                                       // 385
                                                                                                                       //
    // We use /var/log because it's a location in the container to which the front-end is allowed                      //
    // to write.                                                                                                       //
    var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                             // 389
    Heapdump.writeSnapshot(name);                                                                                      // 390
    console.log("Wrote heapdump: /opt/sandstorm" + name);                                                              // 391
    return name;                                                                                                       // 392
  },                                                                                                                   // 393
                                                                                                                       //
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 395
    checkAuth();                                                                                                       // 396
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 397
                                                                                                                       //
    this.connection.sandstormDb.setPreinstalledApps(appAndPackageIds);                                                 // 399
  }                                                                                                                    // 400
});                                                                                                                    // 61
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 403
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 406
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 408
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 409
  return Settings.find();                                                                                              // 410
});                                                                                                                    // 411
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 413
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 414
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 415
});                                                                                                                    // 416
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 418
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 419
});                                                                                                                    // 420
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 422
  check(token, String);                                                                                                // 423
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 424
  this.ready();                                                                                                        // 425
});                                                                                                                    // 426
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 428
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 429
  return Meteor.users.find();                                                                                          // 430
});                                                                                                                    // 431
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 433
  var _this2 = this;                                                                                                   // 433
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 434
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 438
  var accountId = userId;                                                                                              // 439
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 441
    if (!identitySubs[identityId]) {                                                                                   // 442
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 445
      return;                                                                                                          // 446
    }                                                                                                                  // 447
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 449
    delete identitySubs[identityId];                                                                                   // 450
    observeHandle.stop();                                                                                              // 451
    _this2.removed("users", identityId);                                                                               // 452
  };                                                                                                                   // 453
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 455
    if (identitySubs[identityId]) {                                                                                    // 456
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 459
      return;                                                                                                          // 460
    }                                                                                                                  // 461
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 463
    var observeHandle = cursor.observe({                                                                               // 464
      added: function added(doc) {                                                                                     // 465
        _this2.added("users", doc._id, doc);                                                                           // 466
      },                                                                                                               // 467
                                                                                                                       //
      changed: function changed(newDoc, oldDoc) {                                                                      // 469
        fillUndefinedForChangedDoc(newDoc, oldDoc);                                                                    // 470
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 471
      },                                                                                                               // 472
                                                                                                                       //
      removed: function removed(oldDoc) {                                                                              // 474
        _this2.removed("users", oldDoc._id);                                                                           // 475
      }                                                                                                                // 476
    });                                                                                                                // 464
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 479
  };                                                                                                                   // 480
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 482
  var accountSubHandle = accountCursor.observe({                                                                       // 483
    added: function added(newDoc) {                                                                                    // 484
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 485
      newIdentities.forEach(function (identityId) {                                                                    // 486
        refIdentity(identityId);                                                                                       // 487
      });                                                                                                              // 488
                                                                                                                       //
      _this2.added("users", newDoc._id, newDoc);                                                                       // 490
    },                                                                                                                 // 491
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 493
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 494
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 495
                                                                                                                       //
      // Those in newDoc - oldDoc, ref.                                                                                //
      var identitiesAdded = _.difference(newIdentities, oldIdentities);                                                // 498
      identitiesAdded.forEach(function (identityId) {                                                                  // 499
        refIdentity(identityId);                                                                                       // 500
      });                                                                                                              // 501
                                                                                                                       //
      // Those in oldDoc - newDoc, unref.                                                                              //
      var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                              // 504
      identitiesRemoved.forEach(function (identityId) {                                                                // 505
        unrefIdentity(identityId);                                                                                     // 506
      });                                                                                                              // 507
                                                                                                                       //
      fillUndefinedForChangedDoc(newDoc, oldDoc);                                                                      // 509
                                                                                                                       //
      _this2.changed("users", newDoc._id, newDoc);                                                                     // 511
    },                                                                                                                 // 512
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 514
      _this2.removed("users", oldDoc._id);                                                                             // 515
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 516
      oldIdentities.forEach(function (identityId) {                                                                    // 517
        unrefIdentity(identityId);                                                                                     // 518
      });                                                                                                              // 519
    }                                                                                                                  // 520
  });                                                                                                                  // 483
                                                                                                                       //
  this.onStop(function () {                                                                                            // 523
    accountSubHandle.stop();                                                                                           // 524
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 526
    subs.forEach(function (sub) {                                                                                      // 527
      sub.stop();                                                                                                      // 528
    });                                                                                                                // 529
  });                                                                                                                  // 530
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 534
});                                                                                                                    // 535
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 537
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 538
  return ActivityStats.find();                                                                                         // 539
});                                                                                                                    // 540
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 542
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 543
  return StatsTokens.find();                                                                                           // 544
});                                                                                                                    // 545
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 547
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 548
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 549
      "manifest.actions": 1, "manifest.appTitle": 1, progress: 1, status: 1 } });                                      // 551
});                                                                                                                    // 552
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 554
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 555
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 558
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 561
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 562
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 563
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 567
});                                                                                                                    // 568
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 570
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 571
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 573
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 575
  var startSize = Fs.fstatSync(fd).size;                                                                               // 576
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 579
                                                                                                                       //
  var _this = this;                                                                                                    // 581
  function doTail() {                                                                                                  // 582
    for (;;) {                                                                                                         // 583
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 584
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 585
      if (n <= 0) break;                                                                                               // 586
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 587
      offset += n;                                                                                                     // 588
    }                                                                                                                  // 589
  }                                                                                                                    // 590
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 593
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 596
    watcher.close();                                                                                                   // 597
    Fs.closeSync(fd);                                                                                                  // 598
  });                                                                                                                  // 599
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 602
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 605
});                                                                                                                    // 606
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 608
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 609
  return ApiTokens.find({                                                                                              // 610
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 611
  }, {                                                                                                                 // 610
    fields: {                                                                                                          // 616
      frontendRef: 1,                                                                                                  // 617
      created: 1,                                                                                                      // 618
      requirements: 1,                                                                                                 // 619
      revoked: 1,                                                                                                      // 620
      owner: 1                                                                                                         // 621
    }                                                                                                                  // 616
  });                                                                                                                  // 615
});                                                                                                                    // 624
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 626
  var _this3 = this;                                                                                                   // 626
                                                                                                                       //
  // Note: we publish the *raw* feature key data to the client, exactly as it was loaded from the                      //
  // signed blob.  Any mapping from the raw data to "effective" feature key/limits should be applied                   //
  // in the implementation of db.currentFeatureKey().                                                                  //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 630
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 632
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 635
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 636
  var observeHandle = featureKeyQuery.observe({                                                                        // 637
    added: function added(doc) {                                                                                       // 638
      // Load and verify the signed feature key.                                                                       //
      var buf = new Buffer(doc.value);                                                                                 // 640
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 641
      if (doc.renewalProblem) {                                                                                        // 642
        featureKey.renewalProblem = doc.renewalProblem;                                                                // 643
      }                                                                                                                // 644
                                                                                                                       //
      if (featureKey) {                                                                                                // 646
        var _ref;                                                                                                      // 646
                                                                                                                       //
        // If the signature is valid, publish the feature key information.                                             //
        var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                             // 648
        _this3.added("featureKey", doc._id, filteredFeatureKey);                                                       // 649
      }                                                                                                                // 650
    },                                                                                                                 // 651
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 653
      // Load and reverify the new signed feature key.                                                                 //
      var buf = new Buffer(newDoc.value);                                                                              // 655
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 656
      if (newDoc.renewalProblem) {                                                                                     // 657
        featureKey.renewalProblem = newDoc.renewalProblem;                                                             // 658
      } else if (oldDoc.renewalProblem) {                                                                              // 659
        featureKey.renewalProblem = undefined;                                                                         // 660
      }                                                                                                                // 661
                                                                                                                       //
      if (featureKey) {                                                                                                // 663
        var _ref2;                                                                                                     // 663
                                                                                                                       //
        // If the signature is valid, call this.changed() with the interesting fields.                                 //
        var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                           // 665
        _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                  // 666
      } else {                                                                                                         // 667
        // Otherwise, call this.removed(), since the new feature key is invalid.                                       //
        _this3.removed("featureKey", oldDoc._id);                                                                      // 669
      }                                                                                                                // 670
    },                                                                                                                 // 671
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 673
      _this3.removed("featureKey", oldDoc._id);                                                                        // 674
    }                                                                                                                  // 675
  });                                                                                                                  // 637
                                                                                                                       //
  this.onStop(function () {                                                                                            // 678
    observeHandle.stop();                                                                                              // 679
  });                                                                                                                  // 680
                                                                                                                       //
  this.ready();                                                                                                        // 682
});                                                                                                                    // 683
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 685
  var _this4 = this;                                                                                                   // 685
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 687
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 690
  if (cursor.count() > 0) {                                                                                            // 691
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 692
  } else {                                                                                                             // 693
    (function () {                                                                                                     // 693
      var handle = cursor.observeChanges({                                                                             // 694
        added: function added(id) {                                                                                    // 695
          _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                    // 696
          handle.stop();                                                                                               // 697
          handle = null;                                                                                               // 698
        }                                                                                                              // 699
      });                                                                                                              // 694
      _this4.onStop(function () {                                                                                      // 701
        if (handle) handle.stop();                                                                                     // 702
      });                                                                                                              // 703
    })();                                                                                                              // 693
  }                                                                                                                    // 704
                                                                                                                       //
  this.ready();                                                                                                        // 706
});                                                                                                                    // 707
                                                                                                                       //
Meteor.publish("appIndexAdmin", function (token) {                                                                     // 709
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 710
  return globalDb.collections.appIndex.find();                                                                         // 711
});                                                                                                                    // 712
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 714
  Settings.find({ _id: name, value: true }).observe({                                                                  // 715
    added: function added() {                                                                                          // 716
      // Tell the oauth library it should accept login attempts from this service.                                     //
      Accounts.oauth.registerService(name);                                                                            // 718
    },                                                                                                                 // 719
                                                                                                                       //
    removed: function removed() {                                                                                      // 721
      // Tell the oauth library it should deny login attempts from this service.                                       //
      Accounts.oauth.unregisterService(name);                                                                          // 723
    }                                                                                                                  // 724
  });                                                                                                                  // 715
}                                                                                                                      // 726
                                                                                                                       //
observeOauthService("github");                                                                                         // 728
observeOauthService("google");                                                                                         // 729
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":["babel-runtime/helpers/typeof","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Capnp = Npm.require("capnp");                                                                                      // 21
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 23
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 120; // Give enough time for large uploads on slow connections.                            // 25
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 26
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 28
  check(tokenId, String);                                                                                              // 29
  FileTokens.remove({ _id: tokenId });                                                                                 // 30
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 31
}                                                                                                                      // 32
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 34
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 36
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 37
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 39
      cleanupToken(token._id);                                                                                         // 40
    });                                                                                                                // 41
  });                                                                                                                  // 42
});                                                                                                                    // 43
                                                                                                                       //
Meteor.methods({                                                                                                       // 45
  backupGrain: function backupGrain(grainId) {                                                                         // 46
    check(grainId, String);                                                                                            // 47
    var grain = Grains.findOne(grainId);                                                                               // 48
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 49
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 50
    }                                                                                                                  // 51
                                                                                                                       //
    this.unblock();                                                                                                    // 53
                                                                                                                       //
    var token = {                                                                                                      // 55
      _id: Random.id(),                                                                                                // 56
      timestamp: new Date(),                                                                                           // 57
      name: grain.title                                                                                                // 58
    };                                                                                                                 // 55
                                                                                                                       //
    // TODO(soon): does the grain need to be offline?                                                                  //
                                                                                                                       //
    var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                     // 63
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 65
    waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                          // 66
                                                                                                                       //
    return token._id;                                                                                                  // 68
  },                                                                                                                   // 69
  newRestoreToken: function newRestoreToken() {                                                                        // 71
    if (!isSignedUpOrDemo()) {                                                                                         // 72
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can restore backups.");                          // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 76
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 77
    }                                                                                                                  // 79
                                                                                                                       //
    var token = {                                                                                                      // 81
      _id: Random.id(),                                                                                                // 82
      timestamp: new Date()                                                                                            // 83
    };                                                                                                                 // 81
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 86
                                                                                                                       //
    return token._id;                                                                                                  // 88
  },                                                                                                                   // 89
  restoreGrain: function restoreGrain(tokenId, identityId) {                                                           // 91
    check(tokenId, String);                                                                                            // 92
    check(identityId, String);                                                                                         // 93
    var token = FileTokens.findOne(tokenId);                                                                           // 94
    if (!token || !isSignedUpOrDemo()) {                                                                               // 95
      throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");                // 96
    }                                                                                                                  // 98
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 100
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 101
    }                                                                                                                  // 103
                                                                                                                       //
    this.unblock();                                                                                                    // 105
                                                                                                                       //
    var grainId = Random.id(22);                                                                                       // 107
                                                                                                                       //
    try {                                                                                                              // 109
      var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
        console.error("Unzip failure:", err.message);                                                                  // 112
        throw new Meteor.Error(500, "Invalid backup file.");                                                           // 113
      })).info;                                                                                                        // 114
      if (!grainInfo.appId) {                                                                                          // 115
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 116
        throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                                // 117
      }                                                                                                                // 118
                                                                                                                       //
      var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                               // 120
                                                                                                                       //
      // Create variables we'll use for later Mongo query.                                                             //
      var packageId = void 0;                                                                                          // 123
      var appVersion = void 0;                                                                                         // 124
                                                                                                                       //
      // DevPackages are system-wide, so we do not check the user ID.                                                  //
      var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                                // 127
      if (devPackage) {                                                                                                // 128
        // If the dev app package exists, it should override the user action.                                          //
        packageId = devPackage.packageId;                                                                              // 130
        appVersion = devPackage.manifest.appVersion;                                                                   // 131
      } else if (action) {                                                                                             // 132
        // The app is installed, so we can continue restoring this                                                     //
        // grain.                                                                                                      //
        packageId = action.packageId;                                                                                  // 135
        appVersion = action.appVersion;                                                                                // 136
      } else {                                                                                                         // 137
        // If the package isn't installed at all, bail out.                                                            //
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 139
        throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);          // 140
      }                                                                                                                // 143
                                                                                                                       //
      if (appVersion < grainInfo.appVersion) {                                                                         // 145
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 146
        throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
      }                                                                                                                // 152
                                                                                                                       //
      Grains.insert({                                                                                                  // 154
        _id: grainId,                                                                                                  // 155
        packageId: packageId,                                                                                          // 156
        appId: grainInfo.appId,                                                                                        // 157
        appVersion: appVersion,                                                                                        // 158
        userId: this.userId,                                                                                           // 159
        identityId: identityId,                                                                                        // 160
        title: grainInfo.title,                                                                                        // 161
        "private": true,                                                                                               // 162
        size: 0                                                                                                        // 163
      });                                                                                                              // 154
    } finally {                                                                                                        // 165
      cleanupToken(tokenId);                                                                                           // 166
    }                                                                                                                  // 167
                                                                                                                       //
    return grainId;                                                                                                    // 169
  }                                                                                                                    // 170
});                                                                                                                    // 45
                                                                                                                       //
Router.map(function () {                                                                                               // 173
  this.route("downloadBackup", {                                                                                       // 174
    where: "server",                                                                                                   // 175
    path: "/downloadBackup/:tokenId",                                                                                  // 176
    action: function action() {                                                                                        // 177
      var token = FileTokens.findOne(this.params.tokenId);                                                             // 178
      var response = this.response;                                                                                    // 179
      if (!token) {                                                                                                    // 180
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 181
        return response.end("File does not exist");                                                                    // 182
      }                                                                                                                // 183
                                                                                                                       //
      var started = false;                                                                                             // 185
      var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                          // 186
      var sawEnd = false;                                                                                              // 187
                                                                                                                       //
      var stream = {                                                                                                   // 189
        expectSize: function expectSize(size) {                                                                        // 190
          if (!started) {                                                                                              // 191
            started = true;                                                                                            // 192
            response.writeHead(200, {                                                                                  // 193
              "Content-Length": size,                                                                                  // 194
              "Content-Type": "application/zip",                                                                       // 195
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 196
            });                                                                                                        // 193
          }                                                                                                            // 198
        },                                                                                                             // 199
        write: function write(data) {                                                                                  // 201
          if (!started) {                                                                                              // 202
            started = true;                                                                                            // 203
            response.writeHead(200, {                                                                                  // 204
              "Content-Type": "application/zip",                                                                       // 205
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 206
            });                                                                                                        // 204
          }                                                                                                            // 208
                                                                                                                       //
          response.write(data);                                                                                        // 210
        },                                                                                                             // 211
        done: function done(data) {                                                                                    // 213
          if (!started) {                                                                                              // 214
            started = true;                                                                                            // 215
            response.writeHead(200, {                                                                                  // 216
              "Content-Length": 0,                                                                                     // 217
              "Content-Type": "application/zip",                                                                       // 218
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 219
            });                                                                                                        // 216
          }                                                                                                            // 221
                                                                                                                       //
          sawEnd = true;                                                                                               // 223
          response.end();                                                                                              // 224
        }                                                                                                              // 225
      };                                                                                                               // 189
                                                                                                                       //
      waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                    // 228
                                                                                                                       //
      if (!sawEnd) {                                                                                                   // 230
        console.error("backend failed to call done() when downloading backup");                                        // 231
        if (!started) {                                                                                                // 232
          throw new Meteor.Error(500, "backend failed to produce data");                                               // 233
        }                                                                                                              // 234
                                                                                                                       //
        response.end();                                                                                                // 236
      }                                                                                                                // 237
                                                                                                                       //
      cleanupToken(this.params.tokenId);                                                                               // 239
    }                                                                                                                  // 240
  });                                                                                                                  // 174
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 243
    where: "server",                                                                                                   // 244
    path: "/uploadBackup/:token",                                                                                      // 245
    action: function action() {                                                                                        // 246
      var _this = this;                                                                                                // 246
                                                                                                                       //
      if (this.request.method === "POST") {                                                                            // 247
        var _ret = function () {                                                                                       // 247
          var token = FileTokens.findOne(_this.params.token);                                                          // 248
          if (!_this.params.token || !token) {                                                                         // 249
            _this.response.writeHead(403, {                                                                            // 250
              "Content-Type": "text/plain"                                                                             // 251
            });                                                                                                        // 250
            _this.response.write("Invalid upload token.");                                                             // 253
            _this.response.end();                                                                                      // 254
            return {                                                                                                   // 255
              v: void 0                                                                                                // 255
            };                                                                                                         // 255
          }                                                                                                            // 256
                                                                                                                       //
          var request = _this.request;                                                                                 // 258
          try {                                                                                                        // 259
            (function () {                                                                                             // 259
              var stream = globalBackend.cap().uploadBackup(_this.params.token).stream;                                // 260
                                                                                                                       //
              waitPromise(new Promise(function (resolve, reject) {                                                     // 262
                request.on("data", function (data) {                                                                   // 263
                  stream.write(data);                                                                                  // 264
                });                                                                                                    // 265
                request.on("end", function () {                                                                        // 266
                  resolve(stream.done());                                                                              // 267
                });                                                                                                    // 268
                request.on("error", function (err) {                                                                   // 269
                  stream.close();                                                                                      // 270
                });                                                                                                    // 271
              }));                                                                                                     // 272
                                                                                                                       //
              _this.response.writeHead(204);                                                                           // 274
              _this.response.end();                                                                                    // 275
            })();                                                                                                      // 259
          } catch (error) {                                                                                            // 276
            console.error(error.stack);                                                                                // 277
            _this.response.writeHead(500, {                                                                            // 278
              "Content-Type": "text/plain"                                                                             // 279
            });                                                                                                        // 278
            _this.response.write(error.stack);                                                                         // 281
            _this.response.end();                                                                                      // 282
          }                                                                                                            // 283
        }();                                                                                                           // 247
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                   // 247
      } else {                                                                                                         // 284
        this.response.writeHead(405, {                                                                                 // 285
          "Content-Type": "text/plain"                                                                                 // 286
        });                                                                                                            // 285
        this.response.write("You can only POST here.");                                                                // 288
        this.response.end();                                                                                           // 289
      }                                                                                                                // 290
    }                                                                                                                  // 291
  });                                                                                                                  // 243
});                                                                                                                    // 293
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"contacts-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/contacts-server.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.publish("contactProfiles", function (showAll) {                                                                 // 17
  var db = this.connection.sandstormDb;                                                                                // 18
  var _this = this;                                                                                                    // 19
  var userId = this.userId;                                                                                            // 20
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var contactIdentities = {};                                                                                          // 23
  var disallowGuests = db.getOrganizationDisallowGuests();                                                             // 24
                                                                                                                       //
  function addIdentityOfContact(identityId) {                                                                          // 26
    if (!(identityId in contactIdentities)) {                                                                          // 27
      var user = Meteor.users.findOne({ _id: identityId });                                                            // 28
                                                                                                                       //
      if (disallowGuests && !showAll) {                                                                                // 30
        if (!db.isIdentityInOrganization(user)) {                                                                      // 31
          return;                                                                                                      // 32
        }                                                                                                              // 33
      }                                                                                                                // 34
                                                                                                                       //
      if (user) {                                                                                                      // 36
        SandstormDb.fillInProfileDefaults(user);                                                                       // 37
        SandstormDb.fillInIntrinsicName(user);                                                                         // 38
        var filteredUser = _.pick(user, "_id", "profile");                                                             // 39
        _this.added("contactProfiles", user._id, filteredUser);                                                        // 40
      }                                                                                                                // 41
                                                                                                                       //
      contactIdentities[identityId] = Meteor.users.find({ _id: identityId }, { fields: { profile: 1 } }).observeChanges({
        changed: function changed(id, fields) {                                                                        // 45
          _this.changed("contactProfiles", id, fields);                                                                // 46
        }                                                                                                              // 47
      });                                                                                                              // 44
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  var cursor = db.collections.contacts.find({ ownerId: userId });                                                      // 52
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 54
    added: function added(contact) {                                                                                   // 55
      addIdentityOfContact(contact.identityId);                                                                        // 56
    },                                                                                                                 // 57
                                                                                                                       //
    changed: function changed(contact) {                                                                               // 59
      addIdentityOfContact(contact.identityId);                                                                        // 60
    },                                                                                                                 // 61
                                                                                                                       //
    removed: function removed(contact) {                                                                               // 63
      _this.removed("contactProfiles", contact.identityId);                                                            // 64
      var contactIdentity = contactIdentities[contact.identityId];                                                     // 65
      if (contactIdentity) contactIdentities[contact.identityId].stop();                                               // 66
      delete contactIdentities[contact.identityId];                                                                    // 67
    }                                                                                                                  // 68
  });                                                                                                                  // 54
                                                                                                                       //
  var orgHandle = void 0;                                                                                              // 71
                                                                                                                       //
  if (db.getOrganizationShareContacts() && db.isUserInOrganization(db.collections.users.findOne({ _id: userId }))) {   // 73
    var orgCursor = db.collections.users.find({ profile: { $exists: 1 } });                                            // 75
    // TODO(perf): make a mongo query that can find all identities in an organization and add                          //
    // indices for it. Currently, we do some case insensitive matching which mongo can't                               //
    // handle well.                                                                                                    //
                                                                                                                       //
    orgHandle = orgCursor.observe({                                                                                    // 80
      added: function added(user) {                                                                                    // 81
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 82
          addIdentityOfContact(user._id);                                                                              // 83
        }                                                                                                              // 84
      },                                                                                                               // 85
                                                                                                                       //
      changed: function changed(user) {                                                                                // 87
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 88
          addIdentityOfContact(user._id);                                                                              // 89
        }                                                                                                              // 90
      },                                                                                                               // 91
                                                                                                                       //
      removed: function removed(user) {                                                                                // 93
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 94
          _this.removed("contactProfiles", user._id);                                                                  // 95
          var contactIdentity = contactIdentities[contact.identityId];                                                 // 96
          if (contactIdentity) contactIdentities[contact.identityId].stop();                                           // 97
          delete contactIdentities[user._id];                                                                          // 98
        }                                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 80
  }                                                                                                                    // 102
                                                                                                                       //
  this.ready();                                                                                                        // 104
                                                                                                                       //
  this.onStop(function () {                                                                                            // 106
    handle.stop();                                                                                                     // 107
    if (orgHandle) {                                                                                                   // 108
      orgHandle.stop();                                                                                                // 109
    }                                                                                                                  // 110
                                                                                                                       //
    Object.keys(contactIdentities).forEach(function (identityId) {                                                     // 112
      contactIdentities[identityId].stop();                                                                            // 113
      delete contactIdentities[identityId];                                                                            // 114
    });                                                                                                                // 115
  });                                                                                                                  // 116
});                                                                                                                    // 117
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/async-helpers.js","/imports/server/static-asset.js","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});var StaticAssetImpl,IdenticonStaticAssetImpl;module.import("/imports/server/static-asset.js",{"StaticAssetImpl":function(v){StaticAssetImpl=v},"IdenticonStaticAssetImpl":function(v){IdenticonStaticAssetImpl=v}});var PersistentImpl,hashSturdyRef,generateSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v},"hashSturdyRef":function(v){hashSturdyRef=v},"generateSturdyRef":function(v){generateSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Crypto = Npm.require("crypto");                                                                                    // 20
                                                                                                                       // 21
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 24
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 25
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 26
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 27
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 28
var StaticAsset = Capnp.importSystem("sandstorm/util.capnp").StaticAsset;                                              // 29
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 30
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(db, grainId) {                                                                            // 33
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 33
                                                                                                                       //
    this.db = db;                                                                                                      // 34
    this.grainId = grainId;                                                                                            // 35
  }                                                                                                                    // 36
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function restore(sturdyRef) {                                                  //
    var _this = this;                                                                                                  // 38
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 39
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 40
      var token = _this.db.collections.apiTokens.findOne({                                                             // 41
        _id: hashedSturdyRef,                                                                                          // 42
        "owner.grain.grainId": _this.grainId                                                                           // 43
      });                                                                                                              // 41
                                                                                                                       //
      if (!token) {                                                                                                    // 46
        throw new Error("no such token");                                                                              // 47
      }                                                                                                                // 48
                                                                                                                       //
      if (token.owner.grain.introducerIdentity) {                                                                      // 50
        throw new Error("Cannot restore grain-owned sturdyref that contains the obsolete " + "introducerIdentity field. Please request a new capability.");
      }                                                                                                                // 53
                                                                                                                       //
      return restoreInternal(_this.db, sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) }, [], token);
    });                                                                                                                // 58
  };                                                                                                                   // 59
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function drop(sturdyRef) {                                                        //
    var _this2 = this;                                                                                                 // 61
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 62
      return dropInternal(_this2.db, sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this2.grainId }) });        // 63
    });                                                                                                                // 64
  };                                                                                                                   // 65
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function makeToken(ref, owner, requirements) {                               //
    var _this3 = this;                                                                                                 // 67
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 68
      var sturdyRef = new Buffer(generateSturdyRef());                                                                 // 69
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 70
      _this3.db.collections.apiTokens.insert({                                                                         // 71
        _id: hashedSturdyRef,                                                                                          // 72
        grainId: _this3.grainId,                                                                                       // 73
        objectId: ref,                                                                                                 // 74
        owner: owner,                                                                                                  // 75
        created: new Date(),                                                                                           // 76
        requirements: requirements                                                                                     // 77
      });                                                                                                              // 71
                                                                                                                       //
      return {                                                                                                         // 80
        token: sturdyRef                                                                                               // 81
      };                                                                                                               // 80
    });                                                                                                                // 83
  };                                                                                                                   // 84
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function makeChildToken(parent, owner, requirements) {                  //
    var _this4 = this;                                                                                                 // 86
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 87
      // Compute the save ApiToken template.                                                                           //
      return makeSaveTemplateForChild(_this4.db, parent.toString(), requirements);                                     // 89
    }).then(function (saveTemplate) {                                                                                  // 90
      // Create a dummy PersistentImpl and invoke its own save() method.                                               //
      return new PersistentImpl(_this4.db, saveTemplate).save({ sealFor: owner });                                     // 92
    }).then(function (saveResult) {                                                                                    // 93
      // Transform to expected result structure.                                                                       //
      return { token: saveResult.sturdyRef };                                                                          // 95
    });                                                                                                                // 96
  };                                                                                                                   // 97
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function getOwnerNotificationTarget() {                     //
    var _this5 = this;                                                                                                 // 99
                                                                                                                       //
    var grainId = this.grainId;                                                                                        // 100
    return {                                                                                                           // 101
      owner: {                                                                                                         // 102
        addOngoing: function addOngoing(displayInfo, notification) {                                                   // 103
          return inMeteor(function () {                                                                                // 104
            var grain = _this5.db.collections.grains.findOne({ _id: grainId });                                        // 105
            if (!grain) {                                                                                              // 106
              throw new Error("Grain not found.");                                                                     // 107
            }                                                                                                          // 108
                                                                                                                       //
            var castedNotification = notification.castAs(PersistentOngoingNotification);                               // 110
            var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                      // 111
                                                                                                                       //
            // We have to close both the casted cap and the original. Perhaps this should be fixed in                  //
            // node-capnp?                                                                                             //
            castedNotification.close();                                                                                // 115
            notification.close();                                                                                      // 116
            var notificationId = _this5.db.collections.notifications.insert({                                          // 117
              ongoing: wakelockToken,                                                                                  // 118
              grainId: grainId,                                                                                        // 119
              userId: grain.userId,                                                                                    // 120
              text: displayInfo.caption,                                                                               // 121
              timestamp: new Date(),                                                                                   // 122
              isUnread: true                                                                                           // 123
            });                                                                                                        // 117
                                                                                                                       //
            return {                                                                                                   // 126
              handle: globalFrontendRefRegistry.create(_this5.db, { notificationHandle: notificationId })              // 127
            };                                                                                                         // 126
          });                                                                                                          // 130
        }                                                                                                              // 131
      }                                                                                                                // 102
    };                                                                                                                 // 101
  };                                                                                                                   // 134
                                                                                                                       //
  SandstormCoreImpl.prototype.backgroundActivity = function backgroundActivity(event) {                                //
    var _this6 = this;                                                                                                 // 136
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 137
      logActivity(_this6.grainId, null, event);                                                                        // 138
    });                                                                                                                // 139
  };                                                                                                                   // 140
                                                                                                                       //
  SandstormCoreImpl.prototype.reportGrainSize = function reportGrainSize(bytes) {                                      //
    bytes = parseInt(bytes); // int64s are stringified but precision isn't critical here                               // 143
                                                                                                                       //
    var result = this.db.collections.grains.findAndModify({                                                            // 145
      query: { _id: this.grainId },                                                                                    // 146
      update: { $set: { size: bytes } },                                                                               // 147
      fields: { _id: 1, userId: 1, size: 1 }                                                                           // 148
    });                                                                                                                // 145
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 151
      throw new Error("Grain not found.");                                                                             // 152
    }                                                                                                                  // 153
                                                                                                                       //
    // If the grain did not have a "size" field before the update, then it is a grain created                          //
    // before per-grain size tracking was implemented. In that case, we don't want to update the                       //
    // user record because it may already be counting the grain (specifically on Blackrock, where                      //
    // whole-user size counting has existed for some time).                                                            //
    if (this.db.isQuotaEnabled() && "size" in result.value) {                                                          // 159
      // Update the user record, too. Note that we periodically recompute the user's storage usage                     //
      // from scratch as well, so this doesn't have to be perfectly reliable.                                          //
      var diff = bytes - (result.value.size || 0);                                                                     // 162
      this.db.collections.users.update(result.value.userId, { $inc: { storageUsage: diff } });                         // 163
    }                                                                                                                  // 164
  };                                                                                                                   // 165
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(db, grainId) {                                                      // 168
  return new Capnp.Capability(new SandstormCoreImpl(db, grainId), SandstormCore);                                      // 169
};                                                                                                                     // 170
                                                                                                                       //
var NotificationHandle = function (_PersistentImpl) {                                                                  //
  _inherits(NotificationHandle, _PersistentImpl);                                                                      //
                                                                                                                       //
  // TODO(cleanup): Move to a different file.                                                                          //
                                                                                                                       //
  function NotificationHandle(db, saveTemplate, notificationId) {                                                      // 175
    _classCallCheck(this, NotificationHandle);                                                                         // 175
                                                                                                                       //
    var _this7 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 175
                                                                                                                       //
    _this7.notificationId = notificationId;                                                                            // 177
    _this7.db = db;                                                                                                    // 178
    return _this7;                                                                                                     // 175
  }                                                                                                                    // 179
                                                                                                                       //
  NotificationHandle.prototype.close = function close() {                                                              //
    var _this8 = this;                                                                                                 // 181
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 182
      if (!_this8.isSaved()) {                                                                                         // 183
        _dismissNotification(_this8.db, _this8.notificationId);                                                        // 184
      }                                                                                                                // 185
    });                                                                                                                // 186
  };                                                                                                                   // 187
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var PersistentUiViewImpl = function (_PersistentImpl2) {                                                               //
  _inherits(PersistentUiViewImpl, _PersistentImpl2);                                                                   //
                                                                                                                       //
  // TODO(cleanup): Move out of core.js.                                                                               //
                                                                                                                       //
  function PersistentUiViewImpl(db, saveTemplate, grainId) {                                                           // 193
    _classCallCheck(this, PersistentUiViewImpl);                                                                       // 193
                                                                                                                       //
    var _this9 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 193
                                                                                                                       //
    check(grainId, String);                                                                                            // 195
    _this9._db = db;                                                                                                   // 196
    _this9._grainId = grainId;                                                                                         // 197
    return _this9;                                                                                                     // 193
  }                                                                                                                    // 198
                                                                                                                       //
  PersistentUiViewImpl.prototype.getViewInfo = function getViewInfo() {                                                //
    var _this10 = this;                                                                                                // 200
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 201
      var grain = _this10._db.getGrain(_this10._grainId);                                                              // 202
      if (!grain || grain.trashed) {                                                                                   // 203
        throw new Error("grain no longer exists");                                                                     // 204
      }                                                                                                                // 205
                                                                                                                       //
      var pkg = _this10._db.getPackage(grain.packageId) || DevPackages.findOne({ appId: grain.appId }) || {};          // 207
                                                                                                                       //
      var manifest = pkg.manifest || {};                                                                               // 211
                                                                                                                       //
      var viewInfo = grain.cachedViewInfo || {};                                                                       // 213
                                                                                                                       //
      if (!viewInfo.appTitle) {                                                                                        // 215
        viewInfo.appTitle = manifest.appTitle || {};                                                                   // 216
      }                                                                                                                // 217
                                                                                                                       //
      if (!viewInfo.grainIcon) {                                                                                       // 219
        var grainIcon = ((manifest.metadata || {}).icons || {}).grain;                                                 // 220
        if (grainIcon) {                                                                                               // 221
          viewInfo.grainIcon = new Capnp.Capability(new StaticAssetImpl(grainIcon.assetId), StaticAsset);              // 222
        } else {                                                                                                       // 224
          var hash = Identicon.hashAppIdForIdenticon(pkg.appId);                                                       // 225
          viewInfo.grainIcon = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);              // 226
        }                                                                                                              // 228
      }                                                                                                                // 229
                                                                                                                       //
      return viewInfo;                                                                                                 // 231
    });                                                                                                                // 232
  };                                                                                                                   // 233
                                                                                                                       //
  // All other UiView methods are currently unimplemented, which, while not strictly correct,                          //
  // results in the same overall behavior, since users can't call restore() on a PersistentUiView,                     //
  // and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                       //
                                                                                                                       //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(db, saveTemplate, grainId) {                                  // 240
  check(grainId, String);                                                                                              // 241
                                                                                                                       //
  // Verify that the grain exists and hasn't been trashed.                                                             //
  var grain = db.getGrain(grainId);                                                                                    // 244
  if (!grain || grain.trashed) {                                                                                       // 245
    throw new Meteor.Error(404, "grain not found");                                                                    // 246
  }                                                                                                                    // 247
                                                                                                                       //
  return new Capnp.Capability(new PersistentUiViewImpl(db, saveTemplate, grainId), PersistentUiView);                  // 249
};                                                                                                                     // 251
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 253
  frontendRefField: "notificationHandle",                                                                              // 254
                                                                                                                       //
  restore: function restore(db, saveTemplate, notificationId) {                                                        // 256
    return new Capnp.Capability(new NotificationHandle(db, saveTemplate, notificationId), PersistentHandle);           // 257
  }                                                                                                                    // 259
});                                                                                                                    // 253
                                                                                                                       //
function _dismissNotification(db, notificationId, callCancel) {                                                        // 262
  var notification = db.collections.notifications.findOne({ _id: notificationId });                                    // 263
  if (notification) {                                                                                                  // 264
    db.collections.notifications.remove({ _id: notificationId });                                                      // 265
    if (notification.ongoing) {                                                                                        // 266
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 269
                                                                                                                       //
      if (!callCancel) {                                                                                               // 271
        dropInternal(db, id, { frontend: null });                                                                      // 272
      } else {                                                                                                         // 273
        var notificationCap = restoreInternal(db, id, { frontend: null }, []).cap;                                     // 274
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 275
        dropInternal(db, id, { frontend: null });                                                                      // 276
        try {                                                                                                          // 277
          waitPromise(castedNotification.cancel());                                                                    // 278
          castedNotification.close();                                                                                  // 279
          notificationCap.close();                                                                                     // 280
        } catch (err) {                                                                                                // 281
          if (err.kjType !== "disconnected") {                                                                         // 282
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 285
          }                                                                                                            // 286
        }                                                                                                              // 287
      }                                                                                                                // 288
    } else if (notification.appUpdates) {                                                                              // 289
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 290
        db.deleteUnusedPackages(appId);                                                                                // 291
      });                                                                                                              // 292
    }                                                                                                                  // 293
  }                                                                                                                    // 294
}                                                                                                                      // 295
                                                                                                                       //
Meteor.methods({                                                                                                       // 297
  dismissNotification: function dismissNotification(notificationId) {                                                  // 298
    // This will remove notifications from the database and from view of the user.                                     //
    // For ongoing notifications, it will begin the process of cancelling and dropping them from                       //
    // the app.                                                                                                        //
                                                                                                                       //
    check(notificationId, String);                                                                                     // 303
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 305
                                                                                                                       //
    var notification = db.collections.notifications.findOne({ _id: notificationId });                                  // 307
    if (!notification) {                                                                                               // 308
      throw new Meteor.Error(404, "Notification id not found.");                                                       // 309
    } else if (notification.userId !== Meteor.userId()) {                                                              // 310
      throw new Meteor.Error(403, "Notification does not belong to current user.");                                    // 311
    } else {                                                                                                           // 312
      _dismissNotification(db, notificationId, true);                                                                  // 313
    }                                                                                                                  // 314
  },                                                                                                                   // 315
  readAllNotifications: function readAllNotifications() {                                                              // 317
    // Marks all notifications as read for the current user.                                                           //
    if (!Meteor.userId()) {                                                                                            // 319
      throw new Meteor.Error(403, "User not logged in.");                                                              // 320
    }                                                                                                                  // 321
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 323
    db.collections.notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });  // 324
  },                                                                                                                   // 328
  acceptPowerboxOffer: function acceptPowerboxOffer(sessionId, sturdyRef, sessionToken) {                              // 330
    var db = this.connection.sandstormDb;                                                                              // 331
    check(sessionId, String);                                                                                          // 332
    check(sturdyRef, String);                                                                                          // 333
    check(sessionToken, Match.OneOf(String, null, undefined));                                                         // 334
                                                                                                                       //
    var sessionQuery = { _id: sessionId };                                                                             // 336
    if (sessionToken) {                                                                                                // 337
      sessionQuery.hashedToken = hashSturdyRef(sessionToken);                                                          // 338
    } else {                                                                                                           // 339
      sessionQuery.userId = this.userId;                                                                               // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var session = db.collections.sessions.findOne(sessionQuery);                                                       // 343
    if (!session) {                                                                                                    // 344
      throw new Meteor.Error(404, "No matching session found.");                                                       // 345
    }                                                                                                                  // 346
                                                                                                                       //
    var tokenId = hashSturdyRef(sturdyRef);                                                                            // 348
    var apiToken = db.collections.apiTokens.findOne({                                                                  // 349
      _id: tokenId,                                                                                                    // 350
      "owner.clientPowerboxOffer.sessionId": sessionId                                                                 // 351
    });                                                                                                                // 349
                                                                                                                       //
    if (!apiToken) {                                                                                                   // 354
      throw new Meteor.Error(404, "No such token.");                                                                   // 355
    }                                                                                                                  // 356
                                                                                                                       //
    var newSturdyRef = void 0;                                                                                         // 358
    var hashedNewSturdyRef = void 0;                                                                                   // 359
    if (sessionToken && apiToken.parentToken) {                                                                        // 360
      // An anonymous user is being offered a child token. To avoid bloating the database,                             //
      // we deterministically derive the sturdyref from the session token and the hashed parent                        //
      // token.                                                                                                        //
      //                                                                                                               //
      // Note that an attacker with read access to the database might be able to derive                                //
      // `newSturdyRef` from `sessionToken` and gain access to the capability without ever having                      //
      // been explicitly offered it by the grain. Therefore, grains must assume that offering                          //
      // a capability to an anonymous user can possibly make that capability accessible to any                         //
      // other anonymous user who has connected through the same URL.                                                  //
                                                                                                                       //
      newSturdyRef = Crypto.createHash("sha256").update(sessionToken).update(apiToken.parentToken).digest("base64").slice(0, -1) // removing trailing "="
      .replace(/\+/g, "-").replace(/\//g, "_"); // make URL-safe                                                       // 371
                                                                                                                       //
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 378
      if (db.collections.apiTokens.findOne({ _id: hashedNewSturdyRef })) {                                             // 379
        // We have already generated this token.                                                                       //
        db.removeApiTokens({ _id: tokenId });                                                                          // 381
        return newSturdyRef;                                                                                           // 382
      }                                                                                                                // 383
    } else {                                                                                                           // 384
      newSturdyRef = generateSturdyRef();                                                                              // 385
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 386
    }                                                                                                                  // 387
                                                                                                                       //
    apiToken._id = hashedNewSturdyRef;                                                                                 // 389
    apiToken.owner = { webkey: null };                                                                                 // 390
                                                                                                                       //
    db.collections.apiTokens.insert(apiToken);                                                                         // 392
    db.removeApiTokens({ _id: tokenId });                                                                              // 393
    return newSturdyRef;                                                                                               // 394
  }                                                                                                                    // 395
});                                                                                                                    // 297
                                                                                                                       //
var makeSaveTemplateForChild = function makeSaveTemplateForChild(db, parentToken, requirements, parentTokenInfo) {     // 399
  // Constructs (part of) an ApiToken record appropriate to be used when save()ing a capability                        //
  // that was originally created by restore()ing `parentToken`. This fills in everything that is                       //
  // appropriate to fill in based only on the parent. Some fields -- especially `owner`, `created`,                    //
  // and `_id` -- obviously cannot be filled in until `save()` is called.                                              //
  //                                                                                                                   //
  // `parentToken` is the raw SturdyRef of the parent.                                                                 //
  //                                                                                                                   //
  // `requirements` is a list of MembraneRequirements that should be added to any children.                            //
  //                                                                                                                   //
  // `parentTokenInfo` is the ApiToken record for `parentToken`. Provide this only if you have                         //
  // it handy; if omitted it will be looked up.                                                                        //
                                                                                                                       //
  parentTokenInfo = parentTokenInfo || db.collections.apiTokens.findOne(hashSturdyRef(parentToken));                   // 412
  if (!parentTokenInfo) {                                                                                              // 413
    throw new Error("no such token");                                                                                  // 414
  }                                                                                                                    // 415
                                                                                                                       //
  var parentOwner = parentTokenInfo.owner || {};                                                                       // 417
                                                                                                                       //
  var saveTemplate = void 0;                                                                                           // 419
  if (parentOwner.clientPowerboxRequest || parentOwner.clientPowerboxOffer) {                                          // 420
    // Saving this token should make a copy of the restored token, rather than make a child                            //
    // token.                                                                                                          //
                                                                                                                       //
    saveTemplate = _.clone(parentTokenInfo);                                                                           // 424
                                                                                                                       //
    // Don't copy over fields that should be determined at save() time.                                                //
    delete saveTemplate._id;                                                                                           // 427
    delete saveTemplate.owner;                                                                                         // 428
    delete saveTemplate.created;                                                                                       // 429
  } else {                                                                                                             // 430
    if (parentTokenInfo.identityId) {                                                                                  // 431
      // A UiView token. Need to denormalize some fields from the parent.                                              //
      saveTemplate = _.pick(parentTokenInfo, "grainId", "identityId", "accountId");                                    // 433
                                                                                                                       //
      // By default, a save()d copy should have the same permissions, so set an allAccess role                         //
      // assignment.                                                                                                   //
      saveTemplate.roleAssignment = { allAccess: null };                                                               // 437
    } else {                                                                                                           // 438
      // A non-UiView child token.                                                                                     //
      saveTemplate = {};                                                                                               // 440
    }                                                                                                                  // 441
                                                                                                                       //
    // Saved token should be a child of the restored token.                                                            //
    saveTemplate.parentToken = parentTokenInfo._id;                                                                    // 444
  }                                                                                                                    // 445
                                                                                                                       //
  if (requirements) {                                                                                                  // 447
    // Append additional requirements requested by caller.                                                             //
    saveTemplate.requirements = (saveTemplate.requirements || []).concat(requirements);                                // 449
  }                                                                                                                    // 450
                                                                                                                       //
  return saveTemplate;                                                                                                 // 452
};                                                                                                                     // 453
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 455
  function restoreInternal(_x, _x2, _x3, _x4, _x5, _x6) {                                                              // 455
    return _restoreInternal.apply(this, arguments);                                                                    // 455
  }                                                                                                                    // 455
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 455
    return _restoreInternal.toString();                                                                                // 455
  };                                                                                                                   // 455
                                                                                                                       //
  return restoreInternal;                                                                                              // 455
}(function (db, originalToken, ownerPattern, requirements, originalTokenInfo, currentTokenId) {                        // 455
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `originalTokenInfo` is optional. If specified, it should be the ApiToken record associated                        //
  // with `originalToken`. Provide this if you happen to have looked it up already.                                    //
  //                                                                                                                   //
  // `currentTokenId` is only provided when this function calls itself recursively. It is the                          //
  // _id (hashed token) of an ancestor of originalToken. The function recurses until it gets to                        //
  // the top-level token.                                                                                              //
                                                                                                                       //
  requirements = requirements || [];                                                                                   // 472
                                                                                                                       //
  if (!originalTokenInfo) {                                                                                            // 474
    originalTokenInfo = db.collections.apiTokens.findOne(hashSturdyRef(originalToken));                                // 475
    if (!originalTokenInfo) {                                                                                          // 476
      throw new Meteor.Error(403, "No token found to restore");                                                        // 477
    }                                                                                                                  // 478
  }                                                                                                                    // 479
                                                                                                                       //
  var token = currentTokenId ? db.collections.apiTokens.findOne(currentTokenId) : originalTokenInfo;                   // 481
  if (!token) {                                                                                                        // 483
    if (!originalTokenInfo) {                                                                                          // 484
      throw new Meteor.Error(403, "Couldn't restore token because parent token has been deleted");                     // 485
    }                                                                                                                  // 486
  }                                                                                                                    // 487
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 489
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 490
  }                                                                                                                    // 491
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 494
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  checkRequirements(db, token.requirements);                                                                           // 497
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 500
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 501
  }                                                                                                                    // 502
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 504
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 505
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 506
    } else {                                                                                                           // 507
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      db.collections.apiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                 // 509
    }                                                                                                                  // 510
  }                                                                                                                    // 511
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 514
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(db, originalToken, Match.Any, requirements, originalTokenInfo, token.parentToken);          // 517
  }                                                                                                                    // 519
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  checkRequirements(db, requirements);                                                                                 // 522
                                                                                                                       //
  if (token.objectId) {                                                                                                // 524
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 528
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 529
    }                                                                                                                  // 530
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 533
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // don't generate a saveTemplate here.                                                                           //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 536
    }));                                                                                                               // 537
  } else {                                                                                                             // 538
    // Construct a template ApiToken for use if the restored capability is save()d later.                              //
    var saveTemplate = makeSaveTemplateForChild(db, originalToken, requirements, originalTokenInfo);                   // 540
                                                                                                                       //
    if (token.frontendRef) {                                                                                           // 542
      // A token which represents a capability implemented by a pseudo-driver.                                         //
                                                                                                                       //
      var cap = globalFrontendRefRegistry.restore(db, saveTemplate, token.frontendRef);                                // 545
      return { cap: cap };                                                                                             // 546
    } else if (token.grainId) {                                                                                        // 547
      // It's a UiView.                                                                                                //
                                                                                                                       //
      // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                          //
      // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                  //
      // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                     //
      // do some transformation), which will return a different capability.                                            //
      return { cap: makePersistentUiView(db, saveTemplate, token.grainId) };                                           // 554
    } else {                                                                                                           // 555
      throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                             // 556
    }                                                                                                                  // 557
  }                                                                                                                    // 558
});                                                                                                                    // 559
                                                                                                                       //
function dropInternal(db, sturdyRef, ownerPattern) {                                                                   // 561
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 564
  var token = db.collections.apiTokens.findOne({ _id: hashedSturdyRef });                                              // 565
  if (!token) {                                                                                                        // 566
    return;                                                                                                            // 567
  }                                                                                                                    // 568
                                                                                                                       //
  if (!Match.test(token.owner, ownerPattern)) {                                                                        // 570
    // The caller of `drop()` does not own the token. From the caller's perspective, this means                        //
    // that there is actually nothing to be dropped. For example, perhaps a grain got backed up                        //
    // and restored, and now is trying to drop one of its pre-backup tokens. The call to                               //
    // `SandstormApi.drop()` should succeed, behaving exactly as if the token was not found.                           //
    return;                                                                                                            // 575
  }                                                                                                                    // 576
                                                                                                                       //
  if (token.frontendRef && token.frontendRef.notificationHandle) {                                                     // 578
    var notificationId = token.frontendRef.notificationHandle;                                                         // 579
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 580
    var anyToken = db.collections.apiTokens.findOne({ "frontendRef.notificationHandle": notificationId });             // 581
    if (!anyToken) {                                                                                                   // 582
      // No other tokens referencing this notification exist, so dismiss the notification                              //
      _dismissNotification(db, notificationId);                                                                        // 584
    }                                                                                                                  // 585
  } else if (token.objectId) {                                                                                         // 586
    waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                          // 587
      return supervisor.drop(token.objectId);                                                                          // 588
    }));                                                                                                               // 589
                                                                                                                       //
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 591
  } else {                                                                                                             // 592
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 593
  }                                                                                                                    // 594
}                                                                                                                      // 595
                                                                                                                       //
var SandstormCoreFactoryImpl = function () {                                                                           //
  function SandstormCoreFactoryImpl(db) {                                                                              // 598
    _classCallCheck(this, SandstormCoreFactoryImpl);                                                                   // 598
                                                                                                                       //
    this.db = db;                                                                                                      // 599
  }                                                                                                                    // 600
                                                                                                                       //
  SandstormCoreFactoryImpl.prototype.getSandstormCore = function getSandstormCore(grainId) {                           //
    return { core: makeSandstormCore(this.db, grainId) };                                                              // 603
  };                                                                                                                   // 604
                                                                                                                       //
  return SandstormCoreFactoryImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory(db) {                                                     // 607
  return new Capnp.Capability(new SandstormCoreFactoryImpl(db), SandstormCoreFactory);                                 // 608
};                                                                                                                     // 609
                                                                                                                       //
unwrapFrontendCap = function unwrapFrontendCap(cap, type, callback) {                                                  // 611
  // Expect that `cap` is a Cap'n Proto capability implemented by the frontend as a frontendRef                        //
  // with the given type (the name of one of the fields of frontendRef). Unwraps the capability                        //
  // and then calls callback() with the `frontendRef[type]` descriptor object as                                       //
  // the paramater. The callback runs in a Meteor fiber, but this function can be called from                          //
  // anywhere. The function returns a Promise for the result of the callback.                                          //
  //                                                                                                                   //
  // (The reason for the callback, rather than just returning a Promise for the descriptor, is                         //
  // so that you don't have to do your own inMeteor() dance.)                                                          //
                                                                                                                       //
  // For now, we save() the capability and then dig through ApiTokens to find where it leads.                          //
  // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                         //
  //   not available in Javascript yet and even if it were, it wouldn't work in the case where                         //
  //   there are multiple front-end replicas, since the capability could be on a different                             //
  //   replica.                                                                                                        //
                                                                                                                       //
  return cap.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                            // 627
    return inMeteor(function () {                                                                                      // 628
      var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                               // 629
      var tokenInfo = ApiTokens.findOne(tokenId);                                                                      // 630
                                                                                                                       //
      // Delete the token now since it's not needed.                                                                   //
      ApiTokens.remove(tokenId);                                                                                       // 633
                                                                                                                       //
      for (;;) {                                                                                                       // 635
        if (!tokenInfo) throw new Error("missing token?");                                                             // 636
        if (!tokenInfo.parentToken) break;                                                                             // 637
        tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                          // 638
      }                                                                                                                // 639
                                                                                                                       //
      if (!tokenInfo.frontendRef || !tokenInfo.frontendRef[type]) {                                                    // 641
        throw new Error("not a " + type + " capability");                                                              // 642
      }                                                                                                                // 643
                                                                                                                       //
      return callback(tokenInfo.frontendRef[type]);                                                                    // 645
    });                                                                                                                // 646
  });                                                                                                                  // 647
};                                                                                                                     // 648
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":["/imports/server/async-helpers.js","/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 20
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 21
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 23
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 26
    (function () {                                                                                                     // 26
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 27
      if (expireIn < 0) {                                                                                              // 28
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 29
      }                                                                                                                // 30
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 32
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 35
      }                                                                                                                // 36
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 40
      var handle = Meteor.setTimeout(function () {                                                                     // 41
        connection.close();                                                                                            // 41
      }, expireIn);                                                                                                    // 41
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 43
        Meteor.clearTimeout(handle);                                                                                   // 43
      });                                                                                                              // 43
    })();                                                                                                              // 26
  }                                                                                                                    // 44
                                                                                                                       //
  return true;                                                                                                         // 46
});                                                                                                                    // 47
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 49
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 52
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
                                                                                                                       //
    globalDb.deleteGrains({ userId: user._id }, globalBackend, "demoGrain");                                           // 57
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 59
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 62
    UserActions.remove({ userId: user._id });                                                                          // 63
    Notifications.remove({ userId: user._id });                                                                        // 64
    Meteor.users.remove(user._id);                                                                                     // 65
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 66
    if (user.loginIdentities && user.lastActive) {                                                                     // 67
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 71
      var isAppDemoUser = !!user.appDemoId;                                                                            // 72
      if (isAppDemoUser) {                                                                                             // 73
        deleteStatsType = "appDemoUser";                                                                               // 74
      }                                                                                                                // 75
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 79
    }                                                                                                                  // 80
  });                                                                                                                  // 81
}                                                                                                                      // 82
                                                                                                                       //
if (allowDemo) {                                                                                                       // 84
  Meteor.methods({                                                                                                     // 85
    createDemoUser: function createDemoUser(displayName, appDemoId) {                                                  // 86
      // This is a login method that creates a new temporary user                                                      //
      // every time it is used.                                                                                        //
      //                                                                                                               //
      // appDemoId is important for stats; see cleanupExpiredUsers().                                                  //
      check(displayName, String);                                                                                      // 91
      check(appDemoId, Match.OneOf(undefined, null, String));                                                          // 92
                                                                                                                       //
      // Create the new user.                                                                                          //
      var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                            // 95
      if (appDemoId) {                                                                                                 // 96
        newUser.appDemoId = appDemoId;                                                                                 // 97
      }                                                                                                                // 98
                                                                                                                       //
      var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                                // 100
                                                                                                                       //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                            // 103
        return { userId: userId };                                                                                     // 104
      });                                                                                                              // 104
    },                                                                                                                 // 105
                                                                                                                       //
    testExpireDemo: function testExpireDemo() {                                                                        // 107
      if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                               // 108
                                                                                                                       //
      var newExpires = new Date(Date.now() + 15000);                                                                   // 110
      if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                    // 111
        throw new Meteor.Error(403, "can't exend demo");                                                               // 112
      }                                                                                                                // 113
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                             // 115
    }                                                                                                                  // 116
  });                                                                                                                  // 85
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to information about an app by                         //
  // appId. If this were available in non-demo mode, then anonymous users could effectively ask the                    //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appDemoInfo", function (appId) {                                                                     // 122
    // This publishes info about an app, including the latest version of it. Once you log in, it                       //
    // also publishes your list of UserActions.                                                                        //
    check(appId, String);                                                                                              // 125
                                                                                                                       //
    // Get data about this app from the app index. Note that the app index cache on this server                        //
    // is typically 6-24 hours delayed from reality, so if an app is newly-available                                   //
    // in the app market, it won't be in the app index. Therefore we don't bail-out if the app                         //
    // is missing from the AppIndex collection.                                                                        //
    var appIndexData = globalDb.collections.appIndex.findOne({ appId: appId });                                        // 131
                                                                                                                       //
    // Prepare a helper function we can use to transform a package cursor into an appropriate return                   //
    // value for this function.                                                                                        //
    var packageCursorAndMaybeUserActions = function packageCursorAndMaybeUserActions(userId, appId, packageCursor) {   // 135
      // This allows us to avoid creating duplicate UserActions.                                                       //
      if (userId) {                                                                                                    // 137
        return [packageCursor, UserActions.find({ userId: userId, appId: appId })];                                    // 138
      }                                                                                                                // 142
                                                                                                                       //
      return packageCursor;                                                                                            // 144
    };                                                                                                                 // 145
                                                                                                                       //
    // If the app is in the app index, and the current version is installed, always return that. If                    //
    // that package isn't installed, store the version number so we can filter on it later.                            //
    var packageQuery = {};                                                                                             // 149
    if (appIndexData) {                                                                                                // 150
      var appIndexPackageQuery = Packages.find({ _id: appIndexData.packageId });                                       // 151
      if (appIndexPackageQuery.count() > 0) {                                                                          // 152
        return packageCursorAndMaybeUserActions(this.userId, appId, appIndexPackageQuery);                             // 153
      }                                                                                                                // 154
                                                                                                                       //
      // If the app index version isn't present, insist on a lower version than the app index                          //
      // version. This avoids accidentally catching some development version of the app that has the                   //
      // same version number as the app market version but isn't the app market version.                               //
      packageQuery["manifest.appVersion"] = { $lt: appIndexData.versionNumber };                                       // 159
    }                                                                                                                  // 160
                                                                                                                       //
    // If the specific package from the app index isn't installed, or the app isn't there at all, do                   //
    // our best.                                                                                                       //
    packageQuery.appId = appId;                                                                                        // 164
    var packageCursor = Packages.find(packageQuery, { sort: { "manifest.appVersion": -1 },                             // 165
      limit: 1                                                                                                         // 168
    });                                                                                                                // 167
    return packageCursorAndMaybeUserActions(this.userId, appId, packageCursor);                                        // 170
  });                                                                                                                  // 171
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 173
} else {                                                                                                               // 174
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 176
}                                                                                                                      // 177
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications-server.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/desktop-notifications-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});// Sandstorm - Personal Cloud Sandbox       //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
SandstormDb.periodicCleanup(120000, function () {                                                                      // 19
  // Remove old desktop notfications regularly.                                                                        //
  // periodicCleanup doesn't like runs more frequent than once every two minutes                                       //
  var now = Date.now();                                                                                                // 22
  var then = new Date(now - 30000); // Clear tokens older than 30 seconds.                                             // 23
  globalDb.collections.desktopNotifications.find({                                                                     // 24
    creationDate: { $lt: then }                                                                                        // 25
  }).forEach(function (doc) {                                                                                          // 24
    globalDb.collections.desktopNotifications.remove({                                                                 // 27
      _id: doc._id                                                                                                     // 28
    });                                                                                                                // 27
  });                                                                                                                  // 30
});                                                                                                                    // 31
                                                                                                                       //
Meteor.publish("desktopNotifications", function () {                                                                   // 33
  var _this = this;                                                                                                    // 33
                                                                                                                       //
  var subscribeTime = new Date();                                                                                      // 34
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 36
    // No desktop notifications for anonymous users.                                                                   //
    return [];                                                                                                         // 38
  }                                                                                                                    // 39
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 41
  var callbacks = {                                                                                                    // 42
    added: function added(doc) {                                                                                       // 43
      _this.added("desktopNotifications", doc._id, doc);                                                               // 44
    },                                                                                                                 // 45
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 47
      _this.changed("desktopNotifications", newDoc._id, newDoc);                                                       // 48
    },                                                                                                                 // 49
                                                                                                                       //
    removed: function removed(doc) {                                                                                   // 51
      _this.removed("desktopNotifications", doc._id);                                                                  // 52
    }                                                                                                                  // 53
  };                                                                                                                   // 42
                                                                                                                       //
  var sub = db.collections.desktopNotifications.find({                                                                 // 56
    userId: this.userId,                                                                                               // 57
    creationDate: { $gt: subscribeTime }                                                                               // 58
  }).observe(callbacks);                                                                                               // 56
                                                                                                                       //
  this.onStop(function () {                                                                                            // 61
    if (sub) {                                                                                                         // 62
      sub.stop();                                                                                                      // 63
    }                                                                                                                  // 64
  });                                                                                                                  // 65
                                                                                                                       //
  this.ready();                                                                                                        // 67
});                                                                                                                    // 68
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                        // 20
    // This is a login method that creates or logs in a dev account with the given displayName                         //
                                                                                                                       //
    check(displayName, String);                                                                                        // 23
    check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                             // 24
    check(profile, Match.OneOf(undefined, null, Object));                                                              // 25
    check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                      // 26
                                                                                                                       //
    if (!this.connection.sandstormDb.allowDevAccounts()) {                                                             // 28
      throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                      // 29
    }                                                                                                                  // 30
                                                                                                                       //
    isAdmin = isAdmin || false;                                                                                        // 32
                                                                                                                       //
    profile = profile || {};                                                                                           // 34
    profile.name = profile.name || displayName;                                                                        // 35
    var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                               // 36
                                                                                                                       //
    var user = Meteor.users.findOne({ "services.dev.name": displayName });                                             // 38
    var userId = void 0;                                                                                               // 39
                                                                                                                       //
    if (user) {                                                                                                        // 41
      userId = user._id;                                                                                               // 42
    } else {                                                                                                           // 43
      userId = Accounts.insertUserDoc({                                                                                // 44
        profile: profile,                                                                                              // 45
        unverifiedEmail: unverifiedEmail                                                                               // 46
      }, {                                                                                                             // 44
        services: {                                                                                                    // 48
          dev: {                                                                                                       // 49
            name: displayName,                                                                                         // 50
            isAdmin: isAdmin,                                                                                          // 51
            hasCompletedSignup: hasCompletedSignup                                                                     // 52
          }                                                                                                            // 49
        }                                                                                                              // 48
      });                                                                                                              // 47
    }                                                                                                                  // 56
    // Log them in on this connection.                                                                                 //
    return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                             // 58
      return { userId: userId };                                                                                       // 59
    });                                                                                                                // 59
  }                                                                                                                    // 60
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":["babel-runtime/helpers/typeof","/imports/server/email.js","bignum","ed25519",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var send;module.import("/imports/server/email.js",{"send":function(v){send=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var ed25519;module.import("ed25519",{"default":function(v){ed25519=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 21
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 27
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 28
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 29
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 30
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 37
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 40
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 47
  var signedData = buf.slice(64);                                                                                      // 48
                                                                                                                       //
  if (!ed25519.Verify(signedData, signature, signingKey)) {                                                            // 50
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 51
    return undefined;                                                                                                  // 52
  } else {                                                                                                             // 53
    return signedData;                                                                                                 // 54
  }                                                                                                                    // 55
};                                                                                                                     // 56
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 59
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 63
  if (verifiedFeatureKeyBlob) {                                                                                        // 64
    var featureKey = Capnp.parse(FeatureKey, verifiedFeatureKeyBlob, { packed: true });                                // 65
    if (featureKey.isForTesting && !isTesting) {                                                                       // 66
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 69
    }                                                                                                                  // 70
                                                                                                                       //
    return featureKey;                                                                                                 // 72
  } else {                                                                                                             // 73
    return undefined;                                                                                                  // 74
  }                                                                                                                    // 75
};                                                                                                                     // 76
                                                                                                                       //
setNewFeatureKey = function setNewFeatureKey(db, textBlock) {                                                          // 78
  // Set a new feature key. If the new key is expired, check with Sandstorm to see if it was                           //
  // renewed, and use that copy instead.                                                                               //
  //                                                                                                                   //
  // This function under no circumstances stores an expired key to the database, because once                          //
  // a key is stored in the database it will be automatically renewed, and it would be surprising                      //
  // to users if accidentally uploading an old key suddenly caused that key to be renewed.                             //
                                                                                                                       //
  return setNewFeatureKeyInternal(db, textBlock, function (expiredKey) {                                               // 86
    // Key is expired. Try to fetch an updated copy.                                                                   //
                                                                                                                       //
    function throwExpired() {                                                                                          // 89
      throw new Meteor.Error(401, "Feature key is expired. Please purchase a new key.");                               // 90
    }                                                                                                                  // 91
                                                                                                                       //
    try {                                                                                                              // 93
      var newTextBlock = fetchUpdatedFeautureKeyFromVendor(expiredKey);                                                // 94
      return setNewFeatureKeyInternal(db, newTextBlock, throwExpired);                                                 // 95
    } catch (err) {                                                                                                    // 96
      console.error("couldn't fetch newer version of key", err);                                                       // 97
    }                                                                                                                  // 98
                                                                                                                       //
    // No luck.                                                                                                        //
    throwExpired();                                                                                                    // 101
  });                                                                                                                  // 102
};                                                                                                                     // 103
                                                                                                                       //
function setNewFeatureKeyInternal(db, textBlock, ifExpired) {                                                          // 105
  if (!textBlock) {                                                                                                    // 106
    // Delete the feature key.                                                                                         //
    db.collections.featureKey.remove("currentFeatureKey");                                                             // 108
    return;                                                                                                            // 109
  }                                                                                                                    // 110
                                                                                                                       //
  // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                        //
  var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                       // 113
    return line.length > 0 && line[0] !== "-";                                                                         // 114
  }).value().join("");                                                                                                 // 114
                                                                                                                       //
  var buf = new Buffer(featureKeyBase64, "base64");                                                                    // 118
  if (buf.length < 64) {                                                                                               // 119
    throw new Meteor.Error(401, "Invalid feature key");                                                                // 120
  }                                                                                                                    // 121
                                                                                                                       //
  var featureKey = loadSignedFeatureKey(buf);                                                                          // 123
  if (!featureKey) {                                                                                                   // 124
    throw new Meteor.Error(401, "Invalid feature key");                                                                // 125
  }                                                                                                                    // 126
                                                                                                                       //
  if (parseInt(featureKey.expires) * 1000 < Date.now()) {                                                              // 128
    return ifExpired(featureKey);                                                                                      // 129
  }                                                                                                                    // 130
                                                                                                                       //
  // Persist the feature key in the database.                                                                          //
  db.collections.featureKey.upsert("currentFeatureKey", {                                                              // 133
    _id: "currentFeatureKey",                                                                                          // 136
    value: buf                                                                                                         // 137
  });                                                                                                                  // 135
}                                                                                                                      // 140
                                                                                                                       //
// =======================================================================================                             //
// Renewal                                                                                                             //
                                                                                                                       //
var RENEW_API_HOST = "https://api.oasis.sandstorm.io";                                                                 // 145
var RENEW_API_TOKEN = "objFPmEL0gOGfwKYLIwHNmfdKp1FCgMNSrxW4lEeeLk";                                                   // 146
                                                                                                                       //
renewFeatureKey = function renewFeatureKey(db, options) {                                                              // 148
  // Attempts to renew the current feature key.                                                                        //
  //                                                                                                                   //
  // If any errors are detected, admins will be notified and the error information will be stored                      //
  // to the database for display on the feature key page.                                                              //
  //                                                                                                                   //
  // `options` is an object optionally containing:                                                                     //
  //   interactive: Set true if the function was called in response to an admin interactively                          //
  //     requesting the action. This suppresses sending notifications on error, as the admin                           //
  //     will see the error message on the feature key page.                                                           //
  //   dryRun: Go through as many of the motions of renewing as possible without actually renewing,                    //
  //     in order to detect and report if anything would go wrong, and also detect if a newer key                      //
  //     is already available. Useful to test for problems and warn the administrators in advance.                     //
                                                                                                                       //
  options = options || {};                                                                                             // 162
                                                                                                                       //
  var key = void 0;                                                                                                    // 164
  try {                                                                                                                // 165
    var _ret = function () {                                                                                           // 165
      key = db.currentFeatureKey();                                                                                    // 166
      if (!key) return {                                                                                               // 167
          v: void 0                                                                                                    // 167
        }; // nothing to do                                                                                            // 167
                                                                                                                       //
      // Count number of user accounts (not including visitors) active in the last month.                              //
      var count = 0;                                                                                                   // 170
      var oneMonthAgo = new Date(Date.now() - 30 * 86400000);                                                          // 171
      Meteor.users.find({ loginIdentities: { $exists: true }, lastActive: { $gt: oneMonthAgo } }).forEach(function (user) {
        if (db.isAccountSignedUp(user)) {                                                                              // 174
          ++count;                                                                                                     // 175
        }                                                                                                              // 176
      });                                                                                                              // 177
                                                                                                                       //
      console.log("Attempting to renew fetaure key. Active users:", count);                                            // 179
                                                                                                                       //
      // Request renewal.                                                                                              //
      var response = HTTP.post(RENEW_API_HOST + "/renew/" + key.secret.toString("hex"), {                              // 182
        headers: {                                                                                                     // 183
          "Authorization": "Bearer " + RENEW_API_TOKEN                                                                 // 184
        },                                                                                                             // 183
        data: {                                                                                                        // 186
          activeUsers: count,                                                                                          // 187
          dryRun: options.dryRun                                                                                       // 188
        }                                                                                                              // 186
      });                                                                                                              // 182
                                                                                                                       //
      var data = response.data;                                                                                        // 192
      if (data.noPaymentSource !== undefined) {                                                                        // 193
        reportRenewalProblem(db, key, options, { noPaymentSource: true });                                             // 194
      } else if (data.paymentFailed !== undefined) {                                                                   // 195
        reportRenewalProblem(db, key, options, { paymentFailed: data.paymentFailed });                                 // 196
      } else if (data.revoked !== undefined) {                                                                         // 197
        reportRenewalProblem(db, key, options, { revoked: true });                                                     // 198
      } else if (data.noSuchKey !== undefined) {                                                                       // 199
        reportRenewalProblem(db, key, options, { noSuchKey: true });                                                   // 200
      } else if (data.success !== undefined || data.tooEarly !== undefined || data.pendingPayment !== undefined) {     // 201
        // Either we successfully renewed the key, or the key had already been renewed out-of-band.                    //
        // Either way, the next step is to fetch it.                                                                   //
        //                                                                                                             //
        // If we're doing a dry run, then the key wasn't actually updated so there's nothing to                        //
        // fetch. However, if the server indicates that current key is newer than the one we have                      //
        // here, then we should take this chance to update to the current key.                                         //
        if (!options.dryRun || parseInt(data.expires) > parseInt(key.expries)) {                                       // 210
          var newTextBlock = fetchUpdatedFeautureKeyFromVendor(key);                                                   // 211
          setNewFeatureKeyInternal(db, newTextBlock, function () {                                                     // 212
            throw new Error("Renewal seemed to succeed but the service returned an expired key. " + "Is your system clock wrong?");
          });                                                                                                          // 215
        }                                                                                                              // 216
      } else {                                                                                                         // 217
        reportRenewalProblem(db, key, options, { unknownResponse: response.content });                                 // 218
      }                                                                                                                // 219
    }();                                                                                                               // 165
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 165
  } catch (err) {                                                                                                      // 220
    console.error("Exception when trying to renew feature key:", err.stack);                                           // 221
    reportRenewalProblem(db, key, options, { exception: err.message });                                                // 222
  }                                                                                                                    // 223
};                                                                                                                     // 224
                                                                                                                       //
function fetchUpdatedFeautureKeyFromVendor(key) {                                                                      // 226
  var fetchResponse = HTTP.get(RENEW_API_HOST + "/keys/" + key.secret.toString("hex"), {                               // 227
    headers: {                                                                                                         // 228
      "Authorization": "Bearer " + RENEW_API_TOKEN                                                                     // 229
    }                                                                                                                  // 228
  });                                                                                                                  // 227
  var result = fetchResponse.data.key;                                                                                 // 232
  if (!result) throw new Error("Renewal server returned invalid GetKeyResponse.");                                     // 233
  return result;                                                                                                       // 234
}                                                                                                                      // 235
                                                                                                                       //
function reportRenewalProblem(db, key, options, problem) {                                                             // 237
  db.collections.featureKey.update("currentFeatureKey", { $set: { renewalProblem: problem } });                        // 238
                                                                                                                       //
  if (!options.interactive) {                                                                                          // 240
    (function () {                                                                                                     // 240
      if (key.isTrial) {                                                                                               // 241
        db.sendAdminNotification("trialFeatureKeyExpired", "/admin/feature-key");                                      // 242
      } else {                                                                                                         // 243
        db.sendAdminNotification("cantRenewFeatureKey", "/admin/feature-key");                                         // 244
      }                                                                                                                // 245
                                                                                                                       //
      var emailOptions = {                                                                                             // 247
        from: db.getReturnAddress(),                                                                                   // 248
        subject: key.isTrial ? "URGENT: Sandstorm for Work trial for " + db.getServerTitle() + " has expired" : "URGENT: Couldn't renew Sandstorm for Work subscription for " + db.getServerTitle()
      };                                                                                                               // 247
                                                                                                                       //
      emailOptions.text = key.isTrial ? "This is an automated message from your Sandstorm server. Your trial of Sandstorm for Work has expired. To continue using Sandstorm for Work, update your subscription here:" : "This is an automated message from your Sansdtorm server. There was an error when trying to renew your Sandstorm for Work subscription. To resolve the issue, please go to:";
                                                                                                                       //
      emailOptions.text += "\n\n" + process.env.ROOT_URL + "/admin/feature-key";                                       // 258
                                                                                                                       //
      Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                                   // 262
        var email = _.findWhere(SandstormDb.getUserEmails(user), { primary: true });                                   // 263
        if (!email) {                                                                                                  // 264
          console.error("No email found for admin with userId:", user._id);                                            // 265
          return;                                                                                                      // 266
        }                                                                                                              // 267
                                                                                                                       //
        try {                                                                                                          // 269
          emailOptions.to = email.email;                                                                               // 270
          send(emailOptions);                                                                                          // 271
        } catch (err) {                                                                                                // 272
          console.error("Failed to send deletion email to admin (id=" + user._id + ") with error: " + err);            // 273
        }                                                                                                              // 275
      });                                                                                                              // 276
    })();                                                                                                              // 240
  }                                                                                                                    // 277
}                                                                                                                      // 278
                                                                                                                       //
var keyRenewalTimeout = null;                                                                                          // 280
var keyObserver = null;                                                                                                // 281
var currentlyRenewing = false;                                                                                         // 282
keepFeatureKeyRenewed = function keepFeatureKeyRenewed(db) {                                                           // 283
  // Whenever the feature key is expired, try to renew it.                                                             //
                                                                                                                       //
  if (keyObserver) keyObserver.stop();                                                                                 // 286
                                                                                                                       //
  keyObserver = db.observeFeatureKey(function (key) {                                                                  // 288
    if (keyRenewalTimeout) {                                                                                           // 289
      Meteor.clearTimeout(keyRenewalTimeout);                                                                          // 290
      keyRenewalTimeout = null;                                                                                        // 291
    }                                                                                                                  // 292
                                                                                                                       //
    if (!key) return;                                                                                                  // 294
                                                                                                                       //
    function scheduleRenewal() {                                                                                       // 296
      keyRenewalTimeout = null;                                                                                        // 297
                                                                                                                       //
      // Fucking Javascript setTimeout() treats any timeout longer than 2^31 as zero. Documented                       //
      // behavior. Same across all browsers. Node.js has its own custom setTimeout() implementation                    //
      // and still does it. WHHHHYYYYYYYYYYY?                                                                          //
      //                                                                                                               //
      // So instead we cap the delay and we re-check the time in the callback.                                         //
      var delay = Math.min(1e9, parseInt(key.expires) * 1000 - Date.now());                                            // 304
      if (delay > 0) {                                                                                                 // 305
        keyRenewalTimeout = Meteor.setTimeout(scheduleRenewal, delay);                                                 // 306
        return;                                                                                                        // 307
      }                                                                                                                // 308
                                                                                                                       //
      // OK, ready to renew now. Do it.                                                                                //
                                                                                                                       //
      // Careful that flapping doesn't cause us to make concurrent calls.                                              //
      if (!currentlyRenewing) {                                                                                        // 313
        currentlyRenewing = true;                                                                                      // 314
        try {                                                                                                          // 315
          renewFeatureKey(db);                                                                                         // 316
        } finally {                                                                                                    // 317
          currentlyRenewing = false;                                                                                   // 318
        }                                                                                                              // 319
      }                                                                                                                // 320
    }                                                                                                                  // 321
                                                                                                                       //
    scheduleRenewal();                                                                                                 // 323
  });                                                                                                                  // 324
};                                                                                                                     // 325
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"grain-server.js":["babel-runtime/helpers/typeof","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       // 18
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 20
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 22
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 27
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 29
  check(grainId, String);                                                                                              // 30
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 32
    _id: grainId,                                                                                                      // 34
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 35
  }, {                                                                                                                 // 33
    fields: {                                                                                                          // 40
      title: 1,                                                                                                        // 41
      userId: 1,                                                                                                       // 42
      identityId: 1,                                                                                                   // 43
      "private": 1                                                                                                     // 44
    }                                                                                                                  // 40
  })];                                                                                                                 // 39
  if (this.userId) {                                                                                                   // 48
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 49
    result.push(ApiTokens.find({                                                                                       // 50
      grainId: grainId,                                                                                                // 51
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 52
    }));                                                                                                               // 50
  }                                                                                                                    // 57
                                                                                                                       //
  return result;                                                                                                       // 59
});                                                                                                                    // 60
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 66
  check(grainId, String);                                                                                              // 67
  var publishThis = [];                                                                                                // 68
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 71
    _id: grainId,                                                                                                      // 72
    userId: this.userId                                                                                                // 73
  }, {                                                                                                                 // 71
    fields: { packageId: 1 }                                                                                           // 75
  });                                                                                                                  // 74
  publishThis.push(thisGrainCursor);                                                                                   // 77
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 79
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 80
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 81
    publishThis.push(thisPackageCursor);                                                                               // 82
  }                                                                                                                    // 83
                                                                                                                       //
  return publishThis;                                                                                                  // 85
});                                                                                                                    // 86
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 88
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 92
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 94
  var apiToken = ApiTokens.findOne({                                                                                   // 95
    _id: hashedToken                                                                                                   // 96
  }, {                                                                                                                 // 95
    fields: {                                                                                                          // 98
      grainId: 1,                                                                                                      // 99
      identityId: 1,                                                                                                   // 100
      owner: 1,                                                                                                        // 101
      revoked: 1                                                                                                       // 102
    }                                                                                                                  // 98
  });                                                                                                                  // 97
  if (!apiToken) {                                                                                                     // 105
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 106
  } else if (apiToken.revoked) {                                                                                       // 107
    this.added("tokenInfo", token, { revoked: true });                                                                 // 108
  } else {                                                                                                             // 109
    var grainId = apiToken.grainId;                                                                                    // 110
    var grain = Grains.findOne({                                                                                       // 111
      _id: grainId                                                                                                     // 112
    }, {                                                                                                               // 111
      fields: {                                                                                                        // 114
        packageId: 1,                                                                                                  // 115
        appId: 1,                                                                                                      // 116
        userId: 1                                                                                                      // 117
      }                                                                                                                // 114
    });                                                                                                                // 113
    if (!grain) {                                                                                                      // 120
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 121
    } else {                                                                                                           // 122
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 123
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 124
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 125
        if (identity && metadata) {                                                                                    // 126
          SandstormDb.fillInLoginId(identity);                                                                         // 127
          this.added("tokenInfo", token, {                                                                             // 128
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 129
            grainId: grainId,                                                                                          // 130
            grainMetadata: metadata                                                                                    // 131
          });                                                                                                          // 128
        } else {                                                                                                       // 133
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 134
        }                                                                                                              // 135
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 136
        if (this.userId) {                                                                                             // 137
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 138
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 139
          var childToken = ApiTokens.findOne({                                                                         // 140
            "owner.user.identityId": { $in: identityIds },                                                             // 141
            parentToken: apiToken._id                                                                                  // 142
          });                                                                                                          // 140
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 144
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 146
            this.ready();                                                                                              // 147
            return;                                                                                                    // 148
          }                                                                                                            // 149
        }                                                                                                              // 150
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 152
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 153
        var appIcon = undefined;                                                                                       // 154
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 155
          var icons = pkg.manifest.metadata.icons;                                                                     // 156
          appIcon = icons.grain || icons.appGrid;                                                                      // 157
        }                                                                                                              // 158
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 160
          appTitle: appTitle,                                                                                          // 161
          icon: appIcon,                                                                                               // 162
          appId: appIcon ? undefined : grain.appId                                                                     // 163
        };                                                                                                             // 160
        this.added("tokenInfo", token, {                                                                               // 165
          webkey: true,                                                                                                // 166
          grainId: grainId,                                                                                            // 167
          grainMetadata: denormalizedGrainMetadata                                                                     // 168
        });                                                                                                            // 165
      } else {                                                                                                         // 170
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 171
      }                                                                                                                // 172
    }                                                                                                                  // 173
  }                                                                                                                    // 174
                                                                                                                       //
  this.ready();                                                                                                        // 176
  return;                                                                                                              // 177
});                                                                                                                    // 178
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 180
  check(grainId, String);                                                                                              // 181
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 183
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 184
  }                                                                                                                    // 185
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 187
  if (!grain) {                                                                                                        // 188
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 189
  }                                                                                                                    // 190
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 192
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 193
  }                                                                                                                    // 195
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 197
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 198
                                                                                                                       //
  var _this = this;                                                                                                    // 201
  var query = ApiTokens.find({                                                                                         // 202
    grainId: grainId,                                                                                                  // 203
    identityId: { $in: ownerIdentityIds },                                                                             // 204
    parentToken: { $exists: false },                                                                                   // 205
    "owner.user.identityId": { $in: identityIds },                                                                     // 206
    revoked: { $ne: true }                                                                                             // 207
  });                                                                                                                  // 202
  var handle = query.observe({                                                                                         // 209
    added: function added(apiToken) {                                                                                  // 210
      _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
    }                                                                                                                  // 213
  });                                                                                                                  // 209
                                                                                                                       //
  this.onStop(function () {                                                                                            // 216
    return handle.stop();                                                                                              // 216
  });                                                                                                                  // 216
});                                                                                                                    // 217
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 219
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 220
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 221
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 222
  globalDb.deleteGrains({ trashed: { $lt: trashExpiration } }, globalBackend, "grain");                                // 223
});                                                                                                                    // 224
                                                                                                                       //
Meteor.methods({                                                                                                       // 226
  moveGrainsToTrash: function moveGrainsToTrash(grainIds) {                                                            // 227
    check(grainIds, [String]);                                                                                         // 228
                                                                                                                       //
    if (this.userId) {                                                                                                 // 230
      Grains.update({ userId: { $eq: this.userId },                                                                    // 231
        _id: { $in: grainIds },                                                                                        // 232
        trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                            // 233
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 237
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 239
        "owner.user.identityId": { $in: identityIds },                                                                 // 240
        trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                          // 241
    }                                                                                                                  // 244
  },                                                                                                                   // 245
                                                                                                                       //
  moveGrainsOutOfTrash: function moveGrainsOutOfTrash(grainIds) {                                                      // 247
    check(grainIds, [String]);                                                                                         // 248
                                                                                                                       //
    if (this.userId) {                                                                                                 // 250
      Grains.update({ userId: { $eq: this.userId },                                                                    // 251
        _id: { $in: grainIds },                                                                                        // 252
        trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                    // 253
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 257
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 259
        "owner.user.identityId": { $in: identityIds },                                                                 // 260
        "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                                // 261
    }                                                                                                                  // 264
  },                                                                                                                   // 265
                                                                                                                       //
  deleteGrain: function deleteGrain(grainId) {                                                                         // 267
    check(grainId, String);                                                                                            // 268
                                                                                                                       //
    if (this.userId) {                                                                                                 // 270
      var query = {                                                                                                    // 271
        _id: grainId,                                                                                                  // 272
        userId: this.userId,                                                                                           // 273
        trashed: { $exists: true }                                                                                     // 274
      };                                                                                                               // 271
      var numDeleted = globalDb.deleteGrains(query, globalBackend, isDemoUser() ? "demoGrain" : "grain");              // 276
                                                                                                                       //
      // Usually we don't automatically remove user-owned tokens that have become invalid,                             //
      // because if we did their owner might become confused as to why they have mysteriously                          //
      // disappeared. In this particular case, however, for tokens held by the grain owner,                            //
      // there should be no confusion. Indeed, it would be more confusing *not* to remove these                        //
      // tokens, because then the grain could still show up in the trash bin as a "shared with me"                     //
      // grain after the owner clicks "delete permanently".                                                            //
      //                                                                                                               //
      // Note that these tokens may be visible to other accounts if there are identities shared                        //
      // between the accounts; by only removing 'trashed' tokens, we minimize confusion in that                        //
      // case too.                                                                                                     //
      if (numDeleted > 0) {                                                                                            // 289
        globalDb.removeApiTokens({                                                                                     // 290
          grainId: grainId,                                                                                            // 291
          "owner.user.identityId": { $in: SandstormDb.getUserIdentityIds(Meteor.user()) },                             // 292
          "trashed": { $exists: true }                                                                                 // 293
        });                                                                                                            // 290
      }                                                                                                                // 295
    }                                                                                                                  // 296
  },                                                                                                                   // 297
                                                                                                                       //
  forgetGrain: function forgetGrain(grainId, identityId) {                                                             // 299
    check(grainId, String);                                                                                            // 300
    check(identityId, String);                                                                                         // 301
                                                                                                                       //
    if (!this.userId) {                                                                                                // 303
      throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                             // 304
    }                                                                                                                  // 305
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 307
      throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                            // 308
    }                                                                                                                  // 309
                                                                                                                       //
    globalDb.removeApiTokens({ grainId: grainId,                                                                       // 311
      "owner.user.identityId": identityId,                                                                             // 312
      "trashed": { $exists: true }                                                                                     // 313
    });                                                                                                                // 311
  },                                                                                                                   // 315
                                                                                                                       //
  updateGrainPreferredIdentity: function updateGrainPreferredIdentity(grainId, identityId) {                           // 317
    check(grainId, String);                                                                                            // 318
    check(identityId, String);                                                                                         // 319
    if (!this.userId) {                                                                                                // 320
      throw new Meteor.Error(403, "Must be logged in.");                                                               // 321
    }                                                                                                                  // 322
                                                                                                                       //
    var grain = globalDb.getGrain(grainId) || {};                                                                      // 324
    if (!grain.userId === this.userId) {                                                                               // 325
      throw new Meteor.Error(403, "Grain not owned by current user.");                                                 // 326
    }                                                                                                                  // 327
                                                                                                                       //
    Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                             // 329
  },                                                                                                                   // 330
                                                                                                                       //
  updateGrainTitle: function updateGrainTitle(grainId, newTitle, identityId) {                                         // 332
    check(grainId, String);                                                                                            // 333
    check(newTitle, String);                                                                                           // 334
    check(identityId, String);                                                                                         // 335
    if (this.userId) {                                                                                                 // 336
      var grain = Grains.findOne(grainId);                                                                             // 337
      if (grain) {                                                                                                     // 338
        if (grain.userId === this.userId) {                                                                            // 339
          Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                         // 340
                                                                                                                       //
          // Denormalize new title out to all sharing tokens.                                                          //
          ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
        } else {                                                                                                       // 346
          if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                    // 347
            throw new Meteor.Error(403, "Current user does not have identity " + identityId);                          // 348
          }                                                                                                            // 349
                                                                                                                       //
          var token = ApiTokens.findOne({                                                                              // 351
            grainId: grainId,                                                                                          // 352
            objectId: { $exists: false },                                                                              // 353
            "owner.user.identityId": identityId                                                                        // 354
          }, {                                                                                                         // 351
            sort: { created: 1 } });                                                                                   // 356
          // The oldest token is our source of truth for the name.                                                     //
          if (token && token.owner.user.title !== newTitle) {                                                          // 358
            if (token.owner.user.upstreamTitle === newTitle) {                                                         // 359
              // User renamed grain to match upstream title. Act like they never renamed it at                         //
              // all.                                                                                                  //
              ApiTokens.update({                                                                                       // 362
                grainId: grainId,                                                                                      // 363
                "owner.user.identityId": identityId                                                                    // 364
              }, {                                                                                                     // 362
                $set: { "owner.user.title": newTitle },                                                                // 366
                $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                     // 367
              }, {                                                                                                     // 365
                multi: true                                                                                            // 369
              });                                                                                                      // 368
            } else {                                                                                                   // 371
              var modification = {                                                                                     // 372
                "owner.user.title": newTitle,                                                                          // 373
                "owner.user.renamed": true                                                                             // 374
              };                                                                                                       // 372
                                                                                                                       //
              if (!token.owner.user.upstreamTitle) {                                                                   // 377
                // If `upstreamTitle` isn't present then it is equal to the old title.                                 //
                modification["owner.user.upstreamTitle"] = token.owner.user.title;                                     // 379
              }                                                                                                        // 380
                                                                                                                       //
              ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
            }                                                                                                          // 385
          }                                                                                                            // 386
        }                                                                                                              // 387
      }                                                                                                                // 388
    }                                                                                                                  // 389
  },                                                                                                                   // 390
                                                                                                                       //
  privatizeGrain: function privatizeGrain(grainId) {                                                                   // 392
    check(grainId, String);                                                                                            // 393
    if (this.userId) {                                                                                                 // 394
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                             // 395
    }                                                                                                                  // 396
  },                                                                                                                   // 397
                                                                                                                       //
  inviteUsersToGrain: function inviteUsersToGrain(_origin, identityId, grainId, title, roleAssignment, contacts, message) {
    var _this2 = this;                                                                                                 // 400
                                                                                                                       //
    if (!this.isSimulation) {                                                                                          // 401
      var _ret = function () {                                                                                         // 401
        check(_origin, String);                                                                                        // 402
        check(identityId, String);                                                                                     // 403
        check(grainId, String);                                                                                        // 404
        check(title, String);                                                                                          // 405
        check(roleAssignment, roleAssignmentPattern);                                                                  // 406
        check(contacts, [{                                                                                             // 407
          _id: String,                                                                                                 // 409
          isDefault: Match.Optional(Boolean),                                                                          // 410
          profile: Match.ObjectIncluding({                                                                             // 411
            service: String,                                                                                           // 412
            name: String,                                                                                              // 413
            intrinsicName: String                                                                                      // 414
          })                                                                                                           // 411
        }]);                                                                                                           // 408
        check(message, { text: String, html: String });                                                                // 418
        if (!_this2.userId) {                                                                                          // 419
          throw new Meteor.Error(403, "Must be logged in to share by email.");                                         // 420
        }                                                                                                              // 421
                                                                                                                       //
        if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                    // 423
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 424
        }                                                                                                              // 425
                                                                                                                       //
        if (contacts.length === 0) {                                                                                   // 427
          throw new Meteor.Error(400, "No contacts were provided.");                                                   // 428
        }                                                                                                              // 429
                                                                                                                       //
        if (globalDb.isDemoUser()) {                                                                                   // 431
          throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                                // 432
        }                                                                                                              // 433
                                                                                                                       //
        var accountId = _this2.userId;                                                                                 // 435
        var outerResult = { successes: [], failures: [] };                                                             // 436
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 437
        var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                                 // 438
        contacts.forEach(function (contact) {                                                                          // 439
          if (contact.isDefault && contact.profile.service === "email") {                                              // 440
            var emailAddress = contact.profile.intrinsicName;                                                          // 441
            var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
            var url = ROOT_URL + "/shared/" + result.token;                                                            // 446
            var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
            try {                                                                                                      // 452
              globalDb.incrementDailySentMailCount(accountId);                                                         // 453
              sendEmail({                                                                                              // 454
                to: emailAddress,                                                                                      // 455
                from: fromEmail,                                                                                       // 456
                replyTo: replyTo,                                                                                      // 457
                subject: title + " - Invitation to collaborate",                                                       // 458
                text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                html: html                                                                                             // 462
              });                                                                                                      // 454
            } catch (e) {                                                                                              // 464
              outerResult.failures.push({ contact: contact, error: e.toString() });                                    // 465
            }                                                                                                          // 466
          } else {                                                                                                     // 467
            var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
            var _url = ROOT_URL + "/shared/" + _result.token;                                                          // 472
            try {                                                                                                      // 473
              var identity = Meteor.users.findOne({ _id: contact._id });                                               // 474
              var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                     // 475
              if (email) {                                                                                             // 477
                var intrinsicName = contact.profile.intrinsicName;                                                     // 478
                var loginNote = void 0;                                                                                // 479
                if (contact.profile.service === "google") {                                                            // 480
                  loginNote = "Google account with address " + email.email;                                            // 481
                } else if (contact.profile.service === "github") {                                                     // 482
                  loginNote = "Github account with username " + intrinsicName;                                         // 483
                } else if (contact.profile.service === "email") {                                                      // 484
                  loginNote = "email address " + intrinsicName;                                                        // 485
                } else if (contact.profile.service === "ldap") {                                                       // 486
                  loginNote = "LDAP username " + intrinsicName;                                                        // 487
                } else if (contact.profile.service === "saml") {                                                       // 488
                  loginNote = "SAML ID " + intrinsicName;                                                              // 489
                } else {                                                                                               // 490
                  throw new Meteor.Error(500, "Unknown service to email share link.");                                 // 491
                }                                                                                                      // 492
                                                                                                                       //
                var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                globalDb.incrementDailySentMailCount(accountId);                                                       // 499
                sendEmail({                                                                                            // 500
                  to: email.email,                                                                                     // 501
                  from: fromEmail,                                                                                     // 502
                  replyTo: replyTo,                                                                                    // 503
                  subject: title + " - Invitation to collaborate",                                                     // 504
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                  html: _html                                                                                          // 508
                });                                                                                                    // 500
              } else {                                                                                                 // 510
                outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 514
            } catch (e) {                                                                                              // 515
              outerResult.failures.push({ contact: contact, error: e.toString(),                                       // 516
                warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
            }                                                                                                          // 519
          }                                                                                                            // 520
        });                                                                                                            // 521
                                                                                                                       //
        return {                                                                                                       // 523
          v: outerResult                                                                                               // 523
        };                                                                                                             // 523
      }();                                                                                                             // 401
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 401
    }                                                                                                                  // 524
  },                                                                                                                   // 525
                                                                                                                       //
  requestAccess: function requestAccess(_origin, grainId, identityId) {                                                // 527
    check(_origin, String);                                                                                            // 528
    check(grainId, String);                                                                                            // 529
    check(identityId, String);                                                                                         // 530
    if (!this.isSimulation) {                                                                                          // 531
      if (!this.userId) {                                                                                              // 532
        throw new Meteor.Error(403, "Must be logged in to request access.");                                           // 533
      }                                                                                                                // 534
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 536
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 537
      }                                                                                                                // 538
                                                                                                                       //
      var grain = Grains.findOne(grainId);                                                                             // 540
      if (!grain) {                                                                                                    // 541
        throw new Meteor.Error(404, "No such grain");                                                                  // 542
      }                                                                                                                // 543
                                                                                                                       //
      var grainOwner = globalDb.getUser(grain.userId);                                                                 // 545
      var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                               // 546
      if (!email) {                                                                                                    // 547
        throw new Meteor.Error("no email", "Grain owner has no email address.");                                       // 548
      }                                                                                                                // 549
                                                                                                                       //
      var emailAddress = email.email;                                                                                  // 551
                                                                                                                       //
      var identity = globalDb.getIdentity(identityId);                                                                 // 553
      globalDb.addContact(grainOwner._id, identityId);                                                                 // 554
                                                                                                                       //
      var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                            // 556
      var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                             // 557
                                                                                                                       //
      // TODO(soon): In the HTML version, we should display an identity card.                                          //
      var identityNote = "";                                                                                           // 560
      if (identity.profile.service === "google") {                                                                     // 561
        identityNote = " (" + identity.privateIntrinsicName + ")";                                                     // 562
      } else if (identity.profile.service === "github") {                                                              // 563
        identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                          // 564
      } else if (identity.profile.service === "email") {                                                               // 565
        identityNote = " (" + identity.profile.intrinsicName + ")";                                                    // 566
      } else if (identity.profile.service === "ldap") {                                                                // 567
        identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                            // 568
      } else if (identity.profile.service === "saml") {                                                                // 569
        identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                            // 570
      }                                                                                                                // 571
                                                                                                                       //
      var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
      var url = ROOT_URL + "/share/" + grainId + "/" + identityId;                                                     // 576
                                                                                                                       //
      var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                            // 578
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 581
      var ACCESS_REQUEST_LIMIT = 10;                                                                                   // 582
      var resetCount = true;                                                                                           // 583
      if (user.accessRequests) {                                                                                       // 584
        if (user.accessRequests.resetOn < new Date()) {                                                                // 585
          Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                   // 586
        } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                                // 587
          throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
        } else {                                                                                                       // 591
          resetCount = false;                                                                                          // 592
        }                                                                                                              // 593
      }                                                                                                                // 594
                                                                                                                       //
      var modifier = { $inc: { "accessRequests.count": 1 } };                                                          // 596
      if (resetCount) {                                                                                                // 597
        var tomorrow = new Date(Date.now() + 86400000);                                                                // 598
        modifier.$set = { "accessRequests.resetOn": tomorrow };                                                        // 599
      }                                                                                                                // 600
                                                                                                                       //
      Meteor.users.update({ _id: user._id }, modifier);                                                                // 602
                                                                                                                       //
      sendEmail({                                                                                                      // 604
        to: emailAddress,                                                                                              // 605
        from: fromEmail,                                                                                               // 606
        replyTo: replyTo,                                                                                              // 607
        subject: grain.title + " - Request for access",                                                                // 608
        text: message + "\n\nFollow this link to share access:\n\n" + url,                                             // 609
        html: html                                                                                                     // 610
      });                                                                                                              // 604
    }                                                                                                                  // 612
  }                                                                                                                    // 613
});                                                                                                                    // 226
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var hashSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"hashSturdyRef":function(v){hashSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 34
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 36
HOSTNAME = ROOT_URL.hostname;                                                                                          // 37
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 39
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 40
    _classCallCheck(this, SessionContextImpl);                                                                         // 40
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 41
    this.sessionId = sessionId;                                                                                        // 42
    this.identityId = identityId;                                                                                      // 43
    this.tabId = tabId;                                                                                                // 44
  }                                                                                                                    // 45
                                                                                                                       //
  SessionContextImpl.prototype.claimRequest = function claimRequest(sturdyRef, requiredPermissions) {                  // 39
    var _this2 = this;                                                                                                 // 47
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 48
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 49
                                                                                                                       //
      var token = ApiTokens.findOne({                                                                                  // 51
        _id: hashedSturdyRef,                                                                                          // 52
        "owner.clientPowerboxRequest.grainId": _this2.grainId,                                                         // 53
        "owner.clientPowerboxRequest.sessionId": _this2.sessionId                                                      // 54
      });                                                                                                              // 51
                                                                                                                       //
      if (!token) {                                                                                                    // 57
        throw new Error("no such token");                                                                              // 58
      }                                                                                                                // 59
                                                                                                                       //
      // Honor `requiredPermissions`.                                                                                  //
      var requirements = [];                                                                                           // 62
      if (token.owner.clientPowerboxRequest.introducerIdentity) {                                                      // 63
        requirements.push({                                                                                            // 64
          permissionsHeld: {                                                                                           // 65
            permissions: requiredPermissions || [],                                                                    // 66
            identityId: token.owner.clientPowerboxRequest.introducerIdentity,                                          // 67
            grainId: _this2.grainId                                                                                    // 68
          }                                                                                                            // 65
        });                                                                                                            // 64
      }                                                                                                                // 71
                                                                                                                       //
      return restoreInternal(globalDb, new Buffer(sturdyRef), { clientPowerboxRequest: Match.ObjectIncluding({ grainId: _this2.grainId }) }, requirements, token);
    });                                                                                                                // 78
  };                                                                                                                   // 79
                                                                                                                       //
  SessionContextImpl.prototype.offer = function offer(cap, requiredPermissions, descriptor, displayInfo) {             // 39
    var _this3 = this;                                                                                                 // 81
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 82
                                                                                                                       //
      var session = Sessions.findOne({ _id: _this3.sessionId });                                                       // 84
                                                                                                                       //
      if (!session.identityId && !session.hashedToken) {                                                               // 86
        throw new Error("Session has neither an identityId nor a hashedToken.");                                       // 87
      }                                                                                                                // 88
                                                                                                                       //
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 90
      var apiTokenOwner = { clientPowerboxOffer: { sessionId: _this3.sessionId } };                                    // 91
      var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
      if (isUiView) {                                                                                                  // 95
        var tagValue = {};                                                                                             // 96
        if (descriptor.tags[0].value) {                                                                                // 97
          tagValue = Capnp.parse(Grain.UiView.PowerboxTag, descriptor.tags[0].value);                                  // 98
        }                                                                                                              // 99
                                                                                                                       //
        if (!tagValue.title) {                                                                                         // 101
          // TODO(someday): We should arguably throw here, but the collections app currently                           //
          //   fails to provide a title.                                                                               //
          tagValue.title = "offer()ed grain had no title";                                                             // 104
        }                                                                                                              // 105
                                                                                                                       //
        if (session.identityId) {                                                                                      // 107
          apiTokenOwner = {                                                                                            // 108
            user: {                                                                                                    // 109
              identityId: _this3.identityId,                                                                           // 110
              title: tagValue.title                                                                                    // 111
            }                                                                                                          // 109
          };                                                                                                           // 108
        }                                                                                                              // 114
      }                                                                                                                // 115
                                                                                                                       //
      // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                          //
      // are fully implemented for supervisors.                                                                        //
      var permissionsHeld = {                                                                                          // 119
        grainId: _this3.grainId,                                                                                       // 120
        permissions: requiredPermissions                                                                               // 121
      };                                                                                                               // 119
                                                                                                                       //
      if (session.identityId) {                                                                                        // 124
        permissionsHeld.identityId = session.identityId;                                                               // 125
      } else if (session.hashedToken) {                                                                                // 126
        permissionsHeld.tokenId = session.hashedToken;                                                                 // 127
      } else {                                                                                                         // 128
        throw new Error("Cannot offer to anonymous session that does not have a token.");                              // 129
      }                                                                                                                // 130
                                                                                                                       //
      var requirement = { permissionsHeld: permissionsHeld };                                                          // 132
                                                                                                                       //
      checkRequirements(globalDb, [requirement]);                                                                      // 134
                                                                                                                       //
      var save = castedCap.save(apiTokenOwner);                                                                        // 136
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 137
      ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                   // 138
                                                                                                                       //
      var powerboxView = void 0;                                                                                       // 140
      if (isUiView) {                                                                                                  // 141
        if (session.identityId) {                                                                                      // 142
          // Deduplicate.                                                                                              //
          var tokenId = hashSturdyRef(sturdyRef.toString());                                                           // 144
          var newApiToken = ApiTokens.findOne({ _id: tokenId });                                                       // 145
          var dupeQuery = _.pick(newApiToken, "grainId", "roleAssignment", "requirements", "parentToken", "identityId", "accountId");
          dupeQuery._id = { $ne: newApiToken._id };                                                                    // 148
          dupeQuery["owner.user.identityId"] = _this3.identityId;                                                      // 149
          dupeQuery.trashed = { $exists: false };                                                                      // 150
          dupeQuery.revoked = { $exists: false };                                                                      // 151
                                                                                                                       //
          var dupeToken = ApiTokens.findOne(dupeQuery);                                                                // 153
          if (dupeToken) {                                                                                             // 154
            globalDb.removeApiTokens({ _id: tokenId });                                                                // 155
            tokenId = dupeToken._id;                                                                                   // 156
          }                                                                                                            // 157
                                                                                                                       //
          powerboxView = { offer: { uiView: { tokenId: tokenId } } };                                                  // 159
        } else {                                                                                                       // 160
          powerboxView = { offer: { uiView: { token: sturdyRef.toString() } } };                                       // 161
        }                                                                                                              // 162
      } else {                                                                                                         // 163
        powerboxView = {                                                                                               // 164
          offer: {                                                                                                     // 165
            token: sturdyRef.toString()                                                                                // 166
          }                                                                                                            // 165
        };                                                                                                             // 164
      }                                                                                                                // 169
                                                                                                                       //
      Sessions.update({ _id: _this3.sessionId }, {                                                                     // 171
        $set: {                                                                                                        // 173
          powerboxView: powerboxView                                                                                   // 174
        }                                                                                                              // 173
      });                                                                                                              // 172
    });                                                                                                                // 178
  };                                                                                                                   // 179
                                                                                                                       //
  SessionContextImpl.prototype.activity = function activity(event) {                                                   // 39
    var _this4 = this;                                                                                                 // 181
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 182
      logActivity(_this4.grainId, _this4.identityId, event);                                                           // 183
    });                                                                                                                // 184
  };                                                                                                                   // 185
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 39
}();                                                                                                                   // 39
                                                                                                                       //
Meteor.methods({                                                                                                       // 188
  finishPowerboxRequest: function finishPowerboxRequest(sessionId, webkeyUrl, saveLabel, identityId, grainId) {        // 189
    check(sessionId, String);                                                                                          // 190
    check(webkeyUrl, String);                                                                                          // 191
    check(saveLabel, Match.OneOf(undefined, null, String));                                                            // 192
    check(identityId, String);                                                                                         // 193
    check(grainId, String);                                                                                            // 194
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 196
                                                                                                                       //
    var userId = Meteor.userId();                                                                                      // 198
    if (!userId || !db.userHasIdentity(userId, identityId)) {                                                          // 199
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 200
    }                                                                                                                  // 201
                                                                                                                       //
    var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                    // 203
    var hostId = matchWildcardHost(parsedWebkey.host);                                                                 // 204
    if (!hostId || !db.isApiHostId(hostId)) {                                                                          // 205
      throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
    }                                                                                                                  // 208
                                                                                                                       //
    var token = parsedWebkey.hash;                                                                                     // 210
    if (!token) {                                                                                                      // 211
      throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
    }                                                                                                                  // 214
                                                                                                                       //
    token = token.slice(1);                                                                                            // 216
    if (db.isTokenSpecificHostId(hostId) && hostId !== db.apiHostIdForToken(token)) {                                  // 217
      // Note: This case is not security-sensitive. The client could easily compute the correct                        //
      //   host ID for this token. But since they've passed one that doesn't match, we assume                          //
      //   something is wrong and stop here.                                                                           //
      throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                    // 221
    }                                                                                                                  // 222
                                                                                                                       //
    var cap = restoreInternal(db, new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;   // 224
    var castedCap = cap.castAs(SystemPersistent);                                                                      // 226
    var owner = {                                                                                                      // 227
      clientPowerboxRequest: {                                                                                         // 228
        grainId: grainId,                                                                                              // 229
        introducerIdentity: identityId,                                                                                // 230
        sessionId: sessionId                                                                                           // 231
      }                                                                                                                // 228
    };                                                                                                                 // 227
    if (saveLabel) {                                                                                                   // 234
      grainOwner.saveLabel = {                                                                                         // 235
        defaultText: saveLabel                                                                                         // 236
      };                                                                                                               // 235
    }                                                                                                                  // 238
                                                                                                                       //
    var save = castedCap.save(owner);                                                                                  // 240
    var sturdyRef = waitPromise(save).sturdyRef;                                                                       // 241
    return sturdyRef.toString();                                                                                       // 242
  },                                                                                                                   // 243
  finishPowerboxOffer: function finishPowerboxOffer(sessionId) {                                                       // 245
    check(sessionId, String);                                                                                          // 246
                                                                                                                       //
    Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                           // 248
  },                                                                                                                   // 249
  getViewInfoForApiToken: function getViewInfoForApiToken(apiTokenId) {                                                // 251
    check(apiTokenId, String);                                                                                         // 252
    var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                    // 253
    if (!token) {                                                                                                      // 254
      throw new Meteor.Error(400, "No such token.");                                                                   // 255
    }                                                                                                                  // 256
                                                                                                                       //
    var grain = globalDb.collections.grains.findOne(token.grainId);                                                    // 258
    if (!grain) {                                                                                                      // 259
      throw new Meteor.Error(500, "No grain found for token.");                                                        // 260
    }                                                                                                                  // 261
                                                                                                                       //
    return grain.cachedViewInfo;                                                                                       // 263
  }                                                                                                                    // 264
});                                                                                                                    // 188
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 267
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 267
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 268
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 268
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 268
  }                                                                                                                    // 270
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function _getPublicId() {                                            // 267
    // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                      //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    while (!this.publicId) {                                                                                           // 277
      // We haven't looked up the public ID yet.                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                           // 279
      if (!grain) throw new Error("Grain does not exist.");                                                            // 280
                                                                                                                       //
      if (grain.publicId) {                                                                                            // 282
        this.publicId = grain.publicId;                                                                                // 283
      } else {                                                                                                         // 284
        // The grain doesn't have a public ID yet. Generate one.                                                       //
        var candidate = generateRandomHostname(20);                                                                    // 286
                                                                                                                       //
        if (Grains.findOne({ publicId: candidate })) {                                                                 // 288
          // This should never ever happen.                                                                            //
          console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");     // 290
          continue;                                                                                                    // 292
        }                                                                                                              // 293
                                                                                                                       //
        // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                    //
        // simultaneously.                                                                                             //
        if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
          // We won the race.                                                                                          //
          this.publicId = candidate;                                                                                   // 300
        }                                                                                                              // 301
      }                                                                                                                // 302
    }                                                                                                                  // 303
                                                                                                                       //
    return this.publicId;                                                                                              // 305
  };                                                                                                                   // 306
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function _getAddress() {                                              // 267
    // Get the grain's outgoing e-mail address.                                                                        //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    return this._getPublicId() + "@" + HOSTNAME;                                                                       // 313
  };                                                                                                                   // 314
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function _getUserAddress() {                                      // 267
    // Get the user's e-mail address.                                                                                  //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                           // 321
                                                                                                                       //
    var identity = globalDb.getIdentity(grain.identityId);                                                             // 323
                                                                                                                       //
    var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                        // 325
    var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                        // 326
                                                                                                                       //
    var result = {};                                                                                                   // 328
    if (email) {                                                                                                       // 329
      result.address = email;                                                                                          // 330
    }                                                                                                                  // 331
                                                                                                                       //
    if (identity.profile.name) {                                                                                       // 333
      result.name = identity.profile.name;                                                                             // 334
    }                                                                                                                  // 335
                                                                                                                       //
    return result;                                                                                                     // 337
  };                                                                                                                   // 338
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function send(email) {                                                       // 267
    return hackSendEmail(this, email);                                                                                 // 341
  };                                                                                                                   // 342
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function getPublicId() {                                              // 267
    return inMeteor(function () {                                                                                      // 345
      var result = {};                                                                                                 // 346
                                                                                                                       //
      result.publicId = this._getPublicId();                                                                           // 348
      result.hostname = HOSTNAME;                                                                                      // 349
      result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                   // 350
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                             // 352
      result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                   // 353
                                                                                                                       //
      return result;                                                                                                   // 355
    }.bind(this));                                                                                                     // 356
  };                                                                                                                   // 357
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function httpGet(url) {                                                   // 267
    var _this = this;                                                                                                  // 360
    var session = _this;                                                                                               // 361
                                                                                                                       //
    return new Promise(function (resolve, reject) {                                                                    // 363
      var requestMethod = Http.request;                                                                                // 364
      if (url.indexOf("https://") === 0) {                                                                             // 365
        requestMethod = Https.request;                                                                                 // 366
      } else if (url.indexOf("http://") !== 0) {                                                                       // 367
        err = new Error("Protocol not recognized.");                                                                   // 368
        err.nature = "precondition";                                                                                   // 369
        reject(err);                                                                                                   // 370
      }                                                                                                                // 371
                                                                                                                       //
      req = requestMethod(url, function (resp) {                                                                       // 373
        var buffers = [];                                                                                              // 374
        var err = void 0;                                                                                              // 375
                                                                                                                       //
        switch (Math.floor(resp.statusCode / 100)) {                                                                   // 377
          case 2:                                                                                                      // 378
            // 2xx response -- OK.                                                                                     //
            resp.on("data", function (buf) {                                                                           // 379
              buffers.push(buf);                                                                                       // 380
            });                                                                                                        // 381
                                                                                                                       //
            resp.on("end", function () {                                                                               // 383
              resolve({                                                                                                // 384
                content: Buffer.concat(buffers),                                                                       // 385
                mimeType: resp.headers["content-type"] || null                                                         // 386
              });                                                                                                      // 384
            });                                                                                                        // 388
            break;                                                                                                     // 389
          case 3:                                                                                                      // 390
            // 3xx response -- redirect.                                                                               //
            resolve(session.httpGet(resp.headers.location));                                                           // 391
            break;                                                                                                     // 392
          case 4:                                                                                                      // 393
            // 4xx response -- client error.                                                                           //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 394
            err.nature = "precondition";                                                                               // 395
            reject(err);                                                                                               // 396
            break;                                                                                                     // 397
          case 5:                                                                                                      // 398
            // 5xx response -- internal server error.                                                                  //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 399
            err.nature = "localBug";                                                                                   // 400
            reject(err);                                                                                               // 401
            break;                                                                                                     // 402
          default:                                                                                                     // 403
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 404
            err.nature = "localBug";                                                                                   // 405
            reject(err);                                                                                               // 406
            break;                                                                                                     // 407
        }                                                                                                              // 377
      });                                                                                                              // 409
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 411
        e.nature = "networkFailure";                                                                                   // 412
        reject(e);                                                                                                     // 413
      });                                                                                                              // 414
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 416
        req.abort();                                                                                                   // 417
        err = new Error("Request timed out.");                                                                         // 418
        err.nature = "localBug";                                                                                       // 419
        err.durability = "overloaded";                                                                                 // 420
        reject(err);                                                                                                   // 421
      });                                                                                                              // 422
                                                                                                                       //
      req.end();                                                                                                       // 424
    });                                                                                                                // 425
  };                                                                                                                   // 426
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function getUserAddress() {                                        // 267
    return inMeteor(function () {                                                                                      // 429
      return this._getUserAddress();                                                                                   // 430
    }.bind(this));                                                                                                     // 431
  };                                                                                                                   // 432
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function obsoleteGenerateApiToken(petname, userInfo, expires) {
    throw new Error("generateApiToken() has been removed. Use offer templates instead.");                              // 435
  };                                                                                                                   // 436
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function obsoleteListApiTokens() {                          // 267
    throw new Error("listApiTokens() has been removed. Use offer templates instead.");                                 // 439
  };                                                                                                                   // 440
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function obsoleteRevokeApiToken(tokenId) {                 // 267
    throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                                // 443
  };                                                                                                                   // 444
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function getUiViewForEndpoint(url) {                         // 267
    var parsedUrl = Url.parse(url);                                                                                    // 447
                                                                                                                       //
    if (parsedUrl.hash) {                                                                                              // 449
      // Assume that anything with a fragment is a webkey                                                              //
      if (parsedUrl.pathname) {                                                                                        // 450
        throw new Error("Webkey urls cannot contain a path.");                                                         // 451
      }                                                                                                                // 452
                                                                                                                       //
      var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                         // 454
      var hostId = matchWildcardHost(parsedUrl.host);                                                                  // 455
      // Connecting to a remote server with a bearer token.                                                            //
      // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                             //
      return { view: new ExternalUiView(url, this.grainId, token) };                                                   // 458
    } else {                                                                                                           // 459
      return { view: new ExternalUiView(url, this.grainId) };                                                          // 460
    }                                                                                                                  // 461
  };                                                                                                                   // 462
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 267
}(SessionContextImpl);                                                                                                 // 267
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 465
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 466
};                                                                                                                     // 468
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 470
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 472
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 475
  for (var i = 0; i < length; i++) {                                                                                   // 476
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 477
  }                                                                                                                    // 478
                                                                                                                       //
  return digits.join("");                                                                                              // 480
};                                                                                                                     // 481
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"identity.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js","/imports/server/static-asset.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/identity.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var StaticAssetImpl,IdenticonStaticAssetImpl;module.import("/imports/server/static-asset.js",{"StaticAssetImpl":function(v){StaticAssetImpl=v},"IdenticonStaticAssetImpl":function(v){IdenticonStaticAssetImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var IdentityRpc = Capnp.importSystem("sandstorm/identity-impl.capnp");                                                 // 18
                                                                                                                       // 19
                                                                                                                       // 20
var StaticAsset = Capnp.importSystem("sandstorm/util.capnp").StaticAsset;                                              // 21
                                                                                                                       //
var IdentityImpl = function (_PersistentImpl) {                                                                        //
  _inherits(IdentityImpl, _PersistentImpl);                                                                            //
                                                                                                                       //
  function IdentityImpl(db, saveTemplate, identityId) {                                                                // 24
    _classCallCheck(this, IdentityImpl);                                                                               // 24
                                                                                                                       //
    var _this = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                        // 24
                                                                                                                       //
    _this.identityId = identityId;                                                                                     // 26
    _this.db = db;                                                                                                     // 27
    return _this;                                                                                                      // 24
  }                                                                                                                    // 28
                                                                                                                       //
  IdentityImpl.prototype.getProfile = function getProfile() {                                                          //
    var identity = this.db.getIdentity(this.identityId);                                                               // 31
                                                                                                                       //
    var profile = {                                                                                                    // 33
      displayName: { defaultText: identity.profile.name },                                                             // 34
      preferredHandle: identity.profile.handle,                                                                        // 35
      pronouns: identity.profile.pronoun                                                                               // 36
    };                                                                                                                 // 33
                                                                                                                       //
    if (identity.profile.picture) {                                                                                    // 39
      profile.picture = new Capnp.Capability(new StaticAssetImpl(identity.profile.picture), StaticAsset);              // 40
    } else {                                                                                                           // 42
      var hash = this.identityId.slice(0, 32);                                                                         // 43
      profile.picture = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);                     // 44
    }                                                                                                                  // 46
                                                                                                                       //
    return { profile: profile };                                                                                       // 48
  };                                                                                                                   // 49
                                                                                                                       //
  return IdentityImpl;                                                                                                 //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 50
                                                                                                                       //
makeIdentity = function makeIdentity(identityId, requriements) {                                                       // 52
  var saveTemplate = { frontendRef: { identity: identityId } };                                                        // 53
  return new Capnp.Capability(new IdentityImpl(globalDb, saveTemplate, identityId), IdentityRpc.PersistentIdentity);   // 54
};                                                                                                                     // 56
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 58
  frontendRefField: "identity",                                                                                        // 59
                                                                                                                       //
  restore: function restore(db, saveTemplate, identityId) {                                                            // 61
    return new Capnp.Capability(new IdentityImpl(db, saveTemplate, identityId), IdentityRpc.PersistentIdentity);       // 62
  }                                                                                                                    // 64
});                                                                                                                    // 58
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":["/imports/demo.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});var promiseToFuture;module.import("/imports/server/async-helpers.js",{"promiseToFuture":function(v){promiseToFuture=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 20
  defaultText: String,                                                                                                 // 21
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 22
};                                                                                                                     // 20
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 25
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 30
  cancelDownload: function (_cancelDownload) {                                                                         // 31
    function cancelDownload(_x) {                                                                                      // 31
      return _cancelDownload.apply(this, arguments);                                                                   // 31
    }                                                                                                                  // 31
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 31
      return _cancelDownload.toString();                                                                               // 31
    };                                                                                                                 // 31
                                                                                                                       //
    return cancelDownload;                                                                                             // 31
  }(function (packageId) {                                                                                             // 31
    check(packageId, String);                                                                                          // 32
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 35
  }),                                                                                                                  // 36
                                                                                                                       //
  newUploadToken: function newUploadToken() {                                                                          // 38
    if (!isSignedUp()) {                                                                                               // 39
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                              // 40
    }                                                                                                                  // 41
                                                                                                                       //
    if (globalDb.isUninvitedFreeUser()) {                                                                              // 43
      throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                                 // 44
    }                                                                                                                  // 45
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 47
    uploadTokens[token] = setTimeout(function () {                                                                     // 48
      delete uploadTokens[token];                                                                                      // 49
    }, 20 * 60 * 1000);                                                                                                // 50
                                                                                                                       //
    return token;                                                                                                      // 52
  },                                                                                                                   // 53
                                                                                                                       //
  upgradeGrains: function upgradeGrains(appId, version, packageId) {                                                   // 55
    this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                               // 56
  },                                                                                                                   // 57
                                                                                                                       //
  ensureInstalled: function ensureInstalled(packageId, url, isRetry) {                                                 // 59
    check(packageId, String);                                                                                          // 60
    check(url, Match.OneOf(String, undefined, null));                                                                  // 61
    check(isRetry, Boolean);                                                                                           // 62
                                                                                                                       //
    if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                          // 64
      throw new Meteor.Error(400, "The package ID contains illegal characters.");                                      // 65
    }                                                                                                                  // 66
                                                                                                                       //
    if (!this.userId) {                                                                                                // 68
      if (allowDemo && isSafeDemoAppUrl(url)) {                                                                        // 69
        // continue on                                                                                                 //
      } else {                                                                                                         // 71
          // jscs:ignore disallowEmptyBlocks                                                                           //
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 72
        }                                                                                                              // 73
    } else if (!isSignedUp() && !isDemoUser()) {                                                                       // 74
      throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");      // 75
    } else if (isUserOverQuota(Meteor.user())) {                                                                       // 77
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 78
    }                                                                                                                  // 80
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 82
                                                                                                                       //
    if (!pkg || pkg.status !== "ready") {                                                                              // 84
      if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                            // 85
        if (!isSafeDemoAppUrl(url)) {                                                                                  // 86
          // TODO(someday): Billing prompt on client side.                                                             //
          throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
        }                                                                                                              // 90
      }                                                                                                                // 91
    }                                                                                                                  // 92
                                                                                                                       //
    if (!pkg || isRetry) {                                                                                             // 94
      globalDb.startInstall(packageId, url, isRetry);                                                                  // 95
    }                                                                                                                  // 96
  }                                                                                                                    // 97
});                                                                                                                    // 30
                                                                                                                       //
Meteor.publish("packageInfo", function (packageId) {                                                                   // 100
  check(packageId, String);                                                                                            // 101
  var db = this.connection.sandstormDb;                                                                                // 102
  var pkgCursor = db.collections.packages.find(packageId);                                                             // 103
  var pkg = pkgCursor.fetch()[0];                                                                                      // 104
  if (pkg && this.userId) {                                                                                            // 105
    return [pkgCursor, db.collections.userActions.find({ userId: this.userId, appId: pkg.appId }), db.collections.grains.find({ userId: this.userId, appId: pkg.appId })];
  } else {                                                                                                             // 111
    return pkgCursor;                                                                                                  // 112
  }                                                                                                                    // 113
});                                                                                                                    // 114
                                                                                                                       //
Router.map(function () {                                                                                               // 116
  this.route("upload", {                                                                                               // 117
    where: "server",                                                                                                   // 118
    path: "/upload/:token",                                                                                            // 119
                                                                                                                       //
    action: function action() {                                                                                        // 121
      if (!this.params.token || !uploadTokens[this.params.token]) {                                                    // 122
        this.response.writeHead(403, {                                                                                 // 123
          "Content-Type": "text/plain"                                                                                 // 124
        });                                                                                                            // 123
        this.response.write("Invalid upload token.");                                                                  // 126
        this.response.end();                                                                                           // 127
      } else if (this.request.method === "POST") {                                                                     // 128
        try {                                                                                                          // 129
          var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                        // 130
          this.response.writeHead(200, {                                                                               // 131
            "Content-Length": packageId.length,                                                                        // 132
            "Content-Type": "text/plain"                                                                               // 133
          });                                                                                                          // 131
          this.response.write(packageId);                                                                              // 135
          this.response.end();                                                                                         // 136
          clearTimeout(uploadTokens[this.params.token]);                                                               // 137
          delete uploadTokens[this.params.token];                                                                      // 138
        } catch (error) {                                                                                              // 139
          console.error(error.stack);                                                                                  // 140
          this.response.writeHead(500, {                                                                               // 141
            "Content-Type": "text/plain"                                                                               // 142
          });                                                                                                          // 141
          this.response.write("Unpacking SPK failed; is it valid?");                                                   // 144
          this.response.end();                                                                                         // 145
        };                                                                                                             // 146
      } else {                                                                                                         // 147
        this.response.writeHead(405, {                                                                                 // 148
          "Content-Type": "text/plain"                                                                                 // 149
        });                                                                                                            // 148
        this.response.write("You can only POST here.");                                                                // 151
        this.response.end();                                                                                           // 152
      }                                                                                                                // 153
    }                                                                                                                  // 154
  });                                                                                                                  // 117
});                                                                                                                    // 156
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 28
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 30
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 32
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 39
  if (Meteor.settings.replicaNumber) {                                                                                 // 40
    throw new Error("This can only be called on the main front-end replica.");                                         // 41
  }                                                                                                                    // 42
};                                                                                                                     // 43
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 45
  verifyIsMainReplica();                                                                                               // 46
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 48
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 50
    return;                                                                                                            // 51
  }                                                                                                                    // 52
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 54
                                                                                                                       //
  try {                                                                                                                // 56
    var action = UserActions.findOne({ packageId: packageId });                                                        // 57
    var grain = Grains.findOne({ packageId: packageId });                                                              // 58
    var notificationQuery = {};                                                                                        // 59
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 60
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery)) && !globalDb.getAppIdForPreinstalledPackage(packageId)) {
      Packages.update({                                                                                                // 63
        _id: packageId                                                                                                 // 64
      }, {                                                                                                             // 63
        $set: { status: "delete" },                                                                                    // 66
        $unset: { shouldCleanup: "" }                                                                                  // 67
      });                                                                                                              // 65
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 69
      Packages.remove(packageId);                                                                                      // 70
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 73
        globalDb.unrefStaticAsset(assetId);                                                                            // 74
      });                                                                                                              // 75
    } else {                                                                                                           // 76
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 77
    }                                                                                                                  // 78
                                                                                                                       //
    delete installers[packageId];                                                                                      // 80
  } catch (error) {                                                                                                    // 81
    delete installers[packageId];                                                                                      // 82
    throw error;                                                                                                       // 83
  }                                                                                                                    // 84
};                                                                                                                     // 85
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 87
  verifyIsMainReplica();                                                                                               // 88
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 90
    return;                                                                                                            // 91
  }                                                                                                                    // 92
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 94
  installers[pkg._id] = installer;                                                                                     // 95
  installer.start();                                                                                                   // 96
};                                                                                                                     // 97
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 99
  Packages.remove({ _id: packageId, status: "download" });                                                             // 100
};                                                                                                                     // 101
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 103
  verifyIsMainReplica();                                                                                               // 104
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 106
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 109
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 111
      throw new Error("Canceled");                                                                                     // 112
    })();                                                                                                              // 113
  }                                                                                                                    // 114
};                                                                                                                     // 115
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 117
  installers = {};                                                                                                     // 118
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 120
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 122
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 125
      added: startInstallInternal,                                                                                     // 126
      removed: cancelDownloadInternal                                                                                  // 127
    });                                                                                                                // 125
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 131
      added: deletePackageInternal                                                                                     // 132
    });                                                                                                                // 131
  });                                                                                                                  // 134
}                                                                                                                      // 135
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 137
  return new Promise(function (resolve, reject) {                                                                      // 138
    var id = Random.id();                                                                                              // 139
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 141
    var hasher = Crypto.createHash("sha256");                                                                          // 142
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 144
      try {                                                                                                            // 145
        hasher.update(chunk);                                                                                          // 146
        backendStream.write(chunk);                                                                                    // 147
      } catch (err) {                                                                                                  // 148
        reject(err);                                                                                                   // 149
      }                                                                                                                // 150
    });                                                                                                                // 151
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 153
      try {                                                                                                            // 154
        (function () {                                                                                                 // 154
          backendStream.done();                                                                                        // 155
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 156
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 157
            return packageId;                                                                                          // 158
          }));                                                                                                         // 159
          backendStream.close();                                                                                       // 160
        })();                                                                                                          // 154
      } catch (err) {                                                                                                  // 161
        reject(err);                                                                                                   // 162
      }                                                                                                                // 163
    });                                                                                                                // 164
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 166
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 168
        backendStream.close();                                                                                         // 169
        reject(err);                                                                                                   // 170
      } catch (err2) {                                                                                                 // 171
        reject(err2);                                                                                                  // 172
      }                                                                                                                // 173
    });                                                                                                                // 174
  });                                                                                                                  // 175
};                                                                                                                     // 176
                                                                                                                       //
AppInstaller = function () {                                                                                           // 178
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 179
    _classCallCheck(this, AppInstaller);                                                                               // 179
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 180
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 182
    this.url = url;                                                                                                    // 183
    this.failed = false;                                                                                               // 184
    this.appId = appId;                                                                                                // 185
    this.isAutoUpdated = isAutoUpdated;                                                                                // 186
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 189
  }                                                                                                                    // 190
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function updateProgress(status, progress, error, manifest) {                 // 178
    // TODO(security):  On error, we should actually delete the package from the database and only                     //
    //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                       //
    //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                          //
    //   already-downloading package but specifies a different URL, we really should initiate an                       //
    //   entirely separate download...  but cancel it if the first download succeeds.)                                 //
                                                                                                                       //
    this.status = status;                                                                                              // 199
    this.progress = progress || -1;                                                                                    // 200
    this.error = error;                                                                                                // 201
    this.manifest = manifest || null;                                                                                  // 202
                                                                                                                       //
    var _this = this;                                                                                                  // 204
                                                                                                                       //
    // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                     //
    // occur in exactly the order in which we generate them, so we use a promise chain to serialize                    //
    // them.                                                                                                           //
    this.writeChain = this.writeChain.then(function () {                                                               // 209
      return inMeteor(function () {                                                                                    // 210
        if (manifest) extractManifestAssets(manifest);                                                                 // 211
                                                                                                                       //
        Packages.update(_this.packageId, {                                                                             // 213
          $set: {                                                                                                      // 214
            status: _this.status,                                                                                      // 215
            progress: _this.progress,                                                                                  // 216
            error: _this.error ? _this.error.message : null,                                                           // 217
            manifest: _this.manifest,                                                                                  // 218
            appId: _this.appId,                                                                                        // 219
            authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                     // 220
          }                                                                                                            // 214
        });                                                                                                            // 213
                                                                                                                       //
        if (_this.authorPgpKeyFingerprint) {                                                                           // 224
          globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                           // 225
        }                                                                                                              // 226
      })["catch"](function (err) {                                                                                     // 227
        console.error(err.stack);                                                                                      // 228
      });                                                                                                              // 229
    });                                                                                                                // 230
  };                                                                                                                   // 231
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function wrapCallback(method) {                                                // 178
    // Note that the function below must not be an arrow function, since arrow functions do not have                   //
    // access to the context's arguments array.                                                                        //
    var _this = this;                                                                                                  // 236
    return function () {                                                                                               // 237
      if (_this.failed) return;                                                                                        // 238
      try {                                                                                                            // 239
        return method.apply(_this, _.toArray(arguments));                                                              // 240
      } catch (err) {                                                                                                  // 241
        _this.failed = true;                                                                                           // 242
        _this.cleanup();                                                                                               // 243
        _this.updateProgress("failed", 0, err);                                                                        // 244
        _this.writeChain = _this.writeChain.then(function () {                                                         // 245
          delete installers[_this.packageId];                                                                          // 246
        });                                                                                                            // 247
        console.error("Failed to install app:", err.stack);                                                            // 248
      }                                                                                                                // 249
    };                                                                                                                 // 250
  };                                                                                                                   // 251
                                                                                                                       //
  AppInstaller.prototype.cleanup = function cleanup() {                                                                // 178
    if (this.uploadStream) {                                                                                           // 254
      try {                                                                                                            // 255
        this.uploadStream.close();                                                                                     // 256
      } catch (err) {}                                                                                                 // 257
                                                                                                                       //
      delete this.uploadStream;                                                                                        // 259
    }                                                                                                                  // 260
                                                                                                                       //
    if (this.downloadRequest) {                                                                                        // 262
      try {                                                                                                            // 263
        this.downloadRequest.abort();                                                                                  // 264
      } catch (err) {}                                                                                                 // 265
                                                                                                                       //
      delete this.downloadRequest;                                                                                     // 267
    }                                                                                                                  // 268
  };                                                                                                                   // 269
                                                                                                                       //
  AppInstaller.prototype.start = function start() {                                                                    // 178
    var _this2 = this;                                                                                                 // 271
                                                                                                                       //
    return this.wrapCallback(function () {                                                                             // 272
      _this2.cleanup();                                                                                                // 273
                                                                                                                       //
      globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                   // 275
        if (info.appId) {                                                                                              // 276
          _this2.appId = info.appId;                                                                                   // 277
          _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 278
          _this2.done(info.manifest);                                                                                  // 279
        } else {                                                                                                       // 280
          _this2.doDownload();                                                                                         // 281
        }                                                                                                              // 282
      }), _this2.wrapCallback(function (err) {                                                                         // 283
        throw err;                                                                                                     // 284
      }));                                                                                                             // 285
    })();                                                                                                              // 286
  };                                                                                                                   // 287
                                                                                                                       //
  AppInstaller.prototype.doDownload = function doDownload() {                                                          // 178
    if (!this.url) {                                                                                                   // 290
      throw new Error("Unknown package ID, and no URL was provided.");                                                 // 291
    }                                                                                                                  // 292
                                                                                                                       //
    console.log("Downloading app:", this.url);                                                                         // 294
    this.updateProgress("download");                                                                                   // 295
                                                                                                                       //
    this.uploadStream = globalBackend.cap().installPackage().stream;                                                   // 297
    return this.doDownloadTo(this.uploadStream);                                                                       // 298
  };                                                                                                                   // 299
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function doDownloadTo(out) {                                                   // 178
    var _this3 = this;                                                                                                 // 301
                                                                                                                       //
    var url = Url.parse(this.url);                                                                                     // 302
    var options = {                                                                                                    // 303
      hostname: url.hostname,                                                                                          // 304
      port: url.port,                                                                                                  // 305
      path: url.path                                                                                                   // 306
    };                                                                                                                 // 303
                                                                                                                       //
    var protocol = void 0;                                                                                             // 309
    if (url.protocol === "http:" || url.protocol === "https:") {                                                       // 310
      protocol = Request.defaults({                                                                                    // 311
        maxRedirects: 20,                                                                                              // 312
        // Since we will verify the download against a hash anyway, we don't need to verify the                        //
        // server's certificate. In fact, the only reason we support HTTPS at all here is because                      //
        // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                   //
        // certificate check here is helpful in that it means we don't have to worry about having a                    //
        // reasonable list of trusted CAs available to Sandstorm.                                                      //
        strictSSL: false                                                                                               // 318
      });                                                                                                              // 311
    } else {                                                                                                           // 320
      throw new Error("Protocol not supported: " + url.protocol);                                                      // 321
    }                                                                                                                  // 322
                                                                                                                       //
    // TODO(security):  It could arguably be a security problem that it's possible to probe the                        //
    //   server's local network (behind any firewalls) by presenting URLs here.                                        //
    var bytesExpected = undefined;                                                                                     // 326
    var bytesReceived = 0;                                                                                             // 327
    var hasher = Crypto.createHash("sha256");                                                                          // 328
    var done = false;                                                                                                  // 329
    var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                            // 330
      if (!done) {                                                                                                     // 331
        if (bytesExpected) {                                                                                           // 332
          _this3.updateProgress("download", bytesReceived / bytesExpected);                                            // 333
        } else {                                                                                                       // 334
          _this3.updateProgress("download", bytesReceived);                                                            // 335
        }                                                                                                              // 336
      }                                                                                                                // 337
    }), 500);                                                                                                          // 338
                                                                                                                       //
    var request = protocol.get(this.url);                                                                              // 340
                                                                                                                       //
    request.on("response", this.wrapCallback(function (response) {                                                     // 342
      if ("content-length" in response.headers) {                                                                      // 343
        bytesExpected = parseInt(response.headers["content-length"]);                                                  // 344
      }                                                                                                                // 345
    }));                                                                                                               // 346
                                                                                                                       //
    request.on("data", this.wrapCallback(function (chunk) {                                                            // 348
      hasher.update(chunk);                                                                                            // 349
      out.write(chunk);                                                                                                // 350
      bytesReceived += chunk.length;                                                                                   // 351
      updateDownloadProgress();                                                                                        // 352
    }));                                                                                                               // 353
                                                                                                                       //
    request.on("end", this.wrapCallback(function () {                                                                  // 355
      out.done();                                                                                                      // 356
                                                                                                                       //
      if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                    // 358
        throw new Error("Package hash did not match.");                                                                // 359
      }                                                                                                                // 360
                                                                                                                       //
      done = true;                                                                                                     // 362
      delete _this3.downloadRequest;                                                                                   // 363
                                                                                                                       //
      _this3.updateProgress("unpack");                                                                                 // 365
      out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                          // 366
        _this3.appId = info.appId;                                                                                     // 367
        _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                                 // 368
        _this3.done(info.manifest);                                                                                    // 369
      }), _this3.wrapCallback(function (err) {                                                                         // 370
        throw err;                                                                                                     // 371
      }));                                                                                                             // 372
    }));                                                                                                               // 373
                                                                                                                       //
    request.on("error", this.wrapCallback(function (err) {                                                             // 375
      throw err;                                                                                                       // 375
    }));                                                                                                               // 375
                                                                                                                       //
    this.downloadRequest = request;                                                                                    // 377
  };                                                                                                                   // 378
                                                                                                                       //
  AppInstaller.prototype.done = function done(manifest) {                                                              // 178
    console.log("App ready:", this.packageId);                                                                         // 381
    this.updateProgress("ready", 1, undefined, manifest);                                                              // 382
    var _this = this;                                                                                                  // 383
    _this.writeChain = _this.writeChain.then(function () {                                                             // 384
      return inMeteor(function () {                                                                                    // 385
        if (_this.isAutoUpdated) {                                                                                     // 386
          globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
        }                                                                                                              // 390
                                                                                                                       //
        if (globalDb.getPackageIdForPreinstalledApp(_this.appId) && globalDb.collections.appIndex.findOne({            // 392
          _id: _this.appId,                                                                                            // 394
          packageId: _this.packageId                                                                                   // 395
        })) {                                                                                                          // 393
          // Only mark app as preinstall ready if its appId is in the preinstalledApps setting                         //
          // and if it's the latest package version in the appIndex. The updateAppIndex function                       //
          // will always trigger updates of preinstalled apps, even if a concurrent download of                        //
          // an older package is going on.                                                                             //
          globalDb.setPreinstallAppAsReady(_this.appId, _this.packageId);                                              // 401
        }                                                                                                              // 402
      });                                                                                                              // 403
    }).then(function () {                                                                                              // 404
      delete installers[_this.packageId];                                                                              // 405
    });                                                                                                                // 406
  };                                                                                                                   // 407
                                                                                                                       //
  return AppInstaller;                                                                                                 // 178
}();                                                                                                                   // 178
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 410
  var metadata = manifest.metadata;                                                                                    // 411
  if (!metadata) return;                                                                                               // 412
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 414
  if (icons) {                                                                                                         // 415
    var handleIcon = function handleIcon(icon) {                                                                       // 416
      if (icon.svg) {                                                                                                  // 417
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 418
        icon.format = "svg";                                                                                           // 419
        delete icon.svg;                                                                                               // 420
        return true;                                                                                                   // 421
      } else if (icon.png) {                                                                                           // 422
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 424
        if (!normalDpi) return false;                                                                                  // 425
        icon.format = "png";                                                                                           // 426
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 427
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 429
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 431
        }                                                                                                              // 432
                                                                                                                       //
        delete icon.png;                                                                                               // 434
        return true;                                                                                                   // 435
      } else {                                                                                                         // 436
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 438
      }                                                                                                                // 439
    };                                                                                                                 // 440
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 442
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 443
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 446
    if (icons.marketBig) delete icons.marketBig;                                                                       // 447
  }                                                                                                                    // 448
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 450
    if (text.defaultText) {                                                                                            // 451
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 452
      delete text.defaultText;                                                                                         // 453
    }                                                                                                                  // 454
                                                                                                                       //
    if (text.localizations) {                                                                                          // 456
      text.localizations.forEach(function (localization) {                                                             // 457
        if (localization.text) {                                                                                       // 458
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 459
          delete localization.text;                                                                                    // 461
        }                                                                                                              // 462
      });                                                                                                              // 463
    }                                                                                                                  // 464
  };                                                                                                                   // 465
                                                                                                                       //
  var license = metadata.license;                                                                                      // 467
  if (license) {                                                                                                       // 468
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 469
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 470
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 471
  }                                                                                                                    // 472
                                                                                                                       //
  var author = metadata.author;                                                                                        // 474
  if (author) {                                                                                                        // 475
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 477
  }                                                                                                                    // 478
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 481
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 484
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 487
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 490
};                                                                                                                     // 491
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 493
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 496
  if (!metadata) return [];                                                                                            // 497
                                                                                                                       //
  var result = [];                                                                                                     // 499
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 501
  if (icons) {                                                                                                         // 502
    var handleIcon = function handleIcon(icon) {                                                                       // 503
      if (icon.assetId) {                                                                                              // 504
        result.push(icon.assetId);                                                                                     // 505
      }                                                                                                                // 506
    };                                                                                                                 // 507
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 509
    if (icons.grain) handleIcon(icons.grain);                                                                          // 510
  }                                                                                                                    // 511
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 513
    if (text.defaultTextAssetId) {                                                                                     // 514
      result.push(defaultTextAssetId);                                                                                 // 515
    }                                                                                                                  // 516
                                                                                                                       //
    if (text.localizations) {                                                                                          // 518
      text.localizations.forEach(function (localization) {                                                             // 519
        if (localization.assetId) {                                                                                    // 520
          result.push(localization.assetId);                                                                           // 521
        }                                                                                                              // 522
      });                                                                                                              // 523
    }                                                                                                                  // 524
  };                                                                                                                   // 525
                                                                                                                       //
  var license = metadata.license;                                                                                      // 527
  if (license) {                                                                                                       // 528
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 529
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 530
    if (license.notices) handleLocalizedText(license.notices);                                                         // 531
  }                                                                                                                    // 532
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 534
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 535
                                                                                                                       //
  return result;                                                                                                       // 537
};                                                                                                                     // 538
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"notifications-server.js":["/imports/server/async-helpers.js","/imports/server/desktop-notifications.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/notifications-server.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});var createAppActivityDesktopNotification;module.import("/imports/server/desktop-notifications.js",{"createAppActivityDesktopNotification":function(v){createAppActivityDesktopNotification=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 20
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 21
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 22
                                                                                                                       //
logActivity = function logActivity(grainId, identityId, event) {                                                       // 24
  check(grainId, String);                                                                                              // 25
  check(identityId, String);                                                                                           // 26
  // `event` is always an ActivityEvent parsed from Cap'n Proto buf that's too complicated to check                    //
  // here.                                                                                                             //
                                                                                                                       //
  // TODO(perf): A cached copy of the grain from when the session opened would be fine to use                          //
  //   here, rather than looking it up every time.                                                                     //
  grain = Grains.findOne(grainId);                                                                                     // 32
  if (!grain) {                                                                                                        // 33
    // Shouldn't be possible since activity events come from the grain.                                                //
    throw new Error("no such grain");                                                                                  // 35
  }                                                                                                                    // 36
                                                                                                                       //
  // Look up the event typedef.                                                                                        //
  var eventType = ((grain.cachedViewInfo || {}).eventTypes || [])[event.type];                                         // 39
  if (!eventType) {                                                                                                    // 40
    throw new Error("No such event type in app's ViewInfo: " + event.type);                                            // 41
  }                                                                                                                    // 42
                                                                                                                       //
  if (!eventType.suppressUnread) {                                                                                     // 44
    // Clear the "seenAllActivity" bit for all users except the acting user.                                           //
    // TODO(perf): Consider throttling? Or should that be the app's responsibility?                                    //
    if (identityId != grain.identityId) {                                                                              // 47
      Grains.update(grainId, { $unset: { ownerSeenAllActivity: true } });                                              // 48
    }                                                                                                                  // 49
                                                                                                                       //
    // Also clear on ApiTokens.                                                                                        //
    ApiTokens.update({                                                                                                 // 52
      "grainId": grainId,                                                                                              // 53
      "owner.user.seenAllActivity": true,                                                                              // 54
      "owner.user.identityId": { $ne: identityId }                                                                     // 55
    }, { $unset: { "owner.user.seenAllActivity": true } }, { multi: true });                                           // 52
  }                                                                                                                    // 57
                                                                                                                       //
  // Apply auto-subscriptions.                                                                                         //
  if (eventType.autoSubscribeToGrain) {                                                                                // 60
    globalDb.subscribeToActivity(identityId, grainId);                                                                 // 61
  }                                                                                                                    // 62
                                                                                                                       //
  if (event.thread && eventType.autoSubscribeToThread) {                                                               // 64
    globalDb.subscribeToActivity(identityId, grainId, event.thread.path || "");                                        // 65
  }                                                                                                                    // 66
                                                                                                                       //
  // Figure out whom we need to notify.                                                                                //
  var notifyMap = {};                                                                                                  // 69
  var addRecipient = function addRecipient(recipient) {                                                                // 70
    // Mutes take priority over subscriptions.                                                                         //
    if (recipient.mute) {                                                                                              // 72
      notifyMap[identityId] = false;                                                                                   // 73
    } else {                                                                                                           // 74
      if (!(recipient.identityId in notifyMap)) {                                                                      // 75
        notifyMap[recipient.identityId] = true;                                                                        // 76
      }                                                                                                                // 77
    }                                                                                                                  // 78
  };                                                                                                                   // 79
                                                                                                                       //
  // Don't notify self.                                                                                                //
  addRecipient({ identityId: identityId, mute: true });                                                                // 82
                                                                                                                       //
  // Notify subscribers, if desired.                                                                                   //
  if (eventType.notifySubscribers) {                                                                                   // 85
    // The grain owner is implicitly subscribed.                                                                       //
    addRecipient({ identityId: grain.identityId });                                                                    // 87
                                                                                                                       //
    // Add everyone subscribed to the grain.                                                                           //
    globalDb.getActivitySubscriptions(grainId).forEach(addRecipient);                                                  // 90
                                                                                                                       //
    if (event.thread) {                                                                                                // 92
      // Add everyone subscribed to the thread.                                                                        //
      globalDb.getActivitySubscriptions(grainId, event.thread.path || "").forEach(addRecipient);                       // 94
    }                                                                                                                  // 95
  }                                                                                                                    // 96
                                                                                                                       //
  // Add everyone who is mentioned.                                                                                    //
  if (event.users && event.users.length > 0) {                                                                         // 99
    (function () {                                                                                                     // 99
      var promises = [];                                                                                               // 100
      event.users.forEach(function (user) {                                                                            // 101
        if (user.identity && (user.mentioned || user.subscribed)) {                                                    // 102
          promises.push(unwrapFrontendCap(user.identity, "identity", function (targetId) {                             // 103
            addRecipient({ identityId: targetId });                                                                    // 104
          }));                                                                                                         // 105
        }                                                                                                              // 106
      });                                                                                                              // 107
      waitPromise(Promise.all(promises).then(function (junk) {                                                         // 108
        return undefined;                                                                                              // 108
      }));                                                                                                             // 108
    })();                                                                                                              // 99
  }                                                                                                                    // 109
                                                                                                                       //
  // Make a list of everyone to notify.                                                                                //
  var notify = [];                                                                                                     // 112
  for (var _identityId in notifyMap) {                                                                                 // 113
    if (notifyMap[_identityId]) {                                                                                      // 114
      notify.push(_identityId);                                                                                        // 115
    }                                                                                                                  // 116
  }                                                                                                                    // 117
                                                                                                                       //
  if (notify.length > 0) {                                                                                             // 119
    (function () {                                                                                                     // 119
      var notification = {                                                                                             // 120
        grainId: grainId,                                                                                              // 121
        path: event.path || ""                                                                                         // 122
      };                                                                                                               // 120
                                                                                                                       //
      // Fields we'll update even if the notification already exists.                                                  //
      var update = {                                                                                                   // 126
        isUnread: true,                                                                                                // 127
        timestamp: new Date()                                                                                          // 128
      };                                                                                                               // 126
                                                                                                                       //
      if (event.thread) {                                                                                              // 131
        notification.threadPath = event.thread.path || "";                                                             // 132
      }                                                                                                                // 133
                                                                                                                       //
      if (identityId) {                                                                                                // 135
        notification.initiatingIdentity = identityId;                                                                  // 136
      }                                                                                                                // 137
                                                                                                                       //
      notification.eventType = event.type;                                                                             // 139
      update.text = eventType.verbPhrase;                                                                              // 140
                                                                                                                       //
      // Look up icon urls for the responsible identity and the app                                                    //
      var identity = Meteor.users.findOne({ _id: identityId });                                                        // 143
      if (!identity) {                                                                                                 // 144
        throw new Error("no such identity");                                                                           // 145
      }                                                                                                                // 146
                                                                                                                       //
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 148
      SandstormDb.fillInPictureUrl(identity);                                                                          // 149
                                                                                                                       //
      var body = event.notification && event.notification.caption || { defaultText: "" };                              // 151
                                                                                                                       //
      var appActivity = {                                                                                              // 153
        user: {                                                                                                        // 154
          identityId: identity._id,                                                                                    // 155
          name: identity.profile.name,                                                                                 // 156
          avatarUrl: identity.profile.pictureUrl || ""                                                                 // 157
        },                                                                                                             // 154
        grainId: notification.grainId,                                                                                 // 159
        path: notification.path,                                                                                       // 160
        body: body,                                                                                                    // 161
        actionText: eventType.verbPhrase                                                                               // 162
      };                                                                                                               // 153
                                                                                                                       //
      notify.forEach(function (targetId) {                                                                             // 165
        // Notify all accounts connected with this identity.                                                           //
        Meteor.users.find({ $or: [{ "loginIdentities.id": targetId }, { "nonloginIdentities.id": targetId }] }).forEach(function (account) {
          // We need to know the ID of the inserted/updated document so we can embed it in the                         //
          // desktop notification to bind them.                                                                        //
          var idIfInserted = Random.id(17);                                                                            // 173
          var result = Notifications.findAndModify({                                                                   // 174
            query: _.extend({ userId: account._id }, notification),                                                    // 175
            update: {                                                                                                  // 176
              $set: update,                                                                                            // 177
              $inc: { count: 1 },                                                                                      // 178
              $setOnInsert: {                                                                                          // 179
                _id: idIfInserted                                                                                      // 180
              }                                                                                                        // 179
            },                                                                                                         // 176
            upsert: true                                                                                               // 183
          });                                                                                                          // 174
                                                                                                                       //
          if (!result.ok) {                                                                                            // 186
            console.error("Couldn't create notification!", result.lastErrorObject);                                    // 187
            return;                                                                                                    // 188
          }                                                                                                            // 189
                                                                                                                       //
          var notificationId = result.value._id || idIfInserted;                                                       // 191
                                                                                                                       //
          var desktopNotification = {                                                                                  // 193
            userId: account._id,                                                                                       // 194
            notificationId: notificationId,                                                                            // 195
            appActivity: appActivity                                                                                   // 196
          };                                                                                                           // 193
                                                                                                                       //
          createAppActivityDesktopNotification(desktopNotification);                                                   // 199
        });                                                                                                            // 200
      });                                                                                                              // 201
    })();                                                                                                              // 119
  }                                                                                                                    // 202
};                                                                                                                     // 203
                                                                                                                       //
Meteor.methods({                                                                                                       // 205
  testNotifications: function testNotifications() {                                                                    // 206
    // Deliver a test notification of each non-grain-initiated type to the user.                                       //
    if (!this.userId) return;                                                                                          // 208
                                                                                                                       //
    Notifications.insert({                                                                                             // 210
      admin: {                                                                                                         // 211
        action: "/admin/stats",                                                                                        // 212
        type: "reportStats"                                                                                            // 213
      },                                                                                                               // 211
      userId: this.userId,                                                                                             // 215
      timestamp: new Date(),                                                                                           // 216
      isUnread: true                                                                                                   // 217
    });                                                                                                                // 210
                                                                                                                       //
    Notifications.insert({                                                                                             // 220
      admin: {                                                                                                         // 221
        action: "/admin/feature-key",                                                                                  // 222
        type: "cantRenewFeatureKey"                                                                                    // 223
      },                                                                                                               // 221
      userId: this.userId,                                                                                             // 225
      timestamp: new Date(),                                                                                           // 226
      isUnread: true                                                                                                   // 227
    });                                                                                                                // 220
                                                                                                                       //
    Notifications.insert({                                                                                             // 230
      admin: {                                                                                                         // 231
        action: "/admin/feature-key",                                                                                  // 232
        type: "trialFeatureKeyExpired"                                                                                 // 233
      },                                                                                                               // 231
      userId: this.userId,                                                                                             // 235
      timestamp: new Date(),                                                                                           // 236
      isUnread: true                                                                                                   // 237
    });                                                                                                                // 230
                                                                                                                       //
    Notifications.insert({                                                                                             // 240
      userId: this.userId,                                                                                             // 241
      referral: true,                                                                                                  // 242
      timestamp: new Date(),                                                                                           // 243
      isUnread: true                                                                                                   // 244
    });                                                                                                                // 240
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 247
      Notifications.insert({                                                                                           // 248
        userId: this.userId,                                                                                           // 249
        mailingListBonus: true,                                                                                        // 250
        timestamp: new Date(),                                                                                         // 251
        isUnread: true                                                                                                 // 252
      });                                                                                                              // 248
    }                                                                                                                  // 254
  }                                                                                                                    // 255
});                                                                                                                    // 205
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 258
  return Notifications.find({ userId: this.userId });                                                                  // 259
});                                                                                                                    // 260
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 262
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 265
  var notifications = Notifications.find({                                                                             // 266
    _id: { $in: notificationIds },                                                                                     // 267
    userId: this.userId                                                                                                // 268
  }, {                                                                                                                 // 266
    fields: { grainId: 1, initiatingIdentity: 1 }                                                                      // 270
  });                                                                                                                  // 269
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 273
    return row.grainId;                                                                                                // 274
  }).filter(function (x) {                                                                                             // 275
    return x;                                                                                                          // 275
  });                                                                                                                  // 275
                                                                                                                       //
  var identities = notifications.map(function (row) {                                                                  // 277
    return row.initiatingIdentity;                                                                                     // 278
  }).filter(function (x) {                                                                                             // 279
    return x;                                                                                                          // 279
  });                                                                                                                  // 279
                                                                                                                       //
  return [Meteor.users.find({ _id: { $in: identities } }, { fields: { profile: 1 } })];                                // 281
});                                                                                                                    // 284
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
                                                                                                                       // 20
var Url = Npm.require("url");                                                                                          // 21
var Fs = Npm.require("fs");                                                                                            // 22
var Dns = Npm.require("dns");                                                                                          // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 27
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 29
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 32
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 33
                                                                                                                       //
var webPublishingHandlers = {};                                                                                        // 35
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 39
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 45
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 48
}                                                                                                                      // 49
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 53
                                                                                                                       //
var mime = connect["static"].mime;                                                                                     // 55
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 57
  return function (request, response) {                                                                                // 58
    var path = request.url;                                                                                            // 59
                                                                                                                       //
    // If a directory, open "index.html".                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 62
      path = path + "index.html";                                                                                      // 63
    }                                                                                                                  // 64
                                                                                                                       //
    // Strip leading "/".                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 67
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 70
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 72
    var charset = mime.charsets.lookup(type);                                                                          // 73
    if (charset) {                                                                                                     // 74
      type = type + "; charset=" + charset;                                                                            // 75
    } else if (type === "application/json") {                                                                          // 76
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 78
    }                                                                                                                  // 79
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's "compress" middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 84
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 85
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 97
    }                                                                                                                  // 98
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 100
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         //
    // logic to happen if the response has no data.                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): This is pretty ugly.                                                                             //
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 106
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 108
      return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                       // 109
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 111
        if (status === "file") {                                                                                       // 112
          // Nothing to do.                                                                                            //
        } else if (status === "directory") {                                                                           // 114
            stream.sendingDirectResponse();                                                                            // 115
            response.writeHead(303, {                                                                                  // 116
              "Content-Type": "text/plain",                                                                            // 117
              "Location": "/" + path + "/",                                                                            // 118
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 119
            });                                                                                                        // 116
            response.end("redirect: /" + path + "/");                                                                  // 121
          } else if (status === "notFound") {                                                                          // 122
            stream.sendingDirectResponse();                                                                            // 123
            response.writeHead(404, {                                                                                  // 124
              "Content-Type": "text/plain"                                                                             // 125
            });                                                                                                        // 124
            response.end("404 not found: /" + path);                                                                   // 127
          } else {                                                                                                     // 128
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 129
            stream.sendingDirectResponse();                                                                            // 130
            response.writeHead(500, {                                                                                  // 131
              "Content-Type": "text/plain"                                                                             // 132
            });                                                                                                        // 131
            response.end("Internal server error");                                                                     // 134
          }                                                                                                            // 135
                                                                                                                       //
        streamCap.close();                                                                                             // 137
      });                                                                                                              // 138
    })["catch"](function (err) {                                                                                       // 139
      console.error(err.stack);                                                                                        // 140
      streamCap.close();                                                                                               // 141
    });                                                                                                                // 142
  };                                                                                                                   // 143
}                                                                                                                      // 144
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 146
  var status = 500;                                                                                                    // 147
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 148
    status = err.error;                                                                                                // 150
  } else if (err.httpErrorCode) {                                                                                      // 151
    status = err.httpErrorCode;                                                                                        // 152
  }                                                                                                                    // 153
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 156
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 158
  res.end(err.htmlMessage || err.message);                                                                             // 159
}                                                                                                                      // 160
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 162
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 163
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 165
  if (buf.length < magic.length) return false;                                                                         // 166
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 168
    if (buf[i] != magic[i]) return false;                                                                              // 169
  }                                                                                                                    // 170
                                                                                                                       //
  return true;                                                                                                         // 172
}                                                                                                                      // 173
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 175
  try {                                                                                                                // 176
    if (req.method === "GET" && req.url === "/") {                                                                     // 177
      var content = new Buffer("Self-test OK.");                                                                       // 179
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 182
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 183
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 184
      }                                                                                                                // 185
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 187
        "Content-Type": "text/plain",                                                                                  // 188
        "Content-Length": content.length,                                                                              // 189
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 190
      });                                                                                                              // 187
      res.end(content);                                                                                                // 192
    } else {                                                                                                           // 193
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 194
      res.end("Bad request to self-test subdomain.");                                                                  // 195
      return;                                                                                                          // 196
    }                                                                                                                  // 197
  } catch (err) {                                                                                                      // 198
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 199
  }                                                                                                                    // 200
}                                                                                                                      // 201
                                                                                                                       //
function serveStaticAsset(req, res, hostId) {                                                                          // 203
  inMeteor(function () {                                                                                               // 204
    if (req.method === "GET") {                                                                                        // 205
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 206
      if (req.headers["if-none-match"] === "permanent") {                                                              // 207
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 209
          "Cache-Control": "public, max-age=31536000",                                                                 // 210
          "ETag": "permanent",                                                                                         // 211
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          "Content-Security-Policy": assetCspHeader,                                                                   // 214
          "Access-Control-Allow-Origin": "*",                                                                          // 215
          "X-Content-Type-Options": "nosniff"                                                                          // 216
        });                                                                                                            // 209
        res.end();                                                                                                     // 218
        return;                                                                                                        // 219
      }                                                                                                                // 220
                                                                                                                       //
      var url = Url.parse(req.url, true);                                                                              // 222
      var pathname = url.pathname.slice(1);                                                                            // 223
      var asset = void 0;                                                                                              // 224
      if (pathname.startsWith("identicon/")) {                                                                         // 225
        var size = parseInt((url.query || {}).s);                                                                      // 226
        asset = new Identicon(pathname.slice("identicon/".length), size).asAsset();                                    // 227
      } else if (pathname.indexOf("/") == -1) {                                                                        // 228
        asset = globalDb.getStaticAsset(pathname);                                                                     // 229
      }                                                                                                                // 230
                                                                                                                       //
      if (asset) {                                                                                                     // 232
        var headers = {                                                                                                // 233
          "Content-Type": asset.mimeType,                                                                              // 234
          "Content-Length": asset.content.length,                                                                      // 235
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          "Cache-Control": "public, max-age=31536000",                                                                 // 238
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          "ETag": "permanent",                                                                                         // 241
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          "Content-Security-Policy": assetCspHeader,                                                                   // 248
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          "Access-Control-Allow-Origin": "*",                                                                          // 253
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          "X-Content-Type-Options": "nosniff"                                                                          // 256
        };                                                                                                             // 233
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 259
          headers["Content-Encoding"] = asset.encoding;                                                                // 260
        }                                                                                                              // 261
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 263
        res.end(asset.content);                                                                                        // 264
      } else {                                                                                                         // 265
        res.writeHead(404, { "Content-Type": "text/plain" });                                                          // 266
        res.end("not found");                                                                                          // 267
      }                                                                                                                // 268
    } else if (req.method === "POST") {                                                                                // 269
      var _ret = function () {                                                                                         // 269
        res.setHeader("Access-Control-Allow-Origin", "*");                                                             // 270
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 272
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 273
                                                                                                                       //
        // Sanity check the purpose of this upload token.                                                              //
        if (!purpose) {                                                                                                // 276
          res.writeHead(404, { "Content-Type": "text/plain" });                                                        // 277
          res.end("Upload token not found or expired.");                                                               // 278
          return {                                                                                                     // 279
            v: void 0                                                                                                  // 279
          };                                                                                                           // 279
        } else if (purpose.profilePicture) {                                                                           // 280
          var userId = purpose.profilePicture.userId;                                                                  // 281
          var identityId = purpose.profilePicture.identityId;                                                          // 282
          check(userId, String);                                                                                       // 283
          check(identityId, String);                                                                                   // 284
        } else if (purpose.loginLogo) {                                                                                // 285
          // no additional fields for loginLogo                                                                        //
        } else {                                                                                                       // 287
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 288
            res.end("Found invalid purpose for upload");                                                               // 289
            return {                                                                                                   // 290
              v: void 0                                                                                                // 290
            };                                                                                                         // 290
          }                                                                                                            // 291
                                                                                                                       //
        var buffers = [];                                                                                              // 293
        var totalSize = 0;                                                                                             // 294
        var done = new Future();                                                                                       // 295
        req.on("data", function (buf) {                                                                                // 296
          totalSize += buf.length;                                                                                     // 297
          if (totalSize <= 64 * 1024) {                                                                                // 298
            buffers.push(buf);                                                                                         // 299
          }                                                                                                            // 300
        });                                                                                                            // 301
        req.on("end", done["return"].bind(done));                                                                      // 302
        req.on("error", done["throw"].bind(done));                                                                     // 303
        done.wait();                                                                                                   // 304
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 306
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 308
          res.end("Picture too large; please use an image under 64 KiB.");                                             // 309
          return {                                                                                                     // 310
            v: void 0                                                                                                  // 310
          };                                                                                                           // 310
        }                                                                                                              // 311
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 313
        var type = void 0;                                                                                             // 314
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 315
          type = "image/png";                                                                                          // 316
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 317
          type = "image/jpeg";                                                                                         // 318
        } else {                                                                                                       // 319
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 320
          res.end("Image must be PNG or JPEG.");                                                                       // 321
          return {                                                                                                     // 322
            v: void 0                                                                                                  // 322
          };                                                                                                           // 322
        }                                                                                                              // 323
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 325
                                                                                                                       //
        if (purpose.profilePicture) {                                                                                  // 327
          var _identityId = purpose.profilePicture.identityId;                                                         // 328
          var result = Meteor.users.findAndModify({                                                                    // 329
            query: { _id: _identityId },                                                                               // 330
            update: { $set: { "profile.picture": assetId } },                                                          // 331
            fields: { "profile.picture": 1 }                                                                           // 332
          });                                                                                                          // 329
                                                                                                                       //
          if (result.ok) {                                                                                             // 335
            var old = result.value;                                                                                    // 336
            if (old && old.profile && old.profile.picture) {                                                           // 337
              globalDb.unrefStaticAsset(old.profile.picture);                                                          // 338
            }                                                                                                          // 339
          } else {                                                                                                     // 340
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 341
            res.end("Couldn't update profile picture.");                                                               // 342
            return {                                                                                                   // 343
              v: void 0                                                                                                // 343
            };                                                                                                         // 343
          }                                                                                                            // 344
        } else if (purpose.loginLogo) {                                                                                // 345
          var _result = globalDb.collections.settings.findAndModify({                                                  // 346
            query: { _id: "whitelabelCustomLogoAssetId" },                                                             // 347
            update: {                                                                                                  // 348
              $setOnInsert: { _id: "whitelabelCustomLogoAssetId" },                                                    // 349
              $set: { value: assetId }                                                                                 // 350
            },                                                                                                         // 348
            upsert: true,                                                                                              // 352
            fields: { value: 1 }                                                                                       // 353
          });                                                                                                          // 346
                                                                                                                       //
          if (_result.ok) {                                                                                            // 356
            var _old = _result.value;                                                                                  // 357
            if (_old && _old.value) {                                                                                  // 358
              globalDb.unrefStaticAsset(_old.value);                                                                   // 359
            }                                                                                                          // 360
          } else {                                                                                                     // 361
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 362
            res.end("Couldn't update login logo.");                                                                    // 363
            return {                                                                                                   // 364
              v: void 0                                                                                                // 364
            };                                                                                                         // 364
          }                                                                                                            // 365
        }                                                                                                              // 366
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 368
        res.end();                                                                                                     // 369
      }();                                                                                                             // 269
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 269
    } else if (req.method === "OPTIONS") {                                                                             // 370
      var requestedHeaders = req.headers["access-control-request-headers"];                                            // 371
      if (requestedHeaders) {                                                                                          // 372
        res.setHeader("Access-Control-Allow-Headers", requestedHeaders);                                               // 373
      }                                                                                                                // 374
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 376
        "Access-Control-Allow-Origin": "*",                                                                            // 377
        "Access-Control-Allow-Methods": "GET, HEAD, POST, OPTIONS",                                                    // 378
        "Access-Control-Max-Age": "3600"                                                                               // 379
      });                                                                                                              // 376
      res.end();                                                                                                       // 381
    } else {                                                                                                           // 382
      res.writeHead(405, "Method Not Allowed", {                                                                       // 383
        "Allow": "GET, POST, OPTIONS",                                                                                 // 384
        "Content-Type": "text/plain"                                                                                   // 385
      });                                                                                                              // 383
      res.end("405 Method Not Allowed: " + req.method);                                                                // 387
    }                                                                                                                  // 388
  })["catch"](function (err) {                                                                                         // 389
    writeErrorResponse(res, err);                                                                                      // 390
  });                                                                                                                  // 391
}                                                                                                                      // 392
                                                                                                                       //
var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                          // 394
  // Start with ROOT_URL, apply host & path from inbound URL, then                                                     //
  // redirect.                                                                                                         //
  var targetUrl = Url.parse(process.env.ROOT_URL);                                                                     // 397
                                                                                                                       //
  // Retain the protocol & port from ROOT_URL but use the inbound                                                      //
  // hostname.                                                                                                         //
  targetUrl.host = hostname + ":" + targetUrl.port;                                                                    // 401
                                                                                                                       //
  // The following allows to avoid decoding + re-encoding query                                                        //
  // string parameters, if provided.                                                                                   //
  targetUrl = Url.resolve(Url.format(targetUrl), url);                                                                 // 405
  return targetUrl;                                                                                                    // 406
};                                                                                                                     // 407
                                                                                                                       //
var handleNonMeteorRequest = function handleNonMeteorRequest(req, res, next, redirectIfInWildcard) {                   // 409
  // if redirectIfInWildcard is true, and if the host is part of the wildcard host, then we will                       //
  // prefer to redirect to the canonical url for that request.  If false, we will respond to the                       //
  // request directly.                                                                                                 //
                                                                                                                       //
  var hostname = req.headers.host.split(":")[0];                                                                       // 414
                                                                                                                       //
  var publicIdPromise = void 0;                                                                                        // 416
  // See if the request was for a host in the wildcard.                                                                //
  var id = matchWildcardHost(req.headers.host);                                                                        // 418
  if (id) {                                                                                                            // 419
    // Match!                                                                                                          //
    if (redirectIfInWildcard) {                                                                                        // 421
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 422
      res.end();                                                                                                       // 423
      return;                                                                                                          // 424
    }                                                                                                                  // 425
                                                                                                                       //
    if (id === "static") {                                                                                             // 427
      // Static assets domain.                                                                                         //
      serveStaticAsset(req, res);                                                                                      // 429
      return;                                                                                                          // 430
    }                                                                                                                  // 431
                                                                                                                       //
    if (id.match(/^selftest-/)) {                                                                                      // 433
      // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                       //
      // publishing wildcard hosts.                                                                                    //
      serveSelfTest(req, res);                                                                                         // 436
      return;                                                                                                          // 437
    }                                                                                                                  // 438
                                                                                                                       //
    // Try to route the request to a session.                                                                          //
    publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                          // 441
      if (handled) {                                                                                                   // 442
        return null;                                                                                                   // 443
      } else {                                                                                                         // 444
        return id;                                                                                                     // 445
      }                                                                                                                // 446
    });                                                                                                                // 447
  } else {                                                                                                             // 448
    // Not a wildcard host. Perhaps it is a custom host.                                                               //
    publicIdPromise = lookupPublicIdFromDns(hostname);                                                                 // 450
  }                                                                                                                    // 451
                                                                                                                       //
  publicIdPromise.then(function (publicId) {                                                                           // 453
    if (publicId) {                                                                                                    // 454
      return Promise.resolve(undefined).then(function () {                                                             // 455
        var handler = webPublishingHandlers[publicId];                                                                 // 456
        if (handler) {                                                                                                 // 457
          return handler;                                                                                              // 458
        } else {                                                                                                       // 459
          // We don't have a handler for this publicId, so look it up in the grain DB.                                 //
          return inMeteor(function () {                                                                                // 461
            var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                                // 462
            if (!grain) {                                                                                              // 463
              throw new Meteor.Error(404, "No such grain for public ID: " + publicId);                                 // 464
            }                                                                                                          // 465
                                                                                                                       //
            var grainId = grain._id;                                                                                   // 467
            return webPublishingHandlers[publicId] = wwwHandlerForGrain(grainId);                                      // 468
          });                                                                                                          // 469
        }                                                                                                              // 470
      }).then(function (handler) {                                                                                     // 471
        handler(req, res);                                                                                             // 472
      });                                                                                                              // 473
    } else {                                                                                                           // 474
      // Already handled by tryProxyRequest above, no further action needed.                                           //
      return Promise.resolve(undefined);                                                                               // 476
    }                                                                                                                  // 477
  })["catch"](function (err) {                                                                                         // 478
    writeErrorResponse(res, err);                                                                                      // 479
  });                                                                                                                  // 480
};                                                                                                                     // 481
                                                                                                                       //
// This function serves responses on Sandstorm's main HTTP/HTTPS                                                       //
// port.                                                                                                               //
var handleNonMeteorRequestDirectly = function handleNonMeteorRequestDirectly(req, res, next) {                         // 485
  handleNonMeteorRequest(req, res, next, false);                                                                       // 486
};                                                                                                                     // 487
                                                                                                                       //
// "Alternate ports" are ports other than the main HTTP or HTTPS port.                                                 //
// They are handled as follows:                                                                                        //
//                                                                                                                     //
// * Requests to the shell & grains, we redirect to the main port.                                                     //
// * For requests to static publishing on hosts within the wildcard, we redirect to the main port.                     //
// * For static publishing glued in via DNS TXT record, we serve the request as-is.                                    //
//                                                                                                                     //
// Alternate ports are bound to FD #5 and higher.                                                                      //
var getNumberOfAlternatePorts = function getNumberOfAlternatePorts() {                                                 // 497
  var numPorts = process.env.PORT.split(",").length;                                                                   // 498
  var numAlternatePorts = numPorts - 1;                                                                                // 499
  return numAlternatePorts;                                                                                            // 500
};                                                                                                                     // 501
                                                                                                                       //
var handleNonMainPortRequest = function handleNonMainPortRequest(req, res, next) {                                     // 503
  try {                                                                                                                // 504
    if (!req.headers.host) {                                                                                           // 505
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 506
      res.end("Missing Host header");                                                                                  // 507
      return;                                                                                                          // 508
    }                                                                                                                  // 509
                                                                                                                       //
    // If this request is intended for the shell, redirect to the canonical shell URL.                                 //
    var hostname = req.headers.host.split(":")[0];                                                                     // 512
    if (isSandstormShell(hostname)) {                                                                                  // 513
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 514
      res.end();                                                                                                       // 515
      return;                                                                                                          // 516
    }                                                                                                                  // 517
                                                                                                                       //
    handleNonMeteorRequest(req, res, next, true);                                                                      // 519
  } catch (e) {                                                                                                        // 520
    // This should never be reached, because all the request handlers should be catching                               //
    // exceptions, but you can never be too careful in a top-level request handler.                                    //
    console.err("Unhandled exception in request handler:", e.stack);                                                   // 523
    res.writeHead(500, { "Content-Type": "text/plain" });                                                              // 524
    res.end("Unhandled exception: " + e.stack);                                                                        // 525
  }                                                                                                                    // 526
};                                                                                                                     // 527
                                                                                                                       //
var listenOnAlternatePorts = function listenOnAlternatePorts() {                                                       // 529
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 530
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(handleNonMainPortRequest);                                 // 532
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 533
  }                                                                                                                    // 534
};                                                                                                                     // 535
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 537
  var meteorRequestListeners = WebApp.httpServer.listeners("request");                                                 // 538
                                                                                                                       //
  // Construct the middleware chain for requests to non-DDP, non-shell hosts.                                          //
  var nonMeteorRequestHandler = connect();                                                                             // 541
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 543
    // Have to check with global, because it could be undefined.                                                       //
    nonMeteorRequestHandler.use(BlackrockPayments.makeConnectHandler(globalDb));                                       // 544
  }                                                                                                                    // 545
                                                                                                                       //
  nonMeteorRequestHandler.use(handleNonMeteorRequestDirectly);                                                         // 547
                                                                                                                       //
  WebApp.httpServer.removeAllListeners("request");                                                                     // 549
  WebApp.httpServer.on("request", function (req, res) {                                                                // 550
    try {                                                                                                              // 551
      if (!req.headers.host) {                                                                                         // 552
        res.writeHead(400, { "Content-Type": "text/plain" });                                                          // 553
        res.end("Missing Host header");                                                                                // 554
        return;                                                                                                        // 555
      }                                                                                                                // 556
                                                                                                                       //
      var hostname = req.headers.host.split(":")[0];                                                                   // 558
      if (isSandstormShell(hostname)) {                                                                                // 559
        // If destined for the DDP host or the main host, pass on to Meteor                                            //
        for (var i = 0; i < meteorRequestListeners.length; i++) {                                                      // 561
          meteorRequestListeners[i](req, res);                                                                         // 562
        }                                                                                                              // 563
      } else {                                                                                                         // 564
        // Otherwise, dispatch to our own middleware proxy chain.                                                      //
        nonMeteorRequestHandler(req, res);                                                                             // 566
        // Adjust timeouts on proxied requests to allow apps to long-poll if needed.                                   //
        WebApp._timeoutAdjustmentRequestCallback(req, res);                                                            // 568
      }                                                                                                                // 569
    } catch (e) {                                                                                                      // 570
      // This should never be reached, because all the request handlers should be catching                             //
      // exceptions, but you can never be too careful in a top-level request handler.                                  //
      console.err("Unhandled exception in request handler:", e.stack);                                                 // 573
      res.writeHead(500, { "Content-Type": "text/plain" });                                                            // 574
      res.end("Unhandled exception: " + e.stack);                                                                      // 575
    }                                                                                                                  // 576
  });                                                                                                                  // 577
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners("upgrade");                                                 // 579
  WebApp.httpServer.removeAllListeners("upgrade");                                                                     // 580
                                                                                                                       //
  WebApp.httpServer.on("upgrade", function (req, socket, head) {                                                       // 582
    Promise.resolve(undefined).then(function () {                                                                      // 583
      if (!req.headers.host) {                                                                                         // 584
        throw new Meteor.Error(400, "Missing Host header");                                                            // 585
      } else if (isSandstormShell(req.headers.host.split(":")[0])) {                                                   // 586
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 588
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 589
        }                                                                                                              // 590
                                                                                                                       //
        return true;                                                                                                   // 592
      } else {                                                                                                         // 593
        var id = matchWildcardHost(req.headers.host);                                                                  // 594
        if (id) {                                                                                                      // 595
          return tryProxyUpgrade(id, req, socket, head);                                                               // 596
        } else {                                                                                                       // 597
          return false;                                                                                                // 598
        }                                                                                                              // 599
      }                                                                                                                // 600
    }).then(function (handled) {                                                                                       // 601
      if (!handled) socket.destroy();                                                                                  // 602
    })["catch"](function (err) {                                                                                       // 603
      console.error("WebSocket event handler failed:", err.stack);                                                     // 604
      socket.destroy();                                                                                                // 605
    });                                                                                                                // 606
  });                                                                                                                  // 607
                                                                                                                       //
  listenOnAlternatePorts();                                                                                            // 609
});                                                                                                                    // 610
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 612
errorTxtMapping[Dns.NOTFOUND] = "<p>" + "If you were trying to configure static publishing for a blog or website, powered " + "by a Sandstorm app hosted at this server, you either have not added DNS TXT records " + "correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one " + "hour).</p>";
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 618
errorTxtMapping[Dns.TIMEOUT] = "<p>" + "The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>";
errorTxtMapping[Dns.CONNREFUSED] = "<p>" + "The DNS server refused the connection, which means either your DNS server is down/unreachable, " + "or the server has misconfigured their DNS.</p>";
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 625
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 639
  if (cache && Date.now() < cache.expiration) {                                                                        // 640
    return Promise.resolve(cache.value);                                                                               // 641
  }                                                                                                                    // 642
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 644
    Dns.resolveTxt("sandstorm-www." + hostname, function (err, records) {                                              // 645
      if (err) {                                                                                                       // 646
        var errorMsg = errorTxtMapping[err.code] || "";                                                                // 647
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 648
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + "<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>" + errorMsg + "<p>To visit this Sandstorm server's main interface, go to: <a href='" + process.env.ROOT_URL + "'>" + process.env.ROOT_URL + "</a></p>" + "<h3>DNS details</h3>" + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + "</p>" + "<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>" + "<p><tt>dig TXT sandstorm-www." + hostname + "</tt></p>" + "<h3>Changing the server URL, or troubleshooting OAuth login</h3>" + "<p>If you are the server admin and want to use this address as the main interface, " + "edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart " + "Sandstorm.</p>" + "<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), " + "the problem is probably that the OAuth callback URL was set wrong. You need to " + "update it through the respective login provider's management console. The " + "easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then " + "reconfigure the OAuth provider.</p>";
        error.httpErrorCode = _.contains(["ENOTFOUND", "ENODATA"], err.code) ? 404 : 500;                              // 669
        reject(error);                                                                                                 // 670
      } else if (records.length !== 1) {                                                                               // 671
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 672
      } else {                                                                                                         // 673
        // Under node 0.12+, `records` is an array-of-arrays. Each sub-array contains "chunks" of a                    //
        // record, which should be joined.                                                                             //
        var result = records[0].join("");                                                                              // 676
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 677
        resolve(result);                                                                                               // 678
      }                                                                                                                // 679
    });                                                                                                                // 680
  });                                                                                                                  // 681
}                                                                                                                      // 682
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum","/imports/server/constants.js","/imports/server/backend.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});var SandstormBackend,shouldRestartGrain;module.import("/imports/server/backend.js",{"SandstormBackend":function(v){SandstormBackend=v},"shouldRestartGrain":function(v){shouldRestartGrain=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
var Crypto = Npm.require("crypto");                                                                                    // 21
var ChildProcess = Npm.require("child_process");                                                                       // 22
var Fs = Npm.require("fs");                                                                                            // 23
var Path = Npm.require("path");                                                                                        // 24
var Http = Npm.require("http");                                                                                        // 25
var Url = Npm.require("url");                                                                                          // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
var Net = Npm.require("net");                                                                                          // 28
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 30
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 31
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 32
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 33
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 34
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 35
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 40
  check(identityId, String);                                                                                           // 41
  check(apiTokenAccountId, String);                                                                                    // 42
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        //
  if (!db.isReferralEnabled()) {                                                                                       // 45
    return;                                                                                                            // 46
  }                                                                                                                    // 47
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 49
  var bobAccountId = accountId;                                                                                        // 50
  var bobIdentityId = identityId;                                                                                      // 51
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 53
    _id: bobAccountId,                                                                                                 // 54
    referredByComplete: { $exists: true }                                                                              // 55
  }).count() > 0) {                                                                                                    // 53
    return;                                                                                                            // 57
  }                                                                                                                    // 58
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 64
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 66
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        //
  if (!db.isReferralEnabled()) {                                                                                       // 82
    return;                                                                                                            // 83
  }                                                                                                                    // 84
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 87
    return;                                                                                                            // 88
  }                                                                                                                    // 89
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 92
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 93
    _id: { $in: bobIdentityIds },                                                                                      // 94
    referredBy: { $exists: true }                                                                                      // 95
  });                                                                                                                  // 93
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 98
    return;                                                                                                            // 99
  }                                                                                                                    // 100
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 102
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 105
  Meteor.users.update({                                                                                                // 106
    _id: bobAccountId,                                                                                                 // 107
    referredByComplete: { $exists: false }                                                                             // 108
  }, {                                                                                                                 // 106
    $set: {                                                                                                            // 110
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 111
      referredCompleteDate: now                                                                                        // 112
    }                                                                                                                  // 110
  });                                                                                                                  // 109
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 117
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 118
  });                                                                                                                  // 117
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 122
    $unset: { referredBy: true }                                                                                       // 123
  });                                                                                                                  // 122
}                                                                                                                      // 125
                                                                                                                       //
var HeaderWhitelist = function () {                                                                                    //
  function HeaderWhitelist(list) {                                                                                     // 128
    var _this2 = this;                                                                                                 // 128
                                                                                                                       //
    _classCallCheck(this, HeaderWhitelist);                                                                            // 128
                                                                                                                       //
    this._headers = {};                                                                                                // 129
    this._prefixes = [];                                                                                               // 130
                                                                                                                       //
    list.forEach(function (pattern) {                                                                                  // 132
      if (pattern.endsWith("*")) {                                                                                     // 133
        _this2._prefixes.push(pattern.slice(0, -1));                                                                   // 134
      } else {                                                                                                         // 135
        _this2._headers[pattern] = true;                                                                               // 136
      }                                                                                                                // 137
    });                                                                                                                // 138
  }                                                                                                                    // 139
                                                                                                                       //
  HeaderWhitelist.prototype.matches = function matches(header) {                                                       //
    header = header.toLowerCase();                                                                                     // 142
    if (this._headers[header]) return true;                                                                            // 143
                                                                                                                       //
    for (var i in this._prefixes) {                                                                                    // 145
      if (header.startsWith(this._prefixes[i])) {                                                                      // 146
        return true;                                                                                                   // 147
      }                                                                                                                // 148
    };                                                                                                                 // 149
                                                                                                                       //
    return false;                                                                                                      // 151
  };                                                                                                                   // 152
                                                                                                                       //
  return HeaderWhitelist;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var REQUEST_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Context.headerWhitelist);                                // 155
var RESPONSE_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Response.headerWhitelist);                              // 156
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 171
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 173
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory(globalDb);                                                         // 175
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 176
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 177
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 178
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 182
Meteor.onConnection(function (connection) {                                                                            // 183
  connection.sandstormBackend = globalBackend;                                                                         // 184
});                                                                                                                    // 185
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 194
var disconnectCount = 0;                                                                                               // 195
Meteor.setInterval(function () {                                                                                       // 196
  if (!backendHealthy) {                                                                                               // 197
    if (disconnectCount++ > 2) process.abort();                                                                        // 198
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 199
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 200
    sandstormBackendConnection.close();                                                                                // 201
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 202
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 203
    globalBackend._backendCap = sandstormBackend;                                                                      // 204
  }                                                                                                                    // 205
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 207
  backendHealthy = false;                                                                                              // 208
  var promise = sandstormBackend.ping().then(function () {                                                             // 209
    backendHealthy = true;                                                                                             // 210
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 211
  }, function (err) {                                                                                                  // 212
    console.error("error: Backend ping threw error!", err.stack);                                                      // 213
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 217
                                                                                                                       //
  if (debugLog) {                                                                                                      // 219
    console.log("capnp.js: outer promise:", promise);                                                                  // 220
  }                                                                                                                    // 221
}, 30000);                                                                                                             // 222
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 227
                                                                                                                       //
Meteor.methods({                                                                                                       // 229
  newGrain: function newGrain(packageId, command, title, identityId) {                                                 // 230
    // Create and start a new grain.                                                                                   //
                                                                                                                       //
    check(packageId, String);                                                                                          // 233
    check(command, Object); // Manifest.Command from package.capnp.                                                    // 234
    check(title, String);                                                                                              // 235
    check(identityId, String);                                                                                         // 236
                                                                                                                       //
    if (!this.userId) {                                                                                                // 238
      throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                              // 239
    }                                                                                                                  // 240
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 242
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 243
    }                                                                                                                  // 244
                                                                                                                       //
    if (!isSignedUpOrDemo()) {                                                                                         // 246
      throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");              // 247
    }                                                                                                                  // 249
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 251
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 252
    }                                                                                                                  // 254
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 256
    var isDev = false;                                                                                                 // 257
    var mountProc = false;                                                                                             // 258
    if (!pkg) {                                                                                                        // 259
      // Maybe they wanted a dev package.  Check there too.                                                            //
      pkg = DevPackages.findOne(packageId);                                                                            // 261
      isDev = true;                                                                                                    // 262
      mountProc = pkg.mountProc;                                                                                       // 263
    }                                                                                                                  // 264
                                                                                                                       //
    if (!pkg) {                                                                                                        // 266
      throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                       // 267
    }                                                                                                                  // 268
                                                                                                                       //
    var appId = pkg.appId;                                                                                             // 270
    var manifest = pkg.manifest;                                                                                       // 271
    var grainId = Random.id(22); // 128 bits of entropy                                                                // 272
    Grains.insert({                                                                                                    // 273
      _id: grainId,                                                                                                    // 274
      packageId: packageId,                                                                                            // 275
      appId: appId,                                                                                                    // 276
      appVersion: manifest.appVersion,                                                                                 // 277
      userId: this.userId,                                                                                             // 278
      identityId: identityId,                                                                                          // 279
      title: title,                                                                                                    // 280
      "private": true,                                                                                                 // 281
      size: 0                                                                                                          // 282
    });                                                                                                                // 273
                                                                                                                       //
    globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev, mountProc);                // 285
    globalBackend.updateLastActive(grainId, this.userId, identityId);                                                  // 287
    return grainId;                                                                                                    // 288
  },                                                                                                                   // 289
  openSession: function openSession(grainId, identityId, cachedSalt) {                                                 // 291
    // Open a new UI session on an existing grain.  Starts the grain if it is not already                              //
    // running.                                                                                                        //
                                                                                                                       //
    check(grainId, String);                                                                                            // 295
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 296
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 297
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 299
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 300
    }                                                                                                                  // 301
                                                                                                                       //
    var grain = Grains.findOne({ _id: grainId });                                                                      // 303
    if (!grain) {                                                                                                      // 304
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                          // 305
    } else if (grain.trashed) {                                                                                        // 306
      throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                        // 307
    } else if (grain.suspended) {                                                                                      // 308
      throw new Meteor.Error("grain-owner-suspended", "Grain's owner is suspended", "Grain ID: " + grainId);           // 309
    }                                                                                                                  // 311
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 313
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 314
    if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {                 // 315
      throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                       // 317
    }                                                                                                                  // 318
                                                                                                                       //
    var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);          // 320
    var result = opened.methodResult;                                                                                  // 322
    var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
    proxiesByHostId[result.hostId] = proxy;                                                                            // 325
    return result;                                                                                                     // 326
  },                                                                                                                   // 327
  openSessionFromApiToken: function openSessionFromApiToken(params, identityId, cachedSalt) {                          // 329
    // Given an API token, either opens a new WebSession to the underlying grain or returns a                          //
    // path to which the client should redirect in order to open such a session.                                       //
                                                                                                                       //
    check(params, {                                                                                                    // 333
      token: String,                                                                                                   // 334
      incognito: Boolean                                                                                               // 335
    });                                                                                                                // 333
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 337
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 338
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 340
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 341
    }                                                                                                                  // 342
                                                                                                                       //
    if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                     // 344
      throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
    }                                                                                                                  // 347
                                                                                                                       //
    var token = params.token;                                                                                          // 349
    var incognito = params.incognito;                                                                                  // 350
    var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                      // 351
    var apiToken = ApiTokens.findOne(hashedToken);                                                                     // 352
    validateWebkey(apiToken);                                                                                          // 353
    var grain = Grains.findOne({ _id: apiToken.grainId });                                                             // 354
    if (!grain) {                                                                                                      // 355
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                                 // 356
    }                                                                                                                  // 357
                                                                                                                       //
    if (apiToken.accountId) {                                                                                          // 359
      referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                                 // 360
    }                                                                                                                  // 361
                                                                                                                       //
    var title = void 0;                                                                                                // 363
    if (grain.userId === apiToken.accountId) {                                                                         // 364
      title = grain.title;                                                                                             // 365
    } else {                                                                                                           // 366
      var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                     // 367
        grainId: apiToken.grainId,                                                                                     // 369
        "owner.user.identityId": apiToken.identityId                                                                   // 370
      }, {                                                                                                             // 368
        sort: {                                                                                                        // 372
          lastUsed: -1                                                                                                 // 373
        }                                                                                                              // 372
      });                                                                                                              // 371
      if (sharerToken) {                                                                                               // 376
        title = sharerToken.owner.user.title;                                                                          // 377
      } else {                                                                                                         // 378
        title = "shared grain";                                                                                        // 379
      }                                                                                                                // 380
    }                                                                                                                  // 381
                                                                                                                       //
    if (this.userId && !incognito) {                                                                                   // 383
      if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
        var owner = { user: { identityId: identityId, title: title } };                                                // 386
                                                                                                                       //
        // Create a new API token for the identity redeeming this token.                                               //
        var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname || "redeemed webkey", { allAccess: null }, owner);
        globalDb.addContact(apiToken.accountId, identityId);                                                           // 393
                                                                                                                       //
        // If the parent API token is forSharing and it has an accountId, then the logged-in user (call                //
        // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference                //
        // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                        //
        // share-by-identity, this happens immediately.)                                                               //
        if (result.parentApiToken) {                                                                                   // 399
          var parentApiToken = result.parentApiToken;                                                                  // 400
          if (parentApiToken.forSharing && parentApiToken.accountId) {                                                 // 401
            storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
          }                                                                                                            // 404
        }                                                                                                              // 405
      }                                                                                                                // 406
                                                                                                                       //
      return { redirectToGrain: apiToken.grainId };                                                                    // 408
    } else {                                                                                                           // 409
      if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                         // 410
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 411
      }                                                                                                                // 413
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);       // 415
                                                                                                                       //
      var _result = opened.methodResult;                                                                               // 418
      var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false, opened.supervisor);
      proxy.apiToken = apiToken;                                                                                       // 422
      proxiesByHostId[_result.hostId] = proxy;                                                                         // 423
      return _result;                                                                                                  // 424
    }                                                                                                                  // 425
  },                                                                                                                   // 426
  keepSessionAlive: function keepSessionAlive(sessionId) {                                                             // 428
    // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                    //
    //   by them.                                                                                                      //
    check(sessionId, String);                                                                                          // 431
                                                                                                                       //
    var result = Sessions.findAndModify({                                                                              // 433
      query: { _id: sessionId },                                                                                       // 434
      update: { $set: { timestamp: new Date().getTime() } },                                                           // 435
      fields: { grainId: 1, identityId: 1, hostId: 1 }                                                                 // 436
    });                                                                                                                // 433
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 439
      return false;                                                                                                    // 440
    }                                                                                                                  // 441
                                                                                                                       //
    var session = result.value;                                                                                        // 443
    if (session) {                                                                                                     // 444
      // Session still present in database, so send keep-alive to backend.                                             //
      try {                                                                                                            // 446
        var grainId = session.grainId;                                                                                 // 447
        var hostId = session.hostId;                                                                                   // 448
        var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                                // 449
        if (!supervisor) {                                                                                             // 450
          supervisor = globalBackend.continueGrain(grainId).supervisor;                                                // 451
        }                                                                                                              // 452
                                                                                                                       //
        waitPromise(supervisor.keepAlive());                                                                           // 454
        globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                      // 455
      } catch (err) {                                                                                                  // 456
        // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                    //
        // the next request, so whatever.                                                                              //
        if (err.kjType !== "disconnected") {                                                                           // 459
          throw err;                                                                                                   // 460
        }                                                                                                              // 461
      }                                                                                                                // 462
                                                                                                                       //
      return true;                                                                                                     // 464
    } else {                                                                                                           // 465
      return false;                                                                                                    // 466
    }                                                                                                                  // 467
  },                                                                                                                   // 468
  shutdownGrain: function shutdownGrain(grainId) {                                                                     // 470
    check(grainId, String);                                                                                            // 471
    var grain = Grains.findOne(grainId);                                                                               // 472
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 473
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 474
    }                                                                                                                  // 475
                                                                                                                       //
    waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                             // 477
  }                                                                                                                    // 478
});                                                                                                                    // 229
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 481
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 486
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 487
  }                                                                                                                    // 488
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 490
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 491
  }                                                                                                                    // 492
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 494
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 495
  }                                                                                                                    // 496
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 498
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 499
  }                                                                                                                    // 500
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 502
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 503
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 504
    } else if (refreshedExpiration) {                                                                                  // 505
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 506
    } else {                                                                                                           // 507
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 509
    }                                                                                                                  // 510
  }                                                                                                                    // 511
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 513
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 514
  }                                                                                                                    // 515
};                                                                                                                     // 516
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 518
  var shutdownApp = function shutdownApp(appId) {                                                                      // 519
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 520
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 521
    });                                                                                                                // 522
  };                                                                                                                   // 523
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 525
    removed: function removed(devPackage) {                                                                            // 526
      shutdownApp(devPackage.appId);                                                                                   // 526
    },                                                                                                                 // 526
    changed: function changed(newDevPackage, oldDevPackage) {                                                          // 528
      shutdownApp(oldDevPackage.appId);                                                                                // 529
      if (oldDevPackage.appId !== newDevPackage.appId) {                                                               // 530
        shutdownApp(newDevPackage.appId);                                                                              // 531
      }                                                                                                                // 532
    },                                                                                                                 // 533
    added: function added(devPackage) {                                                                                // 535
      shutdownApp(devPackage.appId);                                                                                   // 535
    }                                                                                                                  // 535
  });                                                                                                                  // 525
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 538
    removed: function removed(session) {                                                                               // 539
      var proxy = proxiesByHostId[session.hostId];                                                                     // 540
      delete proxiesByHostId[session.hostId];                                                                          // 541
      if (proxy) {                                                                                                     // 542
        proxy.close();                                                                                                 // 543
      }                                                                                                                // 544
    }                                                                                                                  // 545
  });                                                                                                                  // 538
});                                                                                                                    // 547
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 550
var gcSessions = function gcSessions() {                                                                               // 551
  var now = new Date().getTime();                                                                                      // 552
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 553
};                                                                                                                     // 554
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 556
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 558
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 563
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 565
    var proxy = proxiesByHostId[hostId];                                                                               // 566
    if (proxy) {                                                                                                       // 567
      return proxy;                                                                                                    // 568
    } else {                                                                                                           // 569
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 571
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 573
        var session = Sessions.findOne({ hostId: hostId });                                                            // 574
        if (!session) {                                                                                                // 575
          if (isAlreadyOpened) {                                                                                       // 576
            var _ret = function () {                                                                                   // 576
              var observer = void 0;                                                                                   // 577
              return {                                                                                                 // 578
                v: new Promise(function (resolve, reject) {                                                            // 578
                  var task = Meteor.setTimeout(function () {                                                           // 579
                    reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
                  }, SESSION_PROXY_TIMEOUT);                                                                           // 585
                  observer = Sessions.find({ hostId: hostId }).observe({                                               // 586
                    added: function added() {                                                                          // 587
                      Meteor.clearTimeout(task);                                                                       // 588
                      resolve(getProxyForHostId(hostId, false));                                                       // 589
                    }                                                                                                  // 590
                  });                                                                                                  // 586
                }).then(function (v) {                                                                                 // 592
                  observer.stop();                                                                                     // 593
                  return v;                                                                                            // 594
                }, function (e) {                                                                                      // 595
                  observer.stop();                                                                                     // 596
                  throw e;                                                                                             // 597
                })                                                                                                     // 598
              };                                                                                                       // 578
            }();                                                                                                       // 576
                                                                                                                       //
            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;               // 576
          } else {                                                                                                     // 599
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 601
          }                                                                                                            // 602
        }                                                                                                              // 603
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 605
        if (session.hashedToken) {                                                                                     // 606
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 607
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 610
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 611
          }                                                                                                            // 612
        }                                                                                                              // 613
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 615
        if (!grain) {                                                                                                  // 616
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 618
        }                                                                                                              // 619
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 626
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 630
          proxiesByHostId[hostId] = proxy;                                                                             // 631
        } else {                                                                                                       // 632
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 633
        }                                                                                                              // 634
                                                                                                                       //
        return proxy;                                                                                                  // 636
      });                                                                                                              // 637
    }                                                                                                                  // 638
  });                                                                                                                  // 639
};                                                                                                                     // 640
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 655
    var _this3 = this;                                                                                                 // 655
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 655
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 656
    this.newBucket = {};                                                                                               // 657
    this.oldBucket = {};                                                                                               // 658
    this.interval = Meteor.setInterval(function () {                                                                   // 659
      for (var oldHashedToken in _this3.oldBucket) {                                                                   // 660
        for (var oldHashedParams in _this3.oldBucket[oldHashedToken]) {                                                // 661
          var newProxy = _this3.newBucket[oldHashedToken] && _this3.newBucket[oldHashedToken][oldHashedParams];        // 662
          var oldProxy = _this3.oldBucket[oldHashedToken][oldHashedParams];                                            // 664
          if (oldProxy && !newProxy) {                                                                                 // 665
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 666
              // A client has an open websocket. Keep the proxy around.                                                //
              _this3.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 668
            } else {                                                                                                   // 669
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 671
            }                                                                                                          // 672
          }                                                                                                            // 673
        }                                                                                                              // 674
      }                                                                                                                // 675
                                                                                                                       //
      _this3.oldBucket = _this3.newBucket;                                                                             // 677
      _this3.newBucket = {};                                                                                           // 678
    }, intervalMillis);                                                                                                // 679
  }                                                                                                                    // 680
                                                                                                                       //
  ApiSessionProxies.prototype.get = function get(hashedToken, hashedParams) {                                          //
    if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                    // 683
      return this.newBucket[hashedToken][hashedParams];                                                                // 684
    } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                             // 685
      var proxy = this.oldBucket[hashedToken][hashedParams];                                                           // 686
      delete this.oldBucket[hashedToken][hashedParams];                                                                // 687
      this.put(hashedToken, hashedParams, proxy);                                                                      // 688
      return proxy;                                                                                                    // 689
    } else {                                                                                                           // 690
      return null;                                                                                                     // 691
    }                                                                                                                  // 692
  };                                                                                                                   // 693
                                                                                                                       //
  ApiSessionProxies.prototype.put = function put(hashedToken, hashedParams, proxy) {                                   //
    if (!this.newBucket[hashedToken]) {                                                                                // 696
      this.newBucket[hashedToken] = {};                                                                                // 697
    }                                                                                                                  // 698
                                                                                                                       //
    this.newBucket[hashedToken][hashedParams] = proxy;                                                                 // 700
  };                                                                                                                   // 701
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function removeProxiesOfToken(hashedToken) {                      //
    if (hashedToken in this.oldBucket) {                                                                               // 704
      for (var hashedParams in this.oldBucket[hashedToken]) {                                                          // 705
        this.oldBucket[hashedToken][hashedParams].close();                                                             // 706
      }                                                                                                                // 707
                                                                                                                       //
      delete this.oldBucket[hashedToken];                                                                              // 709
    }                                                                                                                  // 710
                                                                                                                       //
    if (hashedToken in this.newBucket) {                                                                               // 712
      for (var _hashedParams in this.newBucket[hashedToken]) {                                                         // 713
        this.newBucket[hashedToken][_hashedParams].close();                                                            // 714
      }                                                                                                                // 715
                                                                                                                       //
      delete this.newBucket[hashedToken];                                                                              // 717
    }                                                                                                                  // 718
  };                                                                                                                   // 719
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 722
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 724
  Grains.find().observe({                                                                                              // 725
    changed: function changed(newGrain, oldGrain) {                                                                    // 726
      if (oldGrain["private"] != newGrain["private"]) {                                                                // 727
        Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                          // 728
        ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                        // 729
          apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                        // 730
        });                                                                                                            // 731
      }                                                                                                                // 732
    }                                                                                                                  // 733
  });                                                                                                                  // 725
});                                                                                                                    // 735
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 737
  var params = {};                                                                                                     // 738
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 739
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 740
      return s.trim();                                                                                                 // 742
    });                                                                                                                // 742
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 746
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 750
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 751
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 754
      }                                                                                                                // 755
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 757
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 762
          return parseInt(x, 10);                                                                                      // 763
        }).reduce(function (a, b) {                                                                                    // 763
          return 256 * a + b;                                                                                          // 764
        });                                                                                                            // 764
        params.remoteAddress = {                                                                                       // 765
          lower64: v4Int,                                                                                              // 766
          upper64: 0                                                                                                   // 767
        };                                                                                                             // 765
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 769
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 773
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 776
          groups.shift();                                                                                              // 777
        }                                                                                                              // 778
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 780
          groups.pop();                                                                                                // 781
        }                                                                                                              // 782
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 784
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 787
          groups.pop();                                                                                                // 788
          var quad = lastGroup.split(".").map(function (x) {                                                           // 789
            return parseInt(x, 10);                                                                                    // 789
          });                                                                                                          // 789
          groups.push((quad[0] * 256 + quad[1]).toString(16));                                                         // 790
          groups.push((quad[2] * 256 + quad[3]).toString(16));                                                         // 791
        }                                                                                                              // 792
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 794
        var emptyGroupIndex = groups.indexOf("");                                                                      // 795
        var cleanGroups = void 0;                                                                                      // 796
        if (emptyGroupIndex !== -1) {                                                                                  // 797
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 798
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 800
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 801
            mid[i] = "0";                                                                                              // 802
          }                                                                                                            // 803
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 805
          cleanGroups = [].concat(head, mid, tail);                                                                    // 806
        } else {                                                                                                       // 807
          cleanGroups = groups;                                                                                        // 808
        }                                                                                                              // 809
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 811
          return parseInt(x, 16);                                                                                      // 811
        });                                                                                                            // 811
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 814
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 815
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 816
        };                                                                                                             // 814
      }                                                                                                                // 818
    }                                                                                                                  // 819
  }                                                                                                                    // 820
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 822
}                                                                                                                      // 823
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 826
  check(token, String);                                                                                                // 827
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 828
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 829
  var serializedParams = getApiSessionParams(request);                                                                 // 831
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 832
  return Promise.resolve(undefined).then(function () {                                                                 // 833
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 834
    if (proxy) {                                                                                                       // 835
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 836
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 837
      }                                                                                                                // 838
                                                                                                                       //
      return proxy;                                                                                                    // 840
    } else {                                                                                                           // 841
      return inMeteor(function () {                                                                                    // 842
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 843
        validateWebkey(tokenInfo);                                                                                     // 844
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 846
        if (!grain) {                                                                                                  // 847
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 849
        }                                                                                                              // 850
                                                                                                                       //
        var proxy = void 0;                                                                                            // 852
        if (tokenInfo.userInfo) {                                                                                      // 853
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 854
        } else {                                                                                                       // 855
          var identityId = null;                                                                                       // 856
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 857
            identityId = tokenInfo.identityId;                                                                         // 858
          }                                                                                                            // 859
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 861
          proxy.apiToken = tokenInfo;                                                                                  // 862
          proxy.apiSessionParams = serializedParams;                                                                   // 863
        }                                                                                                              // 864
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 866
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 868
        }                                                                                                              // 869
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 871
          proxy.expires = tokenInfo.expires;                                                                           // 872
        }                                                                                                              // 873
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 875
                                                                                                                       //
        return proxy;                                                                                                  // 877
      });                                                                                                              // 878
    }                                                                                                                  // 879
  });                                                                                                                  // 880
};                                                                                                                     // 881
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 883
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 891
    return true;                                                                                                       // 892
  }                                                                                                                    // 893
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 904
  return agent && agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                           // 905
};                                                                                                                     // 906
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 908
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 911
  var token = void 0;                                                                                                  // 912
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 913
    token = auth.slice(7).trim();                                                                                      // 914
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 915
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 917
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 918
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 921
    if (parts.length < 2) {                                                                                            // 922
      token = undefined;                                                                                               // 923
    } else {                                                                                                           // 924
      token = parts[1];                                                                                                // 925
      req.url = "/" + parts.slice(2).join("/");                                                                        // 926
      // remove .sandstorm-token/$TOKEN from path                                                                      //
    }                                                                                                                  // 928
  } else {                                                                                                             // 929
      token = undefined;                                                                                               // 930
    }                                                                                                                  // 931
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 933
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 935
      token = undefined;                                                                                               // 936
    }                                                                                                                  // 937
  }                                                                                                                    // 938
                                                                                                                       //
  return token;                                                                                                        // 940
};                                                                                                                     // 941
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 948
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 954
    var token = apiTokenForRequest(req, hostId);                                                                       // 955
    if (token) {                                                                                                       // 956
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 957
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 960
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 962
        return true;                                                                                                   // 963
      });                                                                                                              // 964
    } else {                                                                                                           // 965
      return Promise.resolve(false);                                                                                   // 966
    }                                                                                                                  // 967
  } else {                                                                                                             // 968
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 969
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 970
      if (proxy) {                                                                                                     // 971
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 973
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 974
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 975
        }                                                                                                              // 976
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 980
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 982
        return true;                                                                                                   // 983
      } else {                                                                                                         // 984
        return false;                                                                                                  // 985
      }                                                                                                                // 986
    });                                                                                                                // 987
  }                                                                                                                    // 988
};                                                                                                                     // 989
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 992
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 998
  if (hostIdHash) {                                                                                                    // 999
    var _ret2 = function () {                                                                                          // 999
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1002
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1004
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1021
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1022
          "Access-Control-Max-Age": "3600"                                                                             // 1023
        };                                                                                                             // 1021
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1027
        if (requestedHeaders) {                                                                                        // 1028
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1029
        }                                                                                                              // 1030
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1033
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1034
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1036
        }                                                                                                              // 1037
                                                                                                                       //
        for (header in accessControlHeaders) {                                                                         // 1039
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1040
        }                                                                                                              // 1041
      }                                                                                                                // 1042
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1044
        if (err instanceof Meteor.Error) {                                                                             // 1045
          console.log("error: " + err);                                                                                // 1046
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1047
        } else {                                                                                                       // 1048
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1049
        }                                                                                                              // 1050
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1052
      };                                                                                                               // 1053
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1055
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1056
        inMeteor(function () {                                                                                         // 1057
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1058
          check(keepaliveDuration, Match.Integer);                                                                     // 1059
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1060
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1061
        }).then(function () {                                                                                          // 1062
          res.writeHead(200, {});                                                                                      // 1063
          res.end();                                                                                                   // 1064
        }, errorHandler);                                                                                              // 1065
      } else if (token) {                                                                                              // 1066
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1067
          proxy.requestHandler(req, res);                                                                              // 1068
        }, errorHandler);                                                                                              // 1069
      } else {                                                                                                         // 1070
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1072
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1073
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1075
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1078
            if (dav.length > 0) {                                                                                      // 1079
              res.setHeader("DAV", dav.join(", "));                                                                    // 1080
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1081
            }                                                                                                          // 1082
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1084
            res.end();                                                                                                 // 1085
          } else {                                                                                                     // 1086
            var resources = (apiHost || {}).resources || {};                                                           // 1087
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1088
            if (path in resources) {                                                                                   // 1089
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1091
              console.log(path, resources, resource);                                                                  // 1092
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1093
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1094
              res.writeHead(200, {                                                                                     // 1095
                "Content-Type": resource.type                                                                          // 1096
              });                                                                                                      // 1095
              res.end(resource.body);                                                                                  // 1098
            } else {                                                                                                   // 1099
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1100
                res.writeHead(401, {                                                                                   // 1101
                  "Content-Type": "text/plain",                                                                        // 1102
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1103
                });                                                                                                    // 1101
              } else {                                                                                                 // 1105
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1107
              }                                                                                                        // 1108
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1114
          }                                                                                                            // 1115
        }).then(function () {}, errorHandler);                                                                         // 1116
      }                                                                                                                // 1117
                                                                                                                       //
      return {                                                                                                         // 1119
        v: Promise.resolve(true)                                                                                       // 1119
      };                                                                                                               // 1119
    }();                                                                                                               // 999
                                                                                                                       //
    if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                    // 999
  } else {                                                                                                             // 1120
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1121
                                                                                                                       //
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1124
      if (proxy) {                                                                                                     // 1125
        // Let's do some CSRF defense.                                                                                 //
        var expectedOrigin = PROTOCOL + "//" + req.headers.host;                                                       // 1127
        var mainUrl = process.env.ROOT_URL;                                                                            // 1128
        var origin = req.headers.origin;                                                                               // 1129
        var referer = req.headers.referer;                                                                             // 1130
        if (origin) {                                                                                                  // 1131
          // If an origin header was provided, then it must be accurate. Note that Chrome and                          //
          // Safari always send an Origin header on non-GET requests (even same-origin), and                           //
          // therefore on those browsers this rule will block all CSRF attacks. Unfortunately,                         //
          // a patch to add this behavior to Firefox has stalled:                                                      //
          //     https://bugzilla.mozilla.org/show_bug.cgi?id=446344                                                   //
          // I haven't found any information on IE/Edge's behavior.                                                    //
          if (origin !== expectedOrigin) {                                                                             // 1138
            throw new Meteor.Error(403, "Blocked illegal cross-origin request from: " + origin);                       // 1139
          }                                                                                                            // 1140
        } else if (referer) {                                                                                          // 1141
          // Mark that we've seed a Referer header on this host, which indicates that the user's                       //
          // browser is not suppressing them.                                                                          //
          proxy.seenReferer = true;                                                                                    // 1144
                                                                                                                       //
          // Deny requests coming from an external referer, since there is no legitimate use case                      //
          // for these. Note of course that an attacker can trivially suppress the referer header                      //
          // in practice, so this check alone does not give us any security benefit if we accept                       //
          // requests that lack a referer.                                                                             //
          if (referer != expectedOrigin && !referer.startsWith(expectedOrigin + "/") && referer != mainUrl && !referer.startsWith(mainUrl + "/")) {
            throw new Meteor.Error(403, "Blocked illegal cross-origin referral from: " + referer);                     // 1152
          }                                                                                                            // 1153
        } else {                                                                                                       // 1154
          // We saw neither an Origin nor a Referer header.                                                            //
          if (req.method !== "GET" && req.method !== "HEAD") {                                                         // 1156
            // This is possibly a side-effecting request, meaning we should worry about CSRF.                          //
            //                                                                                                         //
            // Note that we'll never get to this branch for Chrome or Safari since they would have                     //
            // sent an Origin header.                                                                                  //
                                                                                                                       //
            if (!proxy.wroteCsrfWarning) {                                                                             // 1162
              console.warn("Note: Observed session for which auto-CSRF-protection couldn't be applied.", "seenReferer:", !!proxy.seenReferer, "method:", req.method, "path:", req.url, "UA:", req.headers["user-agent"]);
              proxy.wroteCsrfWarning = true;                                                                           // 1167
            }                                                                                                          // 1168
          }                                                                                                            // 1169
        }                                                                                                              // 1170
                                                                                                                       //
        proxy.requestHandler(req, res);                                                                                // 1172
        return true;                                                                                                   // 1173
      } else {                                                                                                         // 1174
        return false;                                                                                                  // 1175
      }                                                                                                                // 1176
    });                                                                                                                // 1177
  }                                                                                                                    // 1178
};                                                                                                                     // 1179
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1188
    var _this4 = this;                                                                                                 // 1188
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1188
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1189
    this.ownerId = ownerId;                                                                                            // 1190
    this.identityId = identityId;                                                                                      // 1191
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1192
    this.sessionId = sessionId;                                                                                        // 1193
    this.tabId = tabId;                                                                                                // 1194
    this.isApi = isApi;                                                                                                // 1195
    this.hasLoaded = false;                                                                                            // 1196
    this.websockets = {};                                                                                              // 1197
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1198
    if (sessionId) {                                                                                                   // 1199
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1200
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1201
      this.hostId = hostId;                                                                                            // 1202
    } else {                                                                                                           // 1203
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1204
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1205
    }                                                                                                                  // 1206
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1208
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1209
      if (!identity) {                                                                                                 // 1210
        throw new Error("identity not found: " + this.identityId);                                                     // 1211
      }                                                                                                                // 1212
                                                                                                                       //
      // The identity cap becomes invalid if the user no longer has access to the grain.                               //
      var idCapRequirement = {                                                                                         // 1215
        permissionsHeld: { identityId: identity._id, grainId: this.grainId }                                           // 1216
      };                                                                                                               // 1215
                                                                                                                       //
      this.userInfo = {                                                                                                // 1219
        displayName: { defaultText: identity.profile.name },                                                           // 1220
        preferredHandle: identity.profile.handle,                                                                      // 1221
        identityId: new Buffer(identity._id, "hex"),                                                                   // 1222
        identity: makeIdentity(identity._id, [idCapRequirement])                                                       // 1223
      };                                                                                                               // 1219
      if (identity.profile.pictureUrl) {                                                                               // 1225
        this.userInfo.pictureUrl = identity.profile.pictureUrl;                                                        // 1226
      } else {                                                                                                         // 1227
        this.userInfo.pictureUrl = PROTOCOL + "//" + makeWildcardHost("static") + "/identicon/" + this.identityId.slice(0, 32) + "?s=128";
      }                                                                                                                // 1231
                                                                                                                       //
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1233
    } else {                                                                                                           // 1234
      this.userInfo = {                                                                                                // 1235
        displayName: { defaultText: "Anonymous User" },                                                                // 1236
        preferredHandle: "anonymous"                                                                                   // 1237
      };                                                                                                               // 1235
    }                                                                                                                  // 1239
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1241
      if (_this4.sessionId) {                                                                                          // 1242
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1244
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this4.sessionId) {                         // 1245
          _this4.doSessionInit(request, response, url.query.path);                                                     // 1246
          return;                                                                                                      // 1247
        }                                                                                                              // 1248
      }                                                                                                                // 1249
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1251
        var contentLength = request.headers["content-length"];                                                         // 1252
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this4.handleRequestStreaming(request, response, contentLength, 0);                                   // 1256
        } else {                                                                                                       // 1257
          return readAll(request).then(function (data) {                                                               // 1258
            return _this4.handleRequest(request, data, response, 0);                                                   // 1259
          });                                                                                                          // 1260
        }                                                                                                              // 1261
      })["catch"](function (err) {                                                                                     // 1262
        _this4.setHasLoaded();                                                                                         // 1263
                                                                                                                       //
        var body = err.stack;                                                                                          // 1265
        if (err.cppFile) {                                                                                             // 1266
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1267
        }                                                                                                              // 1268
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1270
          body += "\ntype: " + err.kjType;                                                                             // 1271
        }                                                                                                              // 1272
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1274
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1276
          response.end();                                                                                              // 1277
        } else {                                                                                                       // 1278
          if (err instanceof Meteor.Error) {                                                                           // 1279
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1280
          } else {                                                                                                     // 1281
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1282
          }                                                                                                            // 1283
                                                                                                                       //
          response.end(body);                                                                                          // 1285
        }                                                                                                              // 1286
      });                                                                                                              // 1287
    };                                                                                                                 // 1288
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1290
      _this4.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1291
        console.error("WebSocket setup failed:", err.stack);                                                           // 1292
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1294
      });                                                                                                              // 1295
    };                                                                                                                 // 1296
  }                                                                                                                    // 1297
                                                                                                                       //
  Proxy.prototype.close = function close() {                                                                           //
    for (var socketIdx in this.websockets) {                                                                           // 1300
      this.websockets[socketIdx].destroy();                                                                            // 1301
    };                                                                                                                 // 1302
                                                                                                                       //
    this.websockets = {};                                                                                              // 1304
                                                                                                                       //
    if (this.session) {                                                                                                // 1306
      this.session.close();                                                                                            // 1307
      delete this.session;                                                                                             // 1308
    }                                                                                                                  // 1309
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1311
      this.uiView.close();                                                                                             // 1312
      delete this.uiView;                                                                                              // 1313
    }                                                                                                                  // 1314
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1316
      this.supervisor.close();                                                                                         // 1317
      delete this.supervisor;                                                                                          // 1318
    }                                                                                                                  // 1319
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1321
      this.permissionsObserver.stop();                                                                                 // 1322
      delete this.permissionsObserver;                                                                                 // 1323
    }                                                                                                                  // 1324
  };                                                                                                                   // 1325
                                                                                                                       //
  Proxy.prototype.getConnection = function getConnection() {                                                           //
    if (!this.supervisor) {                                                                                            // 1328
      this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                           // 1329
      this.uiView = null;                                                                                              // 1330
    }                                                                                                                  // 1331
                                                                                                                       //
    if (!this.uiView) {                                                                                                // 1333
      this.uiView = this.supervisor.getMainView().view;                                                                // 1334
    }                                                                                                                  // 1335
  };                                                                                                                   // 1336
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function _callNewWebSession(request, userInfo) {                                //
    var params = Capnp.serialize(WebSession.Params, {                                                                  // 1339
      basePath: PROTOCOL + "//" + request.headers.host,                                                                // 1340
      userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",                 // 1341
      acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
        return s.trim();                                                                                               // 1345
      }) : ["en-US", "en"]                                                                                             // 1345
    });                                                                                                                // 1339
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
  };                                                                                                                   // 1351
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function _callNewApiSession(request, userInfo) {                                //
    var _this5 = this;                                                                                                 // 1353
                                                                                                                       //
    var serializedParams = this.apiSessionParams;                                                                      // 1354
    if (!serializedParams) {                                                                                           // 1355
      throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                   // 1356
    }                                                                                                                  // 1357
                                                                                                                       //
    // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                     //
    // calling newSession with an ApiSession._id.                                                                      //
    // Eventually we'll remove this logic once we're sure apps have updated.                                           //
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
      return session.session;                                                                                          // 1366
    }, function (err) {                                                                                                // 1367
      return _this5._callNewWebSession(request, userInfo);                                                             // 1368
    });                                                                                                                // 1369
  };                                                                                                                   // 1370
                                                                                                                       //
  Proxy.prototype._callNewSession = function _callNewSession(request, viewInfo) {                                      //
    var _this6 = this;                                                                                                 // 1372
                                                                                                                       //
    var userInfo = _.clone(this.userInfo);                                                                             // 1373
    var promise = inMeteor(function () {                                                                               // 1374
      var vertex = void 0;                                                                                             // 1375
      if (_this6.apiToken) {                                                                                           // 1376
        vertex = { token: _this6.apiToken };                                                                           // 1377
      } else {                                                                                                         // 1378
        // (this.identityId might be null; this is fine)                                                               //
        vertex = { grain: { _id: _this6.grainId, identityId: _this6.identityId } };                                    // 1380
      }                                                                                                                // 1381
                                                                                                                       //
      var onInvalidated = function onInvalidated() {                                                                   // 1383
        Sessions.remove({ _id: _this6.sessionId });                                                                    // 1384
      };                                                                                                               // 1385
                                                                                                                       //
      if (!_this6.sessionId) {                                                                                         // 1387
        onInvalidated = function onInvalidated() {                                                                     // 1388
          apiSessionProxies.removeProxiesOfToken(_this6.apiToken._id);                                                 // 1389
        };                                                                                                             // 1390
      }                                                                                                                // 1391
                                                                                                                       //
      var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);              // 1393
                                                                                                                       //
      if (_this6.permissionsObserver) _this6.permissionsObserver.stop();                                               // 1396
      _this6.permissionsObserver = permissions.observeHandle;                                                          // 1397
                                                                                                                       //
      if (!permissions.permissions) {                                                                                  // 1399
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 1400
      }                                                                                                                // 1401
                                                                                                                       //
      Sessions.update({                                                                                                // 1403
        _id: _this6.sessionId                                                                                          // 1404
      }, {                                                                                                             // 1403
        $set: {                                                                                                        // 1406
          viewInfo: viewInfo,                                                                                          // 1407
          permissions: permissions.permissions                                                                         // 1408
        }                                                                                                              // 1406
      });                                                                                                              // 1405
                                                                                                                       //
      return permissions.permissions;                                                                                  // 1412
    });                                                                                                                // 1413
                                                                                                                       //
    return promise.then(function (permissions) {                                                                       // 1415
      userInfo.permissions = permissions;                                                                              // 1416
                                                                                                                       //
      var numBytes = Math.ceil(permissions.length / 8);                                                                // 1418
      var buf = new Buffer(numBytes);                                                                                  // 1419
      for (var ii = 0; ii < numBytes; ++ii) {                                                                          // 1420
        buf[ii] = 0;                                                                                                   // 1421
      }                                                                                                                // 1422
                                                                                                                       //
      for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                             // 1424
        var byteNum = Math.floor(_ii / 8);                                                                             // 1425
        var bitNum = _ii % 8;                                                                                          // 1426
        if (permissions[_ii]) {                                                                                        // 1427
          buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                   // 1428
        }                                                                                                              // 1429
      }                                                                                                                // 1430
                                                                                                                       //
      userInfo.deprecatedPermissionsBlob = buf;                                                                        // 1432
                                                                                                                       //
      if (_this6.isApi) {                                                                                              // 1434
        return _this6._callNewApiSession(request, userInfo);                                                           // 1435
      } else {                                                                                                         // 1436
        return _this6._callNewWebSession(request, userInfo);                                                           // 1437
      }                                                                                                                // 1438
    });                                                                                                                // 1439
  };                                                                                                                   // 1440
                                                                                                                       //
  Proxy.prototype.getSession = function getSession(request) {                                                          //
    var _this7 = this;                                                                                                 // 1442
                                                                                                                       //
    if (!this.session) {                                                                                               // 1443
      this.getConnection(); // make sure we're connected                                                               // 1444
      var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                               // 1445
        return inMeteor(function () {                                                                                  // 1446
          // For now, we don't allow grains to set `appTitle` or `grainIcon`.                                          //
          var cachedViewInfo = _.omit(viewInfo, "appTitle", "grainIcon");                                              // 1448
          Grains.update(_this7.grainId, { $set: { cachedViewInfo: cachedViewInfo } });                                 // 1449
        }).then(function () {                                                                                          // 1450
          return _this7._callNewSession(request, viewInfo);                                                            // 1451
        });                                                                                                            // 1452
      }, function (error) {                                                                                            // 1453
        if (error.kjType === "failed" || error.kjType === "unimplemented") {                                           // 1454
          // Method not implemented.                                                                                   //
          // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                     //
          //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                     //
          //   to accept 'failed' here at least until the next API bump.                                               //
          return _this7._callNewSession(request, {});                                                                  // 1459
        } else {                                                                                                       // 1460
          return Promise.reject(error);                                                                                // 1461
        }                                                                                                              // 1462
      });                                                                                                              // 1463
      this.session = new Capnp.Capability(promise, WebSession);                                                        // 1464
    }                                                                                                                  // 1465
                                                                                                                       //
    return this.session;                                                                                               // 1467
  };                                                                                                                   // 1468
                                                                                                                       //
  Proxy.prototype.keepAlive = function keepAlive() {                                                                   //
    this.getConnection();                                                                                              // 1471
    return this.supervisor.keepAlive();                                                                                // 1472
  };                                                                                                                   // 1473
                                                                                                                       //
  Proxy.prototype.resetConnection = function resetConnection() {                                                       //
    if (this.session) {                                                                                                // 1476
      this.session.close();                                                                                            // 1477
      delete this.session;                                                                                             // 1478
    }                                                                                                                  // 1479
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1481
      this.uiView.close();                                                                                             // 1482
      delete this.uiView;                                                                                              // 1483
    }                                                                                                                  // 1484
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1486
      this.supervisor.close();                                                                                         // 1487
      delete this.supervisor;                                                                                          // 1488
    }                                                                                                                  // 1489
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1491
      this.permissionsObserver.stop();                                                                                 // 1492
      delete this.permissionsObserver;                                                                                 // 1493
    }                                                                                                                  // 1494
  };                                                                                                                   // 1495
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function maybeRetryAfterError(error, retryCount) {                            //
    var _this8 = this;                                                                                                 // 1497
                                                                                                                       //
    // If the error may be caused by the grain dying or a network failure, try to restart it,                          //
    // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                            //
    // `retryCount` should be incremented for every successful retry as part of the same request;                      //
    // we only want to retry once.                                                                                     //
    if (shouldRestartGrain(error, retryCount)) {                                                                       // 1502
      this.resetConnection();                                                                                          // 1503
      return inMeteor(function () {                                                                                    // 1504
        _this8.supervisor = globalBackend.continueGrain(_this8.grainId).supervisor;                                    // 1505
      });                                                                                                              // 1506
    } else {                                                                                                           // 1507
      throw error;                                                                                                     // 1508
    }                                                                                                                  // 1509
  };                                                                                                                   // 1510
                                                                                                                       //
  Proxy.prototype.doSessionInit = function doSessionInit(request, response, requestPath) {                             //
    // jscs:disable disallowQuotedKeysInObjects                                                                        //
    var path = requestPath || "/";                                                                                     // 1514
                                                                                                                       //
    // Check that the path is relative (ie. starts with a /).                                                          //
    // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                         //
    if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                           // 1518
      response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                              // 1519
      response.end("Invalid path supplied.");                                                                          // 1520
      return;                                                                                                          // 1521
    }                                                                                                                  // 1522
                                                                                                                       //
    // Set the session ID.                                                                                             //
    response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));     // 1525
                                                                                                                       //
    response.setHeader("Cache-Control", "no-cache, private");                                                          // 1527
                                                                                                                       //
    // Redirect to the app's root URL.                                                                                 //
    // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                  //
    //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                       //
    response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                             // 1532
    response.end();                                                                                                    // 1533
  };                                                                                                                   // 1534
                                                                                                                       //
  Proxy.prototype.makeContext = function makeContext(request, response, callback) {                                    //
    // Parses the cookies from the request, checks that the session ID is present and valid, then                      //
    // synchronously calls callback() passing it the request context object which contains the                         //
    // other cookies. Throws an exception if the session ID is missing or invalid. The callback                        //
    // must immediately use the context in an RPC. Once the callback returns, the context object                       //
    // will be torn down.                                                                                              //
    //                                                                                                                 //
    // `makeContext()` returns the result of `callback()`.                                                             //
                                                                                                                       //
    var context = {};                                                                                                  // 1545
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1547
      var parseResult = parseCookies(request);                                                                         // 1548
      if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                        // 1549
        throw new Meteor.Error(403, "Unauthorized");                                                                   // 1550
      }                                                                                                                // 1551
                                                                                                                       //
      if (parseResult.cookies.length > 0) {                                                                            // 1553
        context.cookies = parseResult.cookies;                                                                         // 1554
      }                                                                                                                // 1555
    } else {                                                                                                           // 1556
      // jscs:disable disallowEmptyBlocks                                                                              //
      // This is an API request. Cookies are not supported.                                                            //
    }                                                                                                                  // 1559
                                                                                                                       //
    context.accept = parseAcceptHeader(request);                                                                       // 1561
                                                                                                                       //
    context.eTagPrecondition = parsePreconditionHeader(request);                                                       // 1563
                                                                                                                       //
    context.additionalHeaders = [];                                                                                    // 1565
    for (var headerName in request.headers) {                                                                          // 1566
      if (REQUEST_HEADER_WHITELIST.matches(headerName)) {                                                              // 1567
        context.additionalHeaders.push({                                                                               // 1568
          name: headerName,                                                                                            // 1569
          value: request.headers[headerName]                                                                           // 1570
        });                                                                                                            // 1568
      }                                                                                                                // 1572
    }                                                                                                                  // 1573
                                                                                                                       //
    if (response) {                                                                                                    // 1575
      var promise = new Promise(function (resolve, reject) {                                                           // 1576
        response.resolveResponseStream = resolve;                                                                      // 1577
        response.rejectResponseStream = reject;                                                                        // 1578
      });                                                                                                              // 1579
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1581
                                                                                                                       //
      try {                                                                                                            // 1583
        return callback(context);                                                                                      // 1584
      } finally {                                                                                                      // 1585
        context.responseStream.close();                                                                                // 1586
      }                                                                                                                // 1587
    } else {                                                                                                           // 1588
      // WebSocket -- no response object.                                                                              //
      return callback(context);                                                                                        // 1590
    }                                                                                                                  // 1591
  };                                                                                                                   // 1592
                                                                                                                       //
  Proxy.prototype.translateResponse = function translateResponse(rpcResponse, response, request) {                     //
    if (this.hostId) {                                                                                                 // 1595
      if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                               // 1596
        response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                             // 1597
      }                                                                                                                // 1598
                                                                                                                       //
      var mainUrl = process.env.ROOT_URL;                                                                              // 1600
      var grainHost = PROTOCOL + "//" + request.headers.host;                                                          // 1601
      response.setHeader("Content-Security-Policy", "frame-ancestors " + mainUrl + " " + grainHost);                   // 1602
      response.setHeader("X-Frame-Options", "ALLOW-FROM " + mainUrl);                                                  // 1603
                                                                                                                       //
      // TODO(security): Add a Content-Security-Policy header which:                                                   //
      // (1) Prevents the app from initiating HTTP requests to third parties.                                          //
      // (2) Prevents the app from navigating the parent frame.                                                        //
      // (3) Prevents the app from opening popups.                                                                     //
      // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                         //
      //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                        //
    } else {                                                                                                           // 1611
        // This is an API request. Cookies are not supported.                                                          //
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                //
        response.setHeader("Vary", "Authorization");                                                                   // 1615
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                //
        response.setHeader("Access-Control-Allow-Origin", "*");                                                        // 1618
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 //
        // in a browser context. This policy should thoroughly neuter it.                                              //
        response.setHeader("Content-Security-Policy", "default-src 'none'; sandbox");                                  // 1622
      }                                                                                                                // 1623
                                                                                                                       //
    if (rpcResponse.additionalHeaders && rpcResponse.additionalHeaders.length > 0) {                                   // 1625
      // Add any additional prefixed/whitelisted headers to the response.                                              //
      // We cannot trust that the headers in the RPC response are actually                                             //
      // allowed, so we check if they are prefixed or whitelisted.                                                     //
      rpcResponse.additionalHeaders.forEach(function (header) {                                                        // 1629
        if (RESPONSE_HEADER_WHITELIST.matches(header.name)) {                                                          // 1630
          // If header is prefixed with appHeaderPrefix,                                                               //
          // or if the header name is in whitelist, set it.                                                            //
          response.setHeader(header.name, header.value);                                                               // 1633
        }                                                                                                              // 1634
      });                                                                                                              // 1635
    }                                                                                                                  // 1636
                                                                                                                       //
    // On first response, update the session to have hasLoaded=true                                                    //
    this.setHasLoaded();                                                                                               // 1639
                                                                                                                       //
    // TODO(security): Set X-Content-Type-Options: nosniff?                                                            //
                                                                                                                       //
    if ("content" in rpcResponse) {                                                                                    // 1643
      var content = rpcResponse.content;                                                                               // 1644
      var code = successCodes[content.statusCode];                                                                     // 1645
      if (!code) {                                                                                                     // 1646
        throw new Error("Unknown status code: ", content.statusCode);                                                  // 1647
      }                                                                                                                // 1648
                                                                                                                       //
      if (content.mimeType) {                                                                                          // 1650
        response.setHeader("Content-Type", content.mimeType);                                                          // 1651
      }                                                                                                                // 1652
                                                                                                                       //
      if (content.encoding) {                                                                                          // 1654
        response.setHeader("Content-Encoding", content.encoding);                                                      // 1655
      }                                                                                                                // 1656
                                                                                                                       //
      if (content.language) {                                                                                          // 1658
        response.setHeader("Content-Language", content.language);                                                      // 1659
      }                                                                                                                // 1660
                                                                                                                       //
      if (content.eTag) {                                                                                              // 1662
        response.setHeader("ETag", composeETag(content.eTag));                                                         // 1663
      }                                                                                                                // 1664
                                                                                                                       //
      if ("disposition" in content && "download" in content.disposition) {                                             // 1666
        response.setHeader("Content-Disposition", 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
      }                                                                                                                // 1669
                                                                                                                       //
      if ("stream" in content.body) {                                                                                  // 1671
        if (request.method === "HEAD") {                                                                               // 1672
          content.body.stream.close();                                                                                 // 1673
          response.rejectResponseStream(new Error("HEAD request; content doesn't matter."));                           // 1674
        } else {                                                                                                       // 1675
          var streamHandle = content.body.stream;                                                                      // 1676
          var responseStream = new Capnp.Capability(new ResponseStream(response, code.id, code.title, streamHandle), ByteStream);
          response.resolveResponseStream(responseStream);                                                              // 1680
          return { streamHandle: responseStream };                                                                     // 1681
        }                                                                                                              // 1682
      } else {                                                                                                         // 1683
        response.rejectResponseStream(new Error("Response content body was not a stream."));                           // 1684
                                                                                                                       //
        if ("bytes" in content.body) {                                                                                 // 1687
          response.setHeader("Content-Length", content.body.bytes.length);                                             // 1688
        } else {                                                                                                       // 1689
          throw new Error("Unknown content body type.");                                                               // 1690
        }                                                                                                              // 1691
      }                                                                                                                // 1692
                                                                                                                       //
      response.writeHead(code.id, code.title);                                                                         // 1694
                                                                                                                       //
      if ("bytes" in content.body && request.method !== "HEAD") {                                                      // 1696
        response.write(content.body.bytes);                                                                            // 1697
      }                                                                                                                // 1698
                                                                                                                       //
      response.end();                                                                                                  // 1700
    } else if ("noContent" in rpcResponse) {                                                                           // 1701
      var noContent = rpcResponse.noContent;                                                                           // 1702
      var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                        // 1703
      if (noContent.eTag) {                                                                                            // 1704
        response.setHeader("ETag", composeETag(noContent.eTag));                                                       // 1705
      }                                                                                                                // 1706
                                                                                                                       //
      response.writeHead(noContentCode.id, noContentCode.title);                                                       // 1708
      response.end();                                                                                                  // 1709
    } else if ("preconditionFailed" in rpcResponse) {                                                                  // 1710
      var preconditionFailed = rpcResponse.preconditionFailed;                                                         // 1711
      if (request.method === "GET" && "if-none-match" in request.headers) {                                            // 1712
        if (preconditionFailed.matchingETag) {                                                                         // 1713
          response.setHeader("ETag", composeETag(preconditionFailed.matchingETag));                                    // 1714
        }                                                                                                              // 1715
                                                                                                                       //
        response.writeHead(304, "Not Modified");                                                                       // 1717
      } else {                                                                                                         // 1718
        response.writeHead(412, "Precondition Failed");                                                                // 1719
      }                                                                                                                // 1720
                                                                                                                       //
      response.end();                                                                                                  // 1722
    } else if ("redirect" in rpcResponse) {                                                                            // 1723
      var redirect = rpcResponse.redirect;                                                                             // 1724
      var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                               // 1725
      response.writeHead(redirectCode.id, redirectCode.title, {                                                        // 1726
        "Location": redirect.location                                                                                  // 1727
      });                                                                                                              // 1726
      response.end();                                                                                                  // 1729
    } else if ("clientError" in rpcResponse) {                                                                         // 1730
      var clientError = rpcResponse.clientError;                                                                       // 1731
      var errorCode = errorCodes[clientError.statusCode];                                                              // 1732
      if (!errorCode) {                                                                                                // 1733
        throw new Error("Unknown status code: ", clientError.statusCode);                                              // 1734
      }                                                                                                                // 1735
                                                                                                                       //
      response.writeHead(errorCode.id, errorCode.title, {                                                              // 1737
        "Content-Type": "text/html"                                                                                    // 1738
      });                                                                                                              // 1737
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1741
        if (clientError.descriptionHtml) {                                                                             // 1742
          response.write(clientError.descriptionHtml);                                                                 // 1743
        } else {                                                                                                       // 1744
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>" + errorCode.id + ": " + errorCode.title + "</h1></body></html>");          // 1746
        }                                                                                                              // 1748
      }                                                                                                                // 1749
                                                                                                                       //
      response.end();                                                                                                  // 1751
    } else if ("serverError" in rpcResponse) {                                                                         // 1752
      response.writeHead(500, "Internal Server Error", {                                                               // 1753
        "Content-Type": "text/html"                                                                                    // 1754
      });                                                                                                              // 1753
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1757
        if (rpcResponse.serverError.descriptionHtml) {                                                                 // 1758
          response.write(rpcResponse.serverError.descriptionHtml);                                                     // 1759
        } else {                                                                                                       // 1760
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>500: Internal Server Error</h1></body></html>");                             // 1762
        }                                                                                                              // 1763
      }                                                                                                                // 1764
                                                                                                                       //
      response.end();                                                                                                  // 1766
    } else {                                                                                                           // 1767
      throw new Error("Unknown HTTP response type:\n" + JSON.stringify(rpcResponse));                                  // 1768
    }                                                                                                                  // 1769
                                                                                                                       //
    return {};                                                                                                         // 1771
  };                                                                                                                   // 1772
                                                                                                                       //
  Proxy.prototype.handleRequest = function handleRequest(request, data, response, retryCount) {                        //
    var _this9 = this;                                                                                                 // 1774
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1775
      return _this9.makeContext(request, response, function (context) {                                                // 1776
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1779
        var session = _this9.getSession(request);                                                                      // 1780
                                                                                                                       //
        var requestContent = function requestContent() {                                                               // 1782
          return {                                                                                                     // 1783
            content: data,                                                                                             // 1784
            encoding: request.headers["content-encoding"],                                                             // 1785
            mimeType: request.headers["content-type"]                                                                  // 1786
          };                                                                                                           // 1783
        };                                                                                                             // 1788
                                                                                                                       //
        var xmlContent = function xmlContent() {                                                                       // 1790
          var type = request.headers["content-type"] || "application/xml;charset=utf-8";                               // 1791
          var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                              // 1792
          if (!match) {                                                                                                // 1793
            response.writeHead(415, "Unsupported media type.", {                                                       // 1794
              "Content-Type": "text/plain"                                                                             // 1795
            });                                                                                                        // 1794
            response.end("expected XML request body");                                                                 // 1797
            throw new Error("expected XML request body");                                                              // 1798
          }                                                                                                            // 1799
                                                                                                                       //
          var charset = match[2] || "ISO-8859-1";                                                                      // 1801
                                                                                                                       //
          var encoding = request.headers["content-encoding"];                                                          // 1803
          if (encoding && encoding !== "identity") {                                                                   // 1804
            if (encoding !== "gzip") throw new Error("unknown Content-Encoding: " + encoding);                         // 1805
            data = gunzipSync(data);                                                                                   // 1806
          }                                                                                                            // 1807
                                                                                                                       //
          return data.toString(charset.toLowerCase() === "utf-8" ? "utf8" : "binary");                                 // 1809
        };                                                                                                             // 1810
                                                                                                                       //
        var propfindDepth = function propfindDepth() {                                                                 // 1812
          var depth = request.headers["depth"];                                                                        // 1813
          return depth === "0" ? "zero" : depth === "1" ? "one" : "infinity";                                          // 1814
        };                                                                                                             // 1817
                                                                                                                       //
        var shallow = function shallow() {                                                                             // 1819
          return request.headers["depth"] === "0";                                                                     // 1820
        };                                                                                                             // 1821
                                                                                                                       //
        var noOverwrite = function noOverwrite() {                                                                     // 1823
          return (request.headers["overwrite"] || "").toLowerCase() === "f";                                           // 1824
        };                                                                                                             // 1825
                                                                                                                       //
        var destination = function destination() {                                                                     // 1827
          var result = request.headers["destination"];                                                                 // 1828
          if (!result) throw new Error("missing destination");                                                         // 1829
          return Url.parse(result).path.slice(1); // remove leading '/'                                                // 1830
        };                                                                                                             // 1831
                                                                                                                       //
        if (request.method === "GET" || request.method === "HEAD") {                                                   // 1833
          return session.get(path, context, request.method === "HEAD");                                                // 1834
        } else if (request.method === "POST") {                                                                        // 1835
          return session.post(path, requestContent(), context);                                                        // 1836
        } else if (request.method === "PUT") {                                                                         // 1837
          return session.put(path, requestContent(), context);                                                         // 1838
        } else if (request.method === "PATCH") {                                                                       // 1839
          return session.patch(path, requestContent(), context);                                                       // 1840
        } else if (request.method === "DELETE") {                                                                      // 1841
          return session["delete"](path, context);                                                                     // 1842
        } else if (request.method === "PROPFIND") {                                                                    // 1843
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1844
        } else if (request.method === "PROPPATCH") {                                                                   // 1845
          return session.proppatch(path, xmlContent(), context);                                                       // 1846
        } else if (request.method === "MKCOL") {                                                                       // 1847
          return session.mkcol(path, requestContent(), context);                                                       // 1848
        } else if (request.method === "COPY") {                                                                        // 1849
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1850
        } else if (request.method === "MOVE") {                                                                        // 1851
          return session.move(path, destination(), noOverwrite(), context);                                            // 1852
        } else if (request.method === "LOCK") {                                                                        // 1853
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1854
        } else if (request.method === "UNLOCK") {                                                                      // 1855
          return session.unlock(path, request.headers["lock-token"], context);                                         // 1856
        } else if (request.method === "ACL") {                                                                         // 1857
          return session.acl(path, xmlContent(), context);                                                             // 1858
        } else if (request.method === "REPORT") {                                                                      // 1859
          return session.report(path, requestContent(), context);                                                      // 1860
        } else if (request.method === "OPTIONS") {                                                                     // 1861
          return session.options(path, context).then(function (options) {                                              // 1862
            var dav = [];                                                                                              // 1863
            if (options.davClass1) dav.push("1");                                                                      // 1864
            if (options.davClass2) dav.push("2");                                                                      // 1865
            if (options.davClass3) dav.push("3");                                                                      // 1866
            if (options.davExtensions) {                                                                               // 1867
              options.davExtensions.forEach(function (token) {                                                         // 1868
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1869
                  dav.push(token);                                                                                     // 1870
                }                                                                                                      // 1871
              });                                                                                                      // 1872
            }                                                                                                          // 1873
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1875
              response.setHeader("DAV", dav.join(", "));                                                               // 1876
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1877
            }                                                                                                          // 1878
                                                                                                                       //
            response.end();                                                                                            // 1880
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1882
            if (err.kjType !== "unimplemented") throw err;                                                             // 1883
            response.end();                                                                                            // 1884
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1886
        } else {                                                                                                       // 1887
            throw new Error("Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.");
          }                                                                                                            // 1889
      });                                                                                                              // 1890
    }).then(function (rpcResponse) {                                                                                   // 1891
      if (rpcResponse !== undefined) {                                                                                 // 1892
        // Will be undefined for OPTIONS request.                                                                      //
        return _this9.translateResponse(rpcResponse, response, request);                                               // 1893
      }                                                                                                                // 1894
    })["catch"](function (error) {                                                                                     // 1895
      return _this9.maybeRetryAfterError(error, retryCount).then(function () {                                         // 1896
        return _this9.handleRequest(request, data, response, retryCount + 1);                                          // 1897
      });                                                                                                              // 1898
    });                                                                                                                // 1899
  };                                                                                                                   // 1900
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function handleRequestStreaming(request, response, contentLength, retryCount) {
    var _this10 = this;                                                                                                // 1902
                                                                                                                       //
    return this.makeContext(request, response, function (context) {                                                    // 1903
      var path = request.url.slice(1); // remove leading '/'                                                           // 1904
      var session = _this10.getSession(request);                                                                       // 1905
                                                                                                                       //
      var mimeType = request.headers["content-type"] || "application/octet-stream";                                    // 1907
      var encoding = request.headers["content-encoding"];                                                              // 1908
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1910
      if (request.method === "POST") {                                                                                 // 1911
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1912
      } else if (request.method === "PUT") {                                                                           // 1913
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1914
      } else {                                                                                                         // 1915
        throw new Error("Sandstorm only supports streaming POST and PUT requests.");                                   // 1916
      }                                                                                                                // 1917
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1923
        var requestStream = requestStreamResult.stream;                                                                // 1924
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1927
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1930
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even                      //
        // while data is still being streamed up. This theoretically allows apps to perform                            //
        // bidirectional streaming, though probably very few actually do that.                                         //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that                      //
        // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                           //
        // variable.                                                                                                   //
        var responsePromise = requestStream.getResponse();                                                             // 1939
                                                                                                                       //
        var reportUploadStreamError = function reportUploadStreamError(err) {                                          // 1941
          // Called when an upload-stream method throws.                                                               //
                                                                                                                       //
          if (!uploadStreamError) {                                                                                    // 1944
            uploadStreamError = err;                                                                                   // 1945
                                                                                                                       //
            // If we're still waiting on any response stuff, cancel it.                                                //
            responsePromise.cancel();                                                                                  // 1948
            requestStream.close();                                                                                     // 1949
            if (downloadStreamHandle) {                                                                                // 1950
              downloadStreamHandle.close();                                                                            // 1951
            }                                                                                                          // 1952
          }                                                                                                            // 1953
        };                                                                                                             // 1954
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1957
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1958
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== "unimplemented") {                                                                      // 1960
              reportUploadStreamError(err);                                                                            // 1961
            }                                                                                                          // 1962
          });                                                                                                          // 1963
        }                                                                                                              // 1964
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        var writesInFlight = 0;                                                                                        // 1967
        var readingPaused = false;                                                                                     // 1968
        request.on("data", function (buf) {                                                                            // 1969
          // TODO(someday): Coalesce small writes.                                                                     //
          if (!uploadStreamError) {                                                                                    // 1971
            requestStream.write(buf).then(function () {                                                                // 1972
              writesInFlight--;                                                                                        // 1973
              if (readingPaused) {                                                                                     // 1974
                request.resume();                                                                                      // 1975
                readingPaused = false;                                                                                 // 1976
              }                                                                                                        // 1977
            })["catch"](reportUploadStreamError);                                                                      // 1978
                                                                                                                       //
            if (writesInFlight++ > 16) {                                                                               // 1980
              request.pause();                                                                                         // 1981
              readingPaused = true;                                                                                    // 1982
            }                                                                                                          // 1983
          }                                                                                                            // 1984
        });                                                                                                            // 1985
                                                                                                                       //
        request.on("end", function () {                                                                                // 1987
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1988
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1991
        });                                                                                                            // 1992
                                                                                                                       //
        request.on("close", function () {                                                                              // 1994
          reportUploadStreamError(new Error("HTTP connection unexpectedly closed during request."));                   // 1995
        });                                                                                                            // 1996
                                                                                                                       //
        request.on("error", function (err) {                                                                           // 1998
          reportUploadStreamError(err);                                                                                // 1999
        });                                                                                                            // 2000
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 2002
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 2004
          downloadStreamHandle = _this10.translateResponse(rpcResponse, response, request).streamHandle;               // 2005
        });                                                                                                            // 2006
      }, function (err) {                                                                                              // 2007
        if (err.kjType === "failed" && err.message.indexOf("not implemented") !== -1) {                                // 2008
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = "unimplemented";                                                                                // 2013
        }                                                                                                              // 2014
                                                                                                                       //
        if (shouldRestartGrain(err, 0)) {                                                                              // 2016
          // This is the kind of error that indicates we should retry. Note that we passed 0 for                       //
          // the retry count above because we were just checking if this is a retriable error (vs.                     //
          // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                    //
          // the proper retry count.                                                                                   //
          return _this10.maybeRetryAfterError(err, retryCount).then(function () {                                      // 2021
            return _this10.handleRequestStreaming(request, response, contentLength, retryCount + 1);                   // 2022
          });                                                                                                          // 2023
        } else if (err.kjType === "unimplemented") {                                                                   // 2024
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 2026
            return _this10.handleRequest(request, data, response, 0);                                                  // 2027
          });                                                                                                          // 2028
        } else {                                                                                                       // 2029
          throw err;                                                                                                   // 2030
        }                                                                                                              // 2031
      });                                                                                                              // 2032
    });                                                                                                                // 2033
  };                                                                                                                   // 2034
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function handleWebSocket(request, socket, head, retryCount) {                      //
    var _this11 = this;                                                                                                // 2036
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 2037
      return _this11.makeContext(request, undefined, function (context) {                                              // 2038
        var path = request.url.slice(1); // remove leading '/'                                                         // 2039
        var session = _this11.getSession(request);                                                                     // 2040
                                                                                                                       //
        if (!("sec-websocket-key" in request.headers)) {                                                               // 2042
          throw new Error("Missing Sec-WebSocket-Accept header.");                                                     // 2043
        }                                                                                                              // 2044
                                                                                                                       //
        var magic = request.headers["sec-websocket-key"] + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";                     // 2046
        var acceptKey = Crypto.createHash("sha1").update(magic).digest("base64");                                      // 2047
                                                                                                                       //
        var protocols = [];                                                                                            // 2049
        if ("sec-websocket-protocol" in request.headers) {                                                             // 2050
          protocols = request.headers["sec-websocket-protocol"].split(",").map(function (s) {                          // 2051
            return s.trim();                                                                                           // 2052
          });                                                                                                          // 2052
        }                                                                                                              // 2053
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 2055
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 2057
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 2059
          promise.serverStream.sendBytes(head);                                                                        // 2060
        }                                                                                                              // 2061
                                                                                                                       //
        var socketIdx = _this11.websocketCounter.toString();                                                           // 2063
        _this11.websockets[socketIdx] = socket;                                                                        // 2064
        _this11.websocketCounter += 1;                                                                                 // 2065
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 2066
          delete _this11.websockets[socketIdx];                                                                        // 2066
        });                                                                                                            // 2066
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 2068
          var headers = ["HTTP/1.1 101 Switching Protocols", "Upgrade: websocket", "Connection: Upgrade", "Sec-WebSocket-Accept: " + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2075
            headers.push("Sec-WebSocket-Protocol: " + response.protocol.join(", "));                                   // 2076
          }                                                                                                            // 2077
                                                                                                                       //
          headers.push("");                                                                                            // 2079
          headers.push("");                                                                                            // 2080
                                                                                                                       //
          socket.write(headers.join("\r\n"));                                                                          // 2082
          receiver.go();                                                                                               // 2083
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 2086
      });                                                                                                              // 2087
    })["catch"](function (error) {                                                                                     // 2088
      return _this11.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2089
        return _this11.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2090
      });                                                                                                              // 2091
    });                                                                                                                // 2092
  };                                                                                                                   // 2093
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function setHasLoaded() {                                                             //
    var _this12 = this;                                                                                                // 2095
                                                                                                                       //
    if (!this.hasLoaded) {                                                                                             // 2096
      (function () {                                                                                                   // 2096
        _this12.hasLoaded = true;                                                                                      // 2097
        var sessionId = _this12.sessionId;                                                                             // 2098
        inMeteor(function () {                                                                                         // 2099
          Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                          // 2100
        });                                                                                                            // 2101
      })();                                                                                                            // 2096
    }                                                                                                                  // 2102
  };                                                                                                                   // 2103
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2106
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2108
  if (Net.isIPv4(address)) {                                                                                           // 2109
    var quad = address.split(".").map(function (x) {                                                                   // 2110
      return parseInt(x, 10);                                                                                          // 2110
    });                                                                                                                // 2110
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2114
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === "::1" || address.lastIndexOf("fd", 0) === 0;                                                    // 2116
  } else {                                                                                                             // 2117
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2119
  }                                                                                                                    // 2120
};                                                                                                                     // 2121
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2123
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2124
  return num.toString();                                                                                               // 2128
};                                                                                                                     // 2129
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2134
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["cookie"];                                                                              // 2136
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2138
  if (header) {                                                                                                        // 2139
    var reqCookies = header.split(";");                                                                                // 2140
    for (var i in reqCookies) {                                                                                        // 2141
      var reqCookie = reqCookies[i];                                                                                   // 2142
      var equalsPos = reqCookie.indexOf("=");                                                                          // 2143
      var cookie = void 0;                                                                                             // 2144
      if (equalsPos === -1) {                                                                                          // 2145
        cookie = { key: reqCookie.trim(), value: "" };                                                                 // 2146
      } else {                                                                                                         // 2147
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2148
      }                                                                                                                // 2149
                                                                                                                       //
      if (cookie.key === "sandstorm-sid") {                                                                            // 2151
        if (result.sessionId) {                                                                                        // 2152
          throw new Error("Multiple sandstorm session IDs?");                                                          // 2153
        }                                                                                                              // 2154
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2156
      } else {                                                                                                         // 2157
        result.cookies.push(cookie);                                                                                   // 2158
      }                                                                                                                // 2159
    }                                                                                                                  // 2160
  }                                                                                                                    // 2161
                                                                                                                       //
  return result;                                                                                                       // 2163
};                                                                                                                     // 2164
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2166
  if (request.headers["if-match"]) {                                                                                   // 2167
    if (request.headers["if-match"].trim() === "*") {                                                                  // 2168
      return { exists: null };                                                                                         // 2169
    }                                                                                                                  // 2170
                                                                                                                       //
    var matches = parseETagList(request.headers["if-match"]);                                                          // 2172
    if (matches.length > 0) {                                                                                          // 2173
      return { matchesOneOf: matches };                                                                                // 2174
    }                                                                                                                  // 2175
  }                                                                                                                    // 2176
                                                                                                                       //
  if (request.headers["if-none-match"]) {                                                                              // 2178
    if (request.headers["if-none-match"].trim() === "*") {                                                             // 2179
      return { doesntExist: null };                                                                                    // 2180
    }                                                                                                                  // 2181
                                                                                                                       //
    var noneMatches = parseETagList(request.headers["if-none-match"]);                                                 // 2183
    if (noneMatches.length > 0) {                                                                                      // 2184
      return { matchesNoneOf: noneMatches };                                                                           // 2185
    }                                                                                                                  // 2186
  }                                                                                                                    // 2187
                                                                                                                       //
  return { none: null };                                                                                               // 2189
};                                                                                                                     // 2190
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2192
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2196
  var results = [];                                                                                                    // 2197
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2199
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2200
    if (!match) throw new Meteor.Error(400, "invalid etag");                                                           // 2201
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2203
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, "$1") });                                       // 2204
  }                                                                                                                    // 2205
                                                                                                                       //
  return results;                                                                                                      // 2207
};                                                                                                                     // 2208
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2210
  var result = '"' + (tag.value || "").replace(/([\\"])/g, "\\$1") + '"';                                              // 2211
  if (tag.weak) result = "W/" + result;                                                                                // 2212
  return result;                                                                                                       // 2213
};                                                                                                                     // 2214
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2216
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["accept"];                                                                              // 2218
                                                                                                                       //
  var result = [];                                                                                                     // 2220
  if (header) {                                                                                                        // 2221
    var acceptList = header.split(",");                                                                                // 2222
    for (var i in acceptList) {                                                                                        // 2223
      var acceptStr = acceptList[i];                                                                                   // 2224
      var tokensList = acceptStr.split(";");                                                                           // 2225
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2227
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2229
      for (var j in tokensListRest) {                                                                                  // 2230
        var token = tokensListRest[j];                                                                                 // 2231
        var equalsPos = token.indexOf("=");                                                                            // 2232
        if (equalsPos) {                                                                                               // 2233
          var key = token.slice(0, equalsPos).trim();                                                                  // 2234
          var value = token.slice(equalsPos + 1).trim();                                                               // 2235
                                                                                                                       //
          if (key === "q") {                                                                                           // 2237
            temp.qValue = +value;                                                                                      // 2238
          }                                                                                                            // 2239
        }                                                                                                              // 2240
      }                                                                                                                // 2241
                                                                                                                       //
      result.push(temp);                                                                                               // 2243
    }                                                                                                                  // 2244
  }                                                                                                                    // 2245
                                                                                                                       //
  return result;                                                                                                       // 2247
};                                                                                                                     // 2248
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2253
  return new Promise(function (resolve, reject) {                                                                      // 2254
    var buffers = [];                                                                                                  // 2255
    stream.on("data", function (buf) {                                                                                 // 2256
      buffers.push(buf);                                                                                               // 2257
    });                                                                                                                // 2258
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 2260
      resolve(Buffer.concat(buffers));                                                                                 // 2261
    });                                                                                                                // 2262
                                                                                                                       //
    stream.on("error", reject);                                                                                        // 2264
  });                                                                                                                  // 2265
};                                                                                                                     // 2266
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2268
  var result = [cookie.name, "=", cookie.value];                                                                       // 2269
                                                                                                                       //
  if ("absolute" in cookie.expires) {                                                                                  // 2271
    result.push("; Expires=");                                                                                         // 2272
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2273
  } else if ("relative" in cookie.expires) {                                                                           // 2274
    result.push("; Max-Age=" + cookie.expires.relative);                                                               // 2275
  }                                                                                                                    // 2276
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2278
    result.push("; Path=" + cookie.path);                                                                              // 2279
  }                                                                                                                    // 2280
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2282
    result.push("; HttpOnly");                                                                                         // 2283
  }                                                                                                                    // 2284
                                                                                                                       //
  return result.join("");                                                                                              // 2286
};                                                                                                                     // 2287
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2290
  ok: { id: 200, title: "OK" },                                                                                        // 2291
  created: { id: 201, title: "Created" },                                                                              // 2292
  accepted: { id: 202, title: "Accepted" },                                                                            // 2293
  multiStatus: { id: 207, title: "Multi-Status" }                                                                      // 2294
};                                                                                                                     // 2290
var noContentSuccessCodes = [                                                                                          // 2296
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: "No Content" }, { id: 205, title: "Reset Content" }];                                                // 2298
var redirectCodes = [                                                                                                  // 2301
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: "Temporary Redirect" }, { id: 308, title: "Permanent Redirect" }, { id: 303, title: "See Other" }, { id: 301, title: "Moved Permanently" }];
var errorCodes = {                                                                                                     // 2308
  badRequest: { id: 400, title: "Bad Request" },                                                                       // 2309
  forbidden: { id: 403, title: "Forbidden" },                                                                          // 2310
  notFound: { id: 404, title: "Not Found" },                                                                           // 2311
  methodNotAllowed: { id: 405, title: "Method Not Allowed" },                                                          // 2312
  notAcceptable: { id: 406, title: "Not Acceptable" },                                                                 // 2313
  conflict: { id: 409, title: "Conflict" },                                                                            // 2314
  gone: { id: 410, title: "Gone" },                                                                                    // 2315
  requestEntityTooLarge: { id: 413, title: "Request Entity Too Large" },                                               // 2316
  requestUriTooLong: { id: 414, title: "Request-URI Too Long" },                                                       // 2317
  unsupportedMediaType: { id: 415, title: "Unsupported Media Type" },                                                  // 2318
  imATeapot: { id: 418, title: "I'm a teapot" },                                                                       // 2319
  unprocessableEntity: { id: 422, title: "Unprocessable Entity" }                                                      // 2320
};                                                                                                                     // 2308
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2323
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle) {                                            // 2326
    var _this13 = this;                                                                                                // 2326
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2326
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2344
    this.httpCode = httpCode;                                                                                          // 2345
    this.httpStatus = httpStatus;                                                                                      // 2346
    this.upstreamHandle = upstreamHandle;                                                                              // 2347
                                                                                                                       //
    this.started = false;                                                                                              // 2349
    this.ended = false;                                                                                                // 2350
    this.waiting = [];                                                                                                 // 2351
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2353
      _this13.waiting.forEach(function (f) {                                                                           // 2354
        return f();                                                                                                    // 2354
      });                                                                                                              // 2354
      _this13.waiting = [];                                                                                            // 2355
    });                                                                                                                // 2356
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2358
      _this13.aborted = true;                                                                                          // 2359
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    //
      // an incomplete download is the client's problem, not the server's. The important thing is                      //
      // to cancel the stream if it is still being generated; to that end, the next new write()                        //
      // call after this point will throw.                                                                             //
      _this13.waiting.forEach(function (f) {                                                                           // 2365
        return f();                                                                                                    // 2365
      });                                                                                                              // 2365
      _this13.waiting = [];                                                                                            // 2366
                                                                                                                       //
      _this13.close();                                                                                                 // 2368
    });                                                                                                                // 2369
  }                                                                                                                    // 2370
                                                                                                                       //
  ResponseStream.prototype.expectSize = function expectSize(size) {                                                    // 2323
    if (!this.started) {                                                                                               // 2373
      this.started = true;                                                                                             // 2374
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                             // 2375
    }                                                                                                                  // 2376
  };                                                                                                                   // 2377
                                                                                                                       //
  ResponseStream.prototype.write = function write(data) {                                                              // 2323
    var _this14 = this;                                                                                                // 2379
                                                                                                                       //
    if (!this.started) {                                                                                               // 2380
      this.started = true;                                                                                             // 2381
      this.response.writeHead(this.httpCode, this.httpStatus);                                                         // 2382
    }                                                                                                                  // 2383
                                                                                                                       //
    if (this.aborted) {                                                                                                // 2385
      // Connection has been aborted.                                                                                  //
      if (this.alreadyThrew) {                                                                                         // 2387
        // We already threw an error from a previous write(). Do not throw more errors, because                        //
        // older versions of sandstorm-http-bridge do not stop on the first error and will print                       //
        // every error to the log, wasting space. Newer versions stop on the first failure.                            //
        return;                                                                                                        // 2391
      } else {                                                                                                         // 2392
        this.alreadyThrew = true;                                                                                      // 2393
        throw new Error("client disconnected");                                                                        // 2394
      }                                                                                                                // 2395
    } else {                                                                                                           // 2396
      if (this.response.write(data)) {                                                                                 // 2397
        // All written.                                                                                                //
        return;                                                                                                        // 2399
      } else {                                                                                                         // 2400
        // Write buffer is full. Don't complete until it has more space.                                               //
        return new Promise(function (resolve, reject) {                                                                // 2402
          _this14.waiting.push(resolve);                                                                               // 2403
        });                                                                                                            // 2404
      }                                                                                                                // 2405
    }                                                                                                                  // 2406
  };                                                                                                                   // 2407
                                                                                                                       //
  ResponseStream.prototype.done = function done() {                                                                    // 2323
    if (!this.started) {                                                                                               // 2410
      this.started = true;                                                                                             // 2411
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                                // 2412
    }                                                                                                                  // 2413
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2415
      this.ended = true;                                                                                               // 2416
      this.response.end();                                                                                             // 2417
    }                                                                                                                  // 2418
                                                                                                                       //
    this.close();                                                                                                      // 2420
  };                                                                                                                   // 2421
                                                                                                                       //
  ResponseStream.prototype.close = function close() {                                                                  // 2323
    if (this.upstreamHandle) {                                                                                         // 2424
      this.upstreamHandle.close();                                                                                     // 2425
    }                                                                                                                  // 2426
                                                                                                                       //
    // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                   //
    // the only case in which we can actually report the error is when we haven't done any writes                      //
    // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                           //
    // implies `!this.ended`.                                                                                          //
    if (!this.started) {                                                                                               // 2432
      this.started = true;                                                                                             // 2433
      this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });        // 2434
    }                                                                                                                  // 2436
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2438
      this.ended = true;                                                                                               // 2439
      this.response.end();                                                                                             // 2440
    }                                                                                                                  // 2441
  };                                                                                                                   // 2442
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function sendingDirectResponse() {                                  // 2323
    // For internal front-end use: Indicates that the caller is going to fill in the response                          //
    // instead. If a response has already been started, this throws an exception.                                      //
    //                                                                                                                 //
    // This is used in particular in pre-meteor.js, when dealing with static web publishing.                           //
                                                                                                                       //
    if (this.started) {                                                                                                // 2450
      throw new Error("can't sendDirectResponse() because response already started");                                  // 2451
      this.response.end();                                                                                             // 2452
    } else if (this.ended) {                                                                                           // 2453
      throw new Error("can't sendDirectResponse() because response already sent");                                     // 2454
    } else {                                                                                                           // 2455
      this.started = true;                                                                                             // 2456
      this.ended = true;                                                                                               // 2457
    }                                                                                                                  // 2458
  };                                                                                                                   // 2459
                                                                                                                       //
  return ResponseStream;                                                                                               // 2323
}();                                                                                                                   // 2323
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require("zlib");                                                                                        // 2463
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2464
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2469
  function WebSocketReceiver(socket) {                                                                                 // 2470
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2470
                                                                                                                       //
    this.socket = socket;                                                                                              // 2471
    this.queue = [];                                                                                                   // 2472
  }                                                                                                                    // 2473
                                                                                                                       //
  WebSocketReceiver.prototype.go = function go() {                                                                     // 2469
    for (var i in this.queue) {                                                                                        // 2476
      this.socket.write(this.queue[i]);                                                                                // 2477
    }                                                                                                                  // 2478
                                                                                                                       //
    this.queue = null;                                                                                                 // 2480
  };                                                                                                                   // 2481
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function sendBytes(message) {                                                // 2469
    // TODO(someday):  Flow control of some sort?                                                                      //
    if (this.queue === null) {                                                                                         // 2485
      this.socket.write(message);                                                                                      // 2486
    } else {                                                                                                           // 2487
      this.queue.push(message);                                                                                        // 2488
    }                                                                                                                  // 2489
  };                                                                                                                   // 2490
                                                                                                                       //
  WebSocketReceiver.prototype.close = function close() {                                                               // 2469
    this.socket.end();                                                                                                 // 2493
  };                                                                                                                   // 2494
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2469
}();                                                                                                                   // 2469
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2497
  var writesInFlight = 0;                                                                                              // 2498
  var readingPaused = false;                                                                                           // 2499
  socket.on("data", function (chunk) {                                                                                 // 2500
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2501
      writesInFlight--;                                                                                                // 2502
      if (readingPaused) {                                                                                             // 2503
        socket.resume();                                                                                               // 2504
        readingPaused = false;                                                                                         // 2505
      }                                                                                                                // 2506
    })["catch"](function (err) {                                                                                       // 2507
      if (err.kjType !== "disconnected") {                                                                             // 2508
        console.error("WebSocket sendBytes failed: " + err.stack);                                                     // 2509
      }                                                                                                                // 2510
                                                                                                                       //
      socket.destroy();                                                                                                // 2512
    });                                                                                                                // 2513
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2515
      socket.pause();                                                                                                  // 2516
      readingPaused = true;                                                                                            // 2517
    }                                                                                                                  // 2518
  });                                                                                                                  // 2519
                                                                                                                       //
  socket.on("end", function (chunk) {                                                                                  // 2521
    rpcStream.close();                                                                                                 // 2522
  });                                                                                                                  // 2523
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2525
    destructor();                                                                                                      // 2526
  });                                                                                                                  // 2527
};                                                                                                                     // 2528
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish("grainLog", function (grainId) {                                                                        // 2533
  var _this15 = this;                                                                                                  // 2533
                                                                                                                       //
  check(grainId, String);                                                                                              // 2534
  var id = 0;                                                                                                          // 2535
  var grain = Grains.findOne(grainId);                                                                                 // 2536
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2537
    this.added("grainLog", id++, { text: "Only the grain owner can view the debug log." });                            // 2538
    this.ready();                                                                                                      // 2539
    return;                                                                                                            // 2540
  }                                                                                                                    // 2541
                                                                                                                       //
  var connected = false;                                                                                               // 2543
  var _this = this;                                                                                                    // 2544
                                                                                                                       //
  var receiver = {                                                                                                     // 2546
    write: function write(data) {                                                                                      // 2547
      connected = true;                                                                                                // 2548
      _this.added("grainLog", id++, { text: data.toString("utf8") });                                                  // 2549
    },                                                                                                                 // 2550
    close: function close() {                                                                                          // 2552
      if (connected) {                                                                                                 // 2553
        _this.added("grainLog", id++, {                                                                                // 2554
          text: "*** lost connection to grain (probably because it shut down) ***"                                     // 2555
        });                                                                                                            // 2554
      }                                                                                                                // 2557
    }                                                                                                                  // 2558
  };                                                                                                                   // 2546
                                                                                                                       //
  try {                                                                                                                // 2561
    (function () {                                                                                                     // 2561
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2562
        return supervisor.watchLog(8192, receiver);                                                                    // 2563
      })).handle;                                                                                                      // 2564
      connected = true;                                                                                                // 2565
      _this15.onStop(function () {                                                                                     // 2566
        handle.close();                                                                                                // 2567
      });                                                                                                              // 2568
    })();                                                                                                              // 2561
  } catch (err) {                                                                                                      // 2569
    if (!connected) {                                                                                                  // 2570
      this.added("grainLog", id++, {                                                                                   // 2571
        text: "*** couldn't connect to grain (" + err + ") ***"                                                        // 2572
      });                                                                                                              // 2571
    }                                                                                                                  // 2574
  }                                                                                                                    // 2575
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2578
});                                                                                                                    // 2579
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 28
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 34
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 36
  var responseCallback = function responseCallback(res) {                                                              // 37
    if (res.statusCode === 200) {                                                                                      // 38
      console.log("Successfully updated sandcats IP");                                                                 // 39
    } else {                                                                                                           // 40
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 41
    }                                                                                                                  // 42
  };                                                                                                                   // 43
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 45
    console.error("Couldn't send update sandcats hostname", err);                                                      // 46
  };                                                                                                                   // 47
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 51
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 53
  var socket = dgram.createSocket("udp4");                                                                             // 54
  var secret = Random.secret(16);                                                                                      // 55
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 57
  socket.on("message", function (buf) {                                                                                // 58
    if (buf.toString() === secret) {                                                                                   // 59
      updateSandcatsIp();                                                                                              // 60
    } else {                                                                                                           // 61
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 62
    }                                                                                                                  // 63
  });                                                                                                                  // 64
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 66
    if (err) {                                                                                                         // 67
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 68
    }                                                                                                                  // 69
  });                                                                                                                  // 70
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 72
    socket.close();                                                                                                    // 73
  }, 10 * 1000);                                                                                                       // 74
};                                                                                                                     // 75
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 78
    hostname: hostname,                                                                                                // 79
    path: path,                                                                                                        // 80
    method: "POST",                                                                                                    // 81
    agent: false,                                                                                                      // 82
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 83
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 84
    headers: {                                                                                                         // 85
      "X-Sand": "cats",                                                                                                // 86
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 87
    }                                                                                                                  // 85
  };                                                                                                                   // 78
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 91
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 95
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 97
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 98
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 103
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 105
  req.write(newPostData);                                                                                              // 106
  req.end();                                                                                                           // 107
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 109
    req.on("error", errorCallback);                                                                                    // 110
  }                                                                                                                    // 111
                                                                                                                       //
  return req;                                                                                                          // 113
};                                                                                                                     // 114
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 116
  check(commonName, String);                                                                                           // 117
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 122
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 126
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = pki.createCertificationRequest();                                                                          // 129
  csr.publicKey = keys.publicKey;                                                                                      // 130
  csr.setSubject([{                                                                                                    // 131
    name: "commonName",                                                                                                // 133
    value: commonName,                                                                                                 // 134
    valueTagClass: asn1.Type.UTF8                                                                                      // 135
  }]);                                                                                                                 // 132
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 141
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 142
  return {                                                                                                             // 143
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 144
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 145
  };                                                                                                                   // 143
};                                                                                                                     // 147
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 149
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 156
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 157
  var csrFilename = keyFilename + ".csr";                                                                              // 158
  var responseFilename = keyFilename + ".response-json";                                                               // 159
  var withWildcard = "*." + hostname;                                                                                  // 160
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 161
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 162
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 164
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 169
    csrFilename: csrFilename,                                                                                          // 170
    keyFilename: keyFilename,                                                                                          // 171
    responseFilename: responseFilename                                                                                 // 172
  };                                                                                                                   // 169
};                                                                                                                     // 174
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 176
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 177
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 178
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 179
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 180
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 182
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 183
    };                                                                                                                 // 184
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 186
      if (res.statusCode == 200) {                                                                                     // 187
        (function () {                                                                                                 // 187
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 190
          res.on("data", function (chunk) {                                                                            // 191
            responseBody += chunk;                                                                                     // 192
          });                                                                                                          // 193
                                                                                                                       //
          res.on("end", function () {                                                                                  // 195
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 198
              JSON.parse(responseBody);                                                                                // 199
            } catch (e) {                                                                                              // 200
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 207
            }                                                                                                          // 208
                                                                                                                       //
            try {                                                                                                      // 210
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 211
            } catch (err) {                                                                                            // 212
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 217
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 221
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 223
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 225
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 227
            }                                                                                                          // 229
          });                                                                                                          // 230
        })();                                                                                                          // 187
      } else {                                                                                                         // 231
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 232
        res.on("data", function (chunk) {                                                                              // 234
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 235
        });                                                                                                            // 236
      }                                                                                                                // 237
    };                                                                                                                 // 238
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 240
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 242
      rawHostname: SANDCATS_NAME,                                                                                      // 243
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 244
    }, errorCallback, responseCallback);                                                                               // 242
  };                                                                                                                   // 246
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 248
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 249
    return renewHttpsCertificate();                                                                                    // 250
  }                                                                                                                    // 251
};                                                                                                                     // 252
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 254
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 255
  if (i < 0) {                                                                                                         // 256
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 259
    var oneMinute = 60 * 1000;                                                                                         // 260
    var oneHour = 60 * oneMinute;                                                                                      // 261
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 262
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 264
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 265
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 267
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 269
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 273
    }                                                                                                                  // 275
  }                                                                                                                    // 276
};                                                                                                                     // 277
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 279
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 280
};                                                                                                                     // 281
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":["/imports/server/async-helpers.js","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});var staticAssetHost;module.import("/imports/server/constants.js",{"staticAssetHost":function(v){staticAssetHost=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
                                                                                                                       // 36
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 38
Meteor.startup(function () {                                                                                           // 39
  var frameSetter = function frameSetter() {                                                                           // 40
    BrowserPolicy.content.disallowFrame(); // This clears all the old rules                                            // 41
    BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                       // 42
    var billingPromptUrl = globalDb.getBillingPromptUrl();                                                             // 43
    if (billingPromptUrl) {                                                                                            // 44
      BrowserPolicy.content.allowFrameOrigin(billingPromptUrl);                                                        // 45
    }                                                                                                                  // 46
  };                                                                                                                   // 47
                                                                                                                       //
  frameSetter(); // Call once on startup                                                                               // 49
  globalDb.collections.settings.find({ _id: "billingPromptUrl" }).observe({                                            // 50
    added: frameSetter,                                                                                                // 51
    changed: frameSetter,                                                                                              // 52
    removed: frameSetter                                                                                               // 53
  });                                                                                                                  // 50
});                                                                                                                    // 55
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
                                                                                                                       // 58
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 59
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 60
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 61
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 62
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 64
  var _this = this;                                                                                                    // 64
                                                                                                                       //
  if (this.userId) {                                                                                                   // 65
    if (globalDb.isQuotaEnabled()) {                                                                                   // 66
      (function () {                                                                                                   // 66
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 71
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 72
          inMeteor(function () {                                                                                       // 73
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 74
          });                                                                                                          // 75
        })["catch"](function (err) {                                                                                   // 76
          if (err.kjType === "unimplemented") {                                                                        // 77
            // Compute based on sum of grain sizes instead.                                                            //
            var total = 0;                                                                                             // 79
            Grains.find({ userId: userId }, { fields: { size: 1 } }).forEach(function (grain) {                        // 80
              return total += grain.size || 0;                                                                         // 81
            });                                                                                                        // 81
            Meteor.users.update(userId, { $set: { storageUsage: total } });                                            // 82
          } else {                                                                                                     // 83
            console.error(err.stack);                                                                                  // 84
          }                                                                                                            // 85
        });                                                                                                            // 86
      })();                                                                                                            // 66
    }                                                                                                                  // 87
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 89
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 95
    return [];                                                                                                         // 96
  }                                                                                                                    // 97
});                                                                                                                    // 98
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 100
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 104
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 105
});                                                                                                                    // 106
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 108
  return DevPackages.find();                                                                                           // 109
});                                                                                                                    // 110
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 112
  var _this2 = this;                                                                                                   // 112
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 116
  if (cursor.count() > 0) {                                                                                            // 117
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 118
  } else {                                                                                                             // 119
    (function () {                                                                                                     // 119
      var handle = cursor.observeChanges({                                                                             // 120
        added: function added(id) {                                                                                    // 121
          _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                    // 122
          handle.stop();                                                                                               // 123
          handle = null;                                                                                               // 124
        }                                                                                                              // 125
      });                                                                                                              // 120
      _this2.onStop(function () {                                                                                      // 127
        if (handle) handle.stop();                                                                                     // 128
      });                                                                                                              // 129
    })();                                                                                                              // 119
  }                                                                                                                    // 130
                                                                                                                       //
  this.ready();                                                                                                        // 132
});                                                                                                                    // 133
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 135
  var _this3 = this;                                                                                                   // 135
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 144
    return [];                                                                                                         // 145
  }                                                                                                                    // 146
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 154
    referredBy: this.userId,                                                                                           // 155
    "profile.name": { $exists: true }                                                                                  // 156
  }, {                                                                                                                 // 154
    fields: {                                                                                                          // 158
      _id: 1,                                                                                                          // 159
      referredBy: 1,                                                                                                   // 160
      "profile.name": 1                                                                                                // 161
    }                                                                                                                  // 158
  });                                                                                                                  // 157
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 164
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function added(id, fields) {                                                                                // 166
      _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                               // 167
    },                                                                                                                 // 168
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function removed(id) {                                                                                    // 171
      _this3.removed("referralInfo", id);                                                                              // 172
    },                                                                                                                 // 173
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function modified(id, fields) {                                                                          // 175
      _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                            // 176
    }                                                                                                                  // 177
  });                                                                                                                  // 164
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 188
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 189
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 190
      stopWatchingIdentity(identityId);                                                                                // 191
    });                                                                                                                // 192
  };                                                                                                                   // 193
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 195
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 196
    if (handleForProfileName) {                                                                                        // 197
      _this3.removed("referralInfo", identityId);                                                                      // 198
      handleForProfileName.stop();                                                                                     // 199
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 201
    }                                                                                                                  // 202
  };                                                                                                                   // 203
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 205
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 206
    if (handleForProfileName) {                                                                                        // 207
      return;                                                                                                          // 208
    }                                                                                                                  // 209
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 211
      _id: identityId                                                                                                  // 212
    }, {                                                                                                               // 211
      fields: {                                                                                                        // 214
        "profile.name": 1                                                                                              // 215
      }                                                                                                                // 214
    }).observeChanges({                                                                                                // 213
      added: function added(id, fields) {                                                                              // 218
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                              // 219
      },                                                                                                               // 220
                                                                                                                       //
      changed: function changed(id, fields) {                                                                          // 222
        _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                            // 223
      },                                                                                                               // 224
                                                                                                                       //
      removed: function removed(id) {                                                                                  // 226
        stopWatchingIdentity(id);                                                                                      // 227
      }                                                                                                                // 228
    });                                                                                                                // 217
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 231
  };                                                                                                                   // 232
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 234
    _id: this.userId,                                                                                                  // 235
    referredIdentityIds: { $exists: true }                                                                             // 236
  }, {                                                                                                                 // 234
    fields: {                                                                                                          // 238
      referredIdentityIds: true                                                                                        // 239
    }                                                                                                                  // 238
  }).observeChanges({                                                                                                  // 237
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function added(id, fields) {                                                                                // 243
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 244
        // Unconditionally mark these as successful referrals and start watching.                                      //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 246
      }                                                                                                                // 248
    },                                                                                                                 // 249
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function changed(id, fields) {                                                                            // 252
      // Two major tasks.                                                                                              //
      //                                                                                                               //
      // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                             //
      //                                                                                                               //
      // 2. Look for identityIds to subscribe to.                                                                      //
                                                                                                                       //
      // Task 1. Unsubscribe where needed.                                                                             //
      var referredIdentityIdsAsObject = {};                                                                            // 260
      fields.referredIdentityIds.forEach(function (i) {                                                                // 261
        referredIdentityIdsAsObject[i] = true;                                                                         // 261
      });                                                                                                              // 261
                                                                                                                       //
      Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                    // 263
        // If the handle doesn't show up in the new list of referredIdentityIds, then remove                           //
        // info from the client & stop it on the server & make it null.                                                //
        var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                       // 266
        if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                  // 267
          stopWatchingIdentity(identityId);                                                                            // 268
        }                                                                                                              // 269
      });                                                                                                              // 270
                                                                                                                       //
      // Task 2. Subscribe where needed.                                                                               //
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 273
        // The watch... function will avoid double-creating subscriptions, so this is safe.                            //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 275
      }                                                                                                                // 276
    },                                                                                                                 // 277
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function removed() {                                                                                      // 279
      // Remove all data from client; stop all handles.                                                                //
      stopWatchingAllIdentities();                                                                                     // 281
    }                                                                                                                  // 282
  });                                                                                                                  // 241
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 286
    stopWatchingAllIdentities();                                                                                       // 287
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 288
    completedIdentityIdsHandle.stop();                                                                                 // 289
  });                                                                                                                  // 290
                                                                                                                       //
  this.ready();                                                                                                        // 292
});                                                                                                                    // 293
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 295
  var _this4 = this;                                                                                                   // 295
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 296
  var anonCount = 0;                                                                                                   // 297
  var counter = 0;                                                                                                     // 298
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 300
    name = name.trim();                                                                                                // 301
    if (name === "") {                                                                                                 // 302
      ++anonCount;                                                                                                     // 303
    } else {                                                                                                           // 304
      _this4.added("backers", counter++, { name: name });                                                              // 305
    }                                                                                                                  // 306
  });                                                                                                                  // 307
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 310
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 312
                                                                                                                       //
  this.ready();                                                                                                        // 314
});                                                                                                                    // 315
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function useSignupKey(key) {                                                                           // 26
    check(key, String);                                                                                                // 27
                                                                                                                       //
    if (!this.userId) {                                                                                                // 29
      throw new Meteor.Error(403, "Must be signed in.");                                                               // 30
    }                                                                                                                  // 31
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 33
    if (user.signupKey) {                                                                                              // 34
      // Don't waste it.                                                                                               //
      return;                                                                                                          // 36
    }                                                                                                                  // 37
                                                                                                                       //
    if (isDemoUser()) {                                                                                                // 39
      throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");             // 40
    }                                                                                                                  // 42
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 44
      // Don't consume signup key as identity user.                                                                    //
      return;                                                                                                          // 46
    }                                                                                                                  // 47
                                                                                                                       //
    var keyInfo = SignupKeys.findOne(key);                                                                             // 49
    if (!keyInfo || keyInfo.used) {                                                                                    // 50
      throw new Meteor.Error(403, "Invalid key or already used.");                                                     // 51
    }                                                                                                                  // 52
                                                                                                                       //
    if (isSignedUp() && user.payments && user.payments.id) {                                                           // 54
      // This user is already signed up with a payment account. Possibly, they signed up before                        //
      // using their invite, and then went back and clicked on the invite. As a result they                            //
      // probably now have two payment accounts. Mark this invite as used but also add a special                       //
      // flag so we can find it later and cancel the dupe payment account. Record who tried to                         //
      // use it so that we can transfer credits over if needed.                                                        //
      SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                       // 60
      return;                                                                                                          // 61
    }                                                                                                                  // 62
                                                                                                                       //
    var userFields = {                                                                                                 // 64
      signupKey: key,                                                                                                  // 65
      signupNote: keyInfo.note                                                                                         // 66
    };                                                                                                                 // 64
    if (keyInfo.email) {                                                                                               // 68
      userFields.signupEmail = keyInfo.email;                                                                          // 69
    }                                                                                                                  // 70
                                                                                                                       //
    if ("quota" in keyInfo) {                                                                                          // 72
      userFields.quota = keyInfo.quota;                                                                                // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (keyInfo.plan) {                                                                                                // 76
      userFields.plan = keyInfo.plan;                                                                                  // 77
    }                                                                                                                  // 78
                                                                                                                       //
    if (keyInfo.payments) {                                                                                            // 80
      userFields["payments.id"] = keyInfo.payments.id;                                                                 // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Meteor.users.update(this.userId, { $set: userFields });                                                            // 84
    SignupKeys.update(key, { $set: { used: true } });                                                                  // 85
  }                                                                                                                    // 86
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    // If the only thing that happened is some trailing slashes got removed, then don't reset OAuth                    //
    // providers.                                                                                                      //
    var resetOAuth = true;                                                                                             // 31
    if (baseUrlRow.value.replace(/[/]*$/, "") === ROOT_URL) {                                                          // 32
      console.log("Not resetting OAuth because old ROOT_URL and new ROOT_URL differ only by trailing slashes.");       // 33
      resetOAuth = false;                                                                                              // 34
    }                                                                                                                  // 35
                                                                                                                       //
    if (resetOAuth) {                                                                                                  // 37
      console.log("resetting oauth");                                                                                  // 38
      Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                               // 39
        if (!!setting.value) {                                                                                         // 40
          Settings.update({ _id: setting._id }, { $set: { value: false,                                                // 41
              automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                       // 43
        }                                                                                                              // 44
      });                                                                                                              // 45
    }                                                                                                                  // 46
                                                                                                                       //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 48
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 49
  }                                                                                                                    // 50
});                                                                                                                    // 51
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 19
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 21
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 24
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 26
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 28
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 29
};                                                                                                                     // 30
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 32
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 34
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 38
    expires: { $exists: false },                                                                                       // 39
    loginIdentities: { $exists: true },                                                                                // 40
    lastActive: timeConstraint                                                                                         // 41
  }).count();                                                                                                          // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 46
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 52
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 54
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 59
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 62
    $group: {                                                                                                          // 65
      _id: "$appId",                                                                                                   // 66
      grains: { $sum: 1 },                                                                                             // 67
      userIds: { $addToSet: "$userId" }                                                                                // 68
    }                                                                                                                  // 65
  }, {                                                                                                                 // 64
    $project: {                                                                                                        // 72
      grains: 1,                                                                                                       // 73
      owners: { $size: "$userIds" }                                                                                    // 74
    }                                                                                                                  // 72
  }]);                                                                                                                 // 71
  apps = _.indexBy(apps, "_id");                                                                                       // 78
                                                                                                                       //
  for (var appId in apps) {                                                                                            // 80
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 90
    delete app._id;                                                                                                    // 91
    var grains = Grains.find({                                                                                         // 92
      lastUsed: timeConstraint,                                                                                        // 93
      appId: appId                                                                                                     // 94
    }, {                                                                                                               // 92
      fields: { _id: 1 }                                                                                               // 96
    }).fetch();                                                                                                        // 95
    var grainIds = _.pluck(grains, "_id");                                                                             // 98
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 100
      $match: {                                                                                                        // 102
        "owner.user": { $exists: true },                                                                               // 103
        lastUsed: timeConstraint,                                                                                      // 104
        grainId: { $in: grainIds }                                                                                     // 105
      }                                                                                                                // 102
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 101
      $group: {                                                                                                        // 110
        _id: "count",                                                                                                  // 111
        count: { $sum: 1 }                                                                                             // 112
      }                                                                                                                // 110
    }]);                                                                                                               // 109
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 117
      if (counts.length !== 1) {                                                                                       // 118
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 119
      }                                                                                                                // 120
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 122
    }                                                                                                                  // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 127
    $match: {                                                                                                          // 129
      lastActive: timeConstraint,                                                                                      // 130
      appId: { $exists: true }                                                                                         // 131
    }                                                                                                                  // 129
  }, {                                                                                                                 // 128
    $group: {                                                                                                          // 135
      _id: {                                                                                                           // 136
        appId: "$appId",                                                                                               // 137
        type: "$type"                                                                                                  // 138
      },                                                                                                               // 136
      count: { $sum: 1 }                                                                                               // 140
    }                                                                                                                  // 135
  }]).forEach(function (deletion) {                                                                                    // 134
    var app = apps[deletion._id.appId];                                                                                // 144
    if (!app) {                                                                                                        // 145
      app = apps[deletion.appId] = {};                                                                                 // 146
    }                                                                                                                  // 147
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 149
      app.appDemoUsers = deletion.count;                                                                               // 150
    } else if (deletion._id.type === "grain") {                                                                        // 151
      app.deleted = deletion.count;                                                                                    // 152
    } else if (deletion._id.type === "demoGrain") {                                                                    // 153
      app.demoed = deletion.count;                                                                                     // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 156
                                                                                                                       //
  return {                                                                                                             // 158
    activeUsers: currentlyActiveUsersCount,                                                                            // 159
    demoUsers: deletedDemoUsersCount,                                                                                  // 160
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 161
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 162
    apps: apps                                                                                                         // 163
  };                                                                                                                   // 158
};                                                                                                                     // 165
                                                                                                                       //
function recordStats() {                                                                                               // 167
  var postStats = function postStats(record) {                                                                         // 168
    HTTP.post("https://alpha-api.sandstorm.io/data", {                                                                 // 169
      data: record,                                                                                                    // 170
      headers: {                                                                                                       // 171
        Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                           // 172
        "Content-Type": "application/json"                                                                             // 173
      }                                                                                                                // 171
    });                                                                                                                // 169
  };                                                                                                                   // 176
                                                                                                                       //
  var now = new Date();                                                                                                // 178
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 186
    timestamp: now,                                                                                                    // 187
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 188
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 189
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 190
    forever: computeStats(new Date(0)),                                                                                // 191
    plans: planStats                                                                                                   // 192
  };                                                                                                                   // 186
  record.computeTime = Date.now() - now;                                                                               // 194
  if (global.BlackrockPayments && global.BlackrockPayments.getTotalCharges) {                                          // 195
    // This only exists under Blackrock                                                                                //
    record.totalCharges = global.BlackrockPayments.getTotalCharges();                                                  // 197
  }                                                                                                                    // 198
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 200
  var age = ActivityStats.find().count();                                                                              // 201
  // The stats page which the user agreed we can send actually displays the whole history                              //
  // of the server, but we're only sending stats from the last day. Let's also throw in the                            //
  // length of said history. This is still strictly less information than what the user said                           //
  // we're allowed to send.                                                                                            //
  record.serverAge = age;                                                                                              // 206
                                                                                                                       //
  if (globalDb.isFeatureKeyOptedIntoStats()) {                                                                         // 208
    record.customerId = globalDb.currentFeatureKey().customer.id;                                                      // 209
    postStats(record);                                                                                                 // 210
  } else if (age > 3) {                                                                                                // 211
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 212
                                                                                                                       //
    if (!reportSetting) {                                                                                              // 214
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("reportStats", "/admin/stats");                                                   // 216
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 217
    } else if (reportSetting.value === true) {                                                                         // 218
      postStats(record);                                                                                               // 219
    }                                                                                                                  // 220
  }                                                                                                                    // 221
}                                                                                                                      // 222
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 224
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 227
    Meteor.setInterval(function () {                                                                                   // 228
      recordStats();                                                                                                   // 229
    }, DAY_MS);                                                                                                        // 230
                                                                                                                       //
    recordStats();                                                                                                     // 232
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 233
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 235
    if (StatsTokens.find().count() === 0) {                                                                            // 236
      StatsTokens.remove({});                                                                                          // 237
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 238
    }                                                                                                                  // 239
  });                                                                                                                  // 240
}                                                                                                                      // 241
                                                                                                                       //
Meteor.methods({                                                                                                       // 243
  regenerateStatsToken: function regenerateStatsToken() {                                                              // 244
    if (!isAdmin()) {                                                                                                  // 245
      throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                               // 246
    }                                                                                                                  // 247
                                                                                                                       //
    StatsTokens.remove({});                                                                                            // 249
    var token = StatsTokens.insert({ _id: Random.id(22) });                                                            // 250
    return token._id;                                                                                                  // 251
  }                                                                                                                    // 252
});                                                                                                                    // 243
                                                                                                                       //
Router.map(function () {                                                                                               // 255
  this.route("fetchStats", {                                                                                           // 256
    where: "server",                                                                                                   // 257
    path: "/fetchStats/:tokenId",                                                                                      // 258
    action: function action() {                                                                                        // 259
      var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                   // 260
                                                                                                                       //
      if (!token) {                                                                                                    // 262
        this.response.writeHead(404, {                                                                                 // 263
          "Content-Type": "text/plain"                                                                                 // 264
        });                                                                                                            // 263
        this.response.write("Token not found");                                                                        // 266
        return this.response.end();                                                                                    // 267
      }                                                                                                                // 268
                                                                                                                       //
      try {                                                                                                            // 270
        var stats = ActivityStats.find().fetch();                                                                      // 271
        var statsString = JSON.stringify(stats);                                                                       // 272
                                                                                                                       //
        this.response.writeHead(200, {                                                                                 // 274
          "Content-Type": "application/json"                                                                           // 275
        });                                                                                                            // 274
        this.response.write(statsString);                                                                              // 277
      } catch (error) {                                                                                                // 278
        console.error(error.stack);                                                                                    // 279
        this.response.writeHead(500, {                                                                                 // 280
          "Content-Type": "text/plain"                                                                                 // 281
        });                                                                                                            // 280
        this.response.write(error.stack);                                                                              // 283
      }                                                                                                                // 284
                                                                                                                       //
      return this.response.end();                                                                                      // 286
    }                                                                                                                  // 287
  });                                                                                                                  // 256
});                                                                                                                    // 289
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// TODO(someday): split out fields by locus                                                                            //
// isEnabled is available on both client and server                                                                    //
// getLoginId is only used on server                                                                                   //
// initiateLogin and loginTemplate are only used on client                                                             //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 22
  var setting = Settings.findOne({ _id: name });                                                                       // 23
  return setting && !!setting.value;                                                                                   // 24
}                                                                                                                      // 25
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 27
  isEnabled: function isEnabled() {                                                                                    // 28
    return serviceEnabled("github");                                                                                   // 29
  },                                                                                                                   // 30
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 32
    return identity.services.github.username;                                                                          // 33
  },                                                                                                                   // 34
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 36
    Meteor.loginWithGithub();                                                                                          // 37
    return { oneClick: true };                                                                                         // 38
  },                                                                                                                   // 39
                                                                                                                       //
  loginTemplate: {                                                                                                     // 41
    name: "oauthLoginButton",                                                                                          // 42
    priority: 1,                                                                                                       // 43
    data: {                                                                                                            // 44
      method: "loginWithGithub",                                                                                       // 45
      name: "github",                                                                                                  // 46
      displayName: "GitHub",                                                                                           // 47
      linkingNewIdentity: false                                                                                        // 48
    }                                                                                                                  // 44
  }                                                                                                                    // 41
};                                                                                                                     // 27
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 53
  isEnabled: function isEnabled() {                                                                                    // 54
    return serviceEnabled("google");                                                                                   // 55
  },                                                                                                                   // 56
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 58
    return identity.services.google.email;                                                                             // 59
  },                                                                                                                   // 60
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 62
    Meteor.loginWithGoogle({ loginHint: loginId });                                                                    // 63
    return { oneClick: true };                                                                                         // 64
  },                                                                                                                   // 65
                                                                                                                       //
  loginTemplate: {                                                                                                     // 67
    name: "oauthLoginButton",                                                                                          // 68
    priority: 2,                                                                                                       // 69
    data: {                                                                                                            // 70
      method: "loginWithGoogle",                                                                                       // 71
      name: "google",                                                                                                  // 72
      displayName: "Google",                                                                                           // 73
      linkingNewIdentity: false                                                                                        // 74
    }                                                                                                                  // 70
  }                                                                                                                    // 67
};                                                                                                                     // 53
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 79
  isEnabled: function isEnabled() {                                                                                    // 80
    return serviceEnabled("emailToken");                                                                               // 81
  },                                                                                                                   // 82
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 84
    return identity.services.email.email;                                                                              // 85
  },                                                                                                                   // 86
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 88
    return { form: true };                                                                                             // 89
  },                                                                                                                   // 90
                                                                                                                       //
  loginTemplate: {                                                                                                     // 92
    name: "emailLoginForm",                                                                                            // 93
    priority: 10                                                                                                       // 94
  }                                                                                                                    // 92
};                                                                                                                     // 79
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 98
  isEnabled: function isEnabled() {                                                                                    // 99
    return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                     // 100
  },                                                                                                                   // 101
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 103
    return identity.services.ldap.username;                                                                            // 104
  },                                                                                                                   // 105
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 107
    return { form: true };                                                                                             // 108
  },                                                                                                                   // 109
                                                                                                                       //
  loginTemplate: {                                                                                                     // 111
    name: "ldapLoginForm",                                                                                             // 112
    priority: 21 }                                                                                                     // 113
};                                                                                                                     // 98
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 117
  isEnabled: function isEnabled() {                                                                                    // 118
    return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                     // 119
  },                                                                                                                   // 120
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 122
    return identity.services.saml.id;                                                                                  // 123
  },                                                                                                                   // 124
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 126
    Meteor.loginWithSaml();                                                                                            // 127
    return { oneClick: true };                                                                                         // 128
  },                                                                                                                   // 129
                                                                                                                       //
  loginTemplate: {                                                                                                     // 131
    name: "samlLoginForm",                                                                                             // 132
    priority: 20 }                                                                                                     // 133
};                                                                                                                     // 117
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 137
  isEnabled: function isEnabled() {                                                                                    // 138
    return false; // You can never authenticate as a demo user.                                                        // 139
  },                                                                                                                   // 140
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 142
    return identity._id;                                                                                               // 143
  },                                                                                                                   // 144
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 146
    return { demoCannotLogin: true };                                                                                  // 147
  },                                                                                                                   // 148
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 150
};                                                                                                                     // 137
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function isEnabled() {                                                                                    // 18
    return globalDb.allowDevAccounts();                                                                                // 19
  },                                                                                                                   // 20
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 22
    return identity.services.dev.name;                                                                                 // 23
  },                                                                                                                   // 24
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 26
    loginDevAccount(loginId);                                                                                          // 27
    return { oneClick: true };                                                                                         // 28
  },                                                                                                                   // 29
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-shared.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/grain-shared.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 17
  // Methods defined in this file have meaningful latency compensation (client-side prediction)                        //
  // potential.                                                                                                        //
  //                                                                                                                   //
  // Methods for which latency compensation makes no sense are defined in grain-server.js.                             //
                                                                                                                       //
  markActivityReadByOwner: function markActivityReadByOwner(grainId) {                                                 // 23
    check(grainId, String);                                                                                            // 24
    check(this.userId, String);                                                                                        // 25
                                                                                                                       //
    Grains.update({ _id: grainId, userId: this.userId }, { $set: { "ownerSeenAllActivity": true } });                  // 27
  },                                                                                                                   // 29
                                                                                                                       //
  markActivityRead: function markActivityRead(grainId, identityId) {                                                   // 31
    check(grainId, String);                                                                                            // 32
    check(identityId, String);                                                                                         // 33
                                                                                                                       //
    if (!this.userId || !globalDb.userHasIdentity(this.userId, identityId)) {                                          // 35
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 36
    }                                                                                                                  // 37
                                                                                                                       //
    ApiTokens.update({ "grainId": grainId, "owner.user.identityId": identityId }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
  }                                                                                                                    // 41
});                                                                                                                    // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function isSafeDemoAppUrl(url) {                                                                    // 17
    // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)                   //
    // and we allow specifying a sandstorm.io URL.                                                                     //
    return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
};                                                                                                                     // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function createMockGithubUser() {                                                        // 35
          Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 39
                                                                                                                       //
        clearMockGithubUser: function clearMockGithubUser() {                                                          // 41
          clearUser("Py8fwsaryQNGBuiXb");                                                                              // 42
        },                                                                                                             // 43
                                                                                                                       //
        createMockGoogleUser: function createMockGoogleUser() {                                                        // 45
          Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 49
                                                                                                                       //
        clearMockGoogleUser: function clearMockGoogleUser() {                                                          // 51
          clearUser("6WJcRo2gg2Ysuxsok");                                                                              // 52
        },                                                                                                             // 53
                                                                                                                       //
        fetchAppIndexTest: function fetchAppIndexTest() {                                                              // 55
          globalDb.collections.appIndex.remove({});                                                                    // 56
          SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                                         // 57
        }                                                                                                              // 58
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 60
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 62
    Meteor.call("createMockGithubUser", function (err) {                                                               // 63
      if (err) {                                                                                                       // 64
        console.log(err);                                                                                              // 65
      }                                                                                                                // 66
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 68
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 69
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 70
      window.location.reload();                                                                                        // 71
    });                                                                                                                // 72
  };                                                                                                                   // 73
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 75
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 76
      if (err) {                                                                                                       // 77
        console.log(err);                                                                                              // 78
      }                                                                                                                // 79
    });                                                                                                                // 80
  };                                                                                                                   // 81
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 83
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 84
      if (err) {                                                                                                       // 85
        console.log(err);                                                                                              // 86
      }                                                                                                                // 87
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 89
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 90
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 91
      window.location.reload();                                                                                        // 92
    });                                                                                                                // 93
  };                                                                                                                   // 94
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 96
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 97
      if (err) {                                                                                                       // 98
        console.log(err);                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 101
  };                                                                                                                   // 102
}                                                                                                                      // 103
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/accounts/email-token/token-server.js");
require("./server/accounts/identity/identity-server.js");
require("./server/accounts/ldap/ldap-server.js");
require("./server/accounts/saml/saml-server.js");
require("./server/accounts/accounts-server.js");
require("./server/accounts/accounts-ui-methods.js");
require("./server/accounts/accounts-ui-server.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/00-startup.js");
require("./server/account-suspension.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/contacts-server.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/desktop-notifications-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/identity.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/notifications-server.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/grain-shared.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
